# Awesome Go

[Awesome]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.4.1/docs/awesome.svg "star > 2000"
[G]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Green.svg "最近一周有更新"
[Y]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Yellow.svg "最近三年没有更新"
[CN]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.1/docs/Cn.svg "包含中文文档"
[Archived]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.2.1/docs/archived.svg "项目已归档"
[D]: https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.3.0/docs/DOC.svg "godoc文档地址"

**此项目是 [awesome-go](https://awesome-go.com/) 中文版，最后一次同步时间 : 2023-09-15 07:12:20(每隔1天同步一次)**

[![chinese](https://cdn.jsdelivr.net/gh/yinggaozhen/awesome-go-cn@1.3.0/docs/english.svg)](README_EN.md) [![Build Status](https://travis-ci.org/avelino/awesome-go.svg?branch=master)](https://travis-ci.org/avelino/awesome-go) [![Awesome](https://cdn.rawgit.com/sindresorhus/awesome/d7305f38d29fed78fa85652e3a63e154dd8e8829/media/badge.svg)](https://github.com/sindresorhus/awesome) [![Slack Widget](https://img.shields.io/badge/join-us%20on%20slack-gray.svg?longCache=true&logo=slack&colorB=red)](http://gophers.slack.com/messages/awesome) [![Netlify Status](https://api.netlify.com/api/v1/badges/83a6dcbe-0da6-433e-b586-f68109286bd5/deploy-status)](https://app.netlify.com/sites/awesome-go/deploys)

[![patreon avelino](https://c5.patreon.com/external/logo/become_a_patron_button@2x.png)](https://www.patreon.com/avelinosource) 为Awesome Go打赏~

精选了一系列很棒的Go框架、库和软件。灵感来自于[awesome-python](https://github.com/vinta/awesome-python)。

**小图标说明** :


小图标 | 说明  
:-:|-
![最近一周有更新][G] | 最近一周有更新。可以基本判断当前库处于积极维护状态。
![最近三年未更新][Y] | 最近三年没有更新。反应了此库的维护积极性不高，使用时需谨慎。
![归档项目][Archived] | 此项目已归档，不再更新，使用时需谨慎。
![此项目有中文文档][CN] | 此项目有中文文档。
![godoc文档][D] | godoc文档地址。

### 说明

[中文](README.md)  | [English](README_EN.md) 
 
[![Netlify Status](https://api.netlify.com/api/v1/badges/83a6dcbe-0da6-433e-b586-f68109286bd5/deploy-status)](https://app.netlify.com/sites/awesome-go/deploys)
[![Track Awesome List](https://www.trackawesomelist.com/badge.svg)](https://www.trackawesomelist.com/avelino/awesome-go/)

你可以快速浏览贡献者名单[contribution guidelines](https://github.com/avelino/awesome-go/blob/master/CONTRIBUTING.md). 感谢所有为此项目付出的同学[contributors](https://github.com/avelino/awesome-go/graphs/contributors); 你真棒!

如果您在看到一个包或项目不再维护或不适合，请往awesome-go提交[Pull Request](https://github.com/avelino/awesome-go/pulls)，本项目每隔一天与英文文档同步。感谢!

**Sponsorships:**

_特别感谢 (翻译出错了? 试试 [英文版](README_EN.md#awesome-go) 吧~)_

<div align="center">
<table cellpadding="5">
<tbody align="center">
<tr>
<td>
<a href="https://bit.ly/awesome-go-workos">
<img src="https://avelino.run/sponsors/workos-logo-white-bg.svg" width="200" alt="WorkOS"><br/>
<b>Your app, enterprise-ready.</b><br/>
<sub>Start selling to enterprise customers with just a few lines of code.</sub><br/>
<sup>Add Single Sign-On (and more) in minutes instead of months.</sup>
</a>
</td>
<td>
<a href="https://bit.ly/awesome-go-keygen">
<img src="https://avelino.run/sponsors/keygen-logo.png" width="200" alt="keygen"><br/>
<b>An open, source-available software licensing and distribution API.</b><br/>
<sub>Securely license and distribute Go applications with a single API.</sub><br>
<sup>Add auto updates with only a few lines of code.</sup>
</a>
</td>
</tr>
<tr>
<td colspan="2">
<a href="https://bit.ly/awesome-go-digitalocean">
<img src="https://avelino.run/sponsors/do_logo_horizontal_blue-210.png" width="200" alt="Digital Ocean">
</a>
</td>
</tr>
</tbody>
</table>
</div>

**Awesome Go has no monthly fee**_, but we have employees who **work hard** to keep it running. With money raised, we can repay the effort of each person involved! You can see how we calculate our billing and distribution as it is open to the entire community. Want to be a supporter of the project click [here](mailto:avelinorun+oss@gmail.com?subject=awesome-go%3A%20project%20support)._

> A curated list of awesome Go frameworks, libraries, and software. Inspired by [awesome-python](https://github.com/vinta/awesome-python).

**Contributing:**

Please take a quick gander at the [contribution guidelines](https://github.com/avelino/awesome-go/blob/main/CONTRIBUTING.md) first. Thanks to all [contributors](https://github.com/avelino/awesome-go/graphs/contributors); you rock!

> _If you see a package or project here that is no longer maintained or is not a good fit, please submit a pull request to improve this file. Thank you!_

## 内容

- [Awesome Go](#awesome-go)
  - [内容](#内容)
  - [音频和音乐](#音频和音乐)
  - [身份验证和OAuth](#身份验证和oauth)
  - [区块链](#区块链)
  - [Bot建设](#bot建设)
  - [构建自动化](#构建自动化)
  - [命令行](#命令行)
    - [高级控制台用户界面](#高级控制台用户界面)
    - [标准CLI](#标准cli)
  - [配置](#配置)
  - [持续集成](#持续集成)
  - [CSS预处理器](#css预处理器)
  - [数据结构与算法](#数据结构与算法)
    - [Bit-packing and Compression](#bit-packing-and-compression)
    - [位集合](#位集合)
    - [布隆和布谷鸟过滤器](#布隆和布谷鸟过滤器)
    - [数据结构和算法集合](#数据结构和算法集合)
    - [迭代器](#迭代器)
    - [地图](#地图)
    - [杂项数据结构和算法](#杂项数据结构和算法)
    - [可空类型](#可空类型)
    - [队列](#队列)
    - [集](#集)
    - [文本分析](#文本分析)
    - [树](#树)
    - [管道](#管道)
  - [数据库](#数据库)
    - [缓存](#缓存)
    - [Go中实现的数据库](#go中实现的数据库)
    - [数据库模式迁移](#数据库模式迁移)
    - [数据库工具](#数据库工具)
    - [SQL查询生成器](#sql查询生成器)
  - [数据库驱动程序](#数据库驱动程序)
    - [多个后端接口](#多个后端接口)
    - [关系数据库驱动程序](#关系数据库驱动程序)
    - [NoSQL数据库驱动程序](#nosql数据库驱动程序)
    - [检索及分析资料库](#检索及分析资料库)
  - [日期和时间](#日期和时间)
  - [分布式系统](#分布式系统)
  - [动态域名](#动态域名)
  - [电子邮件](#电子邮件)
  - [可嵌入的脚本语言](#可嵌入的脚本语言)
  - [错误处理](#错误处理)
  - [文件处理](#文件处理)
  - [金融](#金融)
  - [表单](#表单)
  - [方法](#方法)
  - [游戏开发](#游戏开发)
  - [发电机](#发电机)
  - [地理](#地理)
  - [Go 编译器](#go-编译器)
  - [Goroutines](#goroutines)
  - [GUI](#gui)
  - [硬件](#硬件)
  - [图片](#图片)
  - [IoT (Internet of Things)](#iot-internet-of-things)
  - [作业调度器](#作业调度器)
  - [JSON](#json)
  - [日志记录](#日志记录)
  - [机器学习](#机器学习)
  - [消息](#消息)
  - [微软办公软件](#微软办公软件)
    - [Microsoft Excel](#microsoft-excel)
  - [杂项](#杂项)
    - [依赖注入](#依赖注入)
    - [项目布局](#项目布局)
    - [字符串](#字符串)
    - [未分类的](#未分类的)
  - [自然语言处理](#自然语言处理)
    - [语言检测](#语言检测)
    - [形态分析](#形态分析)
    - [鼻涕虫](#鼻涕虫)
    - [分词器](#分词器)
    - [翻译](#翻译)
    - [音译](#音译)
  - [网络](#网络)
    - [HTTP客户端](#http客户端)
  - [OpenGL](#opengl)
  - [ORM](#orm)
  - [包管理](#包管理)
  - [性能](#性能)
  - [查询语言](#查询语言)
  - [嵌入的资源](#嵌入的资源)
  - [科学与数据分析](#科学与数据分析)
  - [安全](#安全)
  - [序列化](#序列化)
  - [服务器应用程序](#服务器应用程序)
  - [流处理](#流处理)
  - [模板引擎](#模板引擎)
  - [测试](#测试)
  - [文本处理](#文本处理)
    - [格式器](#格式器)
    - [标记语言](#标记语言)
    - [Parsers/Encoders/Decoders](#parsersencodersdecoders)
    - [正则表达式](#正则表达式)
    - [环境卫生](#环境卫生)
    - [刮刀](#刮刀)
    - [RSS](#rss)
    - [Utility/Miscellaneous](#utilitymiscellaneous)
  - [Third-party APIs](#third-party-apis)
  - [公用事业公司](#公用事业公司)
  - [UUID](#uuid)
  - [验证](#验证)
  - [版本控制](#版本控制)
  - [视频](#视频)
  - [Web框架](#web框架)
    - [中间件](#中间件)
      - [仿真中间件](#仿真中间件)
      - [用于创建HTTP中间件的库](#用于创建http中间件的库)
    - [路由器](#路由器)
  - [WebAssembly](#webassembly)
  - [Windows](#windows)
  - [XML](#xml)
  - [零信任](#零信任)
  - [代码分析](#代码分析)
  - [编辑器插件](#编辑器插件)
  - [Go 生成工具](#go-生成工具)
  - [Go 工具](#go-工具)
  - [软件包](#软件包)
    - [DevOps 工具](#devops-工具)
    - [其他软件](#其他软件)
- [资源](#资源)
  - [基准](#基准)
  - [会议](#会议)
  - [E-Books](#e-books)
    - [E-books for purchase](#e-books-for-purchase)
    - [Free e-books](#free-e-books)
  - [Gophers](#gophers)
  - [聚会](#聚会)
  - [风格指南](#风格指南)
  - [社交媒体](#社交媒体)
    - [Twitter](#twitter)
    - [Reddit](#reddit)
  - [网站](#网站)
    - [教程](#教程)
    - [Guided Learning Paths](#guided-learning-paths)

**[⬆ back to top](#contents)**

## 音频和音乐

_用于操作音频的库。 (翻译出错了? 试试 [英文版](README_EN.md#audio-and-music) 吧~)_

- [Oto](https://github.com/hajimehoshi/oto) **star:1349** 多平台的 low-level 声音播放库。   [![近一周有更新][G]](https://github.com/hajimehoshi/oto)   [![godoc][D]](https://godoc.org/github.com/hajimehoshi/oto)
- [PortAudio](https://github.com/gordonklaus/portaudio) **star:613** 基于 Go 的PortAudio audio I/O库。   [![godoc][D]](https://godoc.org/github.com/gordonklaus/portaudio)
- [id3v2](https://github.com/bogem/id3v2) **star:300** ID3解码和编码库为Go。   [![godoc][D]](https://godoc.org/github.com/bogem/id3v2)
- [GoAudio](https://github.com/DylanMeeus/GoAudio) **star:298** 本地Go音频处理库。   [![godoc][D]](https://godoc.org/github.com/DylanMeeus/GoAudio)
- [flac](https://github.com/mewkiz/flac) **star:263** 原生 Go FLAC编码器/解码器，支持FLAC流。   [![godoc][D]](https://godoc.org/github.com/mewkiz/flac)
- [malgo](https://github.com/gen2brain/malgo) **star:227** 迷你音频库。
- [gaad](https://github.com/Comcast/gaad) **star:111** 原生 Go AAC位流解析器。   [![godoc][D]](https://godoc.org/github.com/Comcast/gaad)
- [minimp3](https://github.com/tosone/minimp3) **star:110** 轻量级MP3解码器库。
- [gosamplerate](https://github.com/dh1tw/gosamplerate) **star:30** libsamplerate 的 Go 语言实现接口。   [![近三年未更新][Y]](https://github.com/dh1tw/gosamplerate)   [![godoc][D]](https://godoc.org/github.com/dh1tw/gosamplerate)

**[⬆ back to top](#contents)**

## 身份验证和OAuth

_Libraries for implementing authentication schemes. (翻译出错了? 试试 [英文版](README_EN.md#authentication-and-oauth) 吧~)_

- [casbin](https://github.com/casbin/casbin) **star:15718** Authorization library that supports access control models like ACL, RBAC, and ABAC.   [![godoc][D]](https://godoc.org/github.com/casbin/casbin)
- [jwt-go](https://github.com/golang-jwt/jwt) **star:5315** A full featured implementation of JSON Web Tokens (JWT). This library supports the parsing and verification as well as the generation and signing of JWTs.   [![近一周有更新][G]](https://github.com/golang-jwt/jwt)   [![godoc][D]](https://godoc.org/github.com/golang-jwt/jwt)
- [oauth2](https://github.com/golang/oauth2) **star:4879** Successor of goauth2. Generic OAuth 2.0 package that comes with JWT, Google APIs, Compute Engine, and App Engine support.   [![近一周有更新][G]](https://github.com/golang/oauth2)   [![godoc][D]](https://godoc.org/github.com/golang/oauth2)
- [goth](https://github.com/markbates/goth) **star:4322** 提供了 OAuth 和 OAuth2 的简单清晰易用的方法。可开箱即用处理多个提供程序。   [![godoc][D]](https://godoc.org/github.com/markbates/goth)
- [keto](https://github.com/ory/keto) **star:4211** Open Source (Go) implementation of "Zanzibar: Google's Consistent, Global Authorization System". Ships gRPC, REST APIs, newSQL, and an easy and granular permission language. Supports ACL, RBAC, and other access models.   [![近一周有更新][G]](https://github.com/ory/keto)   [![godoc][D]](https://godoc.org/github.com/ory/keto)
- [authboss](https://github.com/volatiletech/authboss) **star:3490** Modular authentication system for the web. It tries to remove as much boilerplate and "hard things" as possible so that each time you start a new web project in Go, you can plug it in, configure it, and start building your app without having to build an authentication system each time.   [![godoc][D]](https://godoc.org/github.com/volatiletech/authboss)
- [loginsrv](https://github.com/tarent/loginsrv) **star:1901** JWT登录微服务带有可插拔的后端服务，如OAuth2 (Github)、htpasswd、osiam。   [![godoc][D]](https://godoc.org/github.com/tarent/loginsrv)
- [osin](https://github.com/openshift/osin) **star:1833** OAuth2服务器库。   [![godoc][D]](https://godoc.org/github.com/openshift/osin)
- [gologin](https://github.com/dghubble/gologin) **star:1629** 用于使用OAuth1和OAuth2身份验证提供者登录的可链处理程序。   [![近一周有更新][G]](https://github.com/dghubble/gologin)   [![godoc][D]](https://godoc.org/github.com/dghubble/gologin)
- [scs](https://github.com/alexedwards/scs) **star:1572** HTTP服务器的会话管理器。   [![godoc][D]](https://godoc.org/github.com/alexedwards/scs)
- [gorbac](https://github.com/mikespook/gorbac) **star:1491** 轻量级的基于角色的访问控制(RBAC)实现。   [![godoc][D]](https://godoc.org/github.com/mikespook/gorbac)
- [gosession](http://github.com/Kwynto/gosession)  This is quick session for net/http in GoLang. This package is perhaps the best implementation of the session mechanism, or at least it tries to become one.
- [paseto](https://github.com/o1egl/paseto) **star:745** 平台无关的安全令牌(PASETO)。   [![godoc][D]](https://godoc.org/github.com/o1egl/paseto)
- [jwt](https://github.com/cristalhq/jwt) **star:617** Safe, simple, and fast JSON Web Tokens for Go.   [![近一周有更新][G]](https://github.com/cristalhq/jwt)   [![godoc][D]](https://godoc.org/github.com/cristalhq/jwt)
- [permissions2](https://github.com/xyproto/permissions2) **star:491** Library for keeping track of users, login states, and permissions. Uses secure cookies and bcrypt.   [![godoc][D]](https://godoc.org/github.com/xyproto/permissions2)
- [go-guardian](https://github.com/shaj13/go-guardian) **star:488** Go-Guardian is a golang library that provides a simple, clean, and idiomatic way to create powerful modern API and web authentication that supports LDAP, Basic, Bearer token, and Certificate based authentication.   [![godoc][D]](https://godoc.org/github.com/shaj13/go-guardian)
- [jwt](https://github.com/pascaldekloe/jwt) **star:337** 轻量级JSON Web令牌库。   [![godoc][D]](https://godoc.org/github.com/pascaldekloe/jwt)
- [jeff](https://github.com/abraithwaite/jeff) **star:258** Simple, flexible, secure, and idiomatic web session management with pluggable backends.   [![godoc][D]](https://godoc.org/github.com/abraithwaite/jeff)
- [jwt-auth](https://github.com/adam-hanna/jwt-auth) **star:229** JWT中间件，可用于Golang http服务器，提供了许多配置选项。   [![godoc][D]](https://godoc.org/github.com/adam-hanna/jwt-auth)
- [go-jose](https://github.com/go-jose/go-jose) **star:157** 相当完整地实现了JOSE工作组的JSON Web令牌、JSON Web签名和JSON Web加密规范。   [![近一周有更新][G]](https://github.com/go-jose/go-jose)   [![godoc][D]](https://godoc.org/github.com/go-jose/go-jose)
- [otpgen](https://github.com/grijul/otpgen) **star:130** 库生成TOTP/HOTP代码。   [![godoc][D]](https://godoc.org/github.com/grijul/otpgen)
- [sessionup](https://github.com/swithek/sessionup) **star:121** 简单但有效的HTTP会话管理和标识包。   [![godoc][D]](https://godoc.org/github.com/swithek/sessionup)
- [sjwt](https://github.com/brianvoe/sjwt) **star:113** 简单的jwt生成器和解析器。   [![godoc][D]](https://godoc.org/github.com/brianvoe/sjwt)
- [session](https://github.com/icza/session) **star:111** web服务器会话管理(包括支持谷歌应用程序引擎 - GAE)。   [![godoc][D]](https://godoc.org/github.com/icza/session)
- [sessions](https://github.com/adam-hanna/sessions) **star:75** 非常简单，高性能，可深度定制的会话服务，主要用于的 go http 服务器。   [![godoc][D]](https://godoc.org/github.com/adam-hanna/sessions)
- [securecookie](https://github.com/chmike/securecookie) **star:74** 高效安全的cookie编码/解码。   [![godoc][D]](https://godoc.org/github.com/chmike/securecookie)
- [branca](https://github.com/essentialkaos/branca) **star:63** branca token[规范实现](https://github.com/tuupola/branca-spec)用于Golang 1.15+。   [![godoc][D]](https://godoc.org/github.com/essentialkaos/branca)
- [otpgo](https://github.com/jltorresm/otpgo) **star:59** 基于时间的一次性密码(TOTP)和基于hmac的一次性密码(HOTP)库用于Go。   [![godoc][D]](https://godoc.org/github.com/jltorresm/otpgo)
- [scope](https://github.com/SonicRoshan/scope) **star:32** 在Go中轻松管理OAuth2范围。   [![godoc][D]](https://godoc.org/github.com/SonicRoshan/scope)
- [cookiestxt](https://github.com/mengzhuo/cookiestxt) **star:12** provides a parser of cookies.txt file format.   [![godoc][D]](https://godoc.org/github.com/mengzhuo/cookiestxt)

**[⬆ back to top](#contents)**

## 区块链

_构建区块链的工具。 (翻译出错了? 试试 [英文版](README_EN.md#blockchain) 吧~)_

- [go-ethereum](https://github.com/ethereum/go-ethereum) **star:43618** 以太坊协议的官方Go实现。   [![近一周有更新][G]](https://github.com/ethereum/go-ethereum)   [![godoc][D]](https://godoc.org/github.com/ethereum/go-ethereum)
- [tendermint](https://github.com/tendermint/tendermint) **star:5547** 一个高性能中间件，可将任何语言的状态机转换为 Byzantine Fault 状态机。使用 Tendermint 一致性及区块链协议。   [![近一周有更新][G]](https://github.com/tendermint/tendermint)   [![godoc][D]](https://godoc.org/github.com/tendermint/tendermint)
- [cosmos-sdk](https://github.com/cosmos/cosmos-sdk) **star:5416** 在宇宙生态系统中构建公共区块链框架。   [![近一周有更新][G]](https://github.com/cosmos/cosmos-sdk)   [![godoc][D]](https://godoc.org/github.com/cosmos/cosmos-sdk)
- [solana-go](https://github.com/gagliardetto/solana-go) **star:449** 去库与Solana JSON RPC和WebSocket接口接口。   [![godoc][D]](https://godoc.org/github.com/gagliardetto/solana-go)
- [gossamer](https://github.com/ChainSafe/gossamer) **star:391** Polkadot主机的Go实现。   [![近一周有更新][G]](https://github.com/ChainSafe/gossamer)   [![godoc][D]](https://godoc.org/github.com/ChainSafe/gossamer)
- [cometbft](https://github.com/cometbft/cometbft) **star:352** A distributed, Byzantine fault-tolerant, deterministic state machine replication engine. It is a fork of Tendermint Core and implements the Tendermint consensus algorithm.   [![近一周有更新][G]](https://github.com/cometbft/cometbft)   [![godoc][D]](https://godoc.org/github.com/cometbft/cometbft)

**[⬆ back to top](#contents)**

## Bot建设

_用于构建和使用机器人的库。 (翻译出错了? 试试 [英文版](README_EN.md#bot-building) 吧~)_

- [telegram-bot-api](https://github.com/Syfaro/telegram-bot-api) **star:4936** 简单轻量级的Telegram bot客户端。   [![godoc][D]](https://godoc.org/github.com/Syfaro/telegram-bot-api)
- [olivia](https://github.com/olivia-ai/olivia) **star:3584** 用人工神经网络建造的聊天机器人。   [![godoc][D]](https://godoc.org/github.com/olivia-ai/olivia)
- [telebot](https://github.com/tucnak/telebot) **star:3247** Telegram bot framework is written in Go.   [![近一周有更新][G]](https://github.com/tucnak/telebot)   [![godoc][D]](https://godoc.org/github.com/tucnak/telebot)
- [wayback](https://github.com/wabarc/wayback) **star:1421** A bot for Telegram, Mastodon, Slack, and other messaging platforms archives webpages.   [![近一周有更新][G]](https://github.com/wabarc/wayback)   [![godoc][D]](https://godoc.org/github.com/wabarc/wayback)
- [Kelp](https://github.com/stellar/kelp) **star:1018** 官方交易和做市机器人为[Stellar](https://www.stellar.org/) DEX。开箱即用的作品，用 Golang 编写，兼容集中交易和定制交易策略。   [![godoc][D]](https://godoc.org/github.com/stellar/kelp)
- [Golang CryptoTrading Bot](https://github.com/saniales/golang-crypto-trading-bot) **star:934** 基于控制台的，用于加密货币交易所的的交易机器人。   [![godoc][D]](https://godoc.org/github.com/saniales/golang-crypto-trading-bot)
- [go-chat-bot](https://github.com/go-chat-bot/bot) **star:795** 用 Go 编写的IRC, Slack和电报机器人。   [![godoc][D]](https://godoc.org/github.com/go-chat-bot/bot)
- [go-joe](https://joe-bot.net)  一个通用的机器人库的灵感来自于Hubot。
- [slacker](https://github.com/shomali11/slacker) **star:795** 可简单创建Slack机器人的框架。   [![godoc][D]](https://godoc.org/github.com/shomali11/slacker)
- [tbot](https://github.com/yanzay/tbot) **star:336** 带有类似于net/http API的Telegram bot服务器。   [![godoc][D]](https://godoc.org/github.com/yanzay/tbot)
- [go-twitch-irc](https://github.com/gempir/go-twitch-irc) **star:307** 为twitch写机器人的库。电视聊天   [![godoc][D]](https://godoc.org/github.com/gempir/go-twitch-irc)
- [echotron](https://github.com/NicoNex/echotron) **star:268** 一个优雅的并发库Telegram Bots in Go。   [![godoc][D]](https://godoc.org/github.com/NicoNex/echotron)
- [telego](https://github.com/mymmrac/telego) **star:264** goang的Telegram Bot API库，完全一对一的API实现。   [![近一周有更新][G]](https://github.com/mymmrac/telego)   [![godoc][D]](https://godoc.org/github.com/mymmrac/telego)
- [go-sarah](https://github.com/oklahomer/go-sarah) **star:259** Framework to build a bot for desired chat services including LINE, Slack, Gitter, and more.   [![godoc][D]](https://godoc.org/github.com/oklahomer/go-sarah)
- [bot](https://github.com/go-telegram/bot) **star:178** Zero-dependencies Telegram Bot library with additional UI components   [![godoc][D]](https://godoc.org/github.com/go-telegram/bot)
- [Tenyks](https://github.com/kyleterry/tenyks) **star:175** 面向服务的IRC bot，使用Redis和JSON进行消息传递。   [![godoc][D]](https://godoc.org/github.com/kyleterry/tenyks)
- [hanu](https://github.com/sbstjn/hanu) **star:148** 用于编写Slack机器人的框架。   [![godoc][D]](https://godoc.org/github.com/sbstjn/hanu)
- [larry](https://github.com/ezeoleaf/larry) **star:146** 拉里🐦是一个很简单的推特机器人生成器,tweet随机从Github库建在走。   [![godoc][D]](https://godoc.org/github.com/ezeoleaf/larry)
- [slack-bot](https://github.com/innogames/slack-bot) **star:143** 为懒惰的开发者准备好使用Slack Bot:自定义命令，Jenkins, Jira, Bitbucket, Github…   [![近一周有更新][G]](https://github.com/innogames/slack-bot)   [![godoc][D]](https://godoc.org/github.com/innogames/slack-bot)
- [go-tgbot](https://github.com/olebedev/go-tgbot) **star:119** Pure Golang Telegram Bot API wrapper, generated from swagger file, session-based router, and middleware.   [![近三年未更新][Y]](https://github.com/olebedev/go-tgbot)   [![godoc][D]](https://godoc.org/github.com/olebedev/go-tgbot)
- [ephemeral-roles](https://github.com/ewohltman/ephemeral-roles) **star:80** 用于管理基于语音通道成员存在的临时角色的不和机器人。   [![godoc][D]](https://godoc.org/github.com/ewohltman/ephemeral-roles)
- [margelet](https://github.com/zhulik/margelet) **star:80** 构建电报机器人的框架。   [![godoc][D]](https://godoc.org/github.com/zhulik/margelet)
- [slackscot](https://github.com/alexandre-normand/slackscot) **star:55** 另一个构建Slack机器人的框架。   [![godoc][D]](https://godoc.org/github.com/alexandre-normand/slackscot)
- [govkbot](https://github.com/nikepan/govkbot) **star:44** 简单的Go [VK](https://vk.com) bot库。   [![godoc][D]](https://godoc.org/github.com/nikepan/govkbot)
- [teleterm](https://github.com/alfiankan/teleterm) **star:27** Telegram Bot执行终端命令。   [![godoc][D]](https://godoc.org/github.com/alfiankan/teleterm)
- [micha](https://github.com/onrik/micha) **star:25** 基于 GO 实现的Telegram 机器人API库。   [![godoc][D]](https://godoc.org/github.com/onrik/micha)

**[⬆ back to top](#contents)**

## 构建自动化

_Libraries and tools help with build automation. (翻译出错了? 试试 [英文版](README_EN.md#build-automation) 吧~)_

- [Task](https://github.com/go-task/task) **star:8532** 简单的“Go”的选择。   [![近一周有更新][G]](https://github.com/go-task/task)   [![godoc][D]](https://godoc.org/github.com/go-task/task)
- [realize](https://github.com/tockins/realize) **star:4408** Go build a system with file watchers and live to reload. Run, build and watch file changes with custom paths.   [![godoc][D]](https://godoc.org/github.com/tockins/realize)
- [mage](https://github.com/magefile/mage) **star:3677** 法师是一个使用Go制作/耙子类的构建工具。   [![近一周有更新][G]](https://github.com/magefile/mage)   [![godoc][D]](https://godoc.org/github.com/magefile/mage)
- [mmake](https://github.com/tj/mmake) **star:1668** 现代 Make 工具   [![godoc][D]](https://godoc.org/github.com/tj/mmake)
- [xc](https://github.com/joerdav/xc) **star:894** Task runner with README.md defined tasks, executable markdown.   [![近一周有更新][G]](https://github.com/joerdav/xc)   [![godoc][D]](https://godoc.org/github.com/joerdav/xc)
- [goyek](https://github.com/goyek/goyek) **star:398** 在Go中创建构建管道。   [![近一周有更新][G]](https://github.com/goyek/goyek)   [![godoc][D]](https://godoc.org/github.com/goyek/goyek)
- [taskctl](https://github.com/taskctl/taskctl) **star:263** 并发任务跑。   [![godoc][D]](https://godoc.org/github.com/taskctl/taskctl)
- [1build](https://github.com/gopinath-langote/1build) **star:217** 命令行工具，以无摩擦地管理项目特定的命令。   [![godoc][D]](https://godoc.org/github.com/gopinath-langote/1build)
- [gaper](https://github.com/maxcnunes/gaper) **star:75** 当Go项目崩溃或一些人看到文件更改时，构建并重新启动该项目。   [![godoc][D]](https://godoc.org/github.com/maxcnunes/gaper)
- [gilbert](https://go-gilbert.github.io)  一个为 Go 项目而生的构建系统和任务运行器。
- [anko](https://github.com/GuilhermeCaruso/anko) **star:31** 适用于多种编程语言的简单应用程序监视程序。   [![godoc][D]](https://godoc.org/github.com/GuilhermeCaruso/anko)

**[⬆ back to top](#contents)**

## 命令行

### 高级控制台用户界面

_用于构建控制台应用程序和控制台用户界面的库。 (翻译出错了? 试试 [英文版](README_EN.md#advanced-console-uis) 吧~)_

- [bubbletea](https://github.com/charmbracelet/bubbletea) **star:19702** Go framework to build terminal apps, based on The Elm Architecture.   [![近一周有更新][G]](https://github.com/charmbracelet/bubbletea)   [![godoc][D]](https://godoc.org/github.com/charmbracelet/bubbletea)
- [termui](https://github.com/gizak/termui) **star:12638** 此库是基于**termbox-go**实现的，借鉴于[blessed-contrib](https://github.com/yaronn/blessed-contrib)。   [![godoc][D]](https://godoc.org/github.com/gizak/termui)
- [gocui](https://github.com/jroimartin/gocui) **star:9381** 旨在创建控制台用户界面的极简Go库。   [![godoc][D]](https://godoc.org/github.com/jroimartin/gocui)
- [gommon/color](https://github.com/labstack/gommon/tree/master/color)  更换终端文本样式。
- [lipgloss](https://github.com/charmbracelet/lipgloss) **star:6200** Declaratively define styles for color, format and layout in the terminal.   [![godoc][D]](https://godoc.org/github.com/charmbracelet/lipgloss)
- [go-prompt](https://github.com/c-bata/go-prompt) **star:5002** 构建一个强大的交互式提示，借鉴于[python-prompt-toolkit](https://github.com/jonathanslenders/python-prompt-toolkit)   [![godoc][D]](https://godoc.org/github.com/c-bata/go-prompt)
- [termbox-go](https://github.com/nsf/termbox-go) **star:4573** 基于文本的跨平台接口库。   [![godoc][D]](https://godoc.org/github.com/nsf/termbox-go)
- [pterm](https://github.com/pterm/pterm) **star:4002** 一个在每个平台上使用许多可组合组件美化控制台输出的库。   [![近一周有更新][G]](https://github.com/pterm/pterm)   [![godoc][D]](https://godoc.org/github.com/pterm/pterm)
- [bubbles](https://github.com/charmbracelet/bubbles) **star:3754** TUI components for bubbletea.   [![近一周有更新][G]](https://github.com/charmbracelet/bubbles)   [![godoc][D]](https://godoc.org/github.com/charmbracelet/bubbles)
- [progressbar](https://github.com/schollz/progressbar) **star:3470** 基本线程安全的进度条，在每个操作系统工作。   [![godoc][D]](https://godoc.org/github.com/schollz/progressbar)
- [termdash](https://github.com/mum4k/termdash) **star:2360** 此库是基于**termbox-go**实现的，借鉴于[termui](https://github.com/gizak/termui)。   [![godoc][D]](https://godoc.org/github.com/mum4k/termdash)
- [asciigraph](https://github.com/guptarohit/asciigraph) **star:2308** 在命令行中构建轻量级ASCII线图╭┈╯，应用程序中没有其他依赖项。   [![godoc][D]](https://godoc.org/github.com/guptarohit/asciigraph)
- [spinner](https://github.com/briandowns/spinner) **star:2145**  一个 Go 语言软件包，提供多种选项，方便在终端中创建加载动画。   [![godoc][D]](https://godoc.org/github.com/briandowns/spinner)
- [mpb](https://github.com/vbauerster/mpb) **star:2087** 可在终端显示多进度条。   [![godoc][D]](https://godoc.org/github.com/vbauerster/mpb)
- [uiprogress](https://github.com/gosuri/uiprogress) **star:2043** 在终端呈现进度条，可灵活配置的。   [![godoc][D]](https://godoc.org/github.com/gosuri/uiprogress)
- [uilive](https://github.com/gosuri/uilive) **star:1599** Library for updating terminal output in real time.   [![godoc][D]](https://godoc.org/github.com/gosuri/uilive)
- [termenv](https://github.com/muesli/termenv) **star:1467** 先进的ANSI风格和颜色支持您的终端应用程序。   [![godoc][D]](https://godoc.org/github.com/muesli/termenv)
- [gookit/color](https://github.com/gookit/color) **star:1368** 终端显色工具库，支持16种颜色，256种颜色，RGB显色输出，兼容Windows。   [![近一周有更新][G]](https://github.com/gookit/color)   [![godoc][D]](https://godoc.org/github.com/gookit/color)   [![包含中文文档][CN]](https://github.com/gookit/color)
- [aurora](https://github.com/logrusorgru/aurora) **star:1347** ANSI terminal colors that support fmt.Printf/Sprintf.   [![godoc][D]](https://godoc.org/github.com/logrusorgru/aurora)
- [go-isatty](https://github.com/mattn/go-isatty) **star:739** Go 实现的 isatty。   [![godoc][D]](https://godoc.org/github.com/mattn/go-isatty)
- [uitable](https://github.com/gosuri/uitable) **star:713** 改善终端应用程序中表格数据的可读性。   [![godoc][D]](https://godoc.org/github.com/gosuri/uitable)
- [go-colorable](https://github.com/mattn/go-colorable) **star:711** 适用于windows的颜色编写器。   [![godoc][D]](https://godoc.org/github.com/mattn/go-colorable)
- [simpletable](https://github.com/alexeyco/simpletable) **star:465** Simple tables in a terminal with Go.   [![godoc][D]](https://godoc.org/github.com/alexeyco/simpletable)
- [chalk](https://github.com/ttacon/chalk) **star:430** 美化终端/控制台输出。   [![近三年未更新][Y]](https://github.com/ttacon/chalk)   [![godoc][D]](https://godoc.org/github.com/ttacon/chalk)
- [yacspin](https://github.com/theckman/yacspin) **star:409** 用于与终端旋转器一起工作。   [![godoc][D]](https://godoc.org/github.com/theckman/yacspin)
- [box-cli-maker](https://github.com/Delta456/box-cli-maker) **star:382** 为你的CLI制作高度定制的盒子。   [![近一周有更新][G]](https://github.com/Delta456/box-cli-maker)   [![godoc][D]](https://godoc.org/github.com/Delta456/box-cli-maker)
- [tabby](https://github.com/cheynewallace/tabby) **star:333** 一个可在终端生成一个极简Golang表格轻量级库   [![godoc][D]](https://godoc.org/github.com/cheynewallace/tabby)
- [bubble-table](https://github.com/Evertras/bubble-table) **star:239** An interactive table component for bubbletea.   [![godoc][D]](https://godoc.org/github.com/Evertras/bubble-table)
- [go-colortext](https://github.com/daviddengcn/go-colortext) **star:214** 在终端中使用彩色文字。   [![近三年未更新][Y]](https://github.com/daviddengcn/go-colortext)   [![godoc][D]](https://godoc.org/github.com/daviddengcn/go-colortext)
- [cfmt](https://github.com/mingrammer/cfmt) **star:95** 提供上下文的fmt，灵感来自于bootstrap color classes。   [![近三年未更新][Y]](https://github.com/mingrammer/cfmt)   [![godoc][D]](https://godoc.org/github.com/mingrammer/cfmt)
- [tabular](https://github.com/InVisionApp/tabular) **star:72** 不需要向API传递大量参数就可从命令行实用程序中打印ASCII表。   [![godoc][D]](https://godoc.org/github.com/InVisionApp/tabular)
- [cfmt](https://github.com/i582/cfmt) **star:60** 简单和方便格式化格式化输出完全兼容fmt库。   [![godoc][D]](https://godoc.org/github.com/i582/cfmt)
- [ctc](https://github.com/wzshiming/ctc) **star:45** 不需要Print方法的非侵入性跨平台终端颜色库。   [![godoc][D]](https://godoc.org/github.com/wzshiming/ctc)   [![包含中文文档][CN]](https://github.com/wzshiming/ctc)
- [table](https://github.com/tomlazar/table) **star:45** 为基于终端颜色的表的小库。   [![godoc][D]](https://godoc.org/github.com/tomlazar/table)
- [marker](https://github.com/cyucelen/marker) **star:41** 最简单的方法来匹配和标记字符串的彩色终端输出。   [![godoc][D]](https://godoc.org/github.com/cyucelen/marker)
- [colourize](https://github.com/TreyBastian/colourize) **star:26** 在终端提供ANSI彩色文本。   [![godoc][D]](https://godoc.org/github.com/TreyBastian/colourize)   [![归档项目][Archived]](https://github.com/TreyBastian/colourize)
- [go-ataman](https://github.com/workanator/go-ataman) **star:15** 在终端提供ANSI彩色文本模板。   [![godoc][D]](https://godoc.org/github.com/workanator/go-ataman)
- [go-palette](https://github.com/abusomani/go-palette) **star:13** Go library that provides elegant and convenient style definitions using ANSI colors. Fully compatible & wraps the [fmt library](https://pkg.go.dev/fmt) for nice terminal layouts.   [![godoc][D]](https://godoc.org/github.com/abusomani/go-palette)
- [crab-config-files-templating](https://github.com/alfiankan/crab-config-files-templating) **star:6** Dynamic configuration file templating tool for kubernetes manifest or general configuration files.   [![godoc][D]](https://godoc.org/github.com/alfiankan/crab-config-files-templating)

**[⬆ back to top](#contents)**

### 标准CLI

_用于构建标准或基本命令行应用程序的库。 (翻译出错了? 试试 [英文版](README_EN.md#standard-cli) 吧~)_

- [cobra](https://github.com/spf13/cobra) **star:33348** 现代Go CLI命令行交互工具。   [![近一周有更新][G]](https://github.com/spf13/cobra)   [![godoc][D]](https://godoc.org/github.com/spf13/cobra)
- [elvish](https://github.com/elves/elvish) **star:5134** 一种表达性编程语言和通用的交互外壳。   [![godoc][D]](https://godoc.org/github.com/elves/elvish)
- [kingpin](https://github.com/alecthomas/kingpin) **star:3371** 支持子命令的命令行和标志解析器(被' kong '取代;见下文)。   [![godoc][D]](https://godoc.org/github.com/alecthomas/kingpin)
- [Dnote](https://github.com/dnote/dnote) **star:2570** 一个简单的命令行笔记本与多设备同步。   [![godoc][D]](https://godoc.org/github.com/dnote/dnote)
- [go-flags](https://github.com/jessevdk/go-flags) **star:2437**  Go 命令行选项解析器。   [![godoc][D]](https://godoc.org/github.com/jessevdk/go-flags)
- [pflag](https://github.com/spf13/pflag) **star:2182** 基于POSIX/GNU-style --flags实现的包，主要用于替换Go的falg包。   [![近一周有更新][G]](https://github.com/spf13/pflag)   [![godoc][D]](https://godoc.org/github.com/spf13/pflag)
- [go-arg](https://github.com/alexflint/go-arg) **star:1706** 基于结构的参数解析。   [![近一周有更新][G]](https://github.com/alexflint/go-arg)   [![godoc][D]](https://godoc.org/github.com/alexflint/go-arg)
- [mitchellh/cli](https://github.com/mitchellh/cli) **star:1684** 用于实现命令行接口的Go库。   [![godoc][D]](https://godoc.org/github.com/mitchellh/cli)
- [ops](https://github.com/nanovms/ops) **star:1118** Unikernel 构建器/协调器。   [![近一周有更新][G]](https://github.com/nanovms/ops)   [![godoc][D]](https://godoc.org/github.com/nanovms/ops)
- [liner](https://github.com/peterh/liner) **star:1003** 类似readline-like的命令行接口库。   [![godoc][D]](https://godoc.org/github.com/peterh/liner)
- [complete](https://github.com/posener/complete) **star:894** 使用 Go 语言编写的 bash 命令补全工具以及 Go 命令补全工具.   [![godoc][D]](https://godoc.org/github.com/posener/complete)
- [mow.cli](https://github.com/jawher/mow.cli) **star:857** 用于构建具有复杂标志和参数解析和验证的CLI应用程序。   [![godoc][D]](https://godoc.org/github.com/jawher/mow.cli)
- [flaggy](https://github.com/integrii/flaggy) **star:835** 一个健壮的、易用的标志包，具有出色的子命令支持。   [![godoc][D]](https://godoc.org/github.com/integrii/flaggy)
- [cli](https://github.com/mkideal/cli) **star:696** 基于golang结构标签，功能丰富易于使用的命令行包。   [![godoc][D]](https://godoc.org/github.com/mkideal/cli)
- [argparse](https://github.com/akamensky/argparse) **star:547** 命令行参数分析器，灵感来自Python的argparse模块。   [![godoc][D]](https://godoc.org/github.com/akamensky/argparse)
- [carapace-bin](https://github.com/rsteube/carapace-bin) **star:304** 多shell多命令参数完成器。   [![近一周有更新][G]](https://github.com/rsteube/carapace-bin)   [![godoc][D]](https://godoc.org/github.com/rsteube/carapace-bin)
- [climax](https://github.com/tucnak/climax) **star:208** Alternative CLI with "human face", in spirit of Go command.   [![近三年未更新][Y]](https://github.com/tucnak/climax)   [![godoc][D]](https://godoc.org/github.com/tucnak/climax)
- [commandeer](https://github.com/jaffee/commandeer) **star:171** 开发友好的CLI应用程序。   [![godoc][D]](https://godoc.org/github.com/jaffee/commandeer)
- [clîr](https://github.com/leaanthony/clir) **star:156** 一个简单而清晰的CLI库。依赖免费的。   [![godoc][D]](https://godoc.org/github.com/leaanthony/clir)
- [job](https://github.com/liujianping/job) **star:129** 工作，把你的短期指令当作长期任务。   [![近三年未更新][Y]](https://github.com/liujianping/job)
- [flag](https://github.com/cosiner/flag) **star:126** 简单但功能强大的命令行选项解析库，用于支持Go子命令。   [![godoc][D]](https://godoc.org/github.com/cosiner/flag)
- [carapace](https://github.com/rsteube/carapace) **star:123** 用于spf13/cobra的命令参数补全生成器。   [![近一周有更新][G]](https://github.com/rsteube/carapace)   [![godoc][D]](https://godoc.org/github.com/rsteube/carapace)
- [cmdr](https://github.com/hedzr/cmdr) **star:122** 一个POSIX/GNU风格的、类似getopt的命令行UI Go库。   [![godoc][D]](https://godoc.org/github.com/hedzr/cmdr)
- [cli](https://github.com/teris-io/cli) **star:120** 为 Go 构建命令接口提供简单而完整的API。   [![godoc][D]](https://godoc.org/github.com/teris-io/cli)
- [env](https://github.com/codingconcepts/env) **star:107** 基于标记的结构化的环境配置。   [![近三年未更新][Y]](https://github.com/codingconcepts/env)   [![godoc][D]](https://godoc.org/github.com/codingconcepts/env)
- [acmd](https://github.com/cristalhq/acmd) **star:94** Simple, useful, and opinionated CLI package in Go.   [![近一周有更新][G]](https://github.com/cristalhq/acmd)   [![godoc][D]](https://godoc.org/github.com/cristalhq/acmd)
- [gocmd](https://github.com/devfacet/gocmd) **star:65** 用于构建命令行应用程序。   [![godoc][D]](https://godoc.org/github.com/devfacet/gocmd)
- [hiboot cli](https://github.com/hidevopsio/hiboot/tree/master/pkg/app/cli)  具有自动配置和依赖注入的cli应用程序框架。
- [command-chain](https://github.com/rainu/go-command-chain) **star:47** A go library for configure and run command chains - such as pipelining in unix shells.   [![godoc][D]](https://godoc.org/github.com/rainu/go-command-chain)
- [go-getoptions](https://github.com/DavidGamba/go-getoptions) **star:47** Go option parser inspired by the flexibility of Perl’s GetOpt::Long.   [![godoc][D]](https://godoc.org/github.com/DavidGamba/go-getoptions)
- [flagvar](https://github.com/sgreben/flagvar) **star:42** 符合 Go 标准的“flag”标志参数类型包。   [![godoc][D]](https://godoc.org/github.com/sgreben/flagvar)
- [argv](https://github.com/cosiner/argv) **star:38** 基于Base 语法，用于分隔命令行字符串并将其作为参数的 Go 语言库，   [![近三年未更新][Y]](https://github.com/cosiner/argv)   [![godoc][D]](https://godoc.org/github.com/cosiner/argv)
- [cmd](https://github.com/posener/cmd) **star:38** 扩展标准的' flag '包以支持子命令和更多惯用方式。   [![近三年未更新][Y]](https://github.com/posener/cmd)   [![godoc][D]](https://godoc.org/github.com/posener/cmd)
- [go-commander](https://github.com/yitsushi/go-commander) **star:33** 用于简化CLI工作流的 Go 库。   [![近三年未更新][Y]](https://github.com/yitsushi/go-commander)   [![godoc][D]](https://godoc.org/github.com/yitsushi/go-commander)   [![归档项目][Archived]](https://github.com/yitsushi/go-commander)
- [go-andotp](https://github.com/grijul/go-andotp) **star:24** A CLI program to encrypt/decrypt [andOTP](https://github.com/andOTP/andOTP) files. Can be used as a library as well.   [![godoc][D]](https://godoc.org/github.com/grijul/go-andotp)
- [mcli](https://github.com/jxskiss/mcli) **star:21** A minimal but very powerful cli library for Go.   [![近一周有更新][G]](https://github.com/jxskiss/mcli)   [![godoc][D]](https://godoc.org/github.com/jxskiss/mcli)
- [carapace-spec](https://github.com/rsteube/carapace-spec) **star:7** Define simple completions using a spec file.   [![近一周有更新][G]](https://github.com/rsteube/carapace-spec)   [![godoc][D]](https://godoc.org/github.com/rsteube/carapace-spec)
- [readline](https://github.com/reeflective/readline) Shell library with modern and easy to use UI features.
- [urfave/cli](https://github.com/urfave/cli) **star:20695** 可让你简单、快速和愉快的构建命令行应用(之前是codegangsta/cli)。   [![近一周有更新][G]](https://github.com/urfave/cli)   [![godoc][D]](https://godoc.org/github.com/urfave/cli)
- [survey](https://github.com/go-survey/survey) **star:3958** Build interactive and accessible prompts with full support for windows and posix terminals.   [![godoc][D]](https://godoc.org/github.com/go-survey/survey)
- [wmenu](https://github.com/dixonwille/wmenu) **star:193** Easy to use menu structure for cli applications that prompt users to make choices.   [![godoc][D]](https://godoc.org/github.com/dixonwille/wmenu)
- [sflags](https://github.com/octago/sflags) **star:146** Struct based flags generator for flag, urfave/cli, pflag, cobra, kingpin, and other libraries.   [![godoc][D]](https://godoc.org/github.com/octago/sflags)
- [ukautz/clif](https://github.com/ukautz/clif) **star:123** 简小的命令行接口框架。   [![近三年未更新][Y]](https://github.com/ukautz/clif)   [![godoc][D]](https://godoc.org/github.com/ukautz/clif)
- [version](https://github.com/mszostok/version) **star:75** Collects and displays CLI version information in multiple formats along with upgrade notice.   [![godoc][D]](https://godoc.org/github.com/mszostok/version)
- [wlog](https://github.com/dixonwille/wlog) **star:59** 支持跨平台和并发的简单日志记录接口。   [![godoc][D]](https://godoc.org/github.com/dixonwille/wlog)
- [strumt](https://github.com/antham/strumt) **star:55** 用于创建提示链。   [![godoc][D]](https://godoc.org/github.com/antham/strumt)
- [sand](https://github.com/Zaba505/sand) **star:20** 用于创建解释器等的简单API。   [![近三年未更新][Y]](https://github.com/Zaba505/sand)   [![godoc][D]](https://godoc.org/github.com/Zaba505/sand)
- [ts](https://github.com/liujianping/ts) **star:17** 时间戳转换和比较工具。   [![近三年未更新][Y]](https://github.com/liujianping/ts)   [![godoc][D]](https://godoc.org/github.com/liujianping/ts)
- [subcmd](https://github.com/bobg/subcmd) **star:5** 解析和运行子命令的另一种方法。与标准的“旗帜”包一起工作。   [![godoc][D]](https://godoc.org/github.com/bobg/subcmd)

**[⬆ back to top](#contents)**

## 配置

_配置解析的库。 (翻译出错了? 试试 [英文版](README_EN.md#configuration) 吧~)_

- [viper](https://github.com/spf13/viper) **star:23999** 配置管理。   [![近一周有更新][G]](https://github.com/spf13/viper)   [![godoc][D]](https://godoc.org/github.com/spf13/viper)
- [godotenv](https://github.com/joho/godotenv) **star:6614** Ruby 的 dotenv 库的 Go移植版(从.env文件加载环境变量)。   [![godoc][D]](https://godoc.org/github.com/joho/godotenv)
- [kelseyhightower/envconfig](https://github.com/kelseyhightower/envconfig) **star:4654** 管理来自环境变量的配置数据。   [![godoc][D]](https://godoc.org/github.com/kelseyhightower/envconfig)
- [env](https://github.com/caarlos0/env) **star:3819** 解析环境变量并赋值到struct中(默认值)。   [![近一周有更新][G]](https://github.com/caarlos0/env)   [![godoc][D]](https://godoc.org/github.com/caarlos0/env)
- [ini](https://github.com/go-ini/ini) **star:3306**  读和写INI文件。   [![godoc][D]](https://godoc.org/github.com/go-ini/ini)
- [koanf](https://github.com/knadh/koanf) **star:2005** 轻量级可扩展库，用于读取Go应用程序中的配置。内置支持JSON, TOML, YAML, env，命令行。   [![近一周有更新][G]](https://github.com/knadh/koanf)   [![godoc][D]](https://godoc.org/github.com/knadh/koanf)
- [kong](https://github.com/alecthomas/kong) **star:1530** Command-line parser with support for arbitrarily complex command-line structures and additional sources of configuration such as YAML, JSON, TOML, etc (successor to `kingpin`).   [![godoc][D]](https://godoc.org/github.com/alecthomas/kong)
- [cleanenv](https://github.com/ilyakaznacheev/cleanenv) **star:1152** 简约的配置阅读器(来自文件、环境，以及你想要的任何地方)。   [![godoc][D]](https://godoc.org/github.com/ilyakaznacheev/cleanenv)
- [konfig](https://github.com/lalamove/konfig) **star:640** 可组合、可观察和高性能的分布式配置管理。   [![godoc][D]](https://godoc.org/github.com/lalamove/konfig)
- [gookit/config](https://github.com/gookit/config) **star:480** 程序配置管理(load,get,set)。支持JSON, YAML, TOML, INI, HCL。支持多文件加载，数据覆盖合并。   [![近一周有更新][G]](https://github.com/gookit/config)   [![godoc][D]](https://godoc.org/github.com/gookit/config)   [![包含中文文档][CN]](https://github.com/gookit/config)
- [aconfig](https://github.com/cristalhq/aconfig) **star:474** 简单，有用和固执的配置加载程序。   [![近一周有更新][G]](https://github.com/cristalhq/aconfig)   [![godoc][D]](https://godoc.org/github.com/cristalhq/aconfig)
- [confita](https://github.com/heetch/confita) **star:472** 从多个后端级联加载配置到struct中。   [![godoc][D]](https://godoc.org/github.com/heetch/confita)
- [xdg](https://github.com/adrg/xdg) **star:442** Go实现[XDG基本目录规范](https://specifications.freedesktop.org/basedir-spec/basedir-spec-latest.html)和[XDG用户目录](https://wiki.archlinux.org/index.php/XDG_user_directories)。   [![godoc][D]](https://godoc.org/github.com/adrg/xdg)
- [GoLobby/Config](https://github.com/golobby/config) **star:340** GoLobby Config is a lightweight yet powerful configuration manager for the Go programming language.   [![godoc][D]](https://godoc.org/github.com/golobby/config)
- [gone/jconf](https://github.com/One-com/gone/tree/master/jconf)  模块化的JSON配置。保持配置结构及其配置的代码，并将解析委托给子模块，而不牺牲配置的完整序列化。
- [config](https://github.com/JeremyLoy/config) **star:331** 云本地应用程序配置。将ENV绑定到结构体仅需两行代码。   [![godoc][D]](https://godoc.org/github.com/JeremyLoy/config)
- [hjson](https://github.com/hjson/hjson-go) **star:304** 更加人性化的JSON配置。轻松的语法，更少的错误，更多的注释。   [![godoc][D]](https://godoc.org/github.com/hjson/hjson-go)
- [fig](https://github.com/kkyr/fig) **star:278** 用于从文件和环境变量(带有验证和默认值)中读取配置的微型库。   [![godoc][D]](https://godoc.org/github.com/kkyr/fig)
- [store](https://github.com/tucnak/store) **star:271** 轻量级配置管理器。   [![godoc][D]](https://godoc.org/github.com/tucnak/store)
- [config](https://github.com/olebedev/config) **star:265** 带有环境变量和标记解析的JSON或YAML配置包装器。   [![godoc][D]](https://godoc.org/github.com/olebedev/config)
- [envconfig](https://github.com/vrischmann/envconfig) **star:234** 从环境变量中读取配置。   [![godoc][D]](https://godoc.org/github.com/vrischmann/envconfig)
- [joshbetz/config](https://github.com/joshbetz/config) **star:215** 一个可解析环境变量、JSON文件小巧的配置库，在SIGHUP时会自动重新加载。   [![godoc][D]](https://godoc.org/github.com/joshbetz/config)
- [gcfg](https://github.com/go-gcfg/gcfg) **star:164** 将ini的配置文件读入 Go structs中;支持用户定义的类型和子选项。   [![godoc][D]](https://godoc.org/github.com/go-gcfg/gcfg)
- [harvester](https://github.com/beatlabs/harvester) **star:126** Harvester, a easy to use static and dynamic configuration package supporting seeding, env vars and Consul integration.   [![近一周有更新][G]](https://github.com/beatlabs/harvester)   [![godoc][D]](https://godoc.org/github.com/beatlabs/harvester)
- [onion](https://github.com/goraz/onion) **star:113** 基于层配置的Go，支持JSON, TOML, YAML，属性，etcd, env，和加密使用PGP。   [![godoc][D]](https://godoc.org/github.com/goraz/onion)
- [envcfg](https://github.com/tomazk/envcfg) **star:100** 对环境变量进行解析，并赋值到struct。   [![近三年未更新][Y]](https://github.com/tomazk/envcfg)   [![godoc][D]](https://godoc.org/github.com/tomazk/envcfg)
- [envh](https://github.com/antham/envh) **star:96** 协助管理环境变量的Helpers。   [![godoc][D]](https://godoc.org/github.com/antham/envh)
- [configuro](https://github.com/sherifabdlnaby/configuro) **star:86** 固执己见的配置加载和验证框架从环境和文件集中到12因素兼容的应用程序。   [![godoc][D]](https://godoc.org/github.com/sherifabdlnaby/configuro)
- [configuration](https://github.com/BoRuDar/configuration) **star:83** 库，用于从环境变量、文件、标记和“默认”标记初始化配置结构。   [![godoc][D]](https://godoc.org/github.com/BoRuDar/configuration)
- [xdg](https://github.com/OpenPeeDeeP/xdg) **star:76** 遵循[XDG标准](https://standards.freedesktop.org/basedir-spec/basedir-spec-latest.html)的跨平台包。   [![godoc][D]](https://godoc.org/github.com/OpenPeeDeeP/xdg)
- [gofigure](https://github.com/ian-kent/gofigure) **star:67** 让程序配置变得简单。   [![近三年未更新][Y]](https://github.com/ian-kent/gofigure)   [![godoc][D]](https://godoc.org/github.com/ian-kent/gofigure)
- [hocon](https://github.com/gurkankaymak/hocon) **star:62** 使用HOCON(一种人类友好的JSON超集)格式的配置库，支持环境变量、引用其他值、注释和多个文件等特性。   [![godoc][D]](https://godoc.org/github.com/gurkankaymak/hocon)
- [uConfig](https://github.com/omeid/uconfig) **star:62** 轻量级、零依赖和可扩展的配置管理。   [![godoc][D]](https://godoc.org/github.com/omeid/uconfig)
- [configure](https://github.com/paked/configure) **star:56** 通过多个源提供配置，包括JSON、flags和环境变量。   [![近三年未更新][Y]](https://github.com/paked/configure)   [![godoc][D]](https://godoc.org/github.com/paked/configure)
- [go-aws-ssm](https://github.com/PaddleHQ/go-aws-ssm) **star:53** 从AWS系统管理器-参数存储中获取参数的Go包。   [![godoc][D]](https://godoc.org/github.com/PaddleHQ/go-aws-ssm)
- [go-up](https://github.com/ufoscout/go-up) **star:42** 一个简单的配置库，具有递归占位符解析功能。   [![近三年未更新][Y]](https://github.com/ufoscout/go-up)   [![godoc][D]](https://godoc.org/github.com/ufoscout/go-up)
- [env](https://github.com/junk1tm/env) **star:40** 用于将环境变量加载到结构中的轻量级包。   [![godoc][D]](https://godoc.org/github.com/junk1tm/env)
- [config](https://github.com/num30/config) **star:39** configure you app using file, environment variables, or flags in two lines of code   [![godoc][D]](https://godoc.org/github.com/num30/config)
- [ingo](https://github.com/schachmat/ingo) **star:36** flag保存在类ini的配置文件中。   [![近三年未更新][Y]](https://github.com/schachmat/ingo)   [![godoc][D]](https://godoc.org/github.com/schachmat/ingo)
- [mini](https://github.com/sasbury/mini) **star:34** 用于解析ini类型的配置文件。   [![近三年未更新][Y]](https://github.com/sasbury/mini)   [![godoc][D]](https://godoc.org/github.com/sasbury/mini)
- [genv](https://github.com/sakirsensoy/genv) **star:33** 使用dotenv支持轻松读取环境变量。   [![近三年未更新][Y]](https://github.com/sakirsensoy/genv)   [![godoc][D]](https://godoc.org/github.com/sakirsensoy/genv)
- [conflate](https://github.com/the4thamigo-uk/conflate) **star:27** 合并来自任意url的多个JSON/YAML/TOML文件、针对JSON模式的验证以及模式中定义的默认值的应用程序。   [![godoc][D]](https://godoc.org/github.com/the4thamigo-uk/conflate)
- [go-ssm-config](https://github.com/ianlopshire/go-ssm-config) **star:17** 从AWS SSM(参数存储)加载配置参数的Go实用程序。   [![godoc][D]](https://godoc.org/github.com/ianlopshire/go-ssm-config)
- [ini](https://github.com/wlevene/ini) **star:13** INI Parser & Write Library, Unmarshal to Struct,Marshal to Json,Write File,watch File。   [![godoc][D]](https://godoc.org/github.com/wlevene/ini)
- [envconf](https://github.com/ian-kent/envconf) **star:11** 从环境配置中读取配置。   [![近三年未更新][Y]](https://github.com/ian-kent/envconf)   [![godoc][D]](https://godoc.org/github.com/ian-kent/envconf)
- [nasermirzaei89/env](https://github.com/nasermirzaei89/env) **star:10** 读取环境变量的简单有用的包。   [![godoc][D]](https://godoc.org/github.com/nasermirzaei89/env)
- [go-conf](https://github.com/ThomasObenaus/go-conf) **star:9** 用于基于注释结构的应用程序配置的简单库。它支持从环境变量、配置文件和命令行参数读取配置。   [![godoc][D]](https://godoc.org/github.com/ThomasObenaus/go-conf)
- [go-ini](https://github.com/subpop/go-ini) **star:9** 一个对ini文件进行封送和解送的Go包。   [![godoc][D]](https://godoc.org/github.com/subpop/go-ini)
- [typenv](https://github.com/diegomarangoni/typenv) **star:9** 简约，零依赖，类型化环境变量库。   [![godoc][D]](https://godoc.org/github.com/diegomarangoni/typenv)
- [swap](https://github.com/oblq/swap) **star:8** 根据构建环境递归实例化/配置结构。(YAML, TOML, JSON和env)。   [![godoc][D]](https://godoc.org/github.com/oblq/swap)
- [piper](https://github.com/Yiling-J/piper) **star:7** 带有配置继承和密钥生成的Viper包装器。   [![godoc][D]](https://godoc.org/github.com/Yiling-J/piper)
- [gonfig](https://github.com/milad-abbasi/gonfig) **star:6** 基于标记的配置解析器，它将来自不同提供程序的值加载到类型安全结构中。   [![godoc][D]](https://godoc.org/github.com/milad-abbasi/gonfig)
- [nfigure](https://github.com/muir/nfigure) **star:5** Per-library struct-tag based configuration from command lines (Posix & Go-style); environment, JSON, YAML   [![近一周有更新][G]](https://github.com/muir/nfigure)   [![godoc][D]](https://godoc.org/github.com/muir/nfigure)
- [goConfig](https://github.com/crgimenes/goConfig) **star:3** 将结构体解析为输入，并用来自命令行、环境变量和配置文件的参数填充该结构体的字段。   [![godoc][D]](https://godoc.org/github.com/crgimenes/goConfig)

**[⬆ back to top](#contents)**

## 持续集成

_用于帮助进行持续集成的工具。 (翻译出错了? 试试 [英文版](README_EN.md#continuous-integration) 吧~)_

- [drone](https://github.com/drone/drone) **star:27254** Drone 是一个基于 Docker 的持续集成平台，用 Go 编写。   [![godoc][D]](https://godoc.org/github.com/drone/drone)
- [CDS](https://github.com/ovh/cds) **star:4288** 企业级CI/CD和DevOps自动化开源平台。   [![近一周有更新][G]](https://github.com/ovh/cds)   [![godoc][D]](https://godoc.org/github.com/ovh/cds)
- [woodpecker](https://github.com/woodpecker-ci/woodpecker) **star:2997** Woodpecker is a community fork of the Drone CI system.   [![近一周有更新][G]](https://github.com/woodpecker-ci/woodpecker)   [![godoc][D]](https://godoc.org/github.com/woodpecker-ci/woodpecker)
- [goveralls](https://github.com/mattn/goveralls) **star:766** Coveralls.io 是一个用 Go 编写，可持续对代码覆盖率进行检测的系统。   [![godoc][D]](https://godoc.org/github.com/mattn/goveralls)
- [gotestfmt](https://github.com/GoTestTools/gotestfmt) **star:426** 为人类测试输出。   [![godoc][D]](https://godoc.org/github.com/GoTestTools/gotestfmt)
- [overalls](https://github.com/go-playground/overalls) **star:112** 针对多package 的 Go 语言项目，可为类似 goveralls 这样的工具生成覆盖率报告。   [![近三年未更新][Y]](https://github.com/go-playground/overalls)   [![godoc][D]](https://godoc.org/github.com/go-playground/overalls)
- [duci](https://github.com/duck8823/duci) **star:74** 一个简单的 ci 服务。   [![godoc][D]](https://godoc.org/github.com/duck8823/duci)   [![归档项目][Archived]](https://github.com/duck8823/duci)
- [gomason](https://github.com/nikogura/gomason) **star:58** 在一个干净的工作区中对你的 Go 二进制文件进行测试、构建、签名和发布。   [![godoc][D]](https://godoc.org/github.com/nikogura/gomason)
- [go-test-coverage](https://github.com/vladopajic/go-test-coverage) **star:20** Tool and GitHub action which reports issues when test coverage is below set threshold.   [![godoc][D]](https://godoc.org/github.com/vladopajic/go-test-coverage)
- [roveralls](https://github.com/LawrenceWoodman/roveralls) **star:19** 递归覆盖测试工具。   [![近三年未更新][Y]](https://github.com/LawrenceWoodman/roveralls)   [![godoc][D]](https://godoc.org/github.com/LawrenceWoodman/roveralls)
- [go-fuzz-action](https://github.com/jidicula/go-fuzz-action) **star:9** Use Go 1.18's built-in fuzz testing in GitHub Actions.   [![近一周有更新][G]](https://github.com/jidicula/go-fuzz-action)

**[⬆ back to top](#contents)**

## CSS预处理器

_用于预处理CSS文件的库。 (翻译出错了? 试试 [英文版](README_EN.md#css-preprocessors) 吧~)_

- [gcss](https://github.com/yosssi/gcss) **star:483** 纯Go编写的 CSS 预处理器。   [![近三年未更新][Y]](https://github.com/yosssi/gcss)   [![godoc][D]](https://godoc.org/github.com/yosssi/gcss)
- [go-libsass](https://github.com/wellington/go-libsass) **star:198**  采用 Go封装，100% 与 Sass 兼容的 libsass 项目。

**[⬆ back to top](#contents)**

## 数据结构与算法

### Bit-packing和压缩

- [roaring](https://github.com/RoaringBitmap/roaring) **star:2140** 实现了压缩 bitsets 的Go包。   [![godoc][D]](https://godoc.org/github.com/RoaringBitmap/roaring)
- [binpacker](https://github.com/zhuangsirui/binpacker) **star:210** 帮助用户构建自定义二进制流的二进制封装器和解包器   [![godoc][D]](https://godoc.org/github.com/zhuangsirui/binpacker)
- [bit](https://github.com/yourbasic/bit) **star:151** Go 语言集合数据结构。提供了额外的位操作功能。   [![godoc][D]](https://godoc.org/github.com/yourbasic/bit)
- [crunch](https://github.com/superwhiskers/crunch) **star:88** 打包实现缓冲区，以便轻松处理各种数据类型。   [![godoc][D]](https://godoc.org/github.com/superwhiskers/crunch)
- [go-ef](https://github.com/amallia/go-ef) **star:30** 实现了 Elias-Fano 编码。   [![近三年未更新][Y]](https://github.com/amallia/go-ef)   [![godoc][D]](https://godoc.org/github.com/amallia/go-ef)
- [bingo](https://github.com/iancmcc/bingo) **star:23** 将本地类型快速、零分配、保持字典顺序的字节打包。   [![godoc][D]](https://godoc.org/github.com/iancmcc/bingo)

### 位集合

- [bitset](https://github.com/bits-and-blooms/bitset) **star:1156** 实现了 bitsets 的 Go 包。   [![godoc][D]](https://godoc.org/github.com/bits-and-blooms/bitset)
- [bitmap](https://github.com/kelindar/bitmap) **star:228** 高密度，零分配，在Go中启用simd位图/bitset。

### 布隆和布谷鸟过滤器

- [bloom](https://github.com/bits-and-blooms/bloom) **star:2038** 实现Bloom过滤器。   [![godoc][D]](https://godoc.org/github.com/bits-and-blooms/bloom)
- [boomfilters](https://github.com/tylertreat/BoomFilters) **star:1551** 用于处理连续的概率数据结构。   [![godoc][D]](https://godoc.org/github.com/tylertreat/BoomFilters)
- [cuckoofilter](https://github.com/seiflotfy/cuckoofilter) **star:1011** 布谷鸟过滤器:一个用Go实现，可替代计数 bloom 过滤器。   [![godoc][D]](https://godoc.org/github.com/seiflotfy/cuckoofilter)
- [cuckoo-filter](https://github.com/linvon/cuckoo-filter) **star:268** 布谷鸟滤波器:一种综合布谷鸟滤波器，与其他实现相比，具有可配置性和空间优化性，原论文中提到的所有特性均可获得。   [![godoc][D]](https://godoc.org/github.com/linvon/cuckoo-filter)   [![包含中文文档][CN]](https://github.com/linvon/cuckoo-filter)
- [bloom](https://github.com/zhenjl/bloom) **star:147** 在Go中实现了Bloom过滤器。   [![近三年未更新][Y]](https://github.com/zhenjl/bloom)   [![godoc][D]](https://godoc.org/github.com/zhenjl/bloom)
- [ring](https://github.com/TheTannerRyan/ring) **star:131** 高性能、线程安全的bloom过滤器。   [![近三年未更新][Y]](https://github.com/TheTannerRyan/ring)   [![godoc][D]](https://godoc.org/github.com/TheTannerRyan/ring)
- [bloom](https://github.com/yourbasic/bloom) **star:80** Golang Bloom过滤器的实现。   [![近三年未更新][Y]](https://github.com/yourbasic/bloom)   [![godoc][D]](https://godoc.org/github.com/yourbasic/bloom)
- [bloomfilter](https://github.com/OldPanda/bloomfilter) **star:13** 另一个在Go中的Bloomfilter实现，与Java的番石榴库兼容。   [![godoc][D]](https://godoc.org/github.com/OldPanda/bloomfilter)

### 数据结构和算法集合

- [gods](https://github.com/emirpasic/gods) **star:14328** 数据结构。容器、集合、列表、堆栈、地图、BidiMaps、树、HashSet等。   [![godoc][D]](https://godoc.org/github.com/emirpasic/gods)
- [go-datastructures](https://github.com/Workiva/go-datastructures) **star:7165** 可靠的、高性能的和线程安全的数据结构的集合。   [![近一周有更新][G]](https://github.com/Workiva/go-datastructures)   [![godoc][D]](https://godoc.org/github.com/Workiva/go-datastructures)
- [gostl](https://github.com/liyue201/gostl) **star:925** 用于go的数据结构和算法库，旨在提供类似c++ STL的函数。   [![godoc][D]](https://godoc.org/github.com/liyue201/gostl)
- [algorithms](https://github.com/shady831213/algorithms) **star:742** 算法和数据结构。来源于CLRS。   [![godoc][D]](https://godoc.org/github.com/shady831213/algorithms)

### 迭代器

- [iter](https://github.com/disksing/iter) **star:181** Go实现的c++ STL迭代器和算法。   [![godoc][D]](https://godoc.org/github.com/disksing/iter)   [![包含中文文档][CN]](https://github.com/disksing/iter)
- [goterator](https://github.com/yaa110/goterator) **star:14** 迭代器实现，提供映射和减少功能。   [![godoc][D]](https://godoc.org/github.com/yaa110/goterator)

### 地图

See also [Database](#database) for more complex key-value stores, and [Trees](#trees) for
additional ordered map implementations.

- [cmap](https://github.com/lrita/cmap) **star:64** 一个线程安全的go map   [![godoc][D]](https://godoc.org/github.com/lrita/cmap)
- [dict](https://github.com/srfrog/dict) **star:41** 实现类似 python dict的功能(dict)。   [![godoc][D]](https://godoc.org/github.com/srfrog/dict)
- [goradd/maps](https://github.com/goradd/maps) **star:23** Go 1.18+ generic map interface for maps; safe maps; ordered maps; ordered, safe maps; etc.   [![godoc][D]](https://godoc.org/github.com/goradd/maps)

### 杂项数据结构和算法

- [gota](https://github.com/kniren/gota) **star:2740** 实现了数据帧，序列以及数据噪音。   [![godoc][D]](https://godoc.org/github.com/kniren/gota)
- [hyperloglog](https://github.com/axiomhq/hyperloglog) **star:872** HyperLogLog implementation with Sparse, LogLog-Beta bias correction and TailCut space reduction.   [![godoc][D]](https://godoc.org/github.com/axiomhq/hyperloglog)
- [go-geoindex](https://github.com/hailocab/go-geoindex) **star:351** 基于内存的地理索引。   [![近三年未更新][Y]](https://github.com/hailocab/go-geoindex)   [![godoc][D]](https://godoc.org/github.com/hailocab/go-geoindex)
- [hilbert](https://github.com/google/hilbert) **star:267** 用于映射空间填充曲线（例如 Hilbert 曲线和 Peano 曲线）和数值。   [![godoc][D]](https://godoc.org/github.com/google/hilbert)
- [go-rquad](https://github.com/aurelien-rainone/go-rquad) **star:126** 区域四叉树具有高效的点定位和邻域查找功能。   [![godoc][D]](https://godoc.org/github.com/aurelien-rainone/go-rquad)
- [conjungo](https://github.com/InVisionApp/conjungo) **star:116** 一个小型、强大和灵活的合并库。   [![godoc][D]](https://godoc.org/github.com/InVisionApp/conjungo)
- [go-rampart](https://github.com/francesconi/go-rampart) **star:90** Determine how intervals relate to each other.   [![godoc][D]](https://godoc.org/github.com/francesconi/go-rampart)
- [gogu](https://github.com/esimov/gogu) **star:82** A comprehensive, reusable and efficient concurrent-safe generics utility functions and data structures library.   [![godoc][D]](https://godoc.org/github.com/esimov/gogu)
- [go-tuple](https://github.com/barweiss/go-tuple) **star:66** Go 1.18+的通用元组实现。   [![godoc][D]](https://godoc.org/github.com/barweiss/go-tuple)
- [count-min-log](https://github.com/seiflotfy/count-min-log) **star:64** Go实现Count-Min-log sketch的功能 : 使用近似计数器进行近似计数(类似Count-Min sketch，但使用更少内存)。   [![近三年未更新][Y]](https://github.com/seiflotfy/count-min-log)   [![godoc][D]](https://godoc.org/github.com/seiflotfy/count-min-log)
- [hide](https://github.com/emvi/hide) **star:56** ID type with marshalling to/from hash to prevent sending IDs to clients.   [![godoc][D]](https://godoc.org/github.com/emvi/hide)
- [concurrent-writer](https://github.com/free/concurrent-writer) **star:51** 具备高并发能力，可替换 bufio.Writer。   [![近三年未更新][Y]](https://github.com/free/concurrent-writer)   [![godoc][D]](https://godoc.org/github.com/free/concurrent-writer)
- [fsm](https://github.com/cocoonspace/fsm) **star:47** 有限状态机包。   [![godoc][D]](https://godoc.org/github.com/cocoonspace/fsm)
- [genfuncs](https://github.com/nwillc/genfuncs) **star:45** Go 1.18+ generics package inspired by Kotlin's Sequence and Map.   [![godoc][D]](https://godoc.org/github.com/nwillc/genfuncs)
- [go18ds](https://github.com/daichi-m/go18ds) **star:34** Go Data Structures using Go 1.18 generics.   [![godoc][D]](https://godoc.org/github.com/daichi-m/go18ds)
- [go-generics](https://github.com/bobg/go-generics) **star:33** Generic slice, map, set, iterator, and goroutine utilities.   [![godoc][D]](https://godoc.org/github.com/bobg/go-generics)
- [quadtree](https://github.com/s0rg/quadtree) **star:27** Generic, zero-alloc, 100%-test covered quadtree.   [![godoc][D]](https://godoc.org/github.com/s0rg/quadtree)
- [gofal](https://github.com/xxjwxc/gofal) **star:17** 基于 Go 实现的分数计算。包含分子、分母运算    [![近三年未更新][Y]](https://github.com/xxjwxc/gofal)   [![godoc][D]](https://godoc.org/github.com/xxjwxc/gofal)   [![包含中文文档][CN]](https://github.com/xxjwxc/gofal)
- [slices](https://github.com/srfrog/slices) **star:15** 对片进行操作的函数;类似于“包字符串”，但适用于使用片。   [![godoc][D]](https://godoc.org/github.com/srfrog/slices)
- [slices](https://github.com/twharmon/slices) **star:13** Pure, generic functions for slices.   [![godoc][D]](https://godoc.org/github.com/twharmon/slices)

### 可空类型

- [nan](https://github.com/kak-tus/nan) **star:77** 一个库中的可零分配空结构，具有方便的转换函数、编组器和解组器。   [![godoc][D]](https://godoc.org/github.com/kak-tus/nan)
- [typ](https://github.com/gurukami/typ) **star:43** 从复杂结构中获取值，支持空类型、安全的类型转换。   [![godoc][D]](https://godoc.org/github.com/gurukami/typ)
- [null](https://github.com/emvi/null) **star:32** 对空的 Go 数据类型也可以进行JSON进行解析/反解析。   [![godoc][D]](https://godoc.org/github.com/emvi/null)

### 队列

- [deque](https://github.com/gammazero/deque) **star:490** 快速环缓冲区deque(双端队列)。   [![godoc][D]](https://godoc.org/github.com/gammazero/deque)
- [goconcurrentqueue](https://github.com/enriquebris/goconcurrentqueue) **star:318** 并行FIFO队列。   [![godoc][D]](https://godoc.org/github.com/enriquebris/goconcurrentqueue)
- [queue](https://github.com/adrianbrad/queue) **star:191** Multiple thread-safe, generic queue implementations for Go.   [![近一周有更新][G]](https://github.com/adrianbrad/queue)   [![godoc][D]](https://godoc.org/github.com/adrianbrad/queue)
- [deque](https://github.com/edwingeng/deque) **star:139** 高度优化的双端队列。   [![近一周有更新][G]](https://github.com/edwingeng/deque)   [![godoc][D]](https://godoc.org/github.com/edwingeng/deque)
- [memlog](https://github.com/embano1/memlog) **star:102** 受Apache Kafka启发，一个易于使用、轻量级、线程安全、只追加内存数据结构。   [![godoc][D]](https://godoc.org/github.com/embano1/memlog)

### 集

- [golang-set](https://github.com/deckarep/golang-set) **star:3479** 线程安全和非线程安全的高性能集。   [![近一周有更新][G]](https://github.com/deckarep/golang-set)   [![godoc][D]](https://godoc.org/github.com/deckarep/golang-set)
- [goset](https://github.com/zoumo/goset) **star:51** 一个有用的Go集合实现。   [![godoc][D]](https://godoc.org/github.com/zoumo/goset)
- [set](https://github.com/StudioSol/set) **star:23** 使用LinkedHashMap在Go中实现简单的set数据结构。   [![godoc][D]](https://godoc.org/github.com/StudioSol/set)
- [dsu](https://github.com/ihebu/dsu) **star:12** 在Go中实现离散集数据结构。   [![godoc][D]](https://godoc.org/github.com/ihebu/dsu)

### 文本分析

- [bleve](https://github.com/blevesearch/bleve) **star:9266** 基于 Go 的现代文本索引库。   [![近一周有更新][G]](https://github.com/blevesearch/bleve)   [![godoc][D]](https://godoc.org/github.com/blevesearch/bleve)
- [trie](https://github.com/derekparker/trie) **star:679** 在Go中实现Trie。   [![godoc][D]](https://godoc.org/github.com/derekparker/trie)
- [go-edlib](https://github.com/hbollon/go-edlib) **star:402** Go字符串比较和编辑距离算法库(Levenshtein, LCS, Hamming, Damerau Levenshtein, Jaro-Winkler等)兼容Unicode。   [![godoc][D]](https://godoc.org/github.com/hbollon/go-edlib)
- [go-adaptive-radix-tree](https://github.com/plar/go-adaptive-radix-tree) **star:301** 自适应基数树。   [![godoc][D]](https://godoc.org/github.com/plar/go-adaptive-radix-tree)
- [levenshtein](https://github.com/agnivade/levenshtein) **star:297** 实现在Go中计算levenshtein距离。   [![godoc][D]](https://godoc.org/github.com/agnivade/levenshtein)
- [levenshtein](https://github.com/agext/levenshtein) **star:78** Levenshtein distance and similarity metrics with customizable edit costs and Winkler-like bonus for common prefix.   [![godoc][D]](https://godoc.org/github.com/agext/levenshtein)
- [ptrie](https://github.com/viant/ptrie) **star:33** 前缀树的一种实现。   [![godoc][D]](https://godoc.org/github.com/viant/ptrie)
- [mspm](https://github.com/BlackRabbitt/mspm) **star:24** 用于信息检索的多字符串模式匹配算法。   [![近三年未更新][Y]](https://github.com/BlackRabbitt/mspm)   [![godoc][D]](https://godoc.org/github.com/BlackRabbitt/mspm)
- [parsefields](https://github.com/MonaxGT/parsefields) **star:7** 用于解析类似json的日志的工具，用于收集惟一的字段和事件。   [![近三年未更新][Y]](https://github.com/MonaxGT/parsefields)   [![godoc][D]](https://godoc.org/github.com/MonaxGT/parsefields)

### 树

- [hashsplit](http://github.com/bobg/hashsplit)  将字节流分割成块，并将块排列成树，边界由内容而不是位置决定。
- [skiplist](https://github.com/MauriceGit/skiplist) **star:256** 高性能的 Go 跳表实现。   [![godoc][D]](https://godoc.org/github.com/MauriceGit/skiplist)
- [skiplist](https://github.com/gansidui/skiplist) **star:83** 在Go中实现了跳表。   [![近三年未更新][Y]](https://github.com/gansidui/skiplist)   [![godoc][D]](https://godoc.org/github.com/gansidui/skiplist)
- [treemap](https://github.com/igrmk/treemap) **star:48** 在底层使用红黑树的通用键排序地图。   [![godoc][D]](https://godoc.org/github.com/igrmk/treemap)
- [treap](https://github.com/perdata/treap) **star:22** 使用树堆进行持久、快速有序的映射。   [![近三年未更新][Y]](https://github.com/perdata/treap)   [![godoc][D]](https://godoc.org/github.com/perdata/treap)
- [merkle](https://github.com/bobg/merkle) **star:11** 默克尔根哈希的空间高效计算和包含证明。   [![godoc][D]](https://godoc.org/github.com/bobg/merkle)

### 管道

- [pipeline](https://github.com/hyfather/pipeline) **star:50** 实现了 fan-in 和 fan-out 的管道功能。   [![godoc][D]](https://godoc.org/github.com/hyfather/pipeline)
- [ordered-concurrently](https://github.com/tejzpr/ordered-concurrently) **star:24** Go模块，处理并发工作，并在通道中返回输入顺序的输出。   [![godoc][D]](https://godoc.org/github.com/tejzpr/ordered-concurrently)
- [parapipe](https://github.com/nazar256/parapipe) **star:24** FIFO管道，并行执行在每个阶段，同时保持消息和结果的顺序。   [![godoc][D]](https://godoc.org/github.com/nazar256/parapipe)

**[⬆ back to top](#contents)**

## 数据库

### 缓存

_具有过期记录的数据存储、内存中的分布式数据存储或基于文件的数据库的内存子集。 (翻译出错了? 试试 [英文版](README_EN.md#caches) 吧~)_

- [groupcache](https://github.com/golang/groupcache) **star:12309** Groupcache是一个缓存和缓存填充库，在许多情况下，它是memcached的替代品。   [![godoc][D]](https://godoc.org/github.com/golang/groupcache)
- [BigCache](https://github.com/allegro/bigcache) **star:6780** 高效的键/值缓存为千兆字节的数据。   [![近一周有更新][G]](https://github.com/allegro/bigcache)   [![godoc][D]](https://godoc.org/github.com/allegro/bigcache)
- [GCache](https://github.com/bluele/gcache) **star:2432** 支持过期缓存、LFU、LRU和ARC的缓存库。   [![godoc][D]](https://godoc.org/github.com/bluele/gcache)
- [cache2go](https://github.com/muesli/cache2go) **star:2008** 基于内存的 K/V 缓存，支持超时的自动失效。   [![godoc][D]](https://godoc.org/github.com/muesli/cache2go)
- [gocache](https://github.com/eko/gocache) **star:1950** A complete Go cache library with multiple stores (memory, memcache, redis, ...), chainable, loadable, metrics cache and more.   [![近一周有更新][G]](https://github.com/eko/gocache)   [![godoc][D]](https://godoc.org/github.com/eko/gocache)
- [fastcache](https://github.com/VictoriaMetrics/fastcache) **star:1848** 基于内存的快速线程安全的缓存，可缓存大量的条目。最大限度地减少GC开销。   [![godoc][D]](https://godoc.org/github.com/VictoriaMetrics/fastcache)
- [ttlcache](https://github.com/jellydator/ttlcache) **star:712** 具有项目过期和泛型的内存缓存。   [![近一周有更新][G]](https://github.com/jellydator/ttlcache)   [![godoc][D]](https://godoc.org/github.com/jellydator/ttlcache)
- [cachego](https://github.com/faabiosr/cachego) **star:294** 基于多个驱动程序的缓存组件。   [![godoc][D]](https://godoc.org/github.com/faabiosr/cachego)
- [cache](https://github.com/akyoto/cache) **star:150** 基于内存的 K/V 存储:带生命周期的值存储，0个依赖项，<100 LoC, 100%覆盖率。   [![godoc][D]](https://godoc.org/github.com/akyoto/cache)
- [remember-go](https://github.com/rocketlaunchr/remember-go) **star:135** 用于缓存慢速数据库查询的通用接口(支持redis、memcached、ristretto或in-memory)。   [![godoc][D]](https://godoc.org/github.com/rocketlaunchr/remember-go)
- [bcache](https://github.com/iwanbk/bcache) **star:127** Eventually consistent distributed in-memory cache Go library.   [![godoc][D]](https://godoc.org/github.com/iwanbk/bcache)
- [go-cache](https://github.com/viney-shih/go-cache) **star:113** A flexible multi-layer Go caching library to deal with in-memory and shared cache by adopting Cache-Aside pattern.   [![godoc][D]](https://godoc.org/github.com/viney-shih/go-cache)
- [theine](https://github.com/Yiling-J/theine-go) **star:110** High performance, near optimal in-memory cache with proactive TTL expiration and generics.   [![godoc][D]](https://godoc.org/github.com/Yiling-J/theine-go)
- [imcache](https://github.com/erni27/imcache) **star:90** A generic in-memory cache Go library. It supports expiration, sliding expiration, max entries limit, eviction callbacks and sharding.   [![godoc][D]](https://godoc.org/github.com/erni27/imcache)
- [go-mcache](https://github.com/OrlovEvgeny/go-mcache) **star:89** 基于内存的实现了高性能的key:value存储库。指针缓存。   [![近三年未更新][Y]](https://github.com/OrlovEvgeny/go-mcache)   [![godoc][D]](https://godoc.org/github.com/OrlovEvgeny/go-mcache)
- [timedmap](https://github.com/zekroTJA/timedmap) **star:66** 实现了有生命周期的键值对Map。   [![godoc][D]](https://godoc.org/github.com/zekroTJA/timedmap)
- [couchcache](https://github.com/codingsince1985/couchcache) **star:60** 由 Couchbase服务 支持的RESTful缓存微服务。   [![godoc][D]](https://godoc.org/github.com/codingsince1985/couchcache)
- [clusteredBigCache](https://github.com/oaStuff/clusteredBigCache) **star:43** BigCache 支持集群和独立且生命周期存储项。   [![近三年未更新][Y]](https://github.com/oaStuff/clusteredBigCache)   [![godoc][D]](https://godoc.org/github.com/oaStuff/clusteredBigCache)
- [2q](https://github.com/floatdrop/2q) **star:29** 2Q内存缓存实现。   [![godoc][D]](https://godoc.org/github.com/floatdrop/2q)
- [gdcache](https://github.com/ulovecode/gdcache) **star:10** 一个由golang实现的纯非侵入式缓存库，您可以使用它来实现您自己的分布式缓存。   [![godoc][D]](https://godoc.org/github.com/ulovecode/gdcache)   [![包含中文文档][CN]](https://github.com/ulovecode/gdcache)
- [ttlcache](https://github.com/cheshir/ttlcache) **star:9** 内存键值存储与TTL为每个记录。   [![godoc][D]](https://godoc.org/github.com/cheshir/ttlcache)
- [nscache](https://github.com/no-src/nscache) **star:5** A Go caching framework that supports multiple data source drivers.   [![近一周有更新][G]](https://github.com/no-src/nscache)   [![godoc][D]](https://godoc.org/github.com/no-src/nscache)
- [gocache](https://github.com/yuseferi/gocache) **star:3** A data race free Go ache library with high performance and auto pruge functionality   [![godoc][D]](https://godoc.org/github.com/yuseferi/gocache)

### Go中实现的数据库

- [prometheus](https://github.com/prometheus/prometheus) **star:49860** 用于监控系统和时序的数据库。   [![近一周有更新][G]](https://github.com/prometheus/prometheus)   [![godoc][D]](https://godoc.org/github.com/prometheus/prometheus)
- [tidb](https://github.com/pingcap/tidb) **star:34819** TiDB是一个分布式SQL数据库。灵感来自谷歌F1的设计。   [![近一周有更新][G]](https://github.com/pingcap/tidb)   [![godoc][D]](https://godoc.org/github.com/pingcap/tidb)   [![包含中文文档][CN]](https://github.com/pingcap/tidb)
- [cockroach](https://github.com/cockroachdb/cockroach) **star:27774** 可伸缩、区域备份、事务性数据存储。   [![近一周有更新][G]](https://github.com/cockroachdb/cockroach)   [![godoc][D]](https://godoc.org/github.com/cockroachdb/cockroach)
- [influxdb](https://github.com/influxdb/influxdb) **star:26083** 可伸缩的数据存储，用于指标衡量、事件和实时分析。   [![近一周有更新][G]](https://github.com/influxdb/influxdb)   [![godoc][D]](https://godoc.org/github.com/influxdb/influxdb)
- [Milvus](https://github.com/milvus-io/milvus) **star:22868** Milvus是一个矢量数据库，用于嵌入管理、分析和搜索。   [![近一周有更新][G]](https://github.com/milvus-io/milvus)   [![godoc][D]](https://godoc.org/github.com/milvus-io/milvus)
- [dgraph](https://github.com/dgraph-io/dgraph) **star:19592** 可伸缩、分布式、低延迟、高吞吐量的图形数据库。   [![近一周有更新][G]](https://github.com/dgraph-io/dgraph)   [![godoc][D]](https://godoc.org/github.com/dgraph-io/dgraph)
- [dolt](https://github.com/dolthub/dolt) **star:15519** Dolt – It's Git for Data.   [![近一周有更新][G]](https://github.com/dolthub/dolt)   [![godoc][D]](https://godoc.org/github.com/dolthub/dolt)
- [rqlite](https://github.com/rqlite/rqlite) **star:14003** 基于SQLite的轻量级分布式关系数据库。   [![近一周有更新][G]](https://github.com/rqlite/rqlite)   [![godoc][D]](https://godoc.org/github.com/rqlite/rqlite)
- [badger](https://github.com/dgraph-io/badger) **star:12745** 快速 K/V 存储。   [![近一周有更新][G]](https://github.com/dgraph-io/badger)   [![godoc][D]](https://godoc.org/github.com/dgraph-io/badger)
- [VictoriaMetrics](https://github.com/VictoriaMetrics/VictoriaMetrics) **star:9269** 开源，快速，可伸缩的时间序列数据库。支持PromQL。   [![近一周有更新][G]](https://github.com/VictoriaMetrics/VictoriaMetrics)   [![godoc][D]](https://godoc.org/github.com/VictoriaMetrics/VictoriaMetrics)
- [immudb](https://github.com/codenotary/immudb) **star:8355** immudb是一个轻量级、高速、不可变的数据库，用于用Go编写的系统和应用程序。   [![近一周有更新][G]](https://github.com/codenotary/immudb)   [![godoc][D]](https://godoc.org/github.com/codenotary/immudb)
- [bbolt](https://github.com/etcd-io/bbolt) **star:6874** 一个用于Go的嵌入式键/值数据库。   [![近一周有更新][G]](https://github.com/etcd-io/bbolt)   [![godoc][D]](https://godoc.org/github.com/etcd-io/bbolt)
- [Bitcask](https://git.mills.io/prologic/bitcask)  Bitcask是一个可嵌入的、持久的、快速的键值(KV)数据库，使用纯Go编写，具有可预测的读写性能、低延迟和高吞吐量，这得益于Bitcask的磁盘布局(LSM+WAL)。
- [goleveldb](https://github.com/syndtr/goleveldb) **star:5834** 在Go中实现[LevelDB](https://github.com/google/leveldb) key/value数据库。   [![godoc][D]](https://godoc.org/github.com/syndtr/goleveldb)
- [buntdb](https://github.com/tidwall/buntdb) **star:4200** 基于内存的K/V，快速，可嵌入的数据库，可自定义索引和空间支持。   [![godoc][D]](https://godoc.org/github.com/tidwall/buntdb)
- [ledisdb](https://github.com/siddontang/ledisdb) **star:4003** Ledisdb是一种高性能的NoSQL，类似于基于LevelDB的Redis。   [![godoc][D]](https://godoc.org/github.com/siddontang/ledisdb)
- [rosedb](https://github.com/roseduan/rosedb) **star:3990** 基于LSM+WAL的嵌入式k-v数据库，支持string、list、hash、set、zset。   [![近一周有更新][G]](https://github.com/roseduan/rosedb)   [![godoc][D]](https://godoc.org/github.com/roseduan/rosedb)   [![包含中文文档][CN]](https://github.com/roseduan/rosedb)
- [nutsdb](https://github.com/xujiajun/nutsdb) **star:3004** Nutsdb is a simple, fast, embeddable, persistent key/value store written in pure Go. It supports fully serializable transactions and many data structures such as list, set, sorted set.   [![godoc][D]](https://godoc.org/github.com/xujiajun/nutsdb)   [![包含中文文档][CN]](https://github.com/xujiajun/nutsdb)
- [godis](https://github.com/hdt3213/godis) **star:2994** 一个Golang实现了高性能Redis服务器和集群。   [![近一周有更新][G]](https://github.com/hdt3213/godis)   [![godoc][D]](https://godoc.org/github.com/hdt3213/godis)   [![包含中文文档][CN]](https://github.com/hdt3213/godis)
- [tiedot](https://github.com/HouzuoGuo/tiedot) **star:2716** 属于你的NoSQL数据库。   [![godoc][D]](https://godoc.org/github.com/HouzuoGuo/tiedot)
- [lotusdb](https://github.com/flower-corp/lotusdb) **star:1587** 快速k/v数据库兼容lsm和b+树。   [![近一周有更新][G]](https://github.com/flower-corp/lotusdb)   [![godoc][D]](https://godoc.org/github.com/flower-corp/lotusdb)
- [CovenantSQL](https://github.com/CovenantSQL/CovenantSQL) **star:1451** 区块链领域的一个SQL数据库。   [![godoc][D]](https://godoc.org/github.com/CovenantSQL/CovenantSQL)
- [diskv](https://github.com/peterbourgon/diskv) **star:1292** 支持磁盘备份的可持久化 K/V 存储。   [![godoc][D]](https://godoc.org/github.com/peterbourgon/diskv)
- [column](https://github.com/kelindar/column) **star:1288** 高性能、柱状、可嵌入的内存存储，具有位图索引和事务。   [![godoc][D]](https://godoc.org/github.com/kelindar/column)
- [Databunker](https://github.com/paranoidguy/databunker) **star:1118** 个人身份信息(PII)存储服务符合GDPR和CCPA。   [![godoc][D]](https://godoc.org/github.com/paranoidguy/databunker)
- [pogreb](https://github.com/akrylysov/pogreb) **star:1118** 针对大量读取工作负载的嵌入式键值存储。   [![godoc][D]](https://godoc.org/github.com/akrylysov/pogreb)
- [eliasdb](https://github.com/krotik/eliasdb) **star:980** 无其他依赖项，支持REST API，短语搜索和sql类似的查询语言的事务图数据库。   [![godoc][D]](https://godoc.org/github.com/krotik/eliasdb)
- [moss](https://github.com/couchbase/moss) **star:931** Moss是一个用100% Go编写的简单LSM键值存储引擎。   [![godoc][D]](https://godoc.org/github.com/couchbase/moss)
- [objectbox-go](https://github.com/objectbox/objectbox-go) **star:913** High-performance embedded Object Database (NoSQL) with Go API.   [![godoc][D]](https://godoc.org/github.com/objectbox/objectbox-go)
- [clover](https://github.com/ostafen/clover) **star:468** 一个轻量级的面向文档的NoSQL数据库编写纯Golang。   [![近一周有更新][G]](https://github.com/ostafen/clover)   [![godoc][D]](https://godoc.org/github.com/ostafen/clover)
- [levigo](https://github.com/jmhodges/levigo) **star:416** 实现了对LevelDB封装。   [![godoc][D]](https://godoc.org/github.com/jmhodges/levigo)
- [pudge](https://github.com/recoilme/pudge) **star:345** 使用Go的标准库编写的快捷、简单的键/值存储。   [![godoc][D]](https://godoc.org/github.com/recoilme/pudge)
- [Vasto](https://github.com/chrislusf/vasto) **star:249** 分布式高性能键值存储。可做磁盘备份。最终一致。高可用。能够在不中断服务的情况下增长或收缩。   [![近三年未更新][Y]](https://github.com/chrislusf/vasto)   [![godoc][D]](https://godoc.org/github.com/chrislusf/vasto)
- [dtf](https://github.com/dtm-labs/dtf) **star:217** 分布式事务管理器。支持XA, TCC, SAGA，可靠消息。   [![godoc][D]](https://godoc.org/github.com/dtm-labs/dtf)   [![包含中文文档][CN]](https://github.com/dtm-labs/dtf)   [![归档项目][Archived]](https://github.com/dtm-labs/dtf)
- [piladb](https://github.com/fern4lvarez/piladb) **star:201** 基于堆栈数据结构的轻量级RESTful数据库引擎。   [![godoc][D]](https://godoc.org/github.com/fern4lvarez/piladb)
- [libradb](https://github.com/amit-davidson/LibraDB) **star:112** LibraDB is a simple database with less then 1000 lines of code for learning.   [![godoc][D]](https://godoc.org/github.com/amit-davidson/LibraDB)
- [unitdb](https://github.com/unit-io/unitdb) **star:111** Fast timeseries database for IoT, realtime messaging applications. Access unitdb with pubsub over tcp or websocket using github.com/unit-io/unitd application.   [![godoc][D]](https://godoc.org/github.com/unit-io/unitdb)
- [hare](https://github.com/jameycribbs/hare) **star:79** 一个简单的数据库管理系统，将每个表存储为一行分隔的JSON文本文件。   [![godoc][D]](https://godoc.org/github.com/jameycribbs/hare)
- [regatta](https://github.com/jamf/regatta) **star:56** Fast, simple, geo-distributed KV store built for cloud native era.   [![近一周有更新][G]](https://github.com/jamf/regatta)   [![godoc][D]](https://godoc.org/github.com/jamf/regatta)
- [Coffer](https://github.com/claygod/coffer) **star:34** 支持事务的简单ACID键值数据库。   [![godoc][D]](https://godoc.org/github.com/claygod/coffer)
- [tempdb](https://github.com/rafaeljesus/tempdb) **star:17** 用于临时数据存放的 K/V 存储。   [![近三年未更新][Y]](https://github.com/rafaeljesus/tempdb)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/tempdb)

### 数据库模式迁移

- [migrate](https://github.com/golang-migrate/migrate) **star:12216** 基于CLI的数据库迁移库。   [![近一周有更新][G]](https://github.com/golang-migrate/migrate)   [![godoc][D]](https://godoc.org/github.com/golang-migrate/migrate)
- [bytebase](https://github.com/bytebase/bytebase) **star:6808** Safe database schema change and version control for DevOps teams.   [![近一周有更新][G]](https://github.com/bytebase/bytebase)   [![godoc][D]](https://godoc.org/github.com/bytebase/bytebase)
- [goose](https://github.com/pressly/goose) **star:4348** 数据库迁移工具。您可以通过创建增量SQL或Go脚本来管理数据库的升级。   [![近一周有更新][G]](https://github.com/pressly/goose)   [![godoc][D]](https://godoc.org/github.com/pressly/goose)
- [dbmate](https://github.com/amacneil/dbmate) **star:3677** A lightweight, framework-agnostic database migration tool.   [![近一周有更新][G]](https://github.com/amacneil/dbmate)   [![godoc][D]](https://godoc.org/github.com/amacneil/dbmate)
- [atlas](https://github.com/ariga/atlas) **star:3627** 一个数据库工具箱。旨在帮助企业更好地处理数据的CLI。   [![近一周有更新][G]](https://github.com/ariga/atlas)   [![godoc][D]](https://godoc.org/github.com/ariga/atlas)
- [sql-migrate](https://github.com/rubenv/sql-migrate) **star:2933** 数据库迁移工具。允许使用go-bindata将迁移嵌入到应用程序中。   [![godoc][D]](https://godoc.org/github.com/rubenv/sql-migrate)
- [skeema](https://github.com/skeema/skeema) **star:1167** 用于MySQL的纯sql模式管理系统，支持分片和外部在线模式更改工具。   [![近一周有更新][G]](https://github.com/skeema/skeema)   [![godoc][D]](https://godoc.org/github.com/skeema/skeema)
- [soda](https://github.com/gobuffalo/pop/tree/master/soda)  数据库迁移、创建、ORM等。用于MySQL、PostgreSQL和SQLite。
- [gormigrate](https://github.com/go-gormigrate/gormigrate) **star:930** 面向Gorm ORM的数据库 schema 迁移辅助程序。   [![近一周有更新][G]](https://github.com/go-gormigrate/gormigrate)   [![godoc][D]](https://godoc.org/github.com/go-gormigrate/gormigrate)
- [goavro](https://github.com/linkedin/goavro) **star:914** 一个对Avro数据进行编码和解码的Go包。   [![godoc][D]](https://godoc.org/github.com/linkedin/goavro)
- [migrator](https://github.com/lopezator/migrator) **star:156** 非常简单的 Go 数据库迁移库。   [![godoc][D]](https://godoc.org/github.com/lopezator/migrator)
- [darwin](https://github.com/GuiaBolso/darwin) **star:137** 用于数据库 schema 升级的库。   [![godoc][D]](https://godoc.org/github.com/GuiaBolso/darwin)
- [go-pg-migrations](https://github.com/robinjoseph08/go-pg-migrations) **star:83** 用Go -pg/pg编写的迁移包。   [![godoc][D]](https://godoc.org/github.com/robinjoseph08/go-pg-migrations)
- [sqlize](https://github.com/sunary/sqlize) **star:68** 数据库迁移生成器。允许生成sql迁移从模型和现有的sql不同。   [![godoc][D]](https://godoc.org/github.com/sunary/sqlize)
- [avro](https://github.com/khezen/avro) **star:43** 发现SQL schemas并将其转换为AVRO schemas。   [![godoc][D]](https://godoc.org/github.com/khezen/avro)
- [schema](https://github.com/adlio/schema) **star:30** 库，用于将数据库/sql兼容数据库的模式迁移嵌入到Go二进制文件中。   [![godoc][D]](https://godoc.org/github.com/adlio/schema)
- [go-fixtures](https://github.com/RichardKnop/go-fixtures) **star:28** 类似 Django fixture，用于 Go 建立内置数据库/sql库。   [![近三年未更新][Y]](https://github.com/RichardKnop/go-fixtures)   [![godoc][D]](https://godoc.org/github.com/RichardKnop/go-fixtures)
- [migrator](https://github.com/larapulse/migrator) **star:24** MySQL数据库迁移器设计用于运行到您的特性的迁移，并管理数据库模式更新与直观的go代码。   [![godoc][D]](https://godoc.org/github.com/larapulse/migrator)
- [libschema](https://github.com/muir/libschema) **star:13** Define your migrations separately in each library. Migrations for open source libraries. MySQL & PostgreSQL.   [![godoc][D]](https://godoc.org/github.com/muir/libschema)
- [go-pg-migrate](https://github.com/lawzava/go-pg-migrate) **star:11** 用于go-pg迁移管理的cli友好包。   [![godoc][D]](https://godoc.org/github.com/lawzava/go-pg-migrate)
- [gorm-seeder](https://github.com/Kachit/gorm-seeder) **star:10** Simple database seeder for Gorm ORM.   [![godoc][D]](https://godoc.org/github.com/Kachit/gorm-seeder)
- [godfish](https://github.com/rafaelespinoza/godfish) **star:5** 数据库迁移管理器，使用本地查询语言。支持cassandra, mysql, postgres, sqlite3。   [![godoc][D]](https://godoc.org/github.com/rafaelespinoza/godfish)

### 数据库工具

- [vitess](https://github.com/youtube/vitess) **star:16756** vitess提供了可以为大规模web服务扩展MySQL数据库提供便利的服务和工具。   [![近一周有更新][G]](https://github.com/youtube/vitess)   [![godoc][D]](https://godoc.org/github.com/youtube/vitess)
- [pgweb](https://github.com/sosedoff/pgweb) **star:8039** 基于web的PostgreSQL数据库浏览器。   [![近一周有更新][G]](https://github.com/sosedoff/pgweb)   [![godoc][D]](https://godoc.org/github.com/sosedoff/pgweb)
- [kingshard](https://github.com/flike/kingshard) **star:6256** kingshard 是基于 Golang 的MySQL高性能代理。   [![godoc][D]](https://godoc.org/github.com/flike/kingshard)   [![包含中文文档][CN]](https://github.com/flike/kingshard)
- [orchestrator](https://github.com/github/orchestrator) **star:5152** MySQL复制拓扑管理器和可视化工具。   [![godoc][D]](https://godoc.org/github.com/github/orchestrator)
- [go-mysql](https://github.com/siddontang/go-mysql) **star:4211**  Go 工具集，用于处理MySQL协议和复制。   [![近一周有更新][G]](https://github.com/siddontang/go-mysql)   [![godoc][D]](https://godoc.org/github.com/siddontang/go-mysql)
- [go-mysql-elasticsearch](https://github.com/siddontang/go-mysql-elasticsearch) **star:3999** 自动将MySQL数据同步到Elasticsearch中。   [![godoc][D]](https://godoc.org/github.com/siddontang/go-mysql-elasticsearch)
- [hasql](https://golang.yandex/hasql)  用于访问多主机SQL数据库安装的库。
- [pREST](https://github.com/prest/prest) **star:3888** 简化和加速开发,⚡即时、实时、高性能在任何Postgres应用,现有的或新的。   [![近一周有更新][G]](https://github.com/prest/prest)   [![godoc][D]](https://godoc.org/github.com/prest/prest)
- [chproxy](https://github.com/Vertamedia/chproxy) **star:1136** ClickHouse数据库的HTTP代理。   [![godoc][D]](https://godoc.org/github.com/Vertamedia/chproxy)
- [pg_timetable](https://github.com/cybertec-postgresql/pg_timetable) **star:901** 高级调度为PostgreSQL。   [![近一周有更新][G]](https://github.com/cybertec-postgresql/pg_timetable)   [![godoc][D]](https://godoc.org/github.com/cybertec-postgresql/pg_timetable)
- [clickhouse-bulk](https://github.com/nikepan/clickhouse-bulk) **star:435** 收集小的插入，并向ClickHouse服务器发送大的请求。   [![godoc][D]](https://godoc.org/github.com/nikepan/clickhouse-bulk)
- [rdb](https://github.com/HDT3213/rdb) **star:285** Redis RDB文件解析器用于二次开发和内存分析。   [![godoc][D]](https://godoc.org/github.com/HDT3213/rdb)
- [octillery](https://github.com/knocknote/octillery) **star:181** 用于数据库分表(支持每个ORM或原生SQL)。   [![godoc][D]](https://godoc.org/github.com/knocknote/octillery)
- [dbbench](https://github.com/sj14/dbbench) **star:88** 数据库基准测试工具，支持多个数据库和脚本。   [![近一周有更新][G]](https://github.com/sj14/dbbench)   [![godoc][D]](https://godoc.org/github.com/sj14/dbbench)
- [prep](https://github.com/hexdigest/prep) **star:33** 在不更改代码的情况下使用准备好的SQL语句。   [![近三年未更新][Y]](https://github.com/hexdigest/prep)   [![godoc][D]](https://godoc.org/github.com/hexdigest/prep)
- [onedump](https://github.com/liweiyi88/onedump) **star:21** Database backup from different drivers to different destinations with one command and configuration.   [![godoc][D]](https://godoc.org/github.com/liweiyi88/onedump)
- [rwdb](https://github.com/andizzle/rwdb) **star:18** rwdb为多个数据库服务器的设置提供读取副本功能。   [![近三年未更新][Y]](https://github.com/andizzle/rwdb)   [![godoc][D]](https://godoc.org/github.com/andizzle/rwdb)
- [dg](https://github.com/codingconcepts/dg) **star:13** A fast data generator that produces CSV files from generated relational data.   [![godoc][D]](https://godoc.org/github.com/codingconcepts/dg)
- [dynago](https://github.com/twharmon/dynago) **star:8** Simplify working with AWS DynamoDB.   [![godoc][D]](https://godoc.org/github.com/twharmon/dynago)

### SQL查询生成器

_用于构建和使用SQL的库。 (翻译出错了? 试试 [英文版](README_EN.md#sql-query-builders) 吧~)_

- [sqlc](https://github.com/kyleconroy/sqlc) **star:9045** 从SQL生成类型安全的代码。   [![近一周有更新][G]](https://github.com/kyleconroy/sqlc)   [![godoc][D]](https://godoc.org/github.com/kyleconroy/sqlc)
- [Squirrel](https://github.com/Masterminds/squirrel) **star:6046** 帮助您构建SQL查询的Go库。   [![godoc][D]](https://godoc.org/github.com/Masterminds/squirrel)
- [xo](https://github.com/knq/xo) **star:3435** 基于现有的schema定义和自定义查询生成 Go 代码，基于支持PostgreSQL、MySQL、SQLite、Oracle和Microsoft SQL Server。   [![godoc][D]](https://godoc.org/github.com/knq/xo)
- [goqu](https://github.com/doug-martin/goqu) **star:1992** 常用的SQL生成器和查询库。   [![godoc][D]](https://godoc.org/github.com/doug-martin/goqu)
- [jet](https://github.com/go-jet/jet) **star:1526** 用于在Go中编写类型安全的SQL查询的框架，能够轻松地将数据库查询结果转换为所需的任意对象结构。   [![godoc][D]](https://godoc.org/github.com/go-jet/jet)
- [gendry](https://github.com/didi/gendry) **star:1522** 非入侵的SQL构建器和强大的数据绑定器。   [![近一周有更新][G]](https://github.com/didi/gendry)   [![godoc][D]](https://godoc.org/github.com/didi/gendry)   [![包含中文文档][CN]](https://github.com/didi/gendry)
- [Dotsql](https://github.com/gchaincl/dotsql) **star:681** Go library帮助您将sql文件保存在一个地方，并轻松地使用它们。   [![godoc][D]](https://godoc.org/github.com/gchaincl/dotsql)
- [ozzo-dbx](https://github.com/go-ozzo/ozzo-dbx) **star:612** Powerful data retrieval methods as well as DB-agnostic query building capabilities.   [![godoc][D]](https://godoc.org/github.com/go-ozzo/ozzo-dbx)
- [dbq](https://github.com/rocketlaunchr/dbq) **star:385** Zero boilerplate database operations for Go   [![godoc][D]](https://godoc.org/github.com/rocketlaunchr/dbq)
- [sqlingo](https://github.com/lqs/sqlingo) **star:336** 在Go中构建SQL的轻量级DSL。   [![godoc][D]](https://godoc.org/github.com/lqs/sqlingo)
- [sqrl](https://github.com/elgris/sqrl) **star:259** SQL查询生成器，从Squirrel fork而来，并再此基础上对性能做了优化。   [![godoc][D]](https://godoc.org/github.com/elgris/sqrl)
- [Squalus](https://gitlab.com/qosenergy/squalus)  Go SQL中间层，能使得执行查询更加容易。
- [sq](https://github.com/bokwoon95/go-structured-query) **star:194** 用于Go的类型安全的SQL生成器和结构映射器。   [![godoc][D]](https://godoc.org/github.com/bokwoon95/go-structured-query)
- [sqlf](https://github.com/leporo/sqlf) **star:128** 快速SQL查询生成器。   [![godoc][D]](https://godoc.org/github.com/leporo/sqlf)
- [buildsqlx](https://github.com/arthurkushman/buildsqlx) **star:125** 去数据库查询生成器库的PostgreSQL。   [![godoc][D]](https://godoc.org/github.com/arthurkushman/buildsqlx)
- [igor](https://github.com/galeone/igor) **star:112** PostgreSQL的抽象层，支持高级功能和类似gorm的语法。   [![godoc][D]](https://godoc.org/github.com/galeone/igor)
- [bqb](https://github.com/nullism/bqb) **star:98** 轻量级和易于学习的查询构建器。   [![godoc][D]](https://godoc.org/github.com/nullism/bqb)
- [builq](https://github.com/cristalhq/builq) **star:69** Easily build SQL queries in Go.   [![近一周有更新][G]](https://github.com/cristalhq/builq)   [![godoc][D]](https://godoc.org/github.com/cristalhq/builq)
- [godbal](https://github.com/xujiajun/godbal) **star:58** 数据库抽象层(dbal)。支持SQL builder，轻松获取结果。   [![近三年未更新][Y]](https://github.com/xujiajun/godbal)   [![godoc][D]](https://godoc.org/github.com/xujiajun/godbal)
- [gosql](https://github.com/twharmon/gosql) **star:29** 支持更好的空值的SQL查询生成器。   [![godoc][D]](https://godoc.org/github.com/twharmon/gosql)
- [qry](https://github.com/HnH/qry) **star:29** 该工具使用原始SQL查询从文件生成常量。   [![godoc][D]](https://godoc.org/github.com/HnH/qry)
- [ormlite](https://github.com/pupizoid/ormlite) **star:11** 包含一些类似orm的特性和sqlite数据库的辅助程序的轻量级包   [![godoc][D]](https://godoc.org/github.com/pupizoid/ormlite)
- [Hotcoal](https://github.com/motrboat/hotcoal) **star:8** Secure your handcrafted SQL against injection.   [![godoc][D]](https://godoc.org/github.com/motrboat/hotcoal)
- [sg](https://github.com/go-the-way/sg) **star:4** A SQL Gen for generating standard SQLs(supports: CRUD) written in Go.   [![godoc][D]](https://godoc.org/github.com/go-the-way/sg)

**[⬆ back to top](#contents)**

## 数据库驱动程序

### 多个后端接口

- [cayley](https://github.com/google/cayley) **star:14635** 图形数据库，支持多个后端。   [![godoc][D]](https://godoc.org/github.com/google/cayley)
- [gokv](https://github.com/philippgille/gokv) **star:576** 可扩展的简单的 K/V 存储(Redis、Consul、etcd、bbolt、BadgerDB、LevelDB、Memcached、DynamoDB、S3、PostgreSQL、MongoDB、CockroachDB等等)。   [![近一周有更新][G]](https://github.com/philippgille/gokv)   [![godoc][D]](https://godoc.org/github.com/philippgille/gokv)
- [go-transaction-manager](https://github.com/avito-tech/go-transaction-manager) **star:71** Transaction manager with multiple adapters (sql, sqlx, gorm, mongo, ...) controls transaction boundaries.   [![godoc][D]](https://godoc.org/github.com/avito-tech/go-transaction-manager)
- [dsc](https://github.com/viant/dsc) **star:27** 面向 SQL、NoSQL、结构化文件的数据存储连接。   [![godoc][D]](https://godoc.org/github.com/viant/dsc)

### 关系数据库驱动程序

- [go-sql-driver/mysql](https://github.com/go-sql-driver/mysql) **star:13659** MySQL驱动程序。   [![godoc][D]](https://godoc.org/github.com/go-sql-driver/mysql)
- [pq](https://github.com/lib/pq) **star:8285** 纯 Go 的Postgres驱动。   [![godoc][D]](https://godoc.org/github.com/lib/pq)
- [pgx](https://github.com/jackc/pgx) **star:7700** PostgreSQL驱动，支持比现有database/sql更多的特性。   [![近一周有更新][G]](https://github.com/jackc/pgx)   [![godoc][D]](https://godoc.org/github.com/jackc/pgx)
- [go-sqlite3](https://github.com/mattn/go-sqlite3) **star:6856** SQLite3驱动程序。   [![近一周有更新][G]](https://github.com/mattn/go-sqlite3)
- [go-mssqldb](https://github.com/denisenkom/go-mssqldb) **star:1752** 微软MSSQL驱动程序。   [![godoc][D]](https://godoc.org/github.com/denisenkom/go-mssqldb)
- [sqlhooks](https://github.com/qustavo/sqlhooks) **star:613** 将钩子附加到任何数据库/sql驱动程序。   [![godoc][D]](https://godoc.org/github.com/qustavo/sqlhooks)
- [go-oci8](https://github.com/mattn/go-oci8) **star:607** Oracle 驱动程序。   [![godoc][D]](https://godoc.org/github.com/mattn/go-oci8)
- [godror](https://github.com/godror/godror) **star:458** 基于 ODPI-C 的 Oracle 驱动程序   [![近一周有更新][G]](https://github.com/godror/godror)
- [KSQL](https://github.com/VinGarcia/ksql) **star:234** A Simple and Powerful Golang SQL Library   [![godoc][D]](https://godoc.org/github.com/VinGarcia/ksql)
- [firebirdsql](https://github.com/nakagami/firebirdsql) **star:203** Firebird RDBMS SQL驱动程序。   [![godoc][D]](https://godoc.org/github.com/nakagami/firebirdsql)
- [surrealdb.go](https://github.com/surrealdb/surrealdb.go) **star:179** SurrealDB Driver for Go.   [![godoc][D]](https://godoc.org/github.com/surrealdb/surrealdb.go)
- [Sqinn-Go](https://github.com/cvilsmeier/sqinn-go) **star:142** SQLite with pure Go.   [![godoc][D]](https://godoc.org/github.com/cvilsmeier/sqinn-go)
- [go-adodb](https://github.com/mattn/go-adodb) **star:133** Microsoft ActiveX对象数据库驱动程序。   [![godoc][D]](https://godoc.org/github.com/mattn/go-adodb)
- [avatica](https://github.com/apache/calcite-avatica-go) **star:109** Apache Avatica/Phoenix SQL驱动程序。   [![godoc][D]](https://godoc.org/github.com/apache/calcite-avatica-go)
- [gofreetds](https://github.com/minus5/gofreetds) **star:109** 微软该司机。去包装[FreeTDS](https://www.freetds.org)。   [![godoc][D]](https://godoc.org/github.com/minus5/gofreetds)
- [ydb-go-sdk](https://github.com/ydb-platform/ydb-go-sdk) **star:102** native and database/sql driver YDB (Yandex Database)   [![近一周有更新][G]](https://github.com/ydb-platform/ydb-go-sdk)   [![godoc][D]](https://godoc.org/github.com/ydb-platform/ydb-go-sdk)
- [bgc](https://github.com/viant/bgc) **star:20** BigQuery 的数据存储连接。   [![近三年未更新][Y]](https://github.com/viant/bgc)   [![godoc][D]](https://godoc.org/github.com/viant/bgc)
- [pig](https://github.com/alexeyco/pig) **star:14** 简单的[pgx](https://github.com/jackc/pgx)包装器执行和[扫描](https://github.com/georgysavva/scany)查询结果很容易。   [![godoc][D]](https://godoc.org/github.com/alexeyco/pig)

### NoSQL数据库驱动程序

- [redis](https://github.com/redis/go-redis) **star:18012** 基于 Go 的 Redis 客户端。   [![近一周有更新][G]](https://github.com/redis/go-redis)   [![godoc][D]](https://godoc.org/github.com/redis/go-redis)   [![包含中文文档][CN]](https://github.com/redis/go-redis)
- [rueidis](http://github.com/rueian/rueidis)  快速Redis RESP3客户端与自动流水线和服务器辅助的客户端缓存。
- [redigo](https://github.com/gomodule/redigo) **star:9599** Redigo 是基于 Go 的Redis 客户端。   [![godoc][D]](https://godoc.org/github.com/gomodule/redigo)
- [mongo-go-driver](https://github.com/mongodb/mongo-go-driver) **star:7617** 官方的 MongoDB 驱动。   [![近一周有更新][G]](https://github.com/mongodb/mongo-go-driver)   [![godoc][D]](https://godoc.org/github.com/mongodb/mongo-go-driver)
- [mgo](https://github.com/globalsign/mgo) **star:1962** (已停止维护) MongoDB驱动。   [![godoc][D]](https://godoc.org/github.com/globalsign/mgo)
- [gorethink](https://github.com/dancannon/gorethink) **star:1637** RethinkDB 驱动。   [![godoc][D]](https://godoc.org/github.com/dancannon/gorethink)
- [qmgo](https://github.com/qiniu/qmgo) **star:1181** MongoDB司机走了。它是基于官方MongoDB司机但更容易使用像分别。   [![近一周有更新][G]](https://github.com/qiniu/qmgo)   [![godoc][D]](https://godoc.org/github.com/qiniu/qmgo)   [![包含中文文档][CN]](https://github.com/qiniu/qmgo)
- [mgm](https://github.com/kamva/mgm) **star:685** 基于MongoDB模型的ODM for Go(基于官方MongoDB驱动)。   [![近一周有更新][G]](https://github.com/kamva/mgm)   [![godoc][D]](https://godoc.org/github.com/kamva/mgm)
- [redeo](https://github.com/bsm/redeo) **star:429** 与 redis 协议兼容的 TCP 服务器/服务。   [![godoc][D]](https://godoc.org/github.com/bsm/redeo)
- [aerospike-client-go](https://github.com/aerospike/aerospike-client-go) **star:414** Aerospike 客户端。   [![godoc][D]](https://godoc.org/github.com/aerospike/aerospike-client-go)
- [neoism](https://github.com/jmcvetta/neoism) **star:389** Golang 的 Neo4j 客户端。   [![近三年未更新][Y]](https://github.com/jmcvetta/neoism)   [![godoc][D]](https://godoc.org/github.com/jmcvetta/neoism)
- [gocb](https://github.com/couchbase/gocb) **star:348** 官方Couchbase Go SDK。   [![近一周有更新][G]](https://github.com/couchbase/gocb)   [![godoc][D]](https://godoc.org/github.com/couchbase/gocb)
- [go-rejson](https://github.com/nitishm/go-rejson) **star:328** 实现了基于 Redigo 客户端的redislabs' ReJSON 模块。可简单地将结构体存储为JSON对象并对其进行操作。   [![godoc][D]](https://godoc.org/github.com/nitishm/go-rejson)
- [go-couchbase](https://github.com/couchbase/go-couchbase) **star:318** Couchbase客户端。   [![godoc][D]](https://godoc.org/github.com/couchbase/go-couchbase)
- [Kivik](https://github.com/go-kivik/kivik) **star:277** Kivik为CouchDB、PouchDB和类似的数据库提供了一个通用的Go和GopherJS客户端库。   [![近一周有更新][G]](https://github.com/go-kivik/kivik)   [![godoc][D]](https://godoc.org/github.com/go-kivik/kivik)
- [godis](https://github.com/piaohao/godis) **star:109** 由GoLang实现的redis客户端，灵感来自jedis。   [![近三年未更新][Y]](https://github.com/piaohao/godis)   [![godoc][D]](https://godoc.org/github.com/piaohao/godis)
- [Neo4j-GO](https://github.com/davemeehan/Neo4j-GO) **star:76** Neo4j REST 客户端。   [![近三年未更新][Y]](https://github.com/davemeehan/Neo4j-GO)   [![godoc][D]](https://godoc.org/github.com/davemeehan/Neo4j-GO)   [![归档项目][Archived]](https://github.com/davemeehan/Neo4j-GO)
- [arangolite](https://github.com/solher/arangolite) **star:73** 轻量级的 ArangoDB 驱动。   [![godoc][D]](https://godoc.org/github.com/solher/arangolite)
- [go-pilosa](https://github.com/pilosa/go-pilosa) **star:58**  Pilosa客户端。   [![godoc][D]](https://godoc.org/github.com/pilosa/go-pilosa)   [![归档项目][Archived]](https://github.com/pilosa/go-pilosa)
- [forestdb](https://github.com/couchbase/goforestdb) **star:33** 基于 Go 的 ForestDB 接口实现。   [![近三年未更新][Y]](https://github.com/couchbase/goforestdb)   [![godoc][D]](https://godoc.org/github.com/couchbase/goforestdb)
- [goriak](https://github.com/zegl/goriak) **star:30**  Riak KV 驱动。   [![godoc][D]](https://godoc.org/github.com/zegl/goriak)
- [neo4j](https://github.com/cihangir/neo4j) **star:27** Neo4j Rest API实现。   [![近三年未更新][Y]](https://github.com/cihangir/neo4j)   [![godoc][D]](https://godoc.org/github.com/cihangir/neo4j)
- [xredis](https://github.com/shomali11/xredis) **star:19** 类型安全，可定制，清晰和易用的Redis客户端。   [![近三年未更新][Y]](https://github.com/shomali11/xredis)   [![godoc][D]](https://godoc.org/github.com/shomali11/xredis)
- [gocosmos](https://github.com/btnguyen2k/gocosmos) **star:18** Azure Cosmos DB的REST客户端和标准的“数据库/sql”驱动程序。   [![近一周有更新][G]](https://github.com/btnguyen2k/gocosmos)   [![godoc][D]](https://godoc.org/github.com/btnguyen2k/gocosmos)
- [gocql](https://gocql.github.io)  Apache Cassandra 的 Go 驱动。
- [godscache](https://github.com/defcronyke/godscache) **star:11** 谷歌云平台Go Datastore包的封装，它采用了memcached添加缓存。   [![近三年未更新][Y]](https://github.com/defcronyke/godscache)   [![godoc][D]](https://godoc.org/github.com/defcronyke/godscache)
- [gomemcache](https://github.com/bradfitz/gomemcache/)  memcache客户端库。
- [asc](https://github.com/viant/asc) **star:9** Aerospike 的数据存储连接器。   [![近三年未更新][Y]](https://github.com/viant/asc)   [![godoc][D]](https://godoc.org/github.com/viant/asc)

### 检索及分析资料库

- [elastic](https://github.com/olivere/elastic) **star:7212** Elasticsearch 客户端。   [![近一周有更新][G]](https://github.com/olivere/elastic)   [![godoc][D]](https://godoc.org/github.com/olivere/elastic)
- [go-elasticsearch](https://github.com/elastic/go-elasticsearch) **star:5143** 官方 Elasticsearch 客户端。   [![近一周有更新][G]](https://github.com/elastic/go-elasticsearch)   [![godoc][D]](https://godoc.org/github.com/elastic/go-elasticsearch)
- [elasticsql](https://github.com/cch123/elasticsql) **star:1091** 将 SQL 转换为 elasticsearch dsl。   [![godoc][D]](https://godoc.org/github.com/cch123/elasticsql)
- [elastigo](https://github.com/mattbaird/elastigo) **star:950** Elasticsearch 客户端。   [![近三年未更新][Y]](https://github.com/mattbaird/elastigo)   [![godoc][D]](https://godoc.org/github.com/mattbaird/elastigo)
- [skizze](https://github.com/seiflotfy/skizze) **star:88** 面向概率数据结构的服务和存储。   [![近三年未更新][Y]](https://github.com/seiflotfy/skizze)   [![godoc][D]](https://godoc.org/github.com/seiflotfy/skizze)
- [goes](https://github.com/OwnLocal/goes) **star:29** 实现了与 Elasticsearch 交互的库。   [![godoc][D]](https://godoc.org/github.com/OwnLocal/goes)

**[⬆ back to top](#contents)**

## 日期和时间

_用于处理日期和时间的库。 (翻译出错了? 试试 [英文版](README_EN.md#date-and-time) 吧~)_

- [now](https://github.com/jinzhu/now) **star:4234** now 是时间有关的工具类。   [![godoc][D]](https://godoc.org/github.com/jinzhu/now)
- [carbon](https://github.com/golang-module/carbon) **star:3444** datetime的一个简单、语义和开发人员友好的golang包。   [![近一周有更新][G]](https://github.com/golang-module/carbon)   [![godoc][D]](https://godoc.org/github.com/golang-module/carbon)
- [dateparse](https://github.com/araddon/dateparse) **star:1910** 可以解析很多格式不固定的日期字符串。   [![godoc][D]](https://godoc.org/github.com/araddon/dateparse)
- [carbon](https://github.com/uniplaces/carbon) **star:766** 简单的时间扩展，包含了许多使用方法，从 PHP Carbon 库移植的。   [![godoc][D]](https://godoc.org/github.com/uniplaces/carbon)
- [durafmt](https://github.com/hako/durafmt) **star:466** 轻量级、可让time.Duration更加易读的库。   [![godoc][D]](https://godoc.org/github.com/hako/durafmt)
- [timeutil](https://github.com/leekchan/timeutil) **star:194** 面向 Golang 的时间库，集成了很多有用的扩展(Timedelta, Strftime, ...)。   [![近三年未更新][Y]](https://github.com/leekchan/timeutil)   [![godoc][D]](https://godoc.org/github.com/leekchan/timeutil)
- [gostradamus](https://github.com/bykof/gostradamus) **star:190** 和约会对象一起工作的软件包。   [![godoc][D]](https://godoc.org/github.com/bykof/gostradamus)
- [go-persian-calendar](https://github.com/yaa110/go-persian-calendar) **star:170** 太阳历实现。   [![godoc][D]](https://godoc.org/github.com/yaa110/go-persian-calendar)
- [iso8601](https://github.com/relvacode/iso8601) **star:129** 不用正则表达式有效解析 ISO8601 日期时间。   [![godoc][D]](https://godoc.org/github.com/relvacode/iso8601)
- [date](https://github.com/rickb777/date) **star:115** 增加处理日期、日期范围、时间跨度、时间段和time-of-day。   [![godoc][D]](https://godoc.org/github.com/rickb777/date)
- [approx](https://github.com/goschtalt/approx)  A Duration extension supporting parsing/printing durations in days, weeks and years.
- [timespan](https://github.com/SaidinWoT/timespan) **star:82** 用于处理时间间隔相关的库，可定义开始时间和持续时间。   [![近三年未更新][Y]](https://github.com/SaidinWoT/timespan)   [![godoc][D]](https://godoc.org/github.com/SaidinWoT/timespan)
- [go-str2duration](https://github.com/xhit/go-str2duration) **star:78** 将字符串转换为持续时间。支持的时间。持续时间返回字符串等。   [![godoc][D]](https://godoc.org/github.com/xhit/go-str2duration)
- [go-sunrise](https://github.com/nathan-osman/go-sunrise) **star:74** 计算指定位置的日出和日落时间。   [![godoc][D]](https://godoc.org/github.com/nathan-osman/go-sunrise)
- [feiertage](https://github.com/wlbr/feiertage) **star:43** 用于计算德国公共假期的函数，比如复活节、感恩节等   [![godoc][D]](https://godoc.org/github.com/wlbr/feiertage)
- [kair](https://github.com/GuilhermeCaruso/kair) **star:25** 用于处理日期和时间的 golang 库。   [![近三年未更新][Y]](https://github.com/GuilhermeCaruso/kair)   [![godoc][D]](https://godoc.org/github.com/GuilhermeCaruso/kair)
- [cronrange](https://github.com/1set/cronrange) **star:18** 解析cron风格的时间范围表达式，检查给定的时间是否在任何范围内。   [![godoc][D]](https://godoc.org/github.com/1set/cronrange)
- [NullTime](https://github.com/kirillDanshin/nulltime) **star:14** 可以允许 time.Time 为null。   [![近三年未更新][Y]](https://github.com/kirillDanshin/nulltime)   [![godoc][D]](https://godoc.org/github.com/kirillDanshin/nulltime)
- [strftime](https://github.com/awoodbeck/strftime) **star:12** C99-compatible strftime formatter。   [![近三年未更新][Y]](https://github.com/awoodbeck/strftime)   [![godoc][D]](https://godoc.org/github.com/awoodbeck/strftime)
- [tuesday](https://github.com/osteele/tuesday) **star:12** Ruby-compatible Strftime function。   [![godoc][D]](https://godoc.org/github.com/osteele/tuesday)
- [go-anytime](https://github.com/ijt/go-anytime) **star:11** Parse dates/times like "next dec 22nd at 3pm" and ranges like "from today until next thursday" without knowing the format in advance.   [![godoc][D]](https://godoc.org/github.com/ijt/go-anytime)
- [go-week](https://github.com/stoewer/go-week) **star:8** 一个有效的软件包，以配合ISO8601周日期。   [![godoc][D]](https://godoc.org/github.com/stoewer/go-week)

**[⬆ back to top](#contents)**

## 分布式系统

_协助构建分布式系统的包。 (翻译出错了? 试试 [英文版](README_EN.md#distributed-systems) 吧~)_

- [go-zero](https://github.com/tal-tech/go-zero) **star:25466** 一个web和rpc框架。它的诞生是为了确保繁忙场地的稳定性，弹性设计。内置的goctl大大提高了开发效率。   [![近一周有更新][G]](https://github.com/tal-tech/go-zero)   [![godoc][D]](https://godoc.org/github.com/tal-tech/go-zero)
- [go-kit](https://github.com/go-kit/kit) **star:25414** 支持服务发现、负载平衡、插件式传输、请求跟踪等功能的Microservice toolkit。   [![近一周有更新][G]](https://github.com/go-kit/kit)   [![godoc][D]](https://godoc.org/github.com/go-kit/kit)
- [Kratos](https://github.com/go-kratos/kratos) **star:21344** 一个模块化设计的易于使用的微服务框架。   [![近一周有更新][G]](https://github.com/go-kratos/kratos)   [![godoc][D]](https://godoc.org/github.com/go-kratos/kratos)   [![包含中文文档][CN]](https://github.com/go-kratos/kratos)
- [go-micro](https://github.com/micro/go-micro) **star:20820** 分布式系统开发框架。   [![godoc][D]](https://godoc.org/github.com/micro/go-micro)
- [grpc-go](https://github.com/grpc/grpc-go) **star:18834** gRPC的Go语言实现。   [![近一周有更新][G]](https://github.com/grpc/grpc-go)   [![godoc][D]](https://godoc.org/github.com/grpc/grpc-go)
- [NATS](https://github.com/nats-io/gnatsd) **star:13523** 轻量级、高性能消息传递系统，可用于微服务、物联网(IoT)和云。   [![近一周有更新][G]](https://github.com/nats-io/gnatsd)   [![godoc][D]](https://godoc.org/github.com/nats-io/gnatsd)
- [micro](https://github.com/micro/micro) **star:11866** 一个分布式系统运行时，用于云及其他。   [![godoc][D]](https://godoc.org/github.com/micro/micro)
- [rpcx](https://github.com/smallnest/rpcx) **star:7722** 分布式可插拔的RPC服务框架，如阿里巴巴Dubbo。   [![godoc][D]](https://godoc.org/github.com/smallnest/rpcx)
- [raft](https://github.com/hashicorp/raft) **star:7392** Raft consensus协议的实现。 by HashiCorp。   [![近一周有更新][G]](https://github.com/hashicorp/raft)   [![godoc][D]](https://godoc.org/github.com/hashicorp/raft)
- [Kitex](https://github.com/cloudwego/kitex) **star:6213** A high-performance and strong-extensibility Golang RPC framework that helps developers build microservices. If the performance and extensibility are the main concerns when you develop microservices, Kitex can be a good choice.   [![近一周有更新][G]](https://github.com/cloudwego/kitex)   [![godoc][D]](https://godoc.org/github.com/cloudwego/kitex)   [![包含中文文档][CN]](https://github.com/cloudwego/kitex)
- [lura](https://github.com/luraproject/lura) **star:5717** 具有中间件的高性能API网关框架。   [![近一周有更新][G]](https://github.com/luraproject/lura)   [![godoc][D]](https://godoc.org/github.com/luraproject/lura)
- [torrent](https://github.com/anacrolix/torrent) **star:4923** BitTorrent 客户端。   [![近一周有更新][G]](https://github.com/anacrolix/torrent)   [![godoc][D]](https://godoc.org/github.com/anacrolix/torrent)
- [dragonboat](https://github.com/lni/dragonboat) **star:4729** 一个功能齐全，高性能的库集。   [![近一周有更新][G]](https://github.com/lni/dragonboat)   [![godoc][D]](https://godoc.org/github.com/lni/dragonboat)   [![包含中文文档][CN]](https://github.com/lni/dragonboat)
- [emitter-io](https://github.com/emitter-io/emitter) **star:3629** 高性能、分布式、安全和低延迟的发布-订阅平台，使用MQTT、Websockets和love构建。   [![godoc][D]](https://godoc.org/github.com/emitter-io/emitter)
- [gleam](https://github.com/chrislusf/gleam) **star:3238** 使用纯Go和Luajit编写的快速、可伸缩的分布式map/reduce系统，结合了Go的高并发性和Luajit的高性能，可以独立运行或分布式运行。   [![godoc][D]](https://godoc.org/github.com/chrislusf/gleam)
- [glow](https://github.com/chrislusf/glow) **star:3154** 全部用 Go 实现，易用、可伸缩，可用于分布式大数据处理，Map-Reduce, DAG执行。   [![近三年未更新][Y]](https://github.com/chrislusf/glow)   [![godoc][D]](https://godoc.org/github.com/chrislusf/glow)
- [liftbridge](https://github.com/liftbridge-io/liftbridge) **star:2479** 用于nat的轻量级、容错的消息流。   [![godoc][D]](https://godoc.org/github.com/liftbridge-io/liftbridge)
- [Dragonfly](https://github.com/dragonflyoss/Dragonfly2) **star:1595** Provide efficient, stable and secure file distribution and image acceleration based on p2p technology to be the best practice and standard solution in cloud native architectures.   [![近一周有更新][G]](https://github.com/dragonflyoss/Dragonfly2)   [![godoc][D]](https://godoc.org/github.com/dragonflyoss/Dragonfly2)
- [hprose](https://github.com/hprose/hprose-golang) **star:1241** 支持25+种语言RPC库。   [![近一周有更新][G]](https://github.com/hprose/hprose-golang)   [![godoc][D]](https://godoc.org/github.com/hprose/hprose-golang)   [![包含中文文档][CN]](https://github.com/hprose/hprose-golang)
- [go-doudou](https://github.com/unionj-cloud/go-doudou) **star:1215** 八卦协议和基于OpenAPI 3.0规范的去中心化微服务框架。内置的go-doudou cli专注于低代码和快速开发，可以提高您的生产力。   [![godoc][D]](https://godoc.org/github.com/unionj-cloud/go-doudou)   [![包含中文文档][CN]](https://github.com/unionj-cloud/go-doudou)
- [redis-lock](https://github.com/bsm/redislock) **star:1115** 基于redis的分布式锁简易实现。   [![godoc][D]](https://godoc.org/github.com/bsm/redislock)
- [resgate](https://resgate.io/)  用于构建REST、实时和RPC API的实时API网关，其中所有客户端都是无缝同步的。
- [rain](https://github.com/cenkalti/rain) **star:869** BitTorrent客户端和库。   [![近一周有更新][G]](https://github.com/cenkalti/rain)   [![godoc][D]](https://godoc.org/github.com/cenkalti/rain)
- [arpc](https://github.com/lesismal/arpc) **star:804** 更有效的网络通信，支持双向呼叫、通知、广播。   [![godoc][D]](https://godoc.org/github.com/lesismal/arpc)
- [ringpop-go](https://github.com/uber/ringpop-go) **star:798** 可伸缩的，容错、应用分层的的Go应用程序。   [![godoc][D]](https://godoc.org/github.com/uber/ringpop-go)
- [go-health](https://github.com/InVisionApp/go-health) **star:710** 用于在服务中启用异步依赖项健康检查的库。   [![godoc][D]](https://godoc.org/github.com/InVisionApp/go-health)
- [gorpc](https://github.com/valyala/gorpc) **star:679** 简单、快速和可伸缩的RPC库。   [![godoc][D]](https://godoc.org/github.com/valyala/gorpc)
- [consistent](https://github.com/buraksezer/consistent) **star:616** Consistent hashing with bounded loads。   [![godoc][D]](https://godoc.org/github.com/buraksezer/consistent)
- [go-sundheit](https://github.com/AppsFlyer/go-sundheit) **star:513** 为支持为golang服务定义异步服务健康检查而构建的库。   [![godoc][D]](https://godoc.org/github.com/AppsFlyer/go-sundheit)
- [digota](https://github.com/digota/digota) **star:483** 基于 grpc 的电子商务微服务。   [![godoc][D]](https://godoc.org/github.com/digota/digota)
- [dot](https://github.com/dotchain/dot/)  基于 transformation/OT 的分布式同步。
- [go-jump](https://github.com/dgryski/go-jump) **star:369** 提供了谷歌的 “Jump” 一致哈希函数接口。   [![godoc][D]](https://godoc.org/github.com/dgryski/go-jump)
- [sleuth](https://github.com/ursiform/sleuth) **star:366** 用于HTTP服务之间进行无中心p2p自动发现和RPC通信的库(使用[ZeroMQ](https://github.com/zeromq/libzmq))。   [![godoc][D]](https://godoc.org/github.com/ursiform/sleuth)
- [Temporal](https://github.com/temporalio/sdk-go) **star:363** Durable execution system for making code fault-tolerant and simple.   [![近一周有更新][G]](https://github.com/temporalio/sdk-go)   [![godoc][D]](https://godoc.org/github.com/temporalio/sdk-go)
- [raft](https://github.com/etcd-io/raft) **star:330** Raft consensus协议的实现。 by CoreOS。   [![近一周有更新][G]](https://github.com/etcd-io/raft)   [![godoc][D]](https://godoc.org/github.com/etcd-io/raft)
- [jsonrpc](https://github.com/ybbus/jsonrpc) **star:282** JSON-RPC 2.0 HTTP客户端。   [![godoc][D]](https://godoc.org/github.com/ybbus/jsonrpc)
- [dht](https://github.com/anacrolix/dht) **star:271** BitTorrent Kademlia DHT的实现。   [![godoc][D]](https://godoc.org/github.com/anacrolix/dht)
- [jsonrpc](https://github.com/osamingo/jsonrpc) **star:180** jsonrpc 包，实现了 JSON-RPC 2.0。   [![godoc][D]](https://godoc.org/github.com/osamingo/jsonrpc)
- [outboxer](https://github.com/italolelis/outboxer) **star:137** 实现了 outbox pattern Go 库。   [![近一周有更新][G]](https://github.com/italolelis/outboxer)   [![godoc][D]](https://godoc.org/github.com/italolelis/outboxer)
- [pglock](https://cirello.io/pglock)  postgresql 的分布式锁定实现。
- [pjrpc](https://gitlab.com/pjrpc/pjrpc)  Golang JSON-RPC服务器-客户端与原生buf规范。
- [doublejump](https://github.com/edwingeng/doublejump) **star:90** 实现了谷歌的jump consistent hash。   [![godoc][D]](https://godoc.org/github.com/edwingeng/doublejump)
- [Semaphore](https://github.com/jexia/semaphore) **star:87** 简单的(微)服务协调器。   [![godoc][D]](https://godoc.org/github.com/jexia/semaphore)
- [celeriac](https://github.com/svcavallar/celeriac.v1) **star:71** 用于对 Celery worker、任务、事件进行交互和监控的库。   [![godoc][D]](https://godoc.org/github.com/svcavallar/celeriac.v1)
- [go-mysql-lock](https://github.com/sanketplus/go-mysql-lock) **star:57** 基于MySQL分布式锁。   [![godoc][D]](https://godoc.org/github.com/sanketplus/go-mysql-lock)
- [flowgraph](https://github.com/vectaport/flowgraph) **star:52** flow-based programming package。   [![godoc][D]](https://godoc.org/github.com/vectaport/flowgraph)
- [go-pdu](https://github.com/pdupub/go-pdu) **star:47** 一个去中心化的基于身份的社交网络。   [![godoc][D]](https://godoc.org/github.com/pdupub/go-pdu)
- [drmaa](https://github.com/dgruber/drmaa) **star:45** 符合 DRMAA 标准的集群调度程序作业提交库。   [![godoc][D]](https://godoc.org/github.com/dgruber/drmaa)
- [dynamolock](https://cirello.io/dynamolock)  DynamoDB-backed 分布式锁定实现。
- [gmsec](https://github.com/gmsec/micro) **star:22** 一个Go分布式系统开发框架。   [![godoc][D]](https://godoc.org/github.com/gmsec/micro)
- [consistenthash](https://github.com/mbrostami/consistenthash) **star:20** 使用可配置副本的一致哈希。   [![godoc][D]](https://godoc.org/github.com/mbrostami/consistenthash)
- [dynatomic](https://github.com/tylfin/dynatomic) **star:15** 基于 DynamoDB 的 原子计数器的库。   [![godoc][D]](https://godoc.org/github.com/tylfin/dynatomic)
- [failured](https://github.com/andy2046/failured) **star:10** 分布式系统的自适应应计故障检测器。   [![godoc][D]](https://godoc.org/github.com/andy2046/failured)

**[⬆ back to top](#contents)**

## 动态域名

_更新动态DNS记录的工具。 (翻译出错了? 试试 [英文版](README_EN.md#dynamic-dns) 吧~)_

- [GoDNS](https://github.com/timothyye/godns) **star:1345** 一个动态DNS客户端工具，支持DNSPod & HE.net。   [![近一周有更新][G]](https://github.com/timothyye/godns)   [![godoc][D]](https://godoc.org/github.com/timothyye/godns)
- [DDNS](https://github.com/skibish/ddns) **star:238** 个人 DDNS 客户端。   [![godoc][D]](https://godoc.org/github.com/skibish/ddns)
- [dyndns](https://gitlab.com/alcastle/dyndns)  后台去处理定期和自动检查您的IP地址，并作出更新(一个或多个)动态DNS记录，为谷歌域，每当您的地址变化。

**[⬆ back to top](#contents)**

## 电子邮件

_实现了电子邮件创建和发送。 (翻译出错了? 试试 [英文版](README_EN.md#email) 吧~)_

- [MailHog](https://github.com/mailhog/MailHog) **star:12534** 电子邮件和SMTP测试工具，对外提供了 web 和 API 接口。   [![godoc][D]](https://godoc.org/github.com/mailhog/MailHog)
- [Mailpit](https://github.com/axllent/mailpit) **star:3000** Email and SMTP testing tool for developers.   [![godoc][D]](https://godoc.org/github.com/axllent/mailpit)
- [hermes](https://github.com/matcornic/hermes) **star:2668** 可生成干净的、响应式的HTML电子邮件。   [![godoc][D]](https://godoc.org/github.com/matcornic/hermes)
- [email](https://github.com/jordan-wright/email) **star:2420** 一个强大和灵活的电子邮件库。   [![近一周有更新][G]](https://github.com/jordan-wright/email)   [![godoc][D]](https://godoc.org/github.com/jordan-wright/email)
- [go-imap](https://github.com/emersion/go-imap) **star:1847** 用于客户端和服务器的IMAP库。   [![godoc][D]](https://godoc.org/github.com/emersion/go-imap)
- [chasquid](https://blitiri.com.ar/p/chasquid)  用Go编写的SMTP服务器。
- [email-verifier](https://github.com/AfterShip/email-verifier) **star:946** 一个Go库的电子邮件验证而不发送任何电子邮件。   [![godoc][D]](https://godoc.org/github.com/AfterShip/email-verifier)
- [SendGrid](https://github.com/sendgrid/sendgrid-go) **star:924** SendGrid 的 Go语言库，用于发送电子邮件。   [![godoc][D]](https://godoc.org/github.com/sendgrid/sendgrid-go)
- [mailgun-go](https://github.com/mailgun/mailgun-go) **star:655** 使用Mailgun API去库发送邮件。   [![godoc][D]](https://godoc.org/github.com/mailgun/mailgun-go)
- [go-simple-mail](https://github.com/xhit/go-simple-mail) **star:521** 非常简单的包发送电子邮件与SMTP保持活动和两个超时:连接和发送。   [![godoc][D]](https://godoc.org/github.com/xhit/go-simple-mail)
- [go-mail](https://github.com/wneessen/go-mail) **star:328** A simple Go library for sending mails in Go.   [![近一周有更新][G]](https://github.com/wneessen/go-mail)   [![godoc][D]](https://godoc.org/github.com/wneessen/go-mail)
- [go-message](https://github.com/emersion/go-message) **star:327** 用于Internet消息格式化和邮件消息的流媒体库。   [![godoc][D]](https://godoc.org/github.com/emersion/go-message)
- [douceur](https://github.com/aymerick/douceur) **star:230** 在HTML邮件中支持CSS内联。   [![godoc][D]](https://godoc.org/github.com/aymerick/douceur)
- [Hectane](https://github.com/hectane/hectane) **star:220** 轻量级的SMTP客户机，提供了HTTP API。   [![godoc][D]](https://godoc.org/github.com/hectane/hectane)
- [mailchain](https://github.com/mailchain/mailchain) **star:140** 发送加密的电子邮件到区块链地址写在Go。
- [go-premailer](https://github.com/vanng822/go-premailer) **star:116** 在HTML邮件中支持CSS内联。   [![godoc][D]](https://godoc.org/github.com/vanng822/go-premailer)
- [go-dkim](https://github.com/toorop/go-dkim) **star:91** DKIM库，用于签署 & 验证电子邮件。   [![godoc][D]](https://godoc.org/github.com/toorop/go-dkim)
- [smtpmock](https://github.com/mocktools/go-smtp-mock) **star:88** 轻量级的可配置多线程假SMTP服务器。为您的测试环境模拟任何SMTP行为。   [![godoc][D]](https://godoc.org/github.com/mocktools/go-smtp-mock)
- [smtp](https://github.com/mailhog/smtp) **star:75** SMTP服务器协议状态机。   [![godoc][D]](https://godoc.org/github.com/mailhog/smtp)
- [go-email-normalizer](https://github.com/dimuska139/go-email-normalizer) **star:59** Golang库，用于提供电子邮件地址的规范表示。   [![godoc][D]](https://godoc.org/github.com/dimuska139/go-email-normalizer)
- [truemail-go](https://github.com/truemail-rb/truemail-go) **star:54** 可配置Golang电子邮件验证器/验证器。验证电子邮件通过Regex, DNS, SMTP甚至更多。   [![godoc][D]](https://godoc.org/github.com/truemail-rb/truemail-go)
- [go-email-validator](https://github.com/go-email-validator/go-email-validator) **star:51** 模块化电子邮件验证器的语法，一次性，smtp等…检查。   [![godoc][D]](https://godoc.org/github.com/go-email-validator/go-email-validator)
- [mailx](https://github.com/valord577/mailx) **star:8** Mailx是一个使通过SMTP发送电子邮件更容易的库。它是对golang标准库' net/smtp '的增强。   [![godoc][D]](https://godoc.org/github.com/valord577/mailx)

**[⬆ back to top](#contents)**

## 可嵌入的脚本语言

_在go代码中嵌入其他语言。 (翻译出错了? 试试 [英文版](README_EN.md#embeddable-scripting-languages) 吧~)_

- [gopher-lua](https://github.com/yuin/gopher-lua) **star:5632** 用 Go 实现的 Lua 5.1 虚拟机和编译器。   [![godoc][D]](https://godoc.org/github.com/yuin/gopher-lua)
- [expr](https://github.com/antonmedv/expr) **star:4413** Go的表达式计算引擎:快速，非图灵完备，动态类型，静态类型。   [![近一周有更新][G]](https://github.com/antonmedv/expr)   [![godoc][D]](https://godoc.org/github.com/antonmedv/expr)
- [goja](https://github.com/dop251/goja) **star:4275** ECMAScript 5.1(+)实现在Go。   [![godoc][D]](https://godoc.org/github.com/dop251/goja)
- [tengo](https://github.com/d5/tengo) **star:3282** 字节码编译的脚本语言。   [![godoc][D]](https://godoc.org/github.com/d5/tengo)
- [go-lua](https://github.com/Shopify/go-lua) **star:2773** 用 Go 实现的 Lua 5.2 VM接口。   [![godoc][D]](https://godoc.org/github.com/Shopify/go-lua)
- [starlark-go](https://github.com/google/starlark-go) **star:2058** Go implementation of Starlark: Python-like language with deterministic evaluation and hermetic execution.   [![近一周有更新][G]](https://github.com/google/starlark-go)   [![godoc][D]](https://godoc.org/github.com/google/starlark-go)
- [cel-go](https://github.com/google/cel-go) **star:1814** 快速，可移植，非图灵完整的表达评估与渐进分型。   [![近一周有更新][G]](https://github.com/google/cel-go)   [![godoc][D]](https://godoc.org/github.com/google/cel-go)
- [go-python](https://github.com/sbinet/go-python) **star:1510** CPython C-API 的 Go 接口。   [![godoc][D]](https://godoc.org/github.com/sbinet/go-python)   [![归档项目][Archived]](https://github.com/sbinet/go-python)
- [anko](https://github.com/mattn/anko) **star:1364** 用Go编写的解释器。   [![godoc][D]](https://godoc.org/github.com/mattn/anko)
- [metacall](https://github.com/metacall/core) **star:1358** 跨平台多语言运行时，支持NodeJS, JavaScript, TypeScript, Python, Ruby, c#， WebAssembly, Java, Cobol等等。   [![近一周有更新][G]](https://github.com/metacall/core)
- [go-php](https://github.com/deuill/go-php) **star:899** PHP 的 Go 接口。   [![godoc][D]](https://godoc.org/github.com/deuill/go-php)
- [go-duktape](https://github.com/olebedev/go-duktape) **star:777** 支持 Duktape JavaScript 引擎。   [![godoc][D]](https://godoc.org/github.com/olebedev/go-duktape)   [![归档项目][Archived]](https://github.com/olebedev/go-duktape)
- [gval](https://github.com/PaesslerAG/gval) **star:657** 一种用Go编写的高度可定制的表达式语言。   [![godoc][D]](https://godoc.org/github.com/PaesslerAG/gval)
- [golua](https://github.com/aarzilli/golua) **star:621** Lua C 的 Go 接口。
- [prolog](https://github.com/ichiban/prolog) **star:510** 可嵌入的序言。   [![godoc][D]](https://godoc.org/github.com/ichiban/prolog)
- [gisp](https://github.com/jcla1/gisp) **star:504** LISP 的 Go 接口。   [![近三年未更新][Y]](https://github.com/jcla1/gisp)   [![godoc][D]](https://godoc.org/github.com/jcla1/gisp)
- [gentee](https://github.com/gentee/gentee) **star:114** 嵌入式脚本编程语言。   [![godoc][D]](https://godoc.org/github.com/gentee/gentee)
- [binder](https://github.com/alexeyco/binder) **star:67** Lua接口，基于[gopher-lua](https://github.com/yuin/gopher-lua)。   [![godoc][D]](https://godoc.org/github.com/alexeyco/binder)
- [purl](https://github.com/ian-kent/purl) **star:38** 嵌入 Go 的 Perl 5.18.2。   [![近三年未更新][Y]](https://github.com/ian-kent/purl)   [![godoc][D]](https://godoc.org/github.com/ian-kent/purl)
- [ecal](https://github.com/krotik/ecal) **star:34** 一种简单的支持并发事件处理的可嵌入脚本语言。   [![godoc][D]](https://godoc.org/github.com/krotik/ecal)
- [ngaro](https://github.com/db47h/ngaro) **star:25** 嵌入式 Ngaro VM实现，支持在 Retro 中运行脚本。   [![近三年未更新][Y]](https://github.com/db47h/ngaro)   [![godoc][D]](https://godoc.org/github.com/db47h/ngaro)

**[⬆ back to top](#contents)**

## 错误处理

_处理错误的库。 (翻译出错了? 试试 [英文版](README_EN.md#error-handling) 吧~)_

- [errors](https://github.com/pkg/errors) **star:8073** 可让你很简单的进行错误处理。   [![godoc][D]](https://godoc.org/github.com/pkg/errors)   [![归档项目][Archived]](https://github.com/pkg/errors)
- [go-multierror](https://github.com/hashicorp/go-multierror) **star:2026** 可将一系列的错误作为一个整体来显示。   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-multierror)
- [errors](https://github.com/cockroachdb/errors) **star:1807** Go error library with error portability over the network.   [![godoc][D]](https://godoc.org/github.com/cockroachdb/errors)
- [eris](https://github.com/rotisserie/eris) **star:1337** 在Go中处理、跟踪和记录错误的更好方法。兼容标准错误库和github.com/pkg/errors。   [![godoc][D]](https://godoc.org/github.com/rotisserie/eris)
- [errorx](https://github.com/joomcode/errorx) **star:1006** 一个功能丰富的错误包，可进行堆栈跟踪、组装异常信息以及其他。   [![godoc][D]](https://godoc.org/github.com/joomcode/errorx)
- [tracerr](https://github.com/ztrue/tracerr) **star:822** 可展示错误的堆栈跟踪信息和源码片段。   [![godoc][D]](https://godoc.org/github.com/ztrue/tracerr)
- [errlog](https://github.com/snwfdhmp/errlog) **star:453** 用于定位抛出错误的源代码(以及一些其他快速调试特性)。可插入到任何 logger 的位置。   [![godoc][D]](https://godoc.org/github.com/snwfdhmp/errlog)
- [emperror](https://github.com/emperror/emperror) **star:312** 用于Go库和应用程序的错误处理工具和最佳实践。   [![godoc][D]](https://godoc.org/github.com/emperror/emperror)
- [errors](https://github.com/emperror/errors) **star:184** 替换标准库错误包和github.com/pkg/errors。提供各种错误处理原语。   [![godoc][D]](https://godoc.org/github.com/emperror/errors)
- [Fault](https://github.com/Southclaws/fault) **star:135** An ergonomic mechanism for wrapping errors in order to facilitate structured metadata and context for error values.   [![近一周有更新][G]](https://github.com/Southclaws/fault)   [![godoc][D]](https://godoc.org/github.com/Southclaws/fault)
- [oops](https://github.com/samber/oops) **star:79** Error handling with context, stack trace and source fragments.   [![godoc][D]](https://godoc.org/github.com/samber/oops)
- [errors](https://github.com/bnkamalesh/errors) **star:52** Drop-in replacement for builtin Go errors. This is a minimal error handling package with custom error types, user friendly messages, Unwrap & Is. With very easy to use and straightforward helper functions.   [![godoc][D]](https://godoc.org/github.com/bnkamalesh/errors)
- [exception](https://github.com/rbrahul/exception) **star:24** A simple utility package for exception handling with try-catch in Golang.   [![godoc][D]](https://godoc.org/github.com/rbrahul/exception)
- [Falcon](https://github.com/SonicRoshan/falcon) **star:9** 一个简单但功能强大的错误处理包。   [![近三年未更新][Y]](https://github.com/SonicRoshan/falcon)   [![godoc][D]](https://godoc.org/github.com/SonicRoshan/falcon)
- [errors](https://github.com/PumpkinSeed/errors) **star:7** 最简单的错误包装器，具有出色的性能和最小的内存开销。   [![godoc][D]](https://godoc.org/github.com/PumpkinSeed/errors)
- [errors](https://github.com/neuronlabs/errors) **star:5** 使用分类原语进行简单的golang错误处理。   [![近三年未更新][Y]](https://github.com/neuronlabs/errors)   [![godoc][D]](https://godoc.org/github.com/neuronlabs/errors)

**[⬆ back to top](#contents)**

## 文件处理

_处理文件和文件系统的库。 (翻译出错了? 试试 [英文版](README_EN.md#file-handling) 吧~)_

- [pdfcpu](https://github.com/pdfcpu/pdfcpu) **star:5341** PDF处理器。   [![近一周有更新][G]](https://github.com/pdfcpu/pdfcpu)   [![godoc][D]](https://godoc.org/github.com/pdfcpu/pdfcpu)
- [afero](https://github.com/spf13/afero) **star:5324** 文件系统的抽象系统。   [![近一周有更新][G]](https://github.com/spf13/afero)   [![godoc][D]](https://godoc.org/github.com/spf13/afero)
- [gdu](https://github.com/dundee/gdu) **star:2760** 带有控制台接口的磁盘使用分析器。   [![近一周有更新][G]](https://github.com/dundee/gdu)   [![godoc][D]](https://godoc.org/github.com/dundee/gdu)
- [notify](https://github.com/rjeczalik/notify) **star:841** 文件系统事件通知库，具有类似于os/signal的简单API，。   [![godoc][D]](https://godoc.org/github.com/rjeczalik/notify)
- [copy](https://github.com/otiai10/copy) **star:598** 递归地复制目录。   [![godoc][D]](https://godoc.org/github.com/otiai10/copy)
- [gofs](https://github.com/no-src/gofs) **star:329** A cross-platform real-time file synchronization tool out of the box.   [![近一周有更新][G]](https://github.com/no-src/gofs)   [![godoc][D]](https://godoc.org/github.com/no-src/gofs)   [![包含中文文档][CN]](https://github.com/no-src/gofs)
- [afs](https://github.com/viant/afs) **star:261** 用于Go的抽象文件存储(mem、scp、zip、tar、cloud: s3、gs)。   [![godoc][D]](https://godoc.org/github.com/viant/afs)
- [vfs](https://github.com/C2FO/vfs) **star:252** 一组可插拔的、可扩展的和自定义的文件系统功能，用于跨越许多文件系统类型，如os、S3和GCS。   [![godoc][D]](https://godoc.org/github.com/C2FO/vfs)
- [bigfile](https://github.com/bigfile/bigfile) **star:241** 一个文件传输系统，支持管理文件与http api, rpc调用和ftp客户端。   [![godoc][D]](https://godoc.org/github.com/bigfile/bigfile)   [![包含中文文档][CN]](https://github.com/bigfile/bigfile)   [![归档项目][Archived]](https://github.com/bigfile/bigfile)
- [go-exiftool](https://github.com/barasher/go-exiftool) **star:187** ExifTool 的 Go 实现，这个著名的库用于从文件(图片、PDF、office，…)中提取尽可能多的元数据(EXIF、IPTC，…)。   [![godoc][D]](https://godoc.org/github.com/barasher/go-exiftool)
- [go-csv-tag](https://github.com/artonge/go-csv-tag) **star:108** 使用 tag 加载 csv 文件。   [![godoc][D]](https://godoc.org/github.com/artonge/go-csv-tag)
- [skywalker](https://github.com/dixonwille/skywalker) **star:92** 可以轻松地并发地遍历文件系统。   [![godoc][D]](https://godoc.org/github.com/dixonwille/skywalker)
- [stl](https://gitlab.com/russoj88/stl)  Modules to read and write STL (stereolithography) files. Concurrent algorithm for reading.
- [checksum](https://github.com/codingsince1985/checksum) **star:90** 计算消息摘要，如MD5, SHA256, SHA1, CRC或BLAKE2s，对于大文件。   [![godoc][D]](https://godoc.org/github.com/codingsince1985/checksum)
- [parquet](https://github.com/parsyl/parquet) **star:85** 读写[parquet](https://parquet.apache.org)文件。   [![godoc][D]](https://godoc.org/github.com/parsyl/parquet)
- [opc](https://github.com/qmuntal/opc) **star:75** 加载Open Packaging Conventions (OPC)文件。   [![godoc][D]](https://godoc.org/github.com/qmuntal/opc)
- [tarfs](https://github.com/posener/tarfs) **star:56** tar文件的实现[ FileSystem 接口](https://godoc.org/github.com/kr/fs#FileSystem)。   [![近三年未更新][Y]](https://github.com/posener/tarfs)   [![godoc][D]](https://godoc.org/github.com/posener/tarfs)
- [baraka](https://github.com/xis/baraka) **star:51** 一个轻松处理http文件上传的库。   [![godoc][D]](https://godoc.org/github.com/xis/baraka)
- [go-gtfs](https://github.com/artonge/go-gtfs) **star:37** 加载gtfs文件。   [![godoc][D]](https://godoc.org/github.com/artonge/go-gtfs)
- [flop](https://github.com/homedepot/flop) **star:34** 文件操作库，是[GNU cp](https://www.gnu.org/software/coreutils/manual/html_node/cp-invoc.html)的镜像。   [![godoc][D]](https://godoc.org/github.com/homedepot/flop)
- [gut/yos](https://github.com/1set/gut) **star:27** 简单和可靠的包文件操作，如复制/移动/diff/列表的文件，目录和符号链接。   [![godoc][D]](https://godoc.org/github.com/1set/gut)
- [todotxt](https://github.com/1set/todotxt) **star:19** 去吉娜·特拉帕尼的[_todo.txt_](http://todotxt.org/)文件库，支持解析和操作[_todo.txt_格式](https://github.com/todotxt/todo.txt)的任务列表。   [![godoc][D]](https://godoc.org/github.com/1set/todotxt)
- [go-decent-copy](https://github.com/hugocarreira/go-decent-copy) **star:18** 拷贝文件。   [![近三年未更新][Y]](https://github.com/hugocarreira/go-decent-copy)   [![godoc][D]](https://godoc.org/github.com/hugocarreira/go-decent-copy)
- [higgs](https://github.com/dastoori/higgs) **star:17** 一个小小的跨平台Go库，用于隐藏/取消隐藏文件和目录。   [![godoc][D]](https://godoc.org/github.com/dastoori/higgs)
- [pathtype](https://github.com/jonchun/pathtype) **star:12** 将路径视为它们自己的类型，而不是使用字符串。   [![godoc][D]](https://godoc.org/github.com/jonchun/pathtype)

**[⬆ back to top](#contents)**

## 金融

_会计和财务软件包。 (翻译出错了? 试试 [英文版](README_EN.md#financial) 吧~)_

- [decimal](https://github.com/shopspring/decimal) **star:5342** 任意精度定点的十进制数。   [![近一周有更新][G]](https://github.com/shopspring/decimal)   [![godoc][D]](https://godoc.org/github.com/shopspring/decimal)
- [ticker](https://github.com/achannarasappa/ticker) **star:4653** 终端库存观察和库存位置跟踪。   [![近一周有更新][G]](https://github.com/achannarasappa/ticker)   [![godoc][D]](https://godoc.org/github.com/achannarasappa/ticker)
- [go-money](https://github.com/rhymond/go-money) **star:1361** Fowler 货币模式的实现。   [![godoc][D]](https://godoc.org/github.com/rhymond/go-money)
- [bbgo](https://github.com/c9s/bbgo) **star:951** A crypto trading bot framework written in Go. Including common crypto exchange API, standard indicators, back-testing and many built-in strategies.   [![近一周有更新][G]](https://github.com/c9s/bbgo)   [![godoc][D]](https://godoc.org/github.com/c9s/bbgo)
- [accounting](https://github.com/leekchan/accounting) **star:827** 货币和货币格式。   [![godoc][D]](https://godoc.org/github.com/leekchan/accounting)
- [techan](https://github.com/sdcoffey/techan) **star:744** 拥有先进的市场分析和交易策略的技术分析库。   [![近一周有更新][G]](https://github.com/sdcoffey/techan)   [![godoc][D]](https://godoc.org/github.com/sdcoffey/techan)
- [currency](https://github.com/bojanz/currency) **star:421** 处理货币金额，提供货币信息和格式。   [![godoc][D]](https://godoc.org/github.com/bojanz/currency)
- [ach](https://github.com/moov-io/ach) **star:392** A reader, writer, and validator for Automated Clearing House (ACH) files.   [![godoc][D]](https://godoc.org/github.com/moov-io/ach)
- [orderbook](https://github.com/i25959341/orderbook) **star:350** 限购单匹配引擎。   [![godoc][D]](https://godoc.org/github.com/i25959341/orderbook)
- [go-finance](https://github.com/alpeb/go-finance) **star:154** 用于货币时间价值(年金)、现金流、利率转换、债券和折旧计算的金融函数库。   [![godoc][D]](https://godoc.org/github.com/alpeb/go-finance)
- [transaction](https://github.com/claygod/transaction) **star:124** 嵌入式事务数据库，可多线程模式运行。   [![godoc][D]](https://godoc.org/github.com/claygod/transaction)
- [sleet](https://github.com/BoltApp/sleet) **star:123** 多个付款服务供应商使用统一界面处理网上付款。   [![godoc][D]](https://godoc.org/github.com/BoltApp/sleet)
- [ofxgo](https://github.com/aclindsa/ofxgo) **star:119** 查询 OFX 服务器和/或解析响应。   [![godoc][D]](https://godoc.org/github.com/aclindsa/ofxgo)
- [vat](https://github.com/dannyvankooten/vat) **star:101** 增值税编号验证 & 欧盟增值税税率。   [![godoc][D]](https://godoc.org/github.com/dannyvankooten/vat)
- [go-finnhub](https://github.com/m1/go-finnhub) **star:79** 来自finnhu .io的股票市场、外汇和密码数据客户。从60多个证券交易所、10个外汇经纪人和15多个密码交易所获取实时金融市场数据。   [![近三年未更新][Y]](https://github.com/m1/go-finnhub)   [![godoc][D]](https://godoc.org/github.com/m1/go-finnhub)   [![归档项目][Archived]](https://github.com/m1/go-finnhub)
- [currency](https://github.com/bnkamalesh/currency) **star:53** 高性能、准确的货币计算软件包。   [![godoc][D]](https://godoc.org/github.com/bnkamalesh/currency)
- [fpdecimal](https://github.com/nikolaydubina/fpdecimal) **star:23** Fast and precise serialization and arithmetic for small fixed-point decimals   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/fpdecimal)
- [payme](https://github.com/jovandeginste/payme) **star:23** 二维码生成器(ASCII & PNG)用于SEPA支付。   [![godoc][D]](https://godoc.org/github.com/jovandeginste/payme)
- [fpmoney](https://github.com/nikolaydubina/fpmoney) **star:20** Fast and simple ISO4217 fixed-point decimal money.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/fpmoney)
- [go-finance](https://github.com/pieterclaerhout/go-finance) **star:14** 模块获取汇率，通过VIES检查增值税号码，检查IBAN银行账号。   [![godoc][D]](https://godoc.org/github.com/pieterclaerhout/go-finance)
- [decimal](https://github.com/govalues/decimal) **star:3** Immutable decimal numbers with panic-free arithmetic.   [![近一周有更新][G]](https://github.com/govalues/decimal)   [![godoc][D]](https://godoc.org/github.com/govalues/decimal)
- [money](https://github.com/govalues/money) **star:1** Immutable monetary amounts and exchange rates with panic-free arithmetic.   [![godoc][D]](https://godoc.org/github.com/govalues/money)

**[⬆ back to top](#contents)**

## 表单

_用于处理表单的库。 (翻译出错了? 试试 [英文版](README_EN.md#forms) 吧~)_

- [nosurf](https://github.com/justinas/nosurf) **star:1438** CSRF保护中间件。   [![godoc][D]](https://godoc.org/github.com/justinas/nosurf)
- [gorilla/csrf](https://github.com/gorilla/csrf) **star:920** 用于Go web应用程序和服务的CSRF保护。   [![godoc][D]](https://godoc.org/github.com/gorilla/csrf)
- [binding](https://github.com/mholt/binding) **star:795** 将来自 net/HTTP 请求的表单、JSON 数据绑定到结构体。   [![近三年未更新][Y]](https://github.com/mholt/binding)   [![godoc][D]](https://godoc.org/github.com/mholt/binding)   [![归档项目][Archived]](https://github.com/mholt/binding)
- [form](https://github.com/go-playground/form) **star:629**  将 url 中的数据解析到 Go 变量中，以及将 Go 语言变量编码进 url。支持 Dual Array 及 Full map。   [![godoc][D]](https://godoc.org/github.com/go-playground/form)
- [conform](https://github.com/leebenson/conform) **star:310** 控制用户输入。基于struct tags可对数据进行修剪、清理和擦除。   [![godoc][D]](https://godoc.org/github.com/leebenson/conform)
- [httpin](https://github.com/ggicci/httpin) **star:199** 将HTTP请求解码为自定义结构，包括查询字符串、表单、HTTP头等。   [![近一周有更新][G]](https://github.com/ggicci/httpin)   [![godoc][D]](https://godoc.org/github.com/ggicci/httpin)
- [formam](https://github.com/monoculum/formam) **star:181** 将表单的值解码为 struct。   [![godoc][D]](https://godoc.org/github.com/monoculum/formam)
- [forms](https://github.com/albrow/forms) **star:132** 与框架无关的库，用于解析和验证支持多部分表单和文件的表单/JSON数据。   [![godoc][D]](https://godoc.org/github.com/albrow/forms)
- [qs](https://github.com/sonh/qs) **star:66** 去模块编码结构到URL查询参数。   [![godoc][D]](https://godoc.org/github.com/sonh/qs)
- [bind](https://github.com/robfig/bind) **star:29** 将表单数据与任意 Go 变量进行绑定。   [![近三年未更新][Y]](https://github.com/robfig/bind)   [![godoc][D]](https://godoc.org/github.com/robfig/bind)
- [queryparam](https://github.com/tomwright/queryparam) **star:16** 解码的url。值转换为标准或自定义类型的可用结构值。   [![近三年未更新][Y]](https://github.com/tomwright/queryparam)   [![godoc][D]](https://godoc.org/github.com/tomwright/queryparam)
- [gbind](https://github.com/bdjimmy/gbind) **star:8** Bind data to any Go value. Can use built-in and custom expression binding capabilities; supports data validation   [![godoc][D]](https://godoc.org/github.com/bdjimmy/gbind)   [![包含中文文档][CN]](https://github.com/bdjimmy/gbind)

**[⬆ back to top](#contents)**

## 方法

_在Go中支持函数式编程的包。 (翻译出错了? 试试 [英文版](README_EN.md#functional) 吧~)_

- [mo](https://github.com/samber/mo) **star:1784** Monads and popular FP abstractions, based on Go 1.18+ Generics (Option, Result, Either...).   [![godoc][D]](https://godoc.org/github.com/samber/mo)
- [go-underscore](https://github.com/tobyhede/go-underscore) **star:1293** 常用辅助方法集合。   [![godoc][D]](https://godoc.org/github.com/tobyhede/go-underscore)
- [fpGo](https://github.com/TeaEntityLab/fpGo) **star:327** 提供函数式编程功能。   [![godoc][D]](https://godoc.org/github.com/TeaEntityLab/fpGo)
- [fp-go](https://github.com/repeale/fp-go) **star:252** Collection of Functional Programming helpers powered by Golang 1.18+ generics.   [![godoc][D]](https://godoc.org/github.com/repeale/fp-go)
- [go-functional](https://github.com/BooleanCat/go-functional) **star:200** Functional programming in Go using generics   [![godoc][D]](https://godoc.org/github.com/BooleanCat/go-functional)
- [fuego](https://github.com/seborama/fuego) **star:141** Functional Experiment in Go。   [![godoc][D]](https://godoc.org/github.com/seborama/fuego)
- [gofp](https://github.com/rbrahul/gofp) **star:140** 一个类似lodash的强大的Golang实用程序库。   [![godoc][D]](https://godoc.org/github.com/rbrahul/gofp)
- [underscore](https://github.com/rjNemo/underscore) **star:92** Go 1.18及以上版本的函数式编程助手。   [![godoc][D]](https://godoc.org/github.com/rjNemo/underscore)
- [valor](https://github.com/phelmkamp/valor) **star:14** Generic option and result types that optionally contain a value.   [![godoc][D]](https://godoc.org/github.com/phelmkamp/valor)

**[⬆ back to top](#contents)**

## 游戏开发

_很棒的游戏开发库。 (翻译出错了? 试试 [英文版](README_EN.md#game-development) 吧~)_

- [Ebitengine](https://github.com/hajimehoshi/ebiten) **star:8725** dead simple 2D game engine in Go.   [![近一周有更新][G]](https://github.com/hajimehoshi/ebiten)   [![godoc][D]](https://godoc.org/github.com/hajimehoshi/ebiten)
- [Leaf](https://github.com/name5566/leaf) **star:4979** 轻量级游戏服务器框架。   [![godoc][D]](https://godoc.org/github.com/name5566/leaf)   [![包含中文文档][CN]](https://github.com/name5566/leaf)
- [Pixel](https://github.com/faiface/pixel) **star:4294** 手工制作的 2D 游戏库。   [![godoc][D]](https://godoc.org/github.com/faiface/pixel)
- [nano](https://github.com/lonng/nano) **star:2474** 轻量级、方便、高性能的基于golang的游戏服务器框架。   [![godoc][D]](https://godoc.org/github.com/lonng/nano)   [![包含中文文档][CN]](https://github.com/lonng/nano)
- [g3n](https://github.com/g3n/engine) **star:2423**  3D游戏引擎。   [![godoc][D]](https://godoc.org/github.com/g3n/engine)
- [goworld](https://github.com/xiaonanln/goworld) **star:2401** 可伸缩的游戏服务器引擎，具有 space-entity 框架和 hot-swapping 功能。   [![godoc][D]](https://godoc.org/github.com/xiaonanln/goworld)   [![包含中文文档][CN]](https://github.com/xiaonanln/goworld)
- [go-sdl2](https://github.com/veandco/go-sdl2) **star:2023** 实现了[Simple DirectMedia Layer](https://www.libsdl.org/)。
- [Pitaya](https://github.com/topfreegames/pitaya) **star:1954** 可伸缩的游戏服务器框架，支持集群和客户端库的iOS, Android, Unity。   [![近一周有更新][G]](https://github.com/topfreegames/pitaya)   [![godoc][D]](https://godoc.org/github.com/topfreegames/pitaya)
- [engo](https://github.com/EngoEngine/engo) **star:1643** 开源 2D 游戏引擎。它遵循 Entity-Component-System 范式。   [![godoc][D]](https://godoc.org/github.com/EngoEngine/engo)
- [Oak](https://github.com/oakmound/oak) **star:1440** 纯 Go 实现的游戏引擎。   [![godoc][D]](https://godoc.org/github.com/oakmound/oak)
- [termloop](https://github.com/JoelOtter/termloop) **star:1363** 基于终端的 Go 游戏引擎，建立在 Termbox 之上。   [![godoc][D]](https://godoc.org/github.com/JoelOtter/termloop)
- [gonet](https://github.com/xtaci/gonet) **star:1236** 实现了游戏服务器骨架。   [![近三年未更新][Y]](https://github.com/xtaci/gonet)   [![godoc][D]](https://godoc.org/github.com/xtaci/gonet)
- [raylib-go](https://github.com/gen2brain/raylib-go) **star:1061** 去绑定[raylib](https://www.raylib.com/)，一个简单易用的库学习视频游戏编程。
- [Azul3D](https://github.com/azul3d/engine) **star:590** 用Go编写的 3D 游戏引擎。
- [go-astar](https://github.com/beefsack/go-astar) **star:562** 实现了A\*路径查找算法。   [![godoc][D]](https://godoc.org/github.com/beefsack/go-astar)
- [Harfang3D](https://github.com/harfang3d/harfang3d) **star:397** 3D engine for the Go language, works on Windows and Linux ([Harfang on Go.dev](https://github.com/harfang3d/harfang-go)).   [![近一周有更新][G]](https://github.com/harfang3d/harfang3d)
- [go3d](https://github.com/ungerik/go3d) **star:285** 以性能为主的2D/3D数学相关包。   [![godoc][D]](https://godoc.org/github.com/ungerik/go3d)
- [tile](https://github.com/kelindar/tile) **star:113** 面向数据和缓存友好的2D网格库(TileMap)，包括寻路、观察者和导入/导出。   [![近一周有更新][G]](https://github.com/kelindar/tile)   [![godoc][D]](https://godoc.org/github.com/kelindar/tile)
- [prototype](https://github.com/gonutz/prototype) **star:81** 跨平台(Windows/Linux/Mac)库，用于使用最少的API创建桌面游戏。   [![godoc][D]](https://godoc.org/github.com/gonutz/prototype)
- [fantasyname](https://github.com/s0rg/fantasyname) **star:20** Fantasy names generator.   [![godoc][D]](https://godoc.org/github.com/s0rg/fantasyname)

**[⬆ back to top](#contents)**

## 发电机

_生成Go代码的工具。 (翻译出错了? 试试 [英文版](README_EN.md#generators) 吧~)_

- [go-linq](https://github.com/ahmetalpbalkan/go-linq) **star:3352** 提供类似 .NET LINQ 的查询方法。   [![godoc][D]](https://godoc.org/github.com/ahmetalpbalkan/go-linq)
- [jennifer](https://github.com/dave/jennifer) **star:3004** 不使用模板生成任意 Go 代码。   [![godoc][D]](https://godoc.org/github.com/dave/jennifer)
- [goderive](https://github.com/awalterschulze/goderive) **star:1129** 从输入类型来派生函数。   [![godoc][D]](https://godoc.org/github.com/awalterschulze/goderive)
- [GoWrap](https://github.com/hexdigest/gowrap) **star:798** 使用简单模板为 Go 接口生成装饰器。   [![godoc][D]](https://godoc.org/github.com/hexdigest/gowrap)
- [go-enum](https://github.com/abice/go-enum) **star:548** 从代码注释中生成枚举。   [![近一周有更新][G]](https://github.com/abice/go-enum)   [![godoc][D]](https://godoc.org/github.com/abice/go-enum)
- [interfaces](https://github.com/rjeczalik/interfaces) **star:400** 用于生成接口定义的命令行工具。   [![godoc][D]](https://godoc.org/github.com/rjeczalik/interfaces)
- [goverter](https://github.com/jmattheis/goverter) **star:310** 通过定义接口生成转换器。   [![近一周有更新][G]](https://github.com/jmattheis/goverter)   [![godoc][D]](https://godoc.org/github.com/jmattheis/goverter)
- [copygen](https://github.com/switchupcb/copygen) **star:282** Generate type-to-type and type-based code without reflection.   [![近一周有更新][G]](https://github.com/switchupcb/copygen)   [![godoc][D]](https://godoc.org/github.com/switchupcb/copygen)
- [gotype](https://github.com/wzshiming/gotype) **star:56** Golang 源码解析，用法类似reflect(反射)。   [![godoc][D]](https://godoc.org/github.com/wzshiming/gotype)   [![包含中文文档][CN]](https://github.com/wzshiming/gotype)
- [generis](https://github.com/senselogic/GENERIS) **star:42** 提供泛型、free-form 宏、条件编译和HTML模板的代码生成工具。
- [typeregistry](https://github.com/xiaoxin01/typeregistry) **star:21** 动态创建类型的库。   [![近三年未更新][Y]](https://github.com/xiaoxin01/typeregistry)   [![godoc][D]](https://godoc.org/github.com/xiaoxin01/typeregistry)
- [convergen](https://github.com/reedom/convergen) **star:8** Feature rich type-to-type copy code generator.   [![godoc][D]](https://godoc.org/github.com/reedom/convergen)

**[⬆ back to top](#contents)**

## 地理

_地理工具和服务器 (翻译出错了? 试试 [英文版](README_EN.md#geographic) 吧~)_

- [Tile38](https://github.com/tidwall/tile38) **star:8670** 具有空间索引和实时地理定位功能的地理定位数据库。   [![近一周有更新][G]](https://github.com/tidwall/tile38)   [![godoc][D]](https://godoc.org/github.com/tidwall/tile38)
- [S2 geometry](https://github.com/golang/geo) **star:1564** S2 geometry 库。   [![godoc][D]](https://godoc.org/github.com/golang/geo)
- [mbtileserver](https://github.com/consbio/mbtileserver) **star:536** 一个简单的基于go的服务器，用于存储mbtiles格式的地图块。   [![godoc][D]](https://godoc.org/github.com/consbio/mbtileserver)
- [osm](https://github.com/paulmach/osm) **star:293** 用于读取、写入和处理 OpenStreetMap 数据和 APIs。   [![godoc][D]](https://godoc.org/github.com/paulmach/osm)
- [H3](https://github.com/uber/h3-go) **star:240** Go bindings for H3, a hierarchical hexagonal geospatial indexing system.   [![godoc][D]](https://godoc.org/github.com/uber/h3-go)
- [godal](https://github.com/airbusgeo/godal) **star:104** 去包装GDAL。   [![近一周有更新][G]](https://github.com/airbusgeo/godal)   [![godoc][D]](https://godoc.org/github.com/airbusgeo/godal)
- [simplefeatures](https://github.com/peterstace/simplefeatures) **star:96** simplesfeatures是一个2D几何库，提供了建模几何图形的Go类型，以及对几何图形进行操作的算法。   [![近一周有更新][G]](https://github.com/peterstace/simplefeatures)   [![godoc][D]](https://godoc.org/github.com/peterstace/simplefeatures)
- [geoserver](https://github.com/hishamkaram/geoserver) **star:84** 基于geoserver REST API的 geoserver 实例。   [![godoc][D]](https://godoc.org/github.com/hishamkaram/geoserver)
- [gismanager](https://github.com/hishamkaram/gismanager) **star:50** 将你的 GIS 数据(矢量数据)发布到 PostGIS 和 Geoserver。   [![近三年未更新][Y]](https://github.com/hishamkaram/gismanager)   [![godoc][D]](https://godoc.org/github.com/hishamkaram/gismanager)
- [pbf](https://github.com/maguro/pbf) **star:45** 基于Golang 的 OpenStreetMap PBF 编码器/解码器。   [![godoc][D]](https://godoc.org/github.com/maguro/pbf)
- [S2 geojson](https://github.com/pantrif/s2-geojson) **star:25** 将geojson转换为s2单元格&在map上演示一些s2的几何特性。   [![近三年未更新][Y]](https://github.com/pantrif/s2-geojson)   [![godoc][D]](https://godoc.org/github.com/pantrif/s2-geojson)
- [H3 GeoJSON](https://github.com/mmadfox/go-geojson2h3) **star:3** Conversion utilities between H3 indexes and GeoJSON.   [![godoc][D]](https://godoc.org/github.com/mmadfox/go-geojson2h3)
- [H3GeoDist](https://github.com/mmadfox/go-h3geo-dist) **star:1** Distribution of Uber H3geo cells by virtual nodes.   [![godoc][D]](https://godoc.org/github.com/mmadfox/go-h3geo-dist)
- [Web-Mercator-Projection](https://github.com/jorelosorio/web-mercator-projection) A project to easily use and convert LonLat, Point and Tile to display info, markers, etc, in a map using the Web Mercator Projection.
- [WGS84](https://github.com/wroge/wgs84) **star:99** 坐标转换和转换库(ETRS89, OSGB36, NAD83, RGF93, Web Mercator, UTM)。   [![godoc][D]](https://godoc.org/github.com/wroge/wgs84)

**[⬆ back to top](#contents)**

## Go 编译器

_可将 Go 转换为其他语言的编译工具。 (翻译出错了? 试试 [英文版](README_EN.md#go-compilers) 吧~)_

- [gopherjs](https://github.com/gopherjs/gopherjs) **star:12102** 将 Go 编译成 JavaScript。   [![近一周有更新][G]](https://github.com/gopherjs/gopherjs)   [![godoc][D]](https://godoc.org/github.com/gopherjs/gopherjs)
- [tardisgo](https://github.com/tardisgo/tardisgo) **star:427** Golang 转换为 Haxe，再转换为 CPP/CSharp/Java/JavaScript 的编译器.   [![近三年未更新][Y]](https://github.com/tardisgo/tardisgo)   [![godoc][D]](https://godoc.org/github.com/tardisgo/tardisgo)
- [c4go](https://github.com/Konstantin8105/c4go) **star:338** 将 C 代码转换为 Go 代码。
- [c2go](https://github.com/goplus/c2go) **star:274** Convert C code to Go code.   [![近一周有更新][G]](https://github.com/goplus/c2go)   [![godoc][D]](https://godoc.org/github.com/goplus/c2go)
- [esp32](https://github.com/andygeiss/esp32-transpiler) **star:71** 转到Arduino代码。   [![godoc][D]](https://godoc.org/github.com/andygeiss/esp32-transpiler)
- [f4go](https://github.com/Konstantin8105/f4go) **star:37** 将 FORTRAN 77 转换为 Go代码。   [![godoc][D]](https://godoc.org/github.com/Konstantin8105/f4go)

**[⬆ back to top](#contents)**

## Goroutines

_管理和处理 Goroutines 的工具。 (翻译出错了? 试试 [英文版](README_EN.md#goroutines) 吧~)_

- [ants](https://github.com/panjf2000/ants) **star:10986** 一个高性能且低损耗的 goroutine 池。   [![godoc][D]](https://godoc.org/github.com/panjf2000/ants)   [![包含中文文档][CN]](https://github.com/panjf2000/ants)
- [conc](https://github.com/sourcegraph/conc) **star:7255** `conc` is your toolbelt for structured concurrency in go, making common tasks easier and safer.   [![godoc][D]](https://godoc.org/github.com/sourcegraph/conc)
- [tunny](https://github.com/Jeffail/tunny) **star:3683** golang 的协程池。   [![godoc][D]](https://godoc.org/github.com/Jeffail/tunny)
- [goworker](https://github.com/benmanns/goworker) **star:2754** 基于 go 的后台 worker。   [![godoc][D]](https://godoc.org/github.com/benmanns/goworker)
- [workerpool](https://github.com/gammazero/workerpool) **star:1143** 限制任务执行并发数，而不是队列中的任务数量的协程池，。   [![godoc][D]](https://godoc.org/github.com/gammazero/workerpool)
- [pond](https://github.com/alitto/pond) **star:975** 简约和高性能的goroutine工作池写在Go。   [![godoc][D]](https://godoc.org/github.com/alitto/pond)
- [grpool](https://github.com/ivpusic/grpool) **star:734** 轻量级协程池。   [![近三年未更新][Y]](https://github.com/ivpusic/grpool)   [![godoc][D]](https://godoc.org/github.com/ivpusic/grpool)
- [pool](https://github.com/go-playground/pool) **star:720** 有限消费者协程或无限协程池，可用于更加简单的处理和取消协程   [![godoc][D]](https://godoc.org/github.com/go-playground/pool)
- [gowp](https://github.com/xxjwxc/gowp) **star:479** gowp是高并发性限制异步工作池。   [![godoc][D]](https://godoc.org/github.com/xxjwxc/gowp)   [![包含中文文档][CN]](https://github.com/xxjwxc/gowp)
- [go-floc](https://github.com/workanator/go-floc) **star:262** 轻松编排 goroutines。   [![godoc][D]](https://godoc.org/github.com/workanator/go-floc)
- [go-flow](https://github.com/kamildrazkiewicz/go-flow) **star:215** 控制 goroutines 的执行顺序。   [![近三年未更新][Y]](https://github.com/kamildrazkiewicz/go-flow)   [![godoc][D]](https://godoc.org/github.com/kamildrazkiewicz/go-flow)
- [artifex](https://github.com/borderstech/artifex) **star:178** 简单的内存作业队列。   [![godoc][D]](https://godoc.org/github.com/borderstech/artifex)
- [flowmatic](https://github.com/carlmjohnson/flowmatic) **star:168** Structured concurrency made easy.   [![godoc][D]](https://godoc.org/github.com/carlmjohnson/flowmatic)
- [semaphore](https://github.com/marusama/semaphore) **star:161** 基于 CAS 的可快速调整的信号量实现(比基于通道的信号量实现更快)。   [![godoc][D]](https://godoc.org/github.com/marusama/semaphore)
- [go-workers](https://github.com/catmullet/go-workers) **star:160** 为大型数据处理管道轻松安全地运行工人。   [![godoc][D]](https://godoc.org/github.com/catmullet/go-workers)
- [routine](https://github.com/timandy/routine) **star:154** `routine` is a `ThreadLocal` for go library. It encapsulates and provides some easy-to-use, non-competitive, high-performance `goroutine` context access interfaces, which can help you access coroutine context information more gracefully.   [![godoc][D]](https://godoc.org/github.com/timandy/routine)   [![包含中文文档][CN]](https://github.com/timandy/routine)
- [neilotoole/errgroup](https://github.com/neilotoole/errgroup) **star:151** “sync/errgroup”的替代方案，仅限于N个worker goroutines池。   [![godoc][D]](https://godoc.org/github.com/neilotoole/errgroup)
- [async](https://github.com/reugn/async) **star:143** 可选的Go同步库(Future, Promise, Locks)。   [![godoc][D]](https://godoc.org/github.com/reugn/async)
- [cyclicbarrier](https://github.com/marusama/cyclicbarrier) **star:131** 基于 Go 的 CyclicBarrier 实现。   [![近三年未更新][Y]](https://github.com/marusama/cyclicbarrier)   [![godoc][D]](https://godoc.org/github.com/marusama/cyclicbarrier)
- [async](https://github.com/studiosol/async) **star:125** 一种异步执行函数的安全方法，在出现 panic 时恢复它们。   [![godoc][D]](https://godoc.org/github.com/studiosol/async)
- [gollback](https://github.com/vardius/gollback) **star:111** 异步简单的函数实用程序，用于管理闭包和回调的执行。   [![godoc][D]](https://godoc.org/github.com/vardius/gollback)
- [semaphore](https://github.com/kamilsk/semaphore) **star:96** 信号量模式实现，可根据通道和上下文进行具备超时功能的锁定/解锁操作。   [![近三年未更新][Y]](https://github.com/kamilsk/semaphore)   [![godoc][D]](https://godoc.org/github.com/kamilsk/semaphore)
- [threadpool](https://github.com/shettyh/threadpool) **star:96** Golang 的 threadpool 实现。   [![近三年未更新][Y]](https://github.com/shettyh/threadpool)   [![godoc][D]](https://godoc.org/github.com/shettyh/threadpool)
- [Hunch](https://github.com/AaronJan/Hunch) **star:95** Hunch 提供了诸如 All、First、Retry、Waterfall 等功能，这使得异步流控制更加直观。   [![godoc][D]](https://godoc.org/github.com/AaronJan/Hunch)
- [worker-pool](https://github.com/vardius/worker-pool) **star:87** 一个简单的 Go 异步工作池。   [![godoc][D]](https://godoc.org/github.com/vardius/worker-pool)
- [gpool](https://github.com/Sherifabdlnaby/gpool) **star:86** manages a resizeable pool of context-aware goroutines to bound concurrency   [![近三年未更新][Y]](https://github.com/Sherifabdlnaby/gpool)   [![godoc][D]](https://godoc.org/github.com/Sherifabdlnaby/gpool)
- [go-actor](https://github.com/vladopajic/go-actor) **star:69** A tiny library for writing concurrent programs using actor model.   [![godoc][D]](https://godoc.org/github.com/vladopajic/go-actor)
- [goccm](https://github.com/zenthangplus/goccm) **star:66** Go并发管理器包限制了允许并发运行的goroutines的数量。   [![godoc][D]](https://godoc.org/github.com/zenthangplus/goccm)
- [nursery](https://github.com/arunsworld/nursery) **star:63** Go中的结构化并发。   [![godoc][D]](https://godoc.org/github.com/arunsworld/nursery)
- [oversight](https://cirello.io/oversight)  完整的实现了Erlang supervision trees。
- [gowl](https://github.com/hamed-yousefi/gowl) **star:59** Gowl同时是一个流程管理和流程监控工具。无限工作者池使您能够控制池和进程并监视它们的状态。   [![godoc][D]](https://godoc.org/github.com/hamed-yousefi/gowl)
- [routine](https://github.com/x-mod/routine) **star:58** go routine control with context, support: Main, Go, Pool and some useful Executors.   [![godoc][D]](https://godoc.org/github.com/x-mod/routine)
- [gohive](https://github.com/loveleshsharma/gohive) **star:44** 一个高性能和易于使用的Goroutine池去。   [![godoc][D]](https://godoc.org/github.com/loveleshsharma/gohive)
- [go-waitgroup](https://github.com/pieterclaerhout/go-waitgroup) **star:42** 像“同步。有错误处理和并发控制。   [![godoc][D]](https://godoc.org/github.com/pieterclaerhout/go-waitgroup)
- [kyoo](https://github.com/dirkaholic/kyoo) **star:42** 提供无限的作业队列和并发工作池。   [![godoc][D]](https://godoc.org/github.com/dirkaholic/kyoo)
- [parallel-fn](https://github.com/rafaeljesus/parallel-fn) **star:35** 并行运行函数。   [![近三年未更新][Y]](https://github.com/rafaeljesus/parallel-fn)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/parallel-fn)
- [go-trylock](https://github.com/subchen/go-trylock) **star:33** 支持 read-write 锁。   [![godoc][D]](https://godoc.org/github.com/subchen/go-trylock)
- [channelify](https://github.com/ddelizia/channelify) **star:27** 将函数转换为返回通道，以便进行简单而强大的并行处理。   [![godoc][D]](https://godoc.org/github.com/ddelizia/channelify)
- [stl](https://github.com/ssgreg/stl) **star:27** 基于软件事务内存(STM)并发控制机制的软件事务锁。   [![近三年未更新][Y]](https://github.com/ssgreg/stl)   [![godoc][D]](https://godoc.org/github.com/ssgreg/stl)
- [breaker](https://github.com/kamilsk/breaker) **star:16** 灵活的机制，可以使执行流可中断。
- [execpool](https://github.com/hexdigest/execpool) **star:16** 一个围绕exec建立的池。Cmd，它预先启动给定数量的进程，并在需要时将stdin和stdout附加到它们。非常类似于FastCGI或Apache Prefork MPM，但适用于任何命令。   [![godoc][D]](https://godoc.org/github.com/hexdigest/execpool)
- [concurrency-limiter](https://github.com/vivek-ng/concurrency-limiter) **star:15** 支持超时、动态优先级和上下文取消的并发限制器。   [![godoc][D]](https://godoc.org/github.com/vivek-ng/concurrency-limiter)
- [queue](https://github.com/AnikHasibul/queue) **star:14** 提供类似队列组可访问性 sync.WaitGroup 的功能。帮助你节流和限制协程、等待所有协程结束以及更多功能。   [![近三年未更新][Y]](https://github.com/AnikHasibul/queue)   [![godoc][D]](https://godoc.org/github.com/AnikHasibul/queue)
- [conexec](https://github.com/ITcathyh/conexec) **star:13** 一个并发工具包，帮助以高效和安全的方式并发执行函数。它支持指定总体超时来避免阻塞，并使用goroutine池来提高效率。   [![近三年未更新][Y]](https://github.com/ITcathyh/conexec)   [![godoc][D]](https://godoc.org/github.com/ITcathyh/conexec)
- [go-tools/multithreading](https://github.com/nikhilsaraf/go-tools) **star:12** 轻量级的协程池库，可以通过简单的API来管理。   [![近三年未更新][Y]](https://github.com/nikhilsaraf/go-tools)   [![godoc][D]](https://godoc.org/github.com/nikhilsaraf/go-tools)
- [hands](https://github.com/duanckham/hands) **star:10** 进程控制器，用于控制多个goroutine的执行和返回策略。   [![godoc][D]](https://godoc.org/github.com/duanckham/hands)
- [async-job](https://github.com/lab210-dev/async-job) **star:7** AsyncJob is an asynchronous queue job manager with light code, clear and speed.   [![godoc][D]](https://godoc.org/github.com/lab210-dev/async-job)
- [go-workerpool](https://github.com/zenthangplus/go-workerpool) **star:7** Inspired from Java Thread Pool, Go WorkerPool aims to control heavy Go Routines.   [![godoc][D]](https://godoc.org/github.com/zenthangplus/go-workerpool)

**[⬆ back to top](#contents)**

## GUI

_用于构建GUI应用程序的库。 (翻译出错了? 试试 [英文版](README_EN.md#gui) 吧~)_

_工具包 (翻译出错了? 试试 [英文版](README_EN.md#gui) 吧~)_

- [fyne](https://github.com/fyne-io/fyne) **star:21297** 基于材料设计的Go跨平台本机gui设计。支持:Linux, macOS, Windows, BSD, iOS和Android。   [![近一周有更新][G]](https://github.com/fyne-io/fyne)   [![godoc][D]](https://godoc.org/github.com/fyne-io/fyne)
- [gio](https://gioui.org)  Gio is a library for writing cross-platform immediate mode GUI-s in Go. Gio supports all the major platforms: Linux, macOS, Windows, Android, iOS, FreeBSD, OpenBSD and WebAssembly.
- [webview](https://github.com/zserge/webview) **star:11474** 跨平台webview窗口，具有简单的双向JavaScript绑定(Windows / macOS / Linux)。   [![近一周有更新][G]](https://github.com/zserge/webview)
- [qt](https://github.com/therecipe/qt) **star:9954** 实现了 Qt 的 Go接口(支持Windows / macOS / Linux / Android / iOS / Sailfish OS / Raspberry Pi)。   [![godoc][D]](https://godoc.org/github.com/therecipe/qt)
- [ui](https://github.com/andlabs/ui) **star:8288** 跨平台的 Platform-native GUI 库。   [![godoc][D]](https://godoc.org/github.com/andlabs/ui)
- [Wails](https://wails.io)  Mac, Windows, Linux桌面应用程序，主要基于含有内置的OS HTML渲染器的HTML UI。
- [app](https://github.com/murlokswarm/app) **star:7245** 用于创建包含了 GO, HTML 和 CSS 的应用程序。支持 MacOS, Windows 正在开发中。   [![godoc][D]](https://godoc.org/github.com/murlokswarm/app)
- [walk](https://github.com/lxn/walk) **star:6530** Windows应用程序库。   [![godoc][D]](https://godoc.org/github.com/lxn/walk)
- [go-astilectron](https://github.com/asticode/go-astilectron) **star:4810** 使用 GO 和 HTML/JS/CSS (电子驱动)进行构建跨平台 GUI 应用程序。   [![godoc][D]](https://godoc.org/github.com/asticode/go-astilectron)
- [go-gtk](https://mattn.github.io/go-gtk/)  实现了 GTK 的 Go接口。
- [go-sciter](https://github.com/sciter-sdk/go-sciter) **star:2537** 实现了 Sciter 的 Go 接口 : 用于现代桌面 UI 开发的可嵌入HTML/CSS/脚本引擎。可跨平台。
- [gotk3](https://github.com/gotk3/gotk3) **star:1947** 实现了 GTK3 的 Go接口。   [![godoc][D]](https://godoc.org/github.com/gotk3/gotk3)
- [gowd](https://github.com/dtylman/gowd) **star:404** 跨平台、快速、简单的桌面UI开发，采用了GO, HTML, CSS和NW.js实现。   [![godoc][D]](https://godoc.org/github.com/dtylman/gowd)
- [goradd/html5tag](https://github.com/goradd/html5tag) **star:4** 输出HTML5标签的库。   [![godoc][D]](https://godoc.org/github.com/goradd/html5tag)

_交互 (翻译出错了? 试试 [英文版](README_EN.md#gui) 吧~)_

- [robotgo](https://github.com/go-vgo/robotgo) **star:8677** 实现跨平台的GUI系统自动化。包含了控制鼠标、键盘等功能。   [![godoc][D]](https://godoc.org/github.com/go-vgo/robotgo)
- [systray](https://github.com/getlantern/systray) **star:2886** 跨平台 Go 库，可在通知区放置图标和菜单。   [![近一周有更新][G]](https://github.com/getlantern/systray)   [![godoc][D]](https://godoc.org/github.com/getlantern/systray)
- [gosx-notifier](https://github.com/deckarep/gosx-notifier) **star:579** OSX 桌面通知库。   [![近三年未更新][Y]](https://github.com/deckarep/gosx-notifier)   [![godoc][D]](https://godoc.org/github.com/deckarep/gosx-notifier)
- [zenity](https://github.com/ncruces/zenity) **star:541** 跨平台的Go库和CLI创建简单的对话框，与用户进行图形化交互。   [![近一周有更新][G]](https://github.com/ncruces/zenity)   [![godoc][D]](https://godoc.org/github.com/ncruces/zenity)
- [trayhost](https://github.com/shurcooL/trayhost) **star:241** 跨平台 Go 库，可用于在主机操作系统的任务栏中放置图标。   [![godoc][D]](https://godoc.org/github.com/shurcooL/trayhost)
- [mac-sleep-notifier](https://github.com/prashantgupta24/mac-sleep-notifier) **star:29** OSX 睡眠/唤醒通知。   [![近三年未更新][Y]](https://github.com/prashantgupta24/mac-sleep-notifier)   [![godoc][D]](https://godoc.org/github.com/prashantgupta24/mac-sleep-notifier)
- [mac-activity-tracker](https://github.com/prashantgupta24/activity-tracker) **star:24** 用于通知计算机上的任何(可插入的)活动的 OSX 库。   [![godoc][D]](https://godoc.org/github.com/prashantgupta24/activity-tracker)
- [AppIndicator Go](https://github.com/gopherlibs/appindicator) **star:3** 实现了 libappindicator3 C库 的 Go接口。   [![godoc][D]](https://godoc.org/github.com/gopherlibs/appindicator)

**[⬆ back to top](#contents)**

## 硬件

_硬件交互相关的库、工具和教程。 (翻译出错了? 试试 [英文版](README_EN.md#hardware) 吧~)_

- [arduino-cli](https://github.com/arduino/arduino-cli) **star:4001** 官方Arduino CLI和库。可以独立运行，也可以合并到更大的Go项目中。   [![近一周有更新][G]](https://github.com/arduino/arduino-cli)   [![godoc][D]](https://godoc.org/github.com/arduino/arduino-cli)
- [go-rpio](https://github.com/stianeikeland/go-rpio) **star:2051** GPIO for Go，不需要cgo。   [![godoc][D]](https://godoc.org/github.com/stianeikeland/go-rpio)
- [ghw](https://github.com/jaypipes/ghw) **star:1476** Golang硬件发现/检查库。   [![godoc][D]](https://godoc.org/github.com/jaypipes/ghw)
- [emgo](https://github.com/ziutek/emgo) **star:1030** 用于嵌入式系统(如STM32 MCU)编程的Go-like语言。
- [sysinfo](https://github.com/zcalusic/sysinfo) **star:454** 一个提供Linux操作系统/内核/硬件系统信息的纯Go库。   [![godoc][D]](https://godoc.org/github.com/zcalusic/sysinfo)
- [goroslib](https://github.com/aler9/goroslib) **star:272** Go机器人操作系统(ROS)库。   [![近一周有更新][G]](https://github.com/aler9/goroslib)   [![godoc][D]](https://godoc.org/github.com/aler9/goroslib)
- [go-osc](https://github.com/hypebeast/go-osc) **star:175** 为Go打开声音控制(OSC)绑定。   [![godoc][D]](https://godoc.org/github.com/hypebeast/go-osc)
- [joystick](https://github.com/0xcafed00d/joystick) **star:47** 用于读取附加操纵杆状态的轮询API。   [![godoc][D]](https://godoc.org/github.com/0xcafed00d/joystick)

**[⬆ back to top](#contents)**

## 图片

_图像处理相关的库。 (翻译出错了? 试试 [英文版](README_EN.md#images) 吧~)_

- [gocv](https://github.com/hybridgroup/gocv) **star:5753** 使用OpenCV 3.3+实现的计算机视觉(ComputerVision)的Go语言包。   [![godoc][D]](https://godoc.org/github.com/hybridgroup/gocv)
- [imaginary](https://github.com/h2non/imaginary) **star:5091** 用于图像大小调整的快速、简单的HTTP微服务。   [![godoc][D]](https://godoc.org/github.com/h2non/imaginary)
- [imaging](https://github.com/disintegration/imaging) **star:4826** 简单的Go图像处理包。   [![godoc][D]](https://godoc.org/github.com/disintegration/imaging)
- [gg](https://github.com/fogleman/gg) **star:4035** 纯Go语言实现的2D渲染。   [![godoc][D]](https://godoc.org/github.com/fogleman/gg)
- [bild](https://github.com/anthonynsimon/bild) **star:3831** 纯Go语言实现的图像处理算法合集。   [![godoc][D]](https://godoc.org/github.com/anthonynsimon/bild)
- [ln](https://github.com/fogleman/ln) **star:3201** Go实现的3D线艺术（3D Line Art）渲染。   [![近三年未更新][Y]](https://github.com/fogleman/ln)   [![godoc][D]](https://godoc.org/github.com/fogleman/ln)
- [resize](https://github.com/nfnt/resize) **star:2959** Go实现的使用常用的插值法（interpolation methods）调整图像大小的库。   [![godoc][D]](https://godoc.org/github.com/nfnt/resize)   [![归档项目][Archived]](https://github.com/nfnt/resize)
- [bimg](https://github.com/h2non/bimg) **star:2359** 使用libvips实现的快速高效的图像处理包。   [![godoc][D]](https://godoc.org/github.com/h2non/bimg)
- [gowitness](https://github.com/sensepost/gowitness) **star:2332** 在命令行上使用go和headless chrome截屏网页。   [![godoc][D]](https://godoc.org/github.com/sensepost/gowitness)
- [pt](https://github.com/fogleman/pt) **star:2054** Go实现的路径跟踪（path tracing）引擎。   [![近三年未更新][Y]](https://github.com/fogleman/pt)   [![godoc][D]](https://godoc.org/github.com/fogleman/pt)
- [svgo](https://github.com/ajstarks/svgo) **star:2035**  Go实现的SVG生成库。   [![godoc][D]](https://godoc.org/github.com/ajstarks/svgo)
- [picfit](https://github.com/thoas/picfit) **star:1889** Go实现的图像调整服务器。   [![godoc][D]](https://godoc.org/github.com/thoas/picfit)
- [smartcrop](https://github.com/muesli/smartcrop) **star:1752** 为任意图片寻找合适的位置进行图片裁剪。   [![godoc][D]](https://godoc.org/github.com/muesli/smartcrop)
- [gift](https://github.com/disintegration/gift) **star:1668** 图像处理包。   [![godoc][D]](https://godoc.org/github.com/disintegration/gift)
- [imagick](https://github.com/gographics/imagick) **star:1613**  ImageMagick下MagickWand的C API的Go binding。   [![近一周有更新][G]](https://github.com/gographics/imagick)   [![godoc][D]](https://godoc.org/github.com/gographics/imagick)
- [canvas](https://github.com/tdewolff/canvas) **star:1318** 矢量图形到PDF, SVG或光栅图像。   [![近一周有更新][G]](https://github.com/tdewolff/canvas)   [![godoc][D]](https://godoc.org/github.com/tdewolff/canvas)
- [geopattern](https://github.com/pravj/geopattern) **star:1247** 由字符串创建漂亮图案的图片生成器。   [![近三年未更新][Y]](https://github.com/pravj/geopattern)   [![godoc][D]](https://godoc.org/github.com/pravj/geopattern)
- [stegify](https://github.com/DimitarPetrov/stegify) **star:1123**  Go实现的LSB隐写（LSB steganography），能够隐藏任何文件到一个图像中。   [![godoc][D]](https://godoc.org/github.com/DimitarPetrov/stegify)
- [govips](https://github.com/davidbyttow/govips) **star:982** 闪电快速的图像处理和调整库的Go。   [![godoc][D]](https://godoc.org/github.com/davidbyttow/govips)
- [image2ascii](https://github.com/qeesung/image2ascii) **star:791** 将图像转换为ASCII码。   [![godoc][D]](https://godoc.org/github.com/qeesung/image2ascii)
- [goimagehash](https://github.com/corona10/goimagehash) **star:635**  图像哈希处理的Go语言包。   [![godoc][D]](https://godoc.org/github.com/corona10/goimagehash)
- [draft](https://github.com/lucasepe/draft) **star:571** 使用简单的YAML语法为GraphViz生成高级微服务架构图。   [![godoc][D]](https://godoc.org/github.com/lucasepe/draft)
- [govatar](https://github.com/o1egl/govatar) **star:570** 生成有趣头像的库和CMD工具。   [![godoc][D]](https://godoc.org/github.com/o1egl/govatar)
- [mort](https://github.com/aldor007/mort) **star:484** Go语言实现的图像存储和处理服务器。   [![godoc][D]](https://godoc.org/github.com/aldor007/mort)
- [go-nude](https://github.com/koyachi/go-nude) **star:384** Go语言实现的裸照检测工具。   [![godoc][D]](https://godoc.org/github.com/koyachi/go-nude)
- [steganography](https://github.com/auyer/steganography) **star:263** 纯Go实现的LSB隐写（LSB steganography）的库。   [![godoc][D]](https://godoc.org/github.com/auyer/steganography)
- [darkroom](https://github.com/gojek/darkroom) **star:215** An image proxy with changeable storage backends and image processing engines with focus on speed and resiliency.   [![godoc][D]](https://godoc.org/github.com/gojek/darkroom)
- [rez](https://github.com/bamiaux/rez) **star:209** 纯Go语言和SIMD实现的图像大小调整。   [![近三年未更新][Y]](https://github.com/bamiaux/rez)   [![godoc][D]](https://godoc.org/github.com/bamiaux/rez)
- [gltf](https://github.com/qmuntal/gltf) **star:208** 一个高效、健壮的glTF 2.0文件读取、写入和验证器。   [![godoc][D]](https://godoc.org/github.com/qmuntal/gltf)
- [mergi](https://github.com/noelyahan/mergi) **star:207** 用于图像处理(合并、裁剪、调整大小、水印、动画)的工具和Go库。   [![近三年未更新][Y]](https://github.com/noelyahan/mergi)   [![godoc][D]](https://godoc.org/github.com/noelyahan/mergi)
- [go-webp](https://github.com/kolesa-team/go-webp) **star:152** 为编码和解码webp图片的库，使用libwebp。   [![godoc][D]](https://godoc.org/github.com/kolesa-team/go-webp)
- [img](https://github.com/hawx/img) **star:149** 图像处理工具的集合。   [![近三年未更新][Y]](https://github.com/hawx/img)   [![godoc][D]](https://godoc.org/github.com/hawx/img)
- [go-cairo](https://github.com/ungerik/go-cairo) **star:135**  cairo图形库的Go binding。   [![godoc][D]](https://godoc.org/github.com/ungerik/go-cairo)
- [cameron](https://github.com/aofei/cameron) **star:103** 一个Go语言的头像生成器。   [![godoc][D]](https://godoc.org/github.com/aofei/cameron)
- [color-extractor](https://github.com/marekm4/color-extractor) **star:66** Dominant color extractor with no external dependencies.   [![godoc][D]](https://godoc.org/github.com/marekm4/color-extractor)
- [gridder](https://github.com/shomali11/gridder) **star:64** 一个基于网格的2D图形库。   [![godoc][D]](https://godoc.org/github.com/shomali11/gridder)
- [webp-server](https://github.com/mehdipourfar/webp-server) **star:62** 能够存储、调整大小、转换和缓存图像的简单和最小的图像服务器。   [![godoc][D]](https://godoc.org/github.com/mehdipourfar/webp-server)
- [go-gd](https://github.com/bolknote/go-gd) **star:59**  GD库的Go binding。   [![近三年未更新][Y]](https://github.com/bolknote/go-gd)   [![godoc][D]](https://godoc.org/github.com/bolknote/go-gd)
- [goimghdr](https://github.com/corona10/goimghdr) **star:40** Go语言实现的imghdr模块用于确定文件的图像类型。   [![近三年未更新][Y]](https://github.com/corona10/goimghdr)   [![godoc][D]](https://godoc.org/github.com/corona10/goimghdr)
- [tga](https://github.com/ftrvxmtrx/tga) **star:33** tga包是一个TARGA图像的解码、编码器。   [![近三年未更新][Y]](https://github.com/ftrvxmtrx/tga)   [![godoc][D]](https://godoc.org/github.com/ftrvxmtrx/tga)   [![归档项目][Archived]](https://github.com/ftrvxmtrx/tga)
- [go-webcolors](https://github.com/jyotiska/go-webcolors) **star:27** Python下webcolors库的Go语言调用。   [![近三年未更新][Y]](https://github.com/jyotiska/go-webcolors)   [![godoc][D]](https://godoc.org/github.com/jyotiska/go-webcolors)
- [mpo](https://github.com/donatj/mpo) **star:11** MPO三维照片的解码和转换工具。   [![godoc][D]](https://godoc.org/github.com/donatj/mpo)
- [scout](https://github.com/jonoton/scout) **star:10** Scout是一款独立的开源视频安全软件解决方案。   [![godoc][D]](https://godoc.org/github.com/jonoton/scout)

**[⬆ back to top](#contents)**

## 物联网

_物联网设备编程库。 (翻译出错了? 试试 [英文版](README_EN.md#iot-(internet-of-things)) 吧~)_

- [flogo](https://github.com/tibcosoftware/flogo) **star:2314** Flogo是一个面向物联网边缘应用和集成的开源框架。
- [mainflux](https://github.com/Mainflux/mainflux) **star:2146** 工业物联网消息和设备管理服务器。   [![近一周有更新][G]](https://github.com/Mainflux/mainflux)   [![godoc][D]](https://godoc.org/github.com/Mainflux/mainflux)
- [periph](https://periph.io/)  外围设备I/O与低级板(low-level board)设备接口。
- [ekuiper](https://github.com/lf-edge/ekuiper) **star:1143** Lightweight data stream processing engine for IoT edge.   [![近一周有更新][G]](https://github.com/lf-edge/ekuiper)   [![godoc][D]](https://godoc.org/github.com/lf-edge/ekuiper)   [![包含中文文档][CN]](https://github.com/lf-edge/ekuiper)
- [gatt](https://github.com/paypal/gatt) **star:1083** Gatt是一个用于构建低能耗蓝牙外围设备的Go语言包。   [![godoc][D]](https://godoc.org/github.com/paypal/gatt)
- [gobot](https://github.com/hybridgroup/gobot/)  Gobot是一个用于机器人、物理计算和物联网的框架。
- [connectordb](https://github.com/connectordb/connectordb) **star:373** 自我量化和物联网的开源平台。   [![godoc][D]](https://godoc.org/github.com/connectordb/connectordb)
- [devices](https://github.com/goiot/devices) **star:260** 一套用于物联网设备的库，实验性地用于x/exp/io。   [![近三年未更新][Y]](https://github.com/goiot/devices)   [![godoc][D]](https://godoc.org/github.com/goiot/devices)
- [huego](https://github.com/amimof/huego) **star:237** 一个包含广泛的Philips Hue客户端的Go语言库。   [![godoc][D]](https://godoc.org/github.com/amimof/huego)
- [iot](https://github.com/vaelen/iot/)  IoT是一个实现谷歌物联网核心设备的简单框架。
- [sensorbee](https://github.com/sensorbee/sensorbee) **star:222** 轻量级物联网流处理引擎。   [![近三年未更新][Y]](https://github.com/sensorbee/sensorbee)   [![godoc][D]](https://godoc.org/github.com/sensorbee/sensorbee)
- [eywa](https://github.com/xcodersun/eywa) **star:60** Eywa是一个用于跟踪连接的设备连接管理器。   [![近三年未更新][Y]](https://github.com/xcodersun/eywa)   [![godoc][D]](https://godoc.org/github.com/xcodersun/eywa)

**[⬆ back to top](#contents)**

## 作业调度器

_用于作业调度的库。 (翻译出错了? 试试 [英文版](README_EN.md#job-scheduler) 吧~)_

- [gocron](https://github.com/go-co-op/gocron) **star:3927** 熟练掌握Go工作调度。这是一个积极维护的分叉[jasonlvhit/gocron](https://github.com/jasonlvhit/gocron)。   [![近一周有更新][G]](https://github.com/go-co-op/gocron)   [![godoc][D]](https://godoc.org/github.com/go-co-op/gocron)
- [go-quartz](https://github.com/reugn/go-quartz) **star:1406** 简单的，无依赖的Go调度库。   [![近一周有更新][G]](https://github.com/reugn/go-quartz)   [![godoc][D]](https://godoc.org/github.com/reugn/go-quartz)
- [gron](https://github.com/roylee0704/gron) **star:990** 使用简单的Go API定义基于时间的任务。 之后Gron的调度程序将运行它们。   [![godoc][D]](https://godoc.org/github.com/roylee0704/gron)
- [JobRunner](https://github.com/bamzi/jobrunner) **star:980** 智能和功能丰富的cron作业调度程序（包含任务队列和实时监控）。   [![godoc][D]](https://godoc.org/github.com/bamzi/jobrunner)
- [Dagu](https://github.com/dagu-go/dagu) **star:880** No-code workflow executor. it executes DAGs defined in a simple YAML format.   [![近一周有更新][G]](https://github.com/dagu-go/dagu)   [![godoc][D]](https://godoc.org/github.com/dagu-go/dagu)
- [jobs](https://github.com/albrow/jobs) **star:495** 持久和灵活的后台作业库。   [![近三年未更新][Y]](https://github.com/albrow/jobs)   [![godoc][D]](https://godoc.org/github.com/albrow/jobs)   [![归档项目][Archived]](https://github.com/albrow/jobs)
- [scheduler](https://github.com/carlescere/scheduler) **star:433** Cronjobs让调度变得很简单。   [![godoc][D]](https://godoc.org/github.com/carlescere/scheduler)
- [gronx](https://github.com/adhocore/gronx) **star:296** Cron表达式解析器、任务运行器和守护进程像任务列表一样使用crontab。   [![godoc][D]](https://godoc.org/github.com/adhocore/gronx)
- [go-cron](https://github.com/rk/go-cron) **star:220** 一个Go实现的简单的定时任务库。可以在不同的时间间隔（每秒一次到在每年在特定的日期执行）执行闭包或函数。主要用于web应用和长时间运行的守护进程。   [![近三年未更新][Y]](https://github.com/rk/go-cron)   [![godoc][D]](https://godoc.org/github.com/rk/go-cron)
- [tasks](https://github.com/madflojo/tasks) **star:179** 一个易于使用的进程内调度器，用于Go中的重复任务。   [![godoc][D]](https://godoc.org/github.com/madflojo/tasks)
- [goflow](https://github.com/fieldryand/goflow) **star:161** A simple but powerful DAG scheduler and dashboard.   [![godoc][D]](https://godoc.org/github.com/fieldryand/goflow)
- [clockwerk](https://github.com/onatm/clockwerk) **star:139** 使用简单、流畅的语法调度作业的Go语言库。   [![近三年未更新][Y]](https://github.com/onatm/clockwerk)   [![godoc][D]](https://godoc.org/github.com/onatm/clockwerk)
- [leprechaun](https://github.com/kilgaloon/leprechaun) **star:98** 支持webhook、crons和经典调度的作业调度程序。   [![godoc][D]](https://godoc.org/github.com/kilgaloon/leprechaun)
- [cheek](https://github.com/datarootsio/cheek) **star:96** 一个简单的类似crontab的调度器，旨在为作业调度提供一种KISS方法。   [![近一周有更新][G]](https://github.com/datarootsio/cheek)   [![godoc][D]](https://godoc.org/github.com/datarootsio/cheek)
- [cdule](https://github.com/deepaksinghvi/cdule) **star:40** 具有数据库支持的作业调度程序库   [![godoc][D]](https://godoc.org/github.com/deepaksinghvi/cdule)
- [sched](https://github.com/romshark/sched) **star:27** 具有快进时间能力的作业调度程序。   [![godoc][D]](https://godoc.org/github.com/romshark/sched)
- [cronticker](https://github.com/krayzpipes/cronticker) **star:11** 支持cron调度的一个自动报价器实现。   [![godoc][D]](https://godoc.org/github.com/krayzpipes/cronticker)

**[⬆ back to top](#contents)**

## JSON

_用于JSON处理的库。 (翻译出错了? 试试 [英文版](README_EN.md#json) 吧~)_

- [GJSON](https://github.com/tidwall/gjson) **star:12798** 使用一行代码获取JSON的值。   [![godoc][D]](https://godoc.org/github.com/tidwall/gjson)
- [gojson](https://github.com/ChimeraCoder/gojson) **star:2617** 从JSON自动生成Go的结构（struct）定义。   [![godoc][D]](https://godoc.org/github.com/ChimeraCoder/gojson)
- [fastjson](https://github.com/valyala/fastjson) **star:1982** 用于Go的快速JSON解析器和验证器。没有自定义结构，没有代码生成，没有反射。   [![godoc][D]](https://godoc.org/github.com/valyala/fastjson)
- [OjG](https://github.com/ohler55/ojg) **star:635** 优化JSON for Go是一个高性能的解析器，具有多种额外的JSON工具，包括JSONPath。   [![近一周有更新][G]](https://github.com/ohler55/ojg)   [![godoc][D]](https://godoc.org/github.com/ohler55/ojg)
- [marshmallow](https://github.com/PerimeterX/marshmallow) **star:316** Performant JSON unmarshaling for flexible use cases.   [![godoc][D]](https://godoc.org/github.com/PerimeterX/marshmallow)
- [jsondiff](https://github.com/wI2L/jsondiff) **star:268** Go的JSON diff库基于RFC6902 (JSON Patch)。   [![godoc][D]](https://godoc.org/github.com/wI2L/jsondiff)
- [kazaam](https://github.com/Qntfy/kazaam) **star:262** 用于任意JSON文档转换的API。   [![godoc][D]](https://godoc.org/github.com/Qntfy/kazaam)
- [gojq](https://github.com/elgs/gojq) **star:188** Go语言实现的JSON请求。   [![godoc][D]](https://godoc.org/github.com/elgs/gojq)
- [ajson](https://github.com/spyzhov/ajson) **star:183** 为Go语言开发的包含JSONPath支持的抽象JSON。   [![godoc][D]](https://godoc.org/github.com/spyzhov/ajson)
- [jettison](https://github.com/wI2L/jettison) **star:159** Go的快速灵活的JSON编码器。   [![godoc][D]](https://godoc.org/github.com/wI2L/jettison)
- [jsonvalue](https://github.com/Andrew-M-C/go.jsonvalue) **star:157** A fast and convinient library for unstructured JSON data, replacing `encoding/json`.   [![近一周有更新][G]](https://github.com/Andrew-M-C/go.jsonvalue)   [![godoc][D]](https://godoc.org/github.com/Andrew-M-C/go.jsonvalue)   [![包含中文文档][CN]](https://github.com/Andrew-M-C/go.jsonvalue)
- [json2go](https://github.com/m-zajac/json2go) **star:122** 高级JSON去结构转换。提供一个包，该包可以解析多个JSON文档并创建结构体以适应所有这些文档。   [![godoc][D]](https://godoc.org/github.com/m-zajac/json2go)
- [gjo](https://github.com/skanehira/gjo) **star:120** 用于创建JSON对象的小工具。   [![godoc][D]](https://godoc.org/github.com/skanehira/gjo)
- [jsongo](https://github.com/ricardolonga/jsongo) **star:109** 使用Fluent API来更容易地创建Json对象。   [![godoc][D]](https://godoc.org/github.com/ricardolonga/jsongo)
- [JayDiff](https://github.com/yazgazan/jaydiff) **star:101** 用Go编写的JSON比对工具。   [![godoc][D]](https://godoc.org/github.com/yazgazan/jaydiff)
- [ujson](https://github.com/olvrng/ujson) **star:69** 快速和最小的JSON解析器和转换器，工作在非结构化JSON。   [![godoc][D]](https://godoc.org/github.com/olvrng/ujson)
- [jsonf](https://github.com/miolini/jsonf) **star:64** 用于高亮展示和查询JSON的控制台工具。   [![godoc][D]](https://godoc.org/github.com/miolini/jsonf)
- [jscan](https://github.com/romshark/jscan) **star:57** 高性能零分配JSON迭代器。   [![godoc][D]](https://godoc.org/github.com/romshark/jscan)
- [JSON-to-Go](https://mholt.github.io/json-to-go/)  将JSON转换为Go的结构（struct）。
- [JSON-to-Proto](https://json-to-proto.github.io/)  转换JSON到Protobuf在线。
- [go-respond](https://github.com/nicklaw5/go-respond) **star:51** 用于处理常见的HTTP JSON响应的Go语言库。   [![godoc][D]](https://godoc.org/github.com/nicklaw5/go-respond)
- [mp](https://github.com/sanbornm/mp) **star:46** 简单的cli电子邮件解析器。它目前接受stdin并输出JSON。   [![近三年未更新][Y]](https://github.com/sanbornm/mp)   [![godoc][D]](https://godoc.org/github.com/sanbornm/mp)
- [vjson](https://github.com/miladibra10/vjson) **star:34** 用流畅API声明JSON模式来验证JSON对象的Go包。   [![godoc][D]](https://godoc.org/github.com/miladibra10/vjson)
- [jsoncolor](https://github.com/neilotoole/jsoncolor) **star:33** Drop-in替换' encoding/json '，输出彩色json。   [![godoc][D]](https://godoc.org/github.com/neilotoole/jsoncolor)
- [ask](https://github.com/simonnilsson/ask) **star:27** 容易访问映射和片中的嵌套值。与encoding/json和其他将任意数据“解编组”为Go数据类型的包一起工作。   [![godoc][D]](https://godoc.org/github.com/simonnilsson/ask)
- [gojmapr](https://github.com/limiu82214/gojmapr) **star:19** Get simple struct from complex json by json path.   [![godoc][D]](https://godoc.org/github.com/limiu82214/gojmapr)   [![包含中文文档][CN]](https://github.com/limiu82214/gojmapr)
- [dynjson](https://github.com/cocoonspace/dynjson) **star:15** 用于动态api的可定制的JSON格式。   [![godoc][D]](https://godoc.org/github.com/cocoonspace/dynjson)
- [mapslice-json](https://github.com/mickep76/mapslice-json) **star:15** 去MapSlice的有序封送/解封的JSON地图。   [![godoc][D]](https://godoc.org/github.com/mickep76/mapslice-json)
- [go-jsonerror](https://github.com/ddymko/go-jsonerror) **star:13** Go-JsonError is meant to allow us to easily create json response errors that follow the JsonApi spec.   [![近三年未更新][Y]](https://github.com/ddymko/go-jsonerror)   [![godoc][D]](https://godoc.org/github.com/ddymko/go-jsonerror)
- [jsonapi-errors](https://github.com/AmuzaTkts/jsonapi-errors) **star:13** 基于JSON API错误引用的Go bindings。   [![近三年未更新][Y]](https://github.com/AmuzaTkts/jsonapi-errors)   [![godoc][D]](https://godoc.org/github.com/AmuzaTkts/jsonapi-errors)
- [jsonhal](https://github.com/RichardKnop/jsonhal) **star:13** 让自定义结构（struct）转化为JSON兼容的HAL（Hypertext Application Language）返回数据的简单Go包。   [![近三年未更新][Y]](https://github.com/RichardKnop/jsonhal)   [![godoc][D]](https://godoc.org/github.com/RichardKnop/jsonhal)
- [epoch](https://github.com/vtopc/epoch) **star:12** 包含用于封送/解封送Unix时间戳/纪元到内建时间的原语。时间类型为JSON。   [![godoc][D]](https://godoc.org/github.com/vtopc/epoch)
- [jzon](https://github.com/zerosnake0/jzon) **star:11** 具有标准兼容API/行为的JSON库。   [![godoc][D]](https://godoc.org/github.com/zerosnake0/jzon)
- [ej](https://github.com/lucassscaravelli/ej) **star:9** 简洁地编写和读取来自不同来源的JSON。   [![近三年未更新][Y]](https://github.com/lucassscaravelli/ej)   [![godoc][D]](https://godoc.org/github.com/lucassscaravelli/ej)
- [jsonic](https://github.com/sinhashubham95/jsonic) **star:9** 处理和查询JSON的实用程序，无需以类型安全的方式定义结构。   [![godoc][D]](https://godoc.org/github.com/sinhashubham95/jsonic)
- [htmljson](https://github.com/nikolaydubina/htmljson) **star:4** Rich rendering of JSON as HTML in Go.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/htmljson)
- [omg.jsonparser](https://github.com/dedalqq/omg.jsonparser) **star:4** 简单的JSON解析器，通过golang结构字段标签进行条件验证。   [![godoc][D]](https://godoc.org/github.com/dedalqq/omg.jsonparser)
- [jsonhandlers](https://github.com/abusomani/jsonhandlers) **star:1** JSON library to expose simple handlers that lets you easily read and write json from various sources.   [![godoc][D]](https://godoc.org/github.com/abusomani/jsonhandlers)

**[⬆ back to top](#contents)**

## 日志记录

_用于生成和处理日志文件的库。 (翻译出错了? 试试 [英文版](README_EN.md#logging) 吧~)_

- [logrus](https://github.com/Sirupsen/logrus) **star:23222** Go的结构化日志操作 。   [![godoc][D]](https://godoc.org/github.com/Sirupsen/logrus)
- [zap](https://github.com/uber-go/zap) **star:19693** 快速、结构化、多等级的日志记录。   [![近一周有更新][G]](https://github.com/uber-go/zap)   [![godoc][D]](https://godoc.org/github.com/uber-go/zap)
- [zerolog](https://github.com/rs/zerolog) **star:8858** Zero-allocation JSON日志记录。   [![近一周有更新][G]](https://github.com/rs/zerolog)   [![godoc][D]](https://godoc.org/github.com/rs/zerolog)
- [spew](https://github.com/davecgh/go-spew) **star:5710** 为Go数据结构实现一个漂亮的printer用于帮助调试。   [![godoc][D]](https://godoc.org/github.com/davecgh/go-spew)
- [lumberjack](https://github.com/natefinch/lumberjack) **star:4258** 简单的滚动日志，io.WriteCloser的实现。   [![godoc][D]](https://godoc.org/github.com/natefinch/lumberjack)
- [glog](https://github.com/golang/glog) **star:3426** 为Go提供了多等级日志记录。   [![godoc][D]](https://godoc.org/github.com/golang/glog)
- [tail](https://github.com/hpcloud/tail) **star:2597** 努力模拟实现BSD的tail的特性的Go包。   [![godoc][D]](https://godoc.org/github.com/hpcloud/tail)
- [pp](https://github.com/k0kubun/pp) **star:1674** Colored pretty printer for Go language.   [![godoc][D]](https://godoc.org/github.com/k0kubun/pp)
- [seelog](https://github.com/cihub/seelog) **star:1640** 具有灵活调度、过滤和格式化的日志功能。   [![近三年未更新][Y]](https://github.com/cihub/seelog)   [![godoc][D]](https://godoc.org/github.com/cihub/seelog)
- [log](https://github.com/apex/log) **star:1331** Go的结构化日志包。   [![godoc][D]](https://godoc.org/github.com/apex/log)
- [log15](https://github.com/inconshreveable/log15) **star:1093** 简单、强大的日志操作。   [![godoc][D]](https://godoc.org/github.com/inconshreveable/log15)
- [phuslu/log](https://github.com/phuslu/log) **star:513** High performance structured logging.   [![近一周有更新][G]](https://github.com/phuslu/log)   [![godoc][D]](https://godoc.org/github.com/phuslu/log)
- [onelog](https://github.com/francoispqt/onelog) **star:414** Onelog是一个非常简单但非常高效的JSON日志记录器。它是所有场景中最快的JSON记录器。而且，它是配置最低的记录器之一。   [![近三年未更新][Y]](https://github.com/francoispqt/onelog)   [![godoc][D]](https://godoc.org/github.com/francoispqt/onelog)
- [logutils](https://github.com/hashicorp/logutils) **star:356** Go的用于更好地进行日志操作的实用程序，继承了标准日志库。   [![godoc][D]](https://godoc.org/github.com/hashicorp/logutils)
- [logxi](https://github.com/mgutz/logxi) **star:350** 12-factor app的日志程序，快速且让人高兴地使用。   [![近三年未更新][Y]](https://github.com/mgutz/logxi)   [![godoc][D]](https://godoc.org/github.com/mgutz/logxi)
- [sqldb-logger](https://github.com/simukti/sqldb-logger) **star:316** A logger for Go SQL database driver without modify existing \*sql.DB stdlib usage.   [![godoc][D]](https://godoc.org/github.com/simukti/sqldb-logger)
- [httpretty](https://github.com/henvic/httpretty) **star:305** 在终端上美化您的常规HTTP请求以便调试(类似于HTTP . dumprequest)。   [![godoc][D]](https://godoc.org/github.com/henvic/httpretty)
- [tint](https://github.com/lmittmann/tint) **star:302** A slog.Handler that writes tinted logs.   [![近一周有更新][G]](https://github.com/lmittmann/tint)   [![godoc][D]](https://godoc.org/github.com/lmittmann/tint)
- [log](https://github.com/go-playground/log) **star:289** Go的简单、可配置和可伸缩的结构化日志。   [![godoc][D]](https://godoc.org/github.com/go-playground/log)
- [slog](https://github.com/gookit/slog) **star:287** Lightweight, configurable, extensible logger for Go.   [![近一周有更新][G]](https://github.com/gookit/slog)   [![godoc][D]](https://godoc.org/github.com/gookit/slog)   [![包含中文文档][CN]](https://github.com/gookit/slog)
- [go-logger](https://github.com/apsdehal/go-logger) **star:286** 简单的日志程序的 Go 程序，与级别处理程序。   [![近三年未更新][Y]](https://github.com/apsdehal/go-logger)   [![godoc][D]](https://godoc.org/github.com/apsdehal/go-logger)
- [rollingwriter](https://github.com/arthurkiller/rollingWriter) **star:283** RollingWriter是一个自动循环的io.Writer的实现,带有多种策略以提供日志文件循环(rotation)。   [![godoc][D]](https://godoc.org/github.com/arthurkiller/rollingWriter)
- [logur](https://github.com/logur/logur) **star:197** 一个固执的logger接口，集合了著名库的适配器和集成的日志最佳实践([logrus](https://github.com/sirupsen/logrus)， [go-kit log](https://github.com/go-kit/kit/tree/master/log)， [zap](https://github.com/ugo/zap)， [zerolog](https://github.com/rs/zerolog)，等等)。   [![godoc][D]](https://godoc.org/github.com/logur/logur)
- [glg](https://github.com/kpango/glg) **star:188** glg是一个简单而快速的Go日志库。   [![godoc][D]](https://godoc.org/github.com/kpango/glg)
- [logger](https://github.com/azer/logger) **star:158** Go的精简日志库。   [![godoc][D]](https://godoc.org/github.com/azer/logger)
- [xlog](https://github.com/rs/xlog) **star:138** 针对'net/context`实现的结构化的记录器，用于HTTP处理程序。   [![godoc][D]](https://godoc.org/github.com/rs/xlog)
- [slog-multi](https://github.com/samber/slog-multi) **star:135** Chain of slog.Handler (pipeline, fanout...).   [![godoc][D]](https://godoc.org/github.com/samber/slog-multi)
- [ozzo-log](https://github.com/go-ozzo/ozzo-log) **star:122** 支持日志多等级、分类和过滤的高性能日志记录。可以发送过滤后的日志消息到各种目标(如控制台，网络，邮件)。   [![godoc][D]](https://godoc.org/github.com/go-ozzo/ozzo-log)   [![包含中文文档][CN]](https://github.com/go-ozzo/ozzo-log)
- [log-voyage](https://github.com/firstrow/logvoyage) **star:94** 用Go编写的功能齐全的日志写入saas。   [![近三年未更新][Y]](https://github.com/firstrow/logvoyage)   [![godoc][D]](https://godoc.org/github.com/firstrow/logvoyage)
- [go-cronowriter](https://github.com/utahta/go-cronowriter) **star:56** 基于当前日期和时间的自动日志文件写入工具，类似cronolog。   [![godoc][D]](https://godoc.org/github.com/utahta/go-cronowriter)
- [stdlog](https://github.com/alexcesaro/log) **star:47** Stdlog是一个面向对象的库，提供了多等级日志记录。它对cron任务非常有用。   [![近三年未更新][Y]](https://github.com/alexcesaro/log)   [![godoc][D]](https://godoc.org/github.com/alexcesaro/log)
- [noodlog](https://github.com/gyozatech/noodlog) **star:44** 参数化JSON日志记录库，允许您混淆敏感数据和封送任何类型的内容。不再打印指针代替值，也不再为JSON字符串输出转义字符。   [![godoc][D]](https://godoc.org/github.com/gyozatech/noodlog)
- [go-log](https://github.com/ian-kent/go-log) **star:42** Log4j的Go语言。   [![近三年未更新][Y]](https://github.com/ian-kent/go-log)   [![godoc][D]](https://godoc.org/github.com/ian-kent/go-log)
- [slog-formatter](https://github.com/samber/slog-formatter) **star:42** Common formatters for slog and helpers to build your own.   [![godoc][D]](https://godoc.org/github.com/samber/slog-formatter)
- [gologger](https://github.com/sadlil/gologger) **star:41** 为Go提供方便简单的日志操作; 在彩色控制台，简单控制台，文件或Elasticsearch上。   [![近三年未更新][Y]](https://github.com/sadlil/gologger)   [![godoc][D]](https://godoc.org/github.com/sadlil/gologger)   [![归档项目][Archived]](https://github.com/sadlil/gologger)
- [logex](https://github.com/chzyer/logex) **star:41** 由标准日志库封装的Go日志库，支持跟踪和多等级。   [![godoc][D]](https://godoc.org/github.com/chzyer/logex)
- [journald](https://github.com/ssgreg/journald) **star:37**  Go实现systemd Journal的原生API用于日志记录。   [![godoc][D]](https://godoc.org/github.com/ssgreg/journald)
- [go-log](https://github.com/siddontang/go-log) **star:33** 支持多等级和多处理程序的日志库。   [![近三年未更新][Y]](https://github.com/siddontang/go-log)   [![godoc][D]](https://godoc.org/github.com/siddontang/go-log)
- [mlog](https://github.com/jbrodriguez/mlog) **star:33** 简单的go日志模块，有5个级别，可选循环(rotation)日志文件记录功能和stdout/stderr输出。   [![近三年未更新][Y]](https://github.com/jbrodriguez/mlog)   [![godoc][D]](https://godoc.org/github.com/jbrodriguez/mlog)
- [distillog](https://github.com/amoghe/distillog) **star:32** distilled日志记录(可以将其视为stdlib +日志)。   [![近三年未更新][Y]](https://github.com/amoghe/distillog)   [![godoc][D]](https://godoc.org/github.com/amoghe/distillog)
- [logrusly](https://github.com/sebest/logrusly) **star:28** [logrus](https://github.com/sirupsen/logrus)的插件，将错误信息发送到[Loggly](https://www.loggly.com/)。   [![godoc][D]](https://godoc.org/github.com/sebest/logrusly)
- [log](https://github.com/teris-io/log) **star:26** Go的结构化日志接口，清晰地将日志facade与其实现(implementation)分离开来。   [![近三年未更新][Y]](https://github.com/teris-io/log)   [![godoc][D]](https://godoc.org/github.com/teris-io/log)
- [zkits-logger](https://github.com/edoger/zkits-logger) **star:24** 一个强大的零依赖JSON记录器。   [![godoc][D]](https://godoc.org/github.com/edoger/zkits-logger)
- [gomol](https://github.com/aphistic/gomol) **star:19** 为Go实现可多方式输出、结构化日志, 并可扩展日志输出方式。   [![近三年未更新][Y]](https://github.com/aphistic/gomol)   [![godoc][D]](https://godoc.org/github.com/aphistic/gomol)   [![归档项目][Archived]](https://github.com/aphistic/gomol)
- [gone/log](https://github.com/One-com/gone/tree/master/log)  快速、可扩展、功能齐全、std-lib源兼容的日志库。
- [logmatic](https://github.com/borderstech/logmatic) **star:16** Go的彩色日志记录器，带有可配置的日志级别。   [![godoc][D]](https://godoc.org/github.com/borderstech/logmatic)
- [logrusiowriter](https://github.com/cabify/logrusiowriter) **star:16** io。作者的实现使用[logrus](https://github.com/sirupsen/logrus) logger。   [![近三年未更新][Y]](https://github.com/cabify/logrusiowriter)   [![godoc][D]](https://godoc.org/github.com/cabify/logrusiowriter)
- [glo](https://github.com/lajosbencz/glo) **star:15** 参照PHP的Monolog实现的具有相同日志等级的Go日志库。   [![近三年未更新][Y]](https://github.com/lajosbencz/glo)   [![godoc][D]](https://godoc.org/github.com/lajosbencz/glo)
- [xylog](https://github.com/xybor-x/xylog) **star:15** Leveled and structured logging, dynamic fields, high performance, zone management, simple configuration, and readable syntax.   [![godoc][D]](https://godoc.org/github.com/xybor-x/xylog)
- [go-log](https://github.com/subchen/go-log) **star:14** Go实现的简单且可配置的日志工具，并带有多等级、日志格式化和日志写入工具。   [![近三年未更新][Y]](https://github.com/subchen/go-log)   [![godoc][D]](https://godoc.org/github.com/subchen/go-log)
- [log](https://github.com/heartwilltell/log) **star:14** Simple leveled logging wrapper around standard log package.   [![godoc][D]](https://godoc.org/github.com/heartwilltell/log)
- [logdump](https://github.com/ewwwwwqm/logdump) **star:11** 用于多等级级日志记录的包。   [![近三年未更新][Y]](https://github.com/ewwwwwqm/logdump)   [![godoc][D]](https://godoc.org/github.com/ewwwwwqm/logdump)
- [logo](https://github.com/mbndr/logo) **star:11** Go的日志工具，可配置的日志写入器。   [![godoc][D]](https://godoc.org/github.com/mbndr/logo)
- [go-log](https://github.com/pieterclaerhout/go-log) **star:10** A logging library with stack traces, object dumping and optional timestamps.   [![godoc][D]](https://godoc.org/github.com/pieterclaerhout/go-log)
- [kemba](https://github.com/clok/kemba) **star:10** 一个小的调试日志工具，灵感来自[debug](https://github.com/visionmedia/debug)，非常适合CLI工具和应用程序。   [![近一周有更新][G]](https://github.com/clok/kemba)   [![godoc][D]](https://godoc.org/github.com/clok/kemba)
- [log](https://github.com/aerogo/log) **star:10** 一个O(1)日志系统，允许您将一个日志连接到多个日志写入(例如stdout、文件和TCP连接)。   [![近三年未更新][Y]](https://github.com/aerogo/log)   [![godoc][D]](https://godoc.org/github.com/aerogo/log)
- [xlog](https://github.com/xfxdev/xlog) **star:8** 插件架构和灵活的日志系统，带有多级别、多日志目标和自定义日志格式。   [![近三年未更新][Y]](https://github.com/xfxdev/xlog)   [![godoc][D]](https://godoc.org/github.com/xfxdev/xlog)
- [zax](https://github.com/yuseferi/zax) **star:7** Integrate Context with Zap logger, which leads to more flexibility in Go logging.   [![godoc][D]](https://godoc.org/github.com/yuseferi/zax)
- [structy/log](https://github.com/structy/log) **star:5** 一个简单易用的日志系统，极简但具有调试和区分消息的功能。   [![godoc][D]](https://godoc.org/github.com/structy/log)
- [slf4g](https://github.com/echocat/slf4g) **star:3** Simple Logging Facade for Golang: Simple structured logging; but powerful, extendable and customizable, with huge amount of learnings from decades of past logging frameworks.   [![近一周有更新][G]](https://github.com/echocat/slf4g)   [![godoc][D]](https://godoc.org/github.com/echocat/slf4g)
- [log](https://github.com/no-src/log) **star:2** A simple logging framework out of the box.   [![近一周有更新][G]](https://github.com/no-src/log)   [![godoc][D]](https://godoc.org/github.com/no-src/log)
- [yell](https://github.com/jfcg/yell) **star:1** 这是另一个极简的日志库。   [![godoc][D]](https://godoc.org/github.com/jfcg/yell)

**[⬆ back to top](#contents)**

## 机器学习

_机器学习库。 (翻译出错了? 试试 [英文版](README_EN.md#machine-learning) 吧~)_

- [GoLearn](https://github.com/sjwhitworth/golearn) **star:9019** 通用机器学习库。   [![godoc][D]](https://godoc.org/github.com/sjwhitworth/golearn)   [![包含中文文档][CN]](https://github.com/sjwhitworth/golearn)
- [gorse](https://github.com/zhenghaoz/gorse) **star:7581** 基于协同过滤的离线推荐系统后端。   [![godoc][D]](https://godoc.org/github.com/zhenghaoz/gorse)   [![包含中文文档][CN]](https://github.com/zhenghaoz/gorse)
- [gorgonia](https://github.com/gorgonia/gorgonia) **star:5109** 基于图形（graph-based）的计算库，如Theano：它为构建各种机器学习和神经网络算法提供了基本框架。   [![近一周有更新][G]](https://github.com/gorgonia/gorgonia)   [![godoc][D]](https://godoc.org/github.com/gorgonia/gorgonia)
- [m2cgen](https://github.com/BayesWitnesses/m2cgen) **star:2605** 这是一个CLI工具，可以将经过训练的经典ML模型转换成零依赖的本地Go代码，使用Python编写，并支持Go语言。
- [tfgo](https://github.com/galeone/tfgo) **star:2298** 易于使用的Tensorflow bindings:简化了官方Tensorflow Go bindings的使用。在Go中定义计算图形，在Python中加载和执行训练的模型。   [![godoc][D]](https://godoc.org/github.com/galeone/tfgo)
- [gosseract](https://github.com/otiai10/gosseract) **star:2224** 使用c++的Tesseract库实现的OCR。   [![godoc][D]](https://godoc.org/github.com/otiai10/gosseract)
- [goml](https://github.com/cdipaolo/goml) **star:1493** 在线机器学习。   [![godoc][D]](https://godoc.org/github.com/cdipaolo/goml)
- [eaopt](https://github.com/MaxHalford/eaopt) **star:850** 一个进化优化（evolutionary optimization）库。   [![godoc][D]](https://godoc.org/github.com/MaxHalford/eaopt)
- [bayesian](https://github.com/jbrukh/bayesian) **star:769** Go的朴素贝叶斯分类。   [![godoc][D]](https://godoc.org/github.com/jbrukh/bayesian)
- [CloudForest](https://github.com/ryanbressler/CloudForest) **star:731** 快速、灵活、多线程集成的决策树，用于机器学习。   [![godoc][D]](https://godoc.org/github.com/ryanbressler/CloudForest)
- [ocrserver](https://github.com/otiai10/ocrserver) **star:598** 一个简单的OCR API服务器，非常容易地使用Docker和Heroku部署。   [![godoc][D]](https://godoc.org/github.com/otiai10/ocrserver)
- [gobrain](https://github.com/goml/gobrain) **star:544** 用 Go 编写的神经网络库。   [![godoc][D]](https://godoc.org/github.com/goml/gobrain)
- [onnx-go](https://github.com/owulveryck/onnx-go) **star:529** Go Interface， 用于开放式神经网络交换(Open Neural Network Exchange)。   [![godoc][D]](https://godoc.org/github.com/owulveryck/onnx-go)
- [go-deep](https://github.com/patrikeh/go-deep) **star:467** 一个功能丰富的神经网络库 。   [![godoc][D]](https://godoc.org/github.com/patrikeh/go-deep)
- [regommend](https://github.com/muesli/regommend) **star:303** 推荐和协同过滤引擎。   [![近三年未更新][Y]](https://github.com/muesli/regommend)   [![godoc][D]](https://godoc.org/github.com/muesli/regommend)
- [Goptuna](https://github.com/c-bata/goptuna) **star:241** Bayesian optimization framework for black-box functions written in Go. Everything will be optimized.   [![近一周有更新][G]](https://github.com/c-bata/goptuna)   [![godoc][D]](https://godoc.org/github.com/c-bata/goptuna)
- [goga](https://github.com/tomcraven/goga) **star:198** Go的遗传算法库。   [![godoc][D]](https://godoc.org/github.com/tomcraven/goga)
- [go-galib](https://github.com/thoj/go-galib) **star:196** 用Go编写的遗传算法库。   [![近三年未更新][Y]](https://github.com/thoj/go-galib)   [![godoc][D]](https://godoc.org/github.com/thoj/go-galib)
- [goRecommend](https://github.com/timkaye11/goRecommend) **star:194** 用Go编写的推荐算法库。   [![近三年未更新][Y]](https://github.com/timkaye11/goRecommend)   [![godoc][D]](https://godoc.org/github.com/timkaye11/goRecommend)
- [shield](https://github.com/eaigner/shield) **star:154** 贝叶斯文本分类器，具有灵活的tokenizers和存储后端。   [![近三年未更新][Y]](https://github.com/eaigner/shield)   [![godoc][D]](https://godoc.org/github.com/eaigner/shield)
- [go-fann](https://github.com/white-pony/go-fann) **star:114** 快速人工神经网络(FANN)库的Go bindings。   [![近三年未更新][Y]](https://github.com/white-pony/go-fann)   [![godoc][D]](https://godoc.org/github.com/white-pony/go-fann)
- [go-featureprocessing](https://github.com/nikolaydubina/go-featureprocessing) **star:101** 快速和方便的特征处理，低延迟机器学习在Go。   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/go-featureprocessing)
- [goscore](https://github.com/asafschers/goscore) **star:90**  为预言模型标记语言（PMML）实现的评分API。   [![近三年未更新][Y]](https://github.com/asafschers/goscore)   [![godoc][D]](https://godoc.org/github.com/asafschers/goscore)
- [gonet](https://github.com/dathoangnd/gonet) **star:79** 基于go的神经网络。   [![近三年未更新][Y]](https://github.com/dathoangnd/gonet)   [![godoc][D]](https://godoc.org/github.com/dathoangnd/gonet)
- [fonet](https://github.com/Fontinalis/fonet) **star:78** 一个用Go编写的深度神经网络库。   [![godoc][D]](https://godoc.org/github.com/Fontinalis/fonet)
- [libsvm](https://github.com/datastream/libsvm) **star:73** 基于LIBSVM 3.14实现。   [![近三年未更新][Y]](https://github.com/datastream/libsvm)   [![godoc][D]](https://godoc.org/github.com/datastream/libsvm)
- [neat](https://github.com/jinyeom/neat) **star:68** 即插即用的并行Go框架，用于增强拓扑的神经进化(NeuroEvolution of Augmenting Topologies)。   [![近三年未更新][Y]](https://github.com/jinyeom/neat)   [![godoc][D]](https://godoc.org/github.com/jinyeom/neat)   [![归档项目][Archived]](https://github.com/jinyeom/neat)
- [GoMind](https://github.com/surenderthakran/gomind) **star:65** 一个简单的神经网络库。   [![godoc][D]](https://godoc.org/github.com/surenderthakran/gomind)
- [neural-go](https://github.com/schuyler/neural-go) **star:65** 多层感知器网络在Go中的实现，使用反向传播算法进行训练。   [![近三年未更新][Y]](https://github.com/schuyler/neural-go)   [![godoc][D]](https://godoc.org/github.com/schuyler/neural-go)
- [go-pr](https://github.com/daviddengcn/go-pr) **star:62** Go编写的模式识别包。   [![近三年未更新][Y]](https://github.com/daviddengcn/go-pr)   [![godoc][D]](https://godoc.org/github.com/daviddengcn/go-pr)
- [Varis](https://github.com/Xamber/Varis) **star:52** Go实现的神经网络。   [![近三年未更新][Y]](https://github.com/Xamber/Varis)   [![godoc][D]](https://godoc.org/github.com/Xamber/Varis)
- [golinear](https://github.com/danieldk/golinear) **star:44**  Go实现的liblinear bindings。   [![近三年未更新][Y]](https://github.com/danieldk/golinear)   [![godoc][D]](https://godoc.org/github.com/danieldk/golinear)   [![归档项目][Archived]](https://github.com/danieldk/golinear)
- [go-cluster](https://github.com/e-XpertSolutions/go-cluster) **star:39** Go实现的k-modes和k-prototypes聚类算法。   [![godoc][D]](https://godoc.org/github.com/e-XpertSolutions/go-cluster)
- [godist](https://github.com/e-dard/godist) **star:35** 各种概率分布，以及相关的method。   [![近三年未更新][Y]](https://github.com/e-dard/godist)   [![godoc][D]](https://godoc.org/github.com/e-dard/godist)
- [randomforest](https://github.com/malaschitz/randomForest) **star:34** 容易使用随机森林库去。   [![godoc][D]](https://godoc.org/github.com/malaschitz/randomForest)
- [ddt](https://github.com/sgrodriguez/ddt) **star:29** 动态决策树，创建定义可定制规则的树。   [![godoc][D]](https://godoc.org/github.com/sgrodriguez/ddt)
- [evoli](https://github.com/khezen/evoli) **star:27** 遗传算法（Genetic Algorithm）和粒子群优化（Particle Swarm Optimization）库。   [![godoc][D]](https://godoc.org/github.com/khezen/evoli)
- [probab](https://github.com/ThePaw/probab) **star:18** 概率分布函数。贝叶斯推理。使用Go写的。   [![近三年未更新][Y]](https://github.com/ThePaw/probab)   [![godoc][D]](https://godoc.org/github.com/ThePaw/probab)

**[⬆ back to top](#contents)**

## 消息

_实现消息传递系统的库。 (翻译出错了? 试试 [英文版](README_EN.md#messaging) 吧~)_

- [sarama](https://github.com/Shopify/sarama) **star:10352**  Apache Kafka的Go库。   [![近一周有更新][G]](https://github.com/Shopify/sarama)   [![godoc][D]](https://godoc.org/github.com/Shopify/sarama)
- [Centrifugo](https://github.com/centrifugal/centrifugo) **star:7349** 实时消息(Websockets或SockJS)服务器。   [![近一周有更新][G]](https://github.com/centrifugal/centrifugo)   [![godoc][D]](https://godoc.org/github.com/centrifugal/centrifugo)
- [gorush](https://github.com/appleboy/gorush) **star:7254** 使用[APNs2](https://github.com/sideshow/apns2)和谷歌[GCM](https://github.com/google/go-gcm)推送通知服务器。   [![godoc][D]](https://godoc.org/github.com/appleboy/gorush)
- [machinery](https://github.com/RichardKnop/machinery) **star:7003** 基于分布式消息传递的异步任务/作业队列。   [![godoc][D]](https://godoc.org/github.com/RichardKnop/machinery)
- [Asynq](https://github.com/hibiken/asynq) **star:6822** 一个简单、可靠、高效的基于Redis的分布式任务队列。   [![近一周有更新][G]](https://github.com/hibiken/asynq)   [![godoc][D]](https://godoc.org/github.com/hibiken/asynq)
- [Benthos](https://github.com/Jeffail/benthos) **star:6602** 一系列协议之间的消息流桥接。   [![近一周有更新][G]](https://github.com/Jeffail/benthos)   [![godoc][D]](https://godoc.org/github.com/Jeffail/benthos)
- [Watermill](https://github.com/ThreeDotsLabs/watermill) **star:6041** Working efficiently with message streams. Building event driven applications, enabling event sourcing, RPC over messages, sagas. Can use conventional pub/sub implementations like Kafka or RabbitMQ, but also HTTP or MySQL binlog.   [![近一周有更新][G]](https://github.com/ThreeDotsLabs/watermill)   [![godoc][D]](https://godoc.org/github.com/ThreeDotsLabs/watermill)
- [go-socket.io](https://github.com/googollee/go-socket.io) **star:5309** go的socket.io库，一个实时应用程序框架。   [![godoc][D]](https://godoc.org/github.com/googollee/go-socket.io)
- [NATS Go Client](https://github.com/nats-io/nats) **star:4757** 轻量级和高性能的发布-订阅(publish-subscribe)和分布式队列消息传递系统——这是一个Go库。   [![近一周有更新][G]](https://github.com/nats-io/nats)   [![godoc][D]](https://godoc.org/github.com/nats-io/nats)
- [Confluent Kafka Golang Client](https://github.com/confluentinc/confluent-kafka-go) **star:4108** confluent-kafka-go是Confluent为Apache Kafka和Confluent平台开发的Golang客户端。   [![近一周有更新][G]](https://github.com/confluentinc/confluent-kafka-go)   [![godoc][D]](https://godoc.org/github.com/confluentinc/confluent-kafka-go)
- [Mercure](https://github.com/dunglas/mercure) **star:3472** 使用Mercure协议分派服务器发送(server-sent)更新的服务器和库(构建在服务器发送事件之上)。   [![godoc][D]](https://godoc.org/github.com/dunglas/mercure)
- [melody](https://github.com/olahol/melody) **star:3280** 处理websocket session的极简框架，包括广播和自动ping/pong处理。   [![godoc][D]](https://godoc.org/github.com/olahol/melody)
- [APNs2](https://github.com/sideshow/apns2) **star:2861** HTTP / 2苹果消息推送provider——发送推送消息到iOS, tvOS, Safari和OSX应用。   [![godoc][D]](https://godoc.org/github.com/sideshow/apns2)
- [go-nsq](https://github.com/nsqio/go-nsq) **star:2456** NSQ的官方Go包。   [![近一周有更新][G]](https://github.com/nsqio/go-nsq)   [![godoc][D]](https://godoc.org/github.com/nsqio/go-nsq)
- [gopush-cluster](https://github.com/Terry-Mao/gopush-cluster) **star:2079** gopush-cluster是一个gopush服务器集群。   [![近三年未更新][Y]](https://github.com/Terry-Mao/gopush-cluster)   [![godoc][D]](https://godoc.org/github.com/Terry-Mao/gopush-cluster)   [![包含中文文档][CN]](https://github.com/Terry-Mao/gopush-cluster)
- [Uniqush-Push](https://github.com/uniqush/uniqush-push) **star:1509** Redis支持的统一推送服务, 用于服务端向移动设备的消息通知。   [![近三年未更新][Y]](https://github.com/uniqush/uniqush-push)   [![godoc][D]](https://godoc.org/github.com/uniqush/uniqush-push)
- [EventBus](https://github.com/asaskevich/EventBus) **star:1498** 具有异步兼容性的轻量级事件总线。   [![godoc][D]](https://godoc.org/github.com/asaskevich/EventBus)
- [Beaver](https://github.com/Clivern/Beaver) **star:1465** 一个实时消息服务器，可用于在web和手机app端构建一个可伸缩的应用内通知，多人游戏，聊天应用。   [![近一周有更新][G]](https://github.com/Clivern/Beaver)   [![godoc][D]](https://godoc.org/github.com/Clivern/Beaver)
- [Chanify](https://github.com/chanify/chanify) **star:1127** 推送通知服务器向你的iOS设备发送消息。   [![godoc][D]](https://godoc.org/github.com/chanify/chanify)   [![包含中文文档][CN]](https://github.com/chanify/chanify)
- [zmq4](https://github.com/pebbe/zmq4) **star:1081** ZeroMQ的Go interface第4版。也可用于[第3版](https://github.com/pebbe/zmq3)和[第2版](https://github.com/pebbe/zmq2)。   [![godoc][D]](https://godoc.org/github.com/pebbe/zmq4)
- [amqp](https://github.com/rabbitmq/amqp091-go) **star:993** 进入RabbitMQ客户端库。   [![近一周有更新][G]](https://github.com/rabbitmq/amqp091-go)   [![godoc][D]](https://godoc.org/github.com/rabbitmq/amqp091-go)
- [Gollum](https://github.com/trivago/gollum) **star:931** 一个n:m多路复用器(n:m multiplexer)，收集不同来源的消息并将其广播到一组目的地。   [![godoc][D]](https://godoc.org/github.com/trivago/gollum)
- [dbus](https://github.com/godbus/dbus) **star:885** D-Bus的Go bindings。   [![godoc][D]](https://godoc.org/github.com/godbus/dbus)
- [golongpoll](https://github.com/jcuga/golongpoll) **star:636** HTTP longpoll服务器库，使web发布-订阅变得简单。   [![godoc][D]](https://godoc.org/github.com/jcuga/golongpoll)
- [mangos](https://github.com/nanomsg/mangos) **star:607** 具有传输互操作性的Nanomsg(“可伸缩性协议”)的纯go实现。   [![godoc][D]](https://godoc.org/github.com/nanomsg/mangos)
- [emitter](https://github.com/olebedev/emitter) **star:476** 使用Go的方式发出事件, 带有通配符、谓词、取消可能性和许多其他优点。   [![godoc][D]](https://godoc.org/github.com/olebedev/emitter)
- [Glue](https://github.com/desertbit/glue) **star:408** 健壮的Go和Javascript Socket库(替代Socket.io)。   [![近三年未更新][Y]](https://github.com/desertbit/glue)   [![godoc][D]](https://godoc.org/github.com/desertbit/glue)
- [pubsub](https://github.com/tuxychandru/pubsub) **star:392** 简单的pubsub的go包。   [![godoc][D]](https://godoc.org/github.com/tuxychandru/pubsub)
- [Quamina](https://github.com/timbray/quamina) **star:350** Fast pattern-matching for filtering messages and events.   [![近一周有更新][G]](https://github.com/timbray/quamina)   [![godoc][D]](https://godoc.org/github.com/timbray/quamina)
- [Bus](https://github.com/mustafaturan/bus) **star:311** 内部通信的最小消息总线实现。   [![godoc][D]](https://godoc.org/github.com/mustafaturan/bus)
- [messagebus](https://github.com/vardius/message-bus) **star:256** messagebus是一个Go的简单异步消息总线，非常适合在执行事件sourcing、CQRS和DDD时用作事件总线。
- [mob](https://github.com/erni27/mob)  mob is a generic-based, simple mediator / event aggregator library. It supports in-process requests / events processing.
- [rabtap](https://github.com/jandelgado/rabtap) **star:245** RabbitMQ的瑞士军刀cli应用。   [![godoc][D]](https://godoc.org/github.com/jandelgado/rabtap)
- [guble](https://github.com/smancke/guble) **star:155** 使用推送通知服务(谷歌Firebase云消息、苹果推送通知服务、SMS)的消息服务器, 支持websockets,REST API，并具有分布式操作和消息持久性。   [![近三年未更新][Y]](https://github.com/smancke/guble)   [![godoc][D]](https://godoc.org/github.com/smancke/guble)
- [hub](https://github.com/leandro-lugaresi/hub) **star:132** 适用于Go应用程序的消息/事件中心，使用publish/subscribe模式，并支持别名(类似rabbitMQ exchanges)。   [![godoc][D]](https://godoc.org/github.com/leandro-lugaresi/hub)
- [redisqueue](https://github.com/robinjoseph08/redisqueue) **star:114** 基于Redis streams的队列的生产者和消费者。   [![godoc][D]](https://godoc.org/github.com/robinjoseph08/redisqueue)
- [oplog](https://github.com/dailymotion/oplog) **star:113** 用于REST api的通用oplog/replication系统。   [![近三年未更新][Y]](https://github.com/dailymotion/oplog)   [![godoc][D]](https://godoc.org/github.com/dailymotion/oplog)
- [rabbus](https://github.com/rafaeljesus/rabbus) **star:97** amqp exchanges和队列上的一个小工具。   [![近三年未更新][Y]](https://github.com/rafaeljesus/rabbus)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/rabbus)
- [Ratus](https://github.com/hyperonym/ratus) **star:88** Ratus is a RESTful asynchronous task queue server.   [![近一周有更新][G]](https://github.com/hyperonym/ratus)   [![godoc][D]](https://godoc.org/github.com/hyperonym/ratus)
- [go-mq](https://github.com/cheshir/go-mq) **star:87** 具有声明式配置的RabbitMQ客户端。   [![godoc][D]](https://godoc.org/github.com/cheshir/go-mq)
- [drone-line](https://github.com/appleboy/drone-line) **star:79** 使用二进制、docker或Drone CI发送[Line](https://at.line.me/en)通知。   [![godoc][D]](https://godoc.org/github.com/appleboy/drone-line)
- [nsq-event-bus](https://github.com/rafaeljesus/nsq-event-bus) **star:77** 一个围绕NSQ topic和channel的小工具。   [![近三年未更新][Y]](https://github.com/rafaeljesus/nsq-event-bus)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/nsq-event-bus)
- [go-notify](https://github.com/TheCreeper/go-notify) **star:67** 原生的freedesktop通知规范实现。   [![godoc][D]](https://godoc.org/github.com/TheCreeper/go-notify)
- [RapidMQ](https://github.com/sybrexsys/RapidMQ) **star:66** RapidMQ是用于管理本地消息队列的轻量且可靠的库。   [![近三年未更新][Y]](https://github.com/sybrexsys/RapidMQ)   [![godoc][D]](https://godoc.org/github.com/sybrexsys/RapidMQ)
- [Commander](https://github.com/jeroenrinzema/commander) **star:65** 高级事件驱动的消费者/生产者(consumer/producer)，支持各种“方言”，如Apache Kafka。   [![godoc][D]](https://godoc.org/github.com/jeroenrinzema/commander)
- [go-res](https://github.com/jirenius/go-res) **star:63** 用于构建REST/实时服务的包，其中客户端使用NATS和Resgate进行无缝同步。   [![godoc][D]](https://godoc.org/github.com/jirenius/go-res)
- [event](https://github.com/agoalofalife/event) **star:54** 观察者模式的实现。   [![近三年未更新][Y]](https://github.com/agoalofalife/event)   [![godoc][D]](https://godoc.org/github.com/agoalofalife/event)
- [hare](https://github.com/leozz37/hare) **star:51** 一个用户友好的库，用于发送消息和监听TCP套接字。   [![godoc][D]](https://godoc.org/github.com/leozz37/hare)
- [ami](https://github.com/kak-tus/ami) **star:26** 基于Redis集群流的客户端到可靠队列。   [![近三年未更新][Y]](https://github.com/kak-tus/ami)   [![godoc][D]](https://godoc.org/github.com/kak-tus/ami)
- [go-vitotrol](https://github.com/maxatome/go-vitotrol) **star:22** 用于Viessmann Vitotrol web服务的客户端库。   [![godoc][D]](https://godoc.org/github.com/maxatome/go-vitotrol)
- [gosd](https://github.com/alexsniffin/gosd) **star:21** 一种用于调度何时将消息分派到通道的库。   [![godoc][D]](https://godoc.org/github.com/alexsniffin/gosd)
- [rmqconn](https://github.com/sbabiv/rmqconn) **star:20** RabbitMQ重新连接。amqp.Connection和amqp.Dial之上的Wrapper。允许在强制调用Close()方法关闭连接之前重新连接。   [![近三年未更新][Y]](https://github.com/sbabiv/rmqconn)   [![godoc][D]](https://godoc.org/github.com/sbabiv/rmqconn)
- [jazz](https://github.com/socifi/jazz) **star:18** 一个简单的RabbitMQ抽象层，用于队列管理和消息的发布和消费。   [![近三年未更新][Y]](https://github.com/socifi/jazz)   [![godoc][D]](https://godoc.org/github.com/socifi/jazz)
- [gaurun-client](https://github.com/osamingo/gaurun-client) **star:11** 用Go编写的Gaurun客户端。   [![godoc][D]](https://godoc.org/github.com/osamingo/gaurun-client)

**[⬆ back to top](#contents)**

## 微软办公软件

- [unioffice](https://github.com/unidoc/unioffice) **star:3946** 用于创建和处理Office Word (.docx)、Excel (.xlsx)和Powerpoint (.pptx)文档的纯go库。   [![godoc][D]](https://godoc.org/github.com/unidoc/unioffice)

### Microsoft Excel

_用于操作Microsoft Excel的库。 (翻译出错了? 试试 [英文版](README_EN.md#microsoft-excel) 吧~)_

- [excelize](https://github.com/xuri/excelize) **star:15950** Golang图书馆阅读和写作微软Excel&trade;(XLSX)文件。   [![近一周有更新][G]](https://github.com/xuri/excelize)   [![godoc][D]](https://godoc.org/github.com/xuri/excelize)
- [xlsx](https://github.com/tealeg/xlsx) **star:5525** 用以简化在Go程序中读取使用最新版本Microsoft Excel的XML格式文件的库。   [![近一周有更新][G]](https://github.com/tealeg/xlsx)   [![godoc][D]](https://godoc.org/github.com/tealeg/xlsx)
- [go-excel](https://github.com/szyhf/go-excel) **star:180** 一个简单轻便的阅读器，可以将类关系型数据库(relate-db-like)的excel作为表来读取。   [![godoc][D]](https://godoc.org/github.com/szyhf/go-excel)
- [xlsx](https://github.com/plandem/xlsx) **star:165** 在Go程序以快速和安全的方式读取/更新现有的Microsoft Excel文件。   [![godoc][D]](https://godoc.org/github.com/plandem/xlsx)
- [goxlsxwriter](https://github.com/fterrag/goxlsxwriter) **star:21** libxlsxwriter的Go binding, 用于编写XLSX (Microsoft Excel)文件。   [![godoc][D]](https://godoc.org/github.com/fterrag/goxlsxwriter)   [![归档项目][Archived]](https://github.com/fterrag/goxlsxwriter)
- [exl](https://github.com/go-the-way/exl) **star:19** Excel binding to struct written in Go.(Only supports Go1.18+)   [![godoc][D]](https://godoc.org/github.com/go-the-way/exl)

**[⬆ back to top](#contents)**

## 杂项

### 依赖注入

_用于处理依赖项注入的库。 (翻译出错了? 试试 [英文版](README_EN.md#dependency-injection) 吧~)_

- [google/wire](https://github.com/google/wire) **star:11260** Go中的自动初始化。   [![godoc][D]](https://godoc.org/github.com/google/wire)
- [fx](https://github.com/uber-go/fx) **star:4377** 基于依赖注入的Go应用程序框架(构建在dig之上)。   [![近一周有更新][G]](https://github.com/uber-go/fx)   [![godoc][D]](https://godoc.org/github.com/uber-go/fx)
- [dig](https://github.com/uber-go/dig) **star:3375** 一个基于反射的Go依赖注入工具包。   [![godoc][D]](https://godoc.org/github.com/uber-go/dig)
- [do](https://github.com/samber/do) **star:1243** A dependency injection framework based on Generics.   [![godoc][D]](https://godoc.org/github.com/samber/do)
- [GoLobby/Container](https://github.com/golobby/container) **star:485** GoLobby Container is a lightweight yet powerful IoC dependency injection container for the Go programming language.   [![godoc][D]](https://godoc.org/github.com/golobby/container)
- [goioc/di](https://github.com/goioc/di) **star:292** 受spring启发的依赖注入容器。   [![godoc][D]](https://godoc.org/github.com/goioc/di)
- [di](https://github.com/goava/di) **star:201** go编程语言的依赖注入容器。   [![godoc][D]](https://godoc.org/github.com/goava/di)
- [dingo](https://github.com/i-love-flamingo/dingo) **star:164** 基于Guice的Go依赖注入工具包。   [![godoc][D]](https://godoc.org/github.com/i-love-flamingo/dingo)
- [alice](https://github.com/magic003/alice) **star:51** Go的外挂的依赖注入容器。   [![近三年未更新][Y]](https://github.com/magic003/alice)   [![godoc][D]](https://godoc.org/github.com/magic003/alice)
- [wire](https://github.com/Fs02/wire) **star:38** 适用于Go的严格运行时依赖注入(Strict Runtime Dependency Injection)。   [![godoc][D]](https://godoc.org/github.com/Fs02/wire)
- [linker](https://github.com/logrange/linker) **star:35** A reflection based dependency injection and inversion of control library with components lifecycle support.   [![近三年未更新][Y]](https://github.com/logrange/linker)   [![godoc][D]](https://godoc.org/github.com/logrange/linker)
- [nject](https://github.com/muir/nject) **star:27** 用于库、测试、http端点和服务启动的类型安全、反射框架。   [![godoc][D]](https://godoc.org/github.com/muir/nject)
- [gocontainer](https://github.com/vardius/gocontainer) **star:19** 简单的依赖注入容器。   [![近三年未更新][Y]](https://github.com/vardius/gocontainer)   [![godoc][D]](https://godoc.org/github.com/vardius/gocontainer)
- [kinit](https://github.com/go-kata/kinit) **star:9** 可定制的依赖注入容器，具有全局模式，级联初始化和紧急安全结束。   [![godoc][D]](https://godoc.org/github.com/go-kata/kinit)
- [HnH/di](https://github.com/HnH/di) **star:6** DI容器库，专注于干净的API和灵活性。   [![godoc][D]](https://godoc.org/github.com/HnH/di)

**[⬆ back to top](#contents)**

### 项目布局

_**非官方的**模式的结构项目。 (翻译出错了? 试试 [英文版](README_EN.md#project-layout) 吧~)_

- [golang-standards/project-layout](https://github.com/golang-standards/project-layout) **star:41792** golang生态系统中常见的历史和新兴项目布局模式。注意:尽管这个组织名称并不代表golang的官方标准，更多信息请参见[本期](https://github.com/golang-standards/project-layout/issues/117)。尽管如此，有些人可能会发现这种布局很有用。   [![近一周有更新][G]](https://github.com/golang-standards/project-layout)
- [ardanlabs/service](https://github.com/ardanlabs/service) **star:2907** 用于构建产品级可扩展web服务应用程序的[starter kit](https://github.com/ardanlabs/service/wiki)。   [![近一周有更新][G]](https://github.com/ardanlabs/service)   [![godoc][D]](https://godoc.org/github.com/ardanlabs/service)
- [modern-go-application](https://github.com/sagikazarmark/modern-go-application) **star:1653** 应用程序样板和应用现代实践的例子。   [![godoc][D]](https://godoc.org/github.com/sagikazarmark/modern-go-application)
- [pagoda](https://github.com/mikestefanello/pagoda) **star:922** Go内置快速、简单的全栈web开发入门工具包。   [![godoc][D]](https://godoc.org/github.com/mikestefanello/pagoda)
- [cookiecutter-golang](https://github.com/lacion/cookiecutter-golang) **star:628** 遵循生产最佳实践快速启动项目的Go应用程序样板模板。   [![godoc][D]](https://godoc.org/github.com/lacion/cookiecutter-golang)
- [nunu](https://github.com/go-nunu/nunu) **star:623** Nunu is a scaffolding tool for building Go applications.    [![godoc][D]](https://godoc.org/github.com/go-nunu/nunu)   [![包含中文文档][CN]](https://github.com/go-nunu/nunu)
- [golang-templates/seed](https://github.com/golang-templates/seed) **star:397** Go应用程序GitHub存储库模板。   [![近一周有更新][G]](https://github.com/golang-templates/seed)
- [go-starter](https://github.com/allaboutapps/go-starter) **star:382** 一个自以为是的面向生产的RESTful JSON后端模板，与VSCode DevContainers高度集成。   [![godoc][D]](https://godoc.org/github.com/allaboutapps/go-starter)
- [go-todo-backend](https://github.com/Fs02/go-todo-backend) **star:255** 去Todo后端示例使用模块化项目布局的产品微服务。   [![godoc][D]](https://godoc.org/github.com/Fs02/go-todo-backend)
- [scaffold](https://github.com/catchplay/scaffold) **star:143** Scaffold生成一个starter Go项目布局。让您关注已实现的业务逻辑。   [![近三年未更新][Y]](https://github.com/catchplay/scaffold)   [![godoc][D]](https://godoc.org/github.com/catchplay/scaffold)
- [go-sample](https://github.com/zitryss/go-sample) **star:125** 带有实际代码的Go应用程序项目的示例布局。   [![近三年未更新][Y]](https://github.com/zitryss/go-sample)   [![godoc][D]](https://godoc.org/github.com/zitryss/go-sample)
- [gobase](https://github.com/wajox/gobase) **star:49** 一个简单的golang应用框架，带有真实golang应用程序的基本设置。   [![godoc][D]](https://godoc.org/github.com/wajox/gobase)
- [wangyoucao577/go-project-layout](https://github.com/wangyoucao577/go-project-layout) **star:22** 关于如何构造Go项目布局的一组实践和讨论。   [![godoc][D]](https://godoc.org/github.com/wangyoucao577/go-project-layout)
- [insidieux/inizio](https://github.com/insidieux/inizio) **star:16** 带有插件的Golang项目布局生成器。   [![godoc][D]](https://godoc.org/github.com/insidieux/inizio)
- [go-module](https://github.com/octomation/go-module) **star:14** Template for a typical module written on Go.   [![近一周有更新][G]](https://github.com/octomation/go-module)

**[⬆ back to top](#contents)**

### 字符串

_处理字符串的库。 (翻译出错了? 试试 [英文版](README_EN.md#strings) 吧~)_

- [xstrings](https://github.com/huandu/xstrings) **star:1243** 从其他语言移植的有用字符串函数合集。   [![godoc][D]](https://godoc.org/github.com/huandu/xstrings)
- [sttr](https://github.com/abhimanyu003/sttr) **star:743** 跨平台的cli应用程序，对字符串执行各种操作。   [![godoc][D]](https://godoc.org/github.com/abhimanyu003/sttr)
- [strutil](https://github.com/ozgio/strutil) **star:196** 字符串处理工具。   [![godoc][D]](https://godoc.org/github.com/ozgio/strutil)
- [gobeam/Stringy](https://github.com/gobeam/Stringy) **star:190** 字符串操作库，可以将字符串转换为驼色，蛇色，烤肉色等。   [![godoc][D]](https://godoc.org/github.com/gobeam/Stringy)
- [caps](https://github.com/chanced/caps) **star:48** A case conversion library.   [![godoc][D]](https://godoc.org/github.com/chanced/caps)
- [go-formatter](https://gitlab.com/tymonx/go-formatter)  实现**替换字段**由大括号'{}'格式字符串包围。
- [bexp](https://github.com/mkungla/bexp)  执行大括号扩展机制来生成任意字符串。

**[⬆ back to top](#contents)**

### 未分类的

_这些库之所以放在这里，是因为不适合放在其他分类。 (翻译出错了? 试试 [英文版](README_EN.md#uncategorized) 吧~)_

- [gopsutil](https://github.com/shirou/gopsutil) **star:9432** 用于检索进程和系统利用率(CPU、内存、磁盘等)的跨平台的库。   [![近一周有更新][G]](https://github.com/shirou/gopsutil)   [![godoc][D]](https://godoc.org/github.com/shirou/gopsutil)
- [archiver](https://github.com/mholt/archiver) **star:4072** 用于生成和解压.zip和.tar.gz文档的库和命令。   [![近一周有更新][G]](https://github.com/mholt/archiver)   [![godoc][D]](https://godoc.org/github.com/mholt/archiver)
- [gatus](https://github.com/TwinProduction/gatus) **star:4037** 自动服务运行状况仪表板。   [![近一周有更新][G]](https://github.com/TwinProduction/gatus)   [![godoc][D]](https://godoc.org/github.com/TwinProduction/gatus)
- [gofakeit](https://github.com/brianvoe/gofakeit) **star:3286** 用go编写的随机数据生成器。   [![godoc][D]](https://godoc.org/github.com/brianvoe/gofakeit)
- [go-resiliency](https://github.com/eapache/go-resiliency) **star:1862**  Go语言弹性模式(resiliency pattern)。   [![godoc][D]](https://godoc.org/github.com/eapache/go-resiliency)
- [base64Captcha](https://github.com/mojocn/base64Captcha) **star:1845** base64Captcha支持数字，字母，算术，音频和混合模式的验证码。   [![近一周有更新][G]](https://github.com/mojocn/base64Captcha)   [![godoc][D]](https://godoc.org/github.com/mojocn/base64Captcha)   [![包含中文文档][CN]](https://github.com/mojocn/base64Captcha)
- [gosms](https://github.com/haxpax/gosms) **star:1428** Go编写的私人的本地短信网关，可以用来发送短信。   [![godoc][D]](https://godoc.org/github.com/haxpax/gosms)
- [go-commons-pool](https://github.com/jolestar/go-commons-pool) **star:1181** Go语言的通用对象池。   [![godoc][D]](https://godoc.org/github.com/jolestar/go-commons-pool)   [![包含中文文档][CN]](https://github.com/jolestar/go-commons-pool)
- [go-openapi](https://github.com/go-openapi)  用于解析和使用开放api模式(open-api schemas)的包的集合。
- [llvm](https://github.com/llir/llvm) **star:1088** 用于在纯Go中与LLVM IR交互的库。   [![godoc][D]](https://godoc.org/github.com/llir/llvm)
- [shortid](https://github.com/teris-io/shortid) **star:884** 分布式地生成超短、唯一、非顺序、URL友好的id。   [![godoc][D]](https://godoc.org/github.com/teris-io/shortid)
- [shoutrrr](https://github.com/containrrr/shoutrrr) **star:704** 通知库提供了对各种消息服务(如slack、mattermost、fy和smtp等)的轻松访问。   [![godoc][D]](https://godoc.org/github.com/containrrr/shoutrrr)
- [health](https://github.com/alexliesenfeld/health) **star:698** 一个简单而灵活的Go健康检查库。   [![近一周有更新][G]](https://github.com/alexliesenfeld/health)   [![godoc][D]](https://godoc.org/github.com/alexliesenfeld/health)
- [stateless](https://github.com/qmuntal/stateless) **star:679** 用于创建状态机的流畅库。   [![godoc][D]](https://godoc.org/github.com/qmuntal/stateless)
- [health](https://github.com/dimiro1/health) **star:445** 易于使用，可扩展的健康检查库。   [![godoc][D]](https://godoc.org/github.com/dimiro1/health)
- [banner](https://github.com/dimiro1/banner) **star:438** 在Go应用程序中添加漂亮的横幅(banner)。   [![godoc][D]](https://godoc.org/github.com/dimiro1/banner)
- [xz](https://github.com/ulikunitz/xz) **star:429** 纯golang包读和写xz压缩文件。   [![godoc][D]](https://godoc.org/github.com/ulikunitz/xz)
- [gountries](https://github.com/pariz/gountries) **star:394** 获取国家和细节数据的包。   [![godoc][D]](https://godoc.org/github.com/pariz/gountries)
- [conv](https://github.com/cstockton/go-conv) **star:385** conv包提供了跨Go类型(Go types)的快速和直观的转换。   [![godoc][D]](https://godoc.org/github.com/cstockton/go-conv)
- [lk](https://github.com/hyperboloide/lk) **star:313** 一个简单的版权许可证库。   [![godoc][D]](https://godoc.org/github.com/hyperboloide/lk)
- [ffmt](https://github.com/go-ffmt/ffmt) **star:296** 美化数据,使其更适合人查看。   [![godoc][D]](https://godoc.org/github.com/go-ffmt/ffmt)   [![包含中文文档][CN]](https://github.com/go-ffmt/ffmt)
- [healthcheck](https://github.com/etherlabsio/healthcheck) **star:256** 用于RESTful服务的强制的(opinionated)并发健康检查HTTP处理程序。   [![godoc][D]](https://godoc.org/github.com/etherlabsio/healthcheck)
- [antch](https://github.com/antchfx/antch) **star:252** 一个快速、强大和可扩展的web爬虫框架。   [![近三年未更新][Y]](https://github.com/antchfx/antch)   [![godoc][D]](https://godoc.org/github.com/antchfx/antch)   [![包含中文文档][CN]](https://github.com/antchfx/antch)
- [go-unarr](https://github.com/gen2brain/go-unarr) **star:251** 用于RAR、TAR、ZIP和7z文件的解压缩库。   [![godoc][D]](https://godoc.org/github.com/gen2brain/go-unarr)
- [battery](https://github.com/distatus/battery) **star:226** 跨平台、标准化的电池信息库。   [![godoc][D]](https://godoc.org/github.com/distatus/battery)
- [bitio](https://github.com/icza/bitio) **star:221** 高度优化的位级读写器。   [![godoc][D]](https://godoc.org/github.com/icza/bitio)
- [stats](https://github.com/go-playground/stats) **star:167** Monitors Go MemStats + 诸如如内存，Swap和CPU的系统状态统计，并通过UDP发送到任何你想记录的地方   [![近三年未更新][Y]](https://github.com/go-playground/stats)   [![godoc][D]](https://godoc.org/github.com/go-playground/stats)
- [turtle](https://github.com/hackebrot/turtle) **star:152** Go的Emojis库。   [![godoc][D]](https://godoc.org/github.com/hackebrot/turtle)
- [gtree](https://github.com/ddddddO/gtree) **star:144** Provide CLI, Package and Web for tree output and directories creation from Markdown or programmatically.   [![近一周有更新][G]](https://github.com/ddddddO/gtree)   [![godoc][D]](https://godoc.org/github.com/ddddddO/gtree)
- [captcha](https://github.com/steambap/captcha) **star:137** captcha包为验证码生成提供了一个易于使用的、unopinionated的API。   [![godoc][D]](https://godoc.org/github.com/steambap/captcha)
- [gotoprom](https://github.com/cabify/gotoprom) **star:106** 为Prometheus客户端提供类型安全的指标(metric)构建工具库。   [![godoc][D]](https://godoc.org/github.com/cabify/gotoprom)
- [gommit](https://github.com/antham/gommit) **star:104** 分析git提交消息，确保它们遵循已定义的格式。   [![godoc][D]](https://godoc.org/github.com/antham/gommit)
- [indigo](https://github.com/osamingo/indigo) **star:104** 分布式唯一ID生成器, 使用Sonyflake并由Base58编码。   [![godoc][D]](https://godoc.org/github.com/osamingo/indigo)
- [morse](https://github.com/alwindoss/morse) **star:78** 实现字符串与摩尔斯电码转换的库。   [![godoc][D]](https://godoc.org/github.com/alwindoss/morse)
- [faker](https://github.com/pioz/faker) **star:77** 随机假数据和结构生成器为Go。   [![godoc][D]](https://godoc.org/github.com/pioz/faker)
- [persian](https://github.com/mavihq/persian) **star:76** 一些适用于波斯语的Go工具库。   [![godoc][D]](https://godoc.org/github.com/mavihq/persian)
- [pdfgen](https://github.com/hyperboloide/pdfgen) **star:65** 通过Json请求生成PDF的HTTP服务。   [![近三年未更新][Y]](https://github.com/hyperboloide/pdfgen)   [![godoc][D]](https://godoc.org/github.com/hyperboloide/pdfgen)
- [xkg](https://github.com/go-xkg/xkg) **star:56** X Keyboard Grabber(键盘事件捕获)   [![近三年未更新][Y]](https://github.com/go-xkg/xkg)   [![godoc][D]](https://godoc.org/github.com/go-xkg/xkg)
- [browscap_go](https://github.com/digitalcrab/browscap_go) **star:44** GoLang库[浏览器功能项目](https://browscap.org/)。   [![godoc][D]](https://godoc.org/github.com/digitalcrab/browscap_go)
- [datacounter](https://github.com/miolini/datacounter) **star:44** 用于readers/writer/http.ResponseWriter的计数器。   [![godoc][D]](https://godoc.org/github.com/miolini/datacounter)
- [url-shortener](https://github.com/pantrif/url-shortener) **star:43** 一个现代的、强大的、健壮的URL转短链接微服务，带有mysql支持。   [![godoc][D]](https://godoc.org/github.com/pantrif/url-shortener)
- [VarHandler](https://github.com/azr/generators/tree/master/varhandler)  用于生成http输入和输出处理模板。
- [sandid](https://github.com/aofei/sandid) **star:40** 能沟让地球上的每一粒沙子都有自己的ID。   [![godoc][D]](https://godoc.org/github.com/aofei/sandid)
- [autoflags](https://github.com/artyom/autoflags) **star:39** 从struct字段自动定义命令行flag的Go包。   [![godoc][D]](https://godoc.org/github.com/artyom/autoflags)
- [gosh](https://github.com/osamingo/gosh) **star:35** 提供Go统计处理程序，结构和测量方法。   [![godoc][D]](https://godoc.org/github.com/osamingo/gosh)
- [xdg](https://github.com/rkoesters/xdg) **star:35** FreeDesktop.org (xdg)规范在Go中的实现。   [![godoc][D]](https://godoc.org/github.com/rkoesters/xdg)
- [metrics](https://github.com/pascaldekloe/metrics) **star:27** 用于instrumentation和Prometheus exposition的库。   [![godoc][D]](https://godoc.org/github.com/pascaldekloe/metrics)
- [shellwords](https://github.com/Wing924/shellwords) **star:21** 一个Go库，实现了依照UNIX Bourne shell的关键词解析规则进行字符串操纵。   [![godoc][D]](https://godoc.org/github.com/Wing924/shellwords)
- [numa](https://github.com/lrita/numa) **star:18** NUMA是一个用go编写的实用程序库。它可以帮助我们编写一些NUMA-AWARED代码。   [![godoc][D]](https://godoc.org/github.com/lrita/numa)
- [anagent](https://github.com/mudler/anagent) **star:15** Go语言的最小化，可插入的evloop/timer处理程序, 带有依赖注入。   [![近三年未更新][Y]](https://github.com/mudler/anagent)   [![godoc][D]](https://godoc.org/github.com/mudler/anagent)
- [avgRating](https://github.com/kirillDanshin/avgRating) **star:14** 根据威尔逊得分排序算法(Wilson Score Equation)计算平均分和评分。   [![近三年未更新][Y]](https://github.com/kirillDanshin/avgRating)   [![godoc][D]](https://godoc.org/github.com/kirillDanshin/avgRating)
- [hostutils](https://github.com/Wing924/hostutils) **star:12** 一个用于打包和解包FQDNs列表的go语言库。   [![godoc][D]](https://godoc.org/github.com/Wing924/hostutils)
- [faker](https://github.com/neotoolkit/faker) **star:10** 假数据生成器。   [![godoc][D]](https://godoc.org/github.com/neotoolkit/faker)   [![归档项目][Archived]](https://github.com/neotoolkit/faker)
- [go-commandbus](https://github.com/lana/go-commandbus) **star:10** 一个微小的可插拔的Go命令总线。   [![godoc][D]](https://godoc.org/github.com/lana/go-commandbus)
- [openapi](https://github.com/neotoolkit/openapi) **star:9** OpenAPI 3。x解析器。   [![godoc][D]](https://godoc.org/github.com/neotoolkit/openapi)   [![归档项目][Archived]](https://github.com/neotoolkit/openapi)
- [varint](https://github.com/chmike/varint) **star:7** 一个比标准库中提供的更快的变长整数编码器/解码器。   [![godoc][D]](https://godoc.org/github.com/chmike/varint)
- [basexx](https://github.com/bobg/basexx) **star:4** 转换为，从，和之间的数字字符串在不同的数字基数。   [![godoc][D]](https://godoc.org/github.com/bobg/basexx)
- [common](https://github.com/kubeservice-stack/common) **star:4** A library for server framework.   [![godoc][D]](https://godoc.org/github.com/kubeservice-stack/common)
- [sitemap-format](https://github.com/mingard/sitemap-format) **star:3** A simple sitemap generator, with a little syntactic sugar.   [![godoc][D]](https://godoc.org/github.com/mingard/sitemap-format)

**[⬆ back to top](#contents)**

## 自然语言处理

_用于处理人类语言的库。 (翻译出错了? 试试 [英文版](README_EN.md#natural-language-processing) 吧~)_

See also [Text Processing](#text-processing) and [Text Analysis](#text-analysis).

### 语言检测

- [whatlanggo](https://github.com/abadojack/whatlanggo) **star:594** Go的自然语言检测包。支持84种语言和24种脚本(书写系统，如拉丁语、西里尔语等)。   [![godoc][D]](https://godoc.org/github.com/abadojack/whatlanggo)
- [getlang](https://github.com/rylans/getlang) **star:159** 快速自然语言检测包。   [![godoc][D]](https://godoc.org/github.com/rylans/getlang)
- [guesslanguage](https://github.com/endeveit/guesslanguage) **star:57** 通过一个 unicode 文本来猜测该文本使用的语言   [![近三年未更新][Y]](https://github.com/endeveit/guesslanguage)   [![godoc][D]](https://godoc.org/github.com/endeveit/guesslanguage)
- [detectlanguage](https://github.com/detectlanguage/detectlanguage-go) **star:23** 语言检测API Go客户端。支持批量请求，短短语或单字语言检测。   [![godoc][D]](https://godoc.org/github.com/detectlanguage/detectlanguage-go)

### 形态分析

- [spaGO](https://github.com/nlpodyssey/spago) **star:1563** Go中的独立机器学习和自然语言处理库。   [![godoc][D]](https://godoc.org/github.com/nlpodyssey/spago)
- [kagome](https://github.com/ikawaha/kagome) **star:747** JP形态学分析仪编写的纯Go。   [![近一周有更新][G]](https://github.com/ikawaha/kagome)   [![godoc][D]](https://godoc.org/github.com/ikawaha/kagome)
- [nlp](https://github.com/james-bowman/nlp) **star:418** 支持LSA(潜在语义分析)的Go自然语言处理库。   [![godoc][D]](https://godoc.org/github.com/james-bowman/nlp)
- [nlp](https://github.com/Shixzie/nlp) **star:383** 从字符串中提取值并用nlp填充结构。   [![近三年未更新][Y]](https://github.com/Shixzie/nlp)   [![godoc][D]](https://godoc.org/github.com/Shixzie/nlp)   [![归档项目][Archived]](https://github.com/Shixzie/nlp)
- [RAKE.go](https://github.com/afjoseph/RAKE.Go) **star:100** 快速自动关键字提取算法(RAKE)的Go端口。   [![近三年未更新][Y]](https://github.com/afjoseph/RAKE.Go)   [![godoc][D]](https://godoc.org/github.com/afjoseph/RAKE.Go)
- [go-stem](https://github.com/agonopol/go-stem) **star:76** 波特词干算法的实现。   [![近三年未更新][Y]](https://github.com/agonopol/go-stem)   [![godoc][D]](https://godoc.org/github.com/agonopol/go-stem)
- [go2vec](https://github.com/danieldk/go2vec) **star:52** 用于word2vec嵌入式的阅读器和实用程序函数。   [![近三年未更新][Y]](https://github.com/danieldk/go2vec)   [![godoc][D]](https://godoc.org/github.com/danieldk/go2vec)
- [porter2](https://github.com/zhenjl/porter2) **star:46** 非常快的波特2史坦默。   [![godoc][D]](https://godoc.org/github.com/zhenjl/porter2)
- [govader](https://github.com/jonreiter/govader) **star:36** [VADER情绪分析]的Go实现(https://github.com/cjhutto/vaderSentiment)。   [![godoc][D]](https://godoc.org/github.com/jonreiter/govader)
- [snowball](https://github.com/goodsign/snowball) **star:36** 滚雪球柄端口(cgo包装)为 Go 。提供词干提取功能[Snowball native](http://snowball.tartarus.org/)。   [![近三年未更新][Y]](https://github.com/goodsign/snowball)
- [paicehusk](https://github.com/rookii/paicehusk) **star:29** Golang实现了Paice/外壳阻塞算法。   [![近三年未更新][Y]](https://github.com/rookii/paicehusk)   [![godoc][D]](https://godoc.org/github.com/rookii/paicehusk)
- [golibstemmer](https://github.com/rjohnsondev/golibstemmer) **star:20**  Go 绑定斯诺鲍libstemmer库，包括波特2。   [![近三年未更新][Y]](https://github.com/rjohnsondev/golibstemmer)   [![godoc][D]](https://godoc.org/github.com/rjohnsondev/golibstemmer)
- [libtextcat](https://github.com/goodsign/libtextcat) **star:13** 用于libtextcat C库的Cgo绑定。保证与版本2.2兼容。   [![近三年未更新][Y]](https://github.com/goodsign/libtextcat)   [![godoc][D]](https://godoc.org/github.com/goodsign/libtextcat)
- [porter](https://github.com/a2800276/porter) **star:12** 这是Martin Porter在C语言中实现的Porter词干分析算法的一个相当简单的移植。   [![近三年未更新][Y]](https://github.com/a2800276/porter)   [![godoc][D]](https://godoc.org/github.com/a2800276/porter)
- [gosentiwordnet](https://github.com/dinopuguh/gosentiwordnet) **star:11** 情绪分析器使用的多愁善感网词汇在Go。   [![godoc][D]](https://godoc.org/github.com/dinopuguh/gosentiwordnet)
- [govader-backend](https://github.com/PIMPfiction/govader_backend) **star:5** Microservice implementation of [GoVader](https://github.com/jonreiter/govader).   [![godoc][D]](https://godoc.org/github.com/PIMPfiction/govader_backend)
- [spelling-corrector](https://github.com/jorelosorio/spellingcorrector) **star:2** 西班牙语的拼写校正器或创建自己的。   [![godoc][D]](https://godoc.org/github.com/jorelosorio/spellingcorrector)

### 鼻涕虫

- [slug](https://github.com/gosimple/slug) **star:1008** URL 友好的 slug 化工具，支持多种语言   [![godoc][D]](https://godoc.org/github.com/gosimple/slug)
- [go-slugify](https://github.com/mozillazg/go-slugify) **star:87** 生成漂亮的固定链接地址（slug），支持多种语言   [![近三年未更新][Y]](https://github.com/mozillazg/go-slugify)   [![godoc][D]](https://godoc.org/github.com/mozillazg/go-slugify)
- [Slugify](https://github.com/avelino/slugify) **star:32** 字符串 slug 化的工具。   [![近三年未更新][Y]](https://github.com/avelino/slugify)   [![godoc][D]](https://godoc.org/github.com/avelino/slugify)

### 分词器

- [prose](https://github.com/jdkato/prose) **star:3012** 支持标记化、词性标记、命名实体提取等文本处理的库。只说英语。   [![godoc][D]](https://godoc.org/github.com/jdkato/prose)   [![归档项目][Archived]](https://github.com/jdkato/prose)
- [gse](https://github.com/go-ego/gse) **star:2305** 高效的文本分割;支持英语、汉语、日语等。   [![godoc][D]](https://godoc.org/github.com/go-ego/gse)   [![包含中文文档][CN]](https://github.com/go-ego/gse)
- [gojieba](https://github.com/yanyiwu/gojieba) **star:2215** 这是一个Go实现的[jieba](https://github.com/fxsjy/jieba)，这是一个中文分词算法。   [![godoc][D]](https://godoc.org/github.com/yanyiwu/gojieba)   [![包含中文文档][CN]](https://github.com/yanyiwu/gojieba)
- [sentences](https://github.com/neurosnap/sentences) **star:378** Sentence tokenizer: converts text into a list of sentences.   [![godoc][D]](https://godoc.org/github.com/neurosnap/sentences)
- [segment](https://github.com/blevesearch/segment) **star:77** Go库用于执行Unicode文本分割，如[Unicode标准附件#29](https://www.unicode.org/reports/tr29/)所述。   [![godoc][D]](https://godoc.org/github.com/blevesearch/segment)
- [textcat](https://github.com/pebbe/textcat) **star:70** Go package支持基于n-gram的文本分类，支持utf-8和原始文本。   [![godoc][D]](https://godoc.org/github.com/pebbe/textcat)
- [MMSEGO](https://github.com/awsong/MMSEGO) **star:62** 这是一个 Go 实现的[MMSEG](http://technology.chtsai.org/mmseg/)，这是一个中文分词算法。   [![近三年未更新][Y]](https://github.com/awsong/MMSEGO)   [![godoc][D]](https://godoc.org/github.com/awsong/MMSEGO)
- [stemmer](https://github.com/dchest/stemmer) **star:50** 用于Go编程语言的Stemmer包。包括英语和德语词根。   [![近三年未更新][Y]](https://github.com/dchest/stemmer)   [![godoc][D]](https://godoc.org/github.com/dchest/stemmer)
- [gotokenizer](https://github.com/xujiajun/gotokenizer) **star:18** 一种基于字典和双字母格朗语言模型的记号赋予器。(现在只支持中文分割)   [![近三年未更新][Y]](https://github.com/xujiajun/gotokenizer)   [![godoc][D]](https://godoc.org/github.com/xujiajun/gotokenizer)
- [shamoji](https://github.com/osamingo/shamoji) **star:13** shamoji是用Go编写的word过滤包。   [![godoc][D]](https://godoc.org/github.com/osamingo/shamoji)

### 翻译

- [go-pinyin](https://github.com/mozillazg/go-pinyin) **star:1464** 中文汉字到汉语拼音的转换。   [![godoc][D]](https://godoc.org/github.com/mozillazg/go-pinyin)
- [gotext](https://github.com/leonelquinteros/gotext) **star:395** GNU gettext 工具   [![godoc][D]](https://godoc.org/github.com/leonelquinteros/gotext)
- [go-i18n](https://github.com/nicksnyder/go-i18n/)  软件包和用于处理本地化文本的附带工具。
- [go-localize](https://github.com/m1/go-localize) **star:54** 简单易用的i18n(国际化和本地化)引擎——用于翻译语言环境字符串。   [![godoc][D]](https://godoc.org/github.com/m1/go-localize)
- [iuliia-go](https://github.com/mehanizm/iuliia-go) **star:39** 直译斯拉夫字母→拉丁以所有可能的方式。   [![godoc][D]](https://godoc.org/github.com/mehanizm/iuliia-go)
- [go-mystem](https://github.com/dveselov/mystem) **star:30** CGo绑定到Yandex。Mystem -俄罗斯形态学分析仪。   [![近三年未更新][Y]](https://github.com/dveselov/mystem)   [![godoc][D]](https://godoc.org/github.com/dveselov/mystem)
- [spreak](https://github.com/vorlif/spreak) **star:26** Flexible translation and humanization library for Go, based on the concepts behind gettext.   [![godoc][D]](https://godoc.org/github.com/vorlif/spreak)
- [icu](https://github.com/goodsign/icu) **star:20** Cgo绑定用于icu4c C库的检测和转换功能。保证与版本50.1兼容。   [![近三年未更新][Y]](https://github.com/goodsign/icu)   [![godoc][D]](https://godoc.org/github.com/goodsign/icu)
- [t](https://github.com/youthlin/t) **star:16** 另一个用于golang的i18n pkg，它遵循GNU gettext风格并支持.po/。mo文件:“t。T (gettext)”、“T。N (ngettext)”,等等。它包含一个cmd工具[xtemplate](https://github.com/youthlin/t/blob/main/cmd/xtemplate)，可以从文本/html模板中提取消息作为pot文件。   [![godoc][D]](https://godoc.org/github.com/youthlin/t)   [![包含中文文档][CN]](https://github.com/youthlin/t)

### 音译

- [go-unidecode](https://github.com/mozillazg/go-unidecode) **star:111** Unicode文本的ASCII音译。   [![godoc][D]](https://godoc.org/github.com/mozillazg/go-unidecode)
- [gounidecode](https://github.com/fiam/gounidecode) **star:79** 用于Go的Unicode音译器(也称为unidecode)。   [![近三年未更新][Y]](https://github.com/fiam/gounidecode)   [![godoc][D]](https://godoc.org/github.com/fiam/gounidecode)
- [transliterator](https://github.com/alexsergivan/transliterator) **star:36** 提供单向字符串音译，并支持特定于语言的音译规则。   [![godoc][D]](https://godoc.org/github.com/alexsergivan/transliterator)
- [enca](https://github.com/endeveit/enca) **star:15** 最小的cgo绑定[libenca](https://cihar.com/software/enca/)，它检测字符编码。   [![近三年未更新][Y]](https://github.com/endeveit/enca)   [![godoc][D]](https://godoc.org/github.com/endeveit/enca)

**[⬆ back to top](#contents)**

## 网络

_用于处理各种网络层的库。 (翻译出错了? 试试 [英文版](README_EN.md#networking) 吧~)_

- [fasthttp](https://github.com/valyala/fasthttp) **star:20120** 一个快速HTTP实现，比net/http快10倍。   [![近一周有更新][G]](https://github.com/valyala/fasthttp)   [![godoc][D]](https://godoc.org/github.com/valyala/fasthttp)
- [kcptun](https://github.com/xtaci/kcptun) **star:13465** 基于KCP协议的非常简单和快速udp隧道。   [![godoc][D]](https://godoc.org/github.com/xtaci/kcptun)
- [webrtc](https://github.com/pions/webrtc) **star:11663** WebRTC API的纯Go实现。   [![近一周有更新][G]](https://github.com/pions/webrtc)   [![godoc][D]](https://godoc.org/github.com/pions/webrtc)
- [quic-go](https://github.com/lucas-clemente/quic-go) **star:8655** 在纯Go中实现了QUIC协议。   [![近一周有更新][G]](https://github.com/lucas-clemente/quic-go)   [![godoc][D]](https://godoc.org/github.com/lucas-clemente/quic-go)
- [gnet](https://github.com/panjf2000/gnet) **star:8017** “gnet”是一个用纯Go编写的高性能、轻量级、非阻塞、事件驱动的网络框架。   [![近一周有更新][G]](https://github.com/panjf2000/gnet)   [![godoc][D]](https://godoc.org/github.com/panjf2000/gnet)   [![包含中文文档][CN]](https://github.com/panjf2000/gnet)
- [dns](https://github.com/miekg/dns) **star:7199** 用于 DNS 的库。   [![近一周有更新][G]](https://github.com/miekg/dns)   [![godoc][D]](https://godoc.org/github.com/miekg/dns)
- [gopacket](https://github.com/google/gopacket) **star:5800** Go library for packet processing with libpcap bindings.   [![godoc][D]](https://godoc.org/github.com/google/gopacket)
- [HTTPLab](https://github.com/gchaincl/httplab) **star:3916** HTTPLabs 允许你检查 HTTP 请求和伪造响应。   [![godoc][D]](https://godoc.org/github.com/gchaincl/httplab)
- [kcp-go](https://github.com/xtaci/kcp-go) **star:3736** 快速可靠的ARQ协议。   [![godoc][D]](https://godoc.org/github.com/xtaci/kcp-go)
- [netpoll](https://github.com/cloudwego/netpoll) **star:3671** 一个高性能的非阻塞I/O网络框架，它专注于RPC场景，由字节跳动开发。   [![近一周有更新][G]](https://github.com/cloudwego/netpoll)   [![godoc][D]](https://godoc.org/github.com/cloudwego/netpoll)   [![包含中文文档][CN]](https://github.com/cloudwego/netpoll)
- [gobgp](https://github.com/osrg/gobgp) **star:3308** 基于 Go 的 BGP 实现。   [![近一周有更新][G]](https://github.com/osrg/gobgp)   [![godoc][D]](https://godoc.org/github.com/osrg/gobgp)
- [ssh](https://github.com/gliderlabs/ssh) **star:3127** 用于构建SSH服务器的高级API(封装密码/ SSH)。   [![godoc][D]](https://godoc.org/github.com/gliderlabs/ssh)
- [fortio](https://github.com/fortio/fortio) **star:3015** 负载测试库和命令行工具，高级的echo服务器和web UI。允许指定一组每秒查询的负载，并记录延迟直方图和其他有用的统计数据，并将它们作图。支持Tcp、Http、gRPC。   [![近一周有更新][G]](https://github.com/fortio/fortio)   [![godoc][D]](https://godoc.org/github.com/fortio/fortio)
- [nbio](https://github.com/lesismal/nbio) **star:1742** 纯Go 1000k+连接解决方案，支持tls/http1。X /websocket和基本兼容的net/http，具有高性能和低内存成本，无阻塞，事件驱动，易于使用。   [![近一周有更新][G]](https://github.com/lesismal/nbio)   [![godoc][D]](https://godoc.org/github.com/lesismal/nbio)
- [water](https://github.com/songgao/water) **star:1738** 简单TUN / TAP图书馆。   [![godoc][D]](https://godoc.org/github.com/songgao/water)
- [gev](https://github.com/Allenxuxu/gev) **star:1659** gev是一个基于反应器模式的轻量级、快速的非阻塞TCP网络库。   [![godoc][D]](https://godoc.org/github.com/Allenxuxu/gev)
- [go-getter](https://github.com/hashicorp/go-getter) **star:1526**  通过URL来下载文件或目录。   [![近一周有更新][G]](https://github.com/hashicorp/go-getter)   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-getter)
- [sftp](https://github.com/pkg/sftp) **star:1387** 软件包sftp实现SSH文件传输协议，如<https://filezilla-project.org/specs/draft-ietf-secsh-filexfer-02.txt>所示。   [![godoc][D]](https://godoc.org/github.com/pkg/sftp)
- [NFF-Go](https://github.com/intel-go/nff-go) **star:1315** 用于快速开发云计算和裸机网络功能的框架(原YANFF)。   [![godoc][D]](https://godoc.org/github.com/intel-go/nff-go)
- [grab](https://github.com/cavaliercoder/grab) **star:1296**  用于管理文件下载。   [![godoc][D]](https://godoc.org/github.com/cavaliercoder/grab)
- [ftp](https://github.com/jlaffaye/ftp) **star:1160** Package ftp实现了[RFC 959](https://tools.ietf.org/html/rfc959)中描述的ftp客户端。   [![godoc][D]](https://godoc.org/github.com/jlaffaye/ftp)
- [mdns](https://github.com/hashicorp/mdns) **star:1020** 简单mDNS(Multicast DNS)客户端/服务器库。   [![godoc][D]](https://godoc.org/github.com/hashicorp/mdns)
- [mqttPaho](https://eclipse.org/paho/clients/golang/)  Paho Go客户端提供了一个 MQTT 客户端库，用于通过TCP、TLS或WebSockets连接到MQTT代理。
- [gosnmp](https://github.com/soniah/gosnmp) **star:991** 用于执行 SNMP 操作的原生 Go 库。   [![近一周有更新][G]](https://github.com/soniah/gosnmp)   [![godoc][D]](https://godoc.org/github.com/soniah/gosnmp)
- [vssh](https://github.com/yahoo/vssh) **star:913** Go库建立网络和服务器自动化的SSH协议。   [![godoc][D]](https://godoc.org/github.com/yahoo/vssh)
- [gmqtt](https://github.com/DrmagicE/gmqtt) **star:911** Gmqtt是一个灵活、高性能的MQTT代理库，它完全实现了MQTT协议V3.1.1。   [![godoc][D]](https://godoc.org/github.com/DrmagicE/gmqtt)   [![包含中文文档][CN]](https://github.com/DrmagicE/gmqtt)
- [cidranger](https://github.com/yl2chen/cidranger) **star:855** 快速得 IP 到 CIDR 查找。   [![godoc][D]](https://godoc.org/github.com/yl2chen/cidranger)
- [easytcp](https://github.com/DarthPestilane/easytcp) **star:732** 一个用Go (Golang)编写的轻量级TCP框架，与消息路由器一起构建。EasyTCP可以帮助您轻松、快速地构建TCP服务器，而且不那么痛苦。   [![godoc][D]](https://godoc.org/github.com/DarthPestilane/easytcp)
- [lhttp](https://github.com/fanux/lhttp) **star:691** 强大的websocket框架，可以让你更容易的构建IM服务器。   [![近三年未更新][Y]](https://github.com/fanux/lhttp)   [![godoc][D]](https://godoc.org/github.com/fanux/lhttp)   [![包含中文文档][CN]](https://github.com/fanux/lhttp)
- [peerdiscovery](https://github.com/schollz/peerdiscovery) **star:607** 基于UDP组播的跨平台本地对等点发现库。   [![godoc][D]](https://godoc.org/github.com/schollz/peerdiscovery)
- [go-stun](https://github.com/ccding/go-stun) **star:599** 实现了 STUN 客户端(RFC 3489和RFC 5389)。   [![近一周有更新][G]](https://github.com/ccding/go-stun)   [![godoc][D]](https://godoc.org/github.com/ccding/go-stun)
- [gaio](https://github.com/xtaci/gaio) **star:513** 高性能异步io网络在proactor模式下的Golang。   [![godoc][D]](https://godoc.org/github.com/xtaci/gaio)
- [gotcp](https://github.com/gansidui/gotcp) **star:509** 用于快速编写 tcp 应用程序。   [![godoc][D]](https://godoc.org/github.com/gansidui/gotcp)
- [stun](https://github.com/go-rtc/stun) **star:485** Go实现的RFC 5389 STUN协议。   [![godoc][D]](https://godoc.org/github.com/go-rtc/stun)   [![归档项目][Archived]](https://github.com/go-rtc/stun)
- [gopcap](https://github.com/akrennmair/gopcap) **star:472**  用 Go 实现了对 libpcap 的封装。   [![godoc][D]](https://godoc.org/github.com/akrennmair/gopcap)
- [gws](https://github.com/lxzan/gws) **star:451** High-Performance WebSocket Server & Client With AsyncIO Supporting .   [![近一周有更新][G]](https://github.com/lxzan/gws)   [![godoc][D]](https://godoc.org/github.com/lxzan/gws)
- [tcp_server](https://github.com/firstrow/tcp_server) **star:425**  Go 图书馆建设tcp服务器更快。   [![godoc][D]](https://godoc.org/github.com/firstrow/tcp_server)
- [raw](https://github.com/mdlayher/raw) **star:420** Package raw支持在设备驱动程序级别读取和写入网络接口的数据。   [![godoc][D]](https://godoc.org/github.com/mdlayher/raw)   [![归档项目][Archived]](https://github.com/mdlayher/raw)
- [winrm](https://github.com/masterzen/winrm) **star:407**  Go WinRM客户端远程执行Windows机器上的命令。   [![godoc][D]](https://godoc.org/github.com/masterzen/winrm)
- [ftpserverlib](https://github.com/fclairamb/ftpserverlib) **star:374** 功能齐全的FTP服务器库。   [![godoc][D]](https://godoc.org/github.com/fclairamb/ftpserverlib)
- [arp](https://github.com/mdlayher/arp) **star:334** 实现了arp协议，如RFC 826中所述。   [![godoc][D]](https://godoc.org/github.com/mdlayher/arp)
- [dnsmonster](https://github.com/mosajjal/dnsmonster) **star:277** 被动DNS捕获/监控框架。   [![近一周有更新][G]](https://github.com/mosajjal/dnsmonster)   [![godoc][D]](https://godoc.org/github.com/mosajjal/dnsmonster)
- [ethernet](https://github.com/mdlayher/ethernet) **star:271** 实现了对IEEE 802.3以太网II帧和IEEE 802.1Q VLAN标签的编组和解组。   [![godoc][D]](https://godoc.org/github.com/mdlayher/ethernet)
- [buffstreams](https://github.com/stabbycutyou/buffstreams) **star:254** 通过TCP传输协议缓冲区数据。   [![近三年未更新][Y]](https://github.com/stabbycutyou/buffstreams)   [![godoc][D]](https://godoc.org/github.com/stabbycutyou/buffstreams)
- [gNxI](https://github.com/google/gnxi) **star:244** 一组基于 gNMI 和 gNOI 协议的网络管理工具。   [![近一周有更新][G]](https://github.com/google/gnxi)
- [jazigo](https://github.com/udhos/jazigo) **star:194** Jazigo是一个用Go编写的工具，用于检索多个网络设备的配置。   [![godoc][D]](https://godoc.org/github.com/udhos/jazigo)
- [utp](https://github.com/anacrolix/utp) **star:169** Go uTP微传输协议的实现。   [![godoc][D]](https://godoc.org/github.com/anacrolix/utp)
- [event](https://github.com/cheng-zhongliang/event) **star:153** Simple I/O event notification library wirtten in Golang.   [![近一周有更新][G]](https://github.com/cheng-zhongliang/event)   [![godoc][D]](https://godoc.org/github.com/cheng-zhongliang/event)
- [canopus](https://github.com/zubairhamed/canopus) **star:152** CoAP客户端/服务器实现(RFC 7252)。   [![近三年未更新][Y]](https://github.com/zubairhamed/canopus)   [![godoc][D]](https://godoc.org/github.com/zubairhamed/canopus)
- [sslb](https://github.com/eduardonunesp/sslb) **star:145** 它是一个超级简单的负载平衡器，只是一个实现某种性能的小项目。   [![godoc][D]](https://godoc.org/github.com/eduardonunesp/sslb)
- [xtcp](https://github.com/xfxdev/xtcp) **star:144** TCP服务器框架，同时全双工通信，优雅的关机，和自定义协议。   [![近三年未更新][Y]](https://github.com/xfxdev/xtcp)   [![godoc][D]](https://godoc.org/github.com/xfxdev/xtcp)
- [iplib](https://github.com/c-robinson/iplib) **star:119** 用于处理IP地址的库(net)。借鉴于python 的 [ipaddress](https://docy-doc.org/3/library/ipaddress.html)和ruby [ipaddr](https://ruby-doc.org/stdlib-2.5.1/libdoc/ipaddr/rdoc/IPAddr.html)   [![godoc][D]](https://godoc.org/github.com/c-robinson/iplib)
- [gldap](https://github.com/jimlambrt/gldap) **star:99** Gldap提供了一个ldap服务器实现，您可以为它的ldap操作提供处理程序。   [![godoc][D]](https://godoc.org/github.com/jimlambrt/gldap)
- [ether](https://github.com/songgao/ether) **star:79** 一个用于发送和接收以太网帧的跨平台 Go 库。   [![近三年未更新][Y]](https://github.com/songgao/ether)   [![godoc][D]](https://godoc.org/github.com/songgao/ether)
- [dhcp6](https://github.com/mdlayher/dhcp6) **star:76** 实现了一个DHCPv6服务器，如RFC 3315所述。   [![godoc][D]](https://godoc.org/github.com/mdlayher/dhcp6)
- [packet](https://github.com/aerogo/packet) **star:74** 通过TCP和UDP发送数据包。它可以缓冲消息和热交换连接。   [![近三年未更新][Y]](https://github.com/aerogo/packet)   [![godoc][D]](https://godoc.org/github.com/aerogo/packet)
- [go-powerdns](https://github.com/joeig/go-powerdns) **star:72** Golang的PowerDNS API绑定。   [![近一周有更新][G]](https://github.com/joeig/go-powerdns)   [![godoc][D]](https://godoc.org/github.com/joeig/go-powerdns)
- [fullproxy](https://github.com/shoriwe/fullproxy) **star:64** A fully featured scriptable and daemon configurable proxy and pivoting toolkit with SOCKS5, HTTP, raw ports and reverse proxy protocols.   [![godoc][D]](https://godoc.org/github.com/shoriwe/fullproxy)
- [portproxy](https://github.com/aybabtme/portproxy) **star:54** Simple TCP proxy which adds CORS support to API's which don't support it.   [![近三年未更新][Y]](https://github.com/aybabtme/portproxy)   [![godoc][D]](https://godoc.org/github.com/aybabtme/portproxy)
- [linkio](https://github.com/ian-kent/linkio) **star:52** 网络链路速度模拟，主要用于接口的读/写。   [![近三年未更新][Y]](https://github.com/ian-kent/linkio)   [![godoc][D]](https://godoc.org/github.com/ian-kent/linkio)
- [panoptes-stream](https://github.com/yahoo/panoptes-stream) **star:38** 云本地分布式流媒体网络遥测(gNMI, Juniper JTI和Cisco MDT)。   [![godoc][D]](https://godoc.org/github.com/yahoo/panoptes-stream)
- [golibwireshark](https://github.com/sunwxg/golibwireshark) **star:29** 用于解码 pcap 文件和分析解剖数据。   [![近三年未更新][Y]](https://github.com/sunwxg/golibwireshark)   [![godoc][D]](https://godoc.org/github.com/sunwxg/golibwireshark)
- [graval](https://github.com/koofr/graval) **star:28** FTP服务器框架。   [![godoc][D]](https://godoc.org/github.com/koofr/graval)
- [publicip](https://github.com/polera/publicip) **star:26** 包publicip返回面向公共的IPv4地址(internet出口)。   [![近三年未更新][Y]](https://github.com/polera/publicip)   [![godoc][D]](https://godoc.org/github.com/polera/publicip)
- [httpproxy](https://github.com/wzshiming/httpproxy) **star:20** HTTP代理处理程序和拨号。   [![godoc][D]](https://godoc.org/github.com/wzshiming/httpproxy)
- [goshark](https://github.com/sunwxg/goshark) **star:16** 用于解码IP包，创建用于分析的数据结构包。   [![近三年未更新][Y]](https://github.com/sunwxg/goshark)   [![godoc][D]](https://godoc.org/github.com/sunwxg/goshark)
- [llb](https://github.com/kirillDanshin/llb) **star:14** 一个非常简单、快速的代理服务器后端。可用于快速重定向到预定义域，具有零内存分配和快速响应。   [![近三年未更新][Y]](https://github.com/kirillDanshin/llb)   [![godoc][D]](https://godoc.org/github.com/kirillDanshin/llb)
- [tspool](https://github.com/two/tspool) **star:14** TCP库使用工作池来提高性能并保护服务器。   [![近三年未更新][Y]](https://github.com/two/tspool)   [![godoc][D]](https://godoc.org/github.com/two/tspool)
- [gnet](https://github.com/fish-tennis/gnet) **star:12** `gnet` is a high-performance networking framework,especially for game servers.   [![godoc][D]](https://godoc.org/github.com/fish-tennis/gnet)   [![包含中文文档][CN]](https://github.com/fish-tennis/gnet)
- [go-sse](https://github.com/lampctl/go-sse) **star:3** Go client and server implementation of HTML server-sent events.   [![godoc][D]](https://godoc.org/github.com/lampctl/go-sse)

**[⬆ back to top](#contents)**

### HTTP客户端

_用于发出HTTP请求的库。 (翻译出错了? 试试 [英文版](README_EN.md#http-clients) 吧~)_

- [resty](https://github.com/go-resty/resty) **star:8343** 简单的 HTTP 和 REST 客户端，受到 Ruby rest-client 的启发。   [![godoc][D]](https://godoc.org/github.com/go-resty/resty)
- [req](https://github.com/imroc/req) **star:3595** 简单的去HTTP客户端与黑魔法(更少的代码和更高的效率)。   [![godoc][D]](https://godoc.org/github.com/imroc/req)
- [heimdall](https://github.com/gojektech/heimdall) **star:2490** 一个增强的http客户端，具有重试和hystrix功能。   [![godoc][D]](https://godoc.org/github.com/gojektech/heimdall)
- [grequests](https://github.com/levigross/grequests) **star:1984** 一个 Go “克隆”的伟大和著名的请求库。   [![godoc][D]](https://godoc.org/github.com/levigross/grequests)
- [go-retryablehttp](https://github.com/hashicorp/go-retryablehttp) **star:1660** Go中可重试的HTTP客户端。   [![近一周有更新][G]](https://github.com/hashicorp/go-retryablehttp)   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-retryablehttp)
- [sling](https://github.com/dghubble/sling) **star:1596** Sling是一个用于创建和发送API请求的Go HTTP客户端库。   [![godoc][D]](https://godoc.org/github.com/dghubble/sling)
- [requests](https://github.com/carlmjohnson/requests) **star:1145** gopher的HTTP请求。使用上下文。上下文，并且不隐藏底层的net/http。客户端，使其与标准Go api兼容。还包括测试工具。   [![近一周有更新][G]](https://github.com/carlmjohnson/requests)   [![godoc][D]](https://godoc.org/github.com/carlmjohnson/requests)
- [gentleman](https://github.com/h2non/gentleman) **star:1015** 功能齐全的插件驱动HTTP客户端库。   [![godoc][D]](https://godoc.org/github.com/h2non/gentleman)
- [pester](https://github.com/sethgrid/pester) **star:621** 使用重试、后退和并发执行HTTP客户机调用。   [![godoc][D]](https://godoc.org/github.com/sethgrid/pester)
- [go-cleanhttp](https://github.com/hashicorp/go-cleanhttp) **star:324** 很容易获得stdlib HTTP客户端，它不与其他客户端共享任何状态。   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-cleanhttp)
- [request](https://github.com/monaco-io/request) **star:250** golang的HTTP客户端。如果您有关于axios或请求的经验，您会喜欢它。没有第三依赖性。   [![godoc][D]](https://godoc.org/github.com/monaco-io/request)
- [go-otelroundtripper](https://github.com/NdoleStudio/go-otelroundtripper) **star:72** http。为HTTP请求发出开放遥测指标的RoundTripper。   [![godoc][D]](https://godoc.org/github.com/NdoleStudio/go-otelroundtripper)
- [go-http-client](https://github.com/bozd4g/go-http-client) **star:61** 简单而容易地进行http调用。   [![godoc][D]](https://godoc.org/github.com/bozd4g/go-http-client)
- [go-zoox/fetch](https://github.com/go-zoox/fetch) **star:52** A Powerful, Lightweight, Easy Http Client, inspired by Web Fetch API.   [![godoc][D]](https://godoc.org/github.com/go-zoox/fetch)
- [rq](https://github.com/ddo/rq) **star:50** golang stdlib HTTP客户端更好的接口。   [![近三年未更新][Y]](https://github.com/ddo/rq)   [![godoc][D]](https://godoc.org/github.com/ddo/rq)
- [httpretry](https://github.com/ybbus/httpretry) **star:39** 用重试功能丰富默认的go HTTP客户端。   [![godoc][D]](https://godoc.org/github.com/ybbus/httpretry)
- [go-req](https://github.com/wenerme/go-req) **star:20** 声明式golang HTTP客户端。   [![godoc][D]](https://godoc.org/github.com/wenerme/go-req)

**[⬆ back to top](#contents)**

## OpenGL

_用于在Go中使用OpenGL的库。 (翻译出错了? 试试 [英文版](README_EN.md#opengl) 吧~)_

- [glfw](https://github.com/go-gl/glfw) **star:1431** GLFW 3 的 Go 接口实现。
- [gl](https://github.com/go-gl/gl) **star:986** OpenGL 的 Go 接口实现(通过glow生成)。
- [mathgl](https://github.com/go-gl/mathgl) **star:503** 完全基于 Go 实现的数学软件包，专门用于处理三维数学。借鉴于 GLM。   [![godoc][D]](https://godoc.org/github.com/go-gl/mathgl)
- [goxjs/gl](https://github.com/goxjs/gl) **star:166** 跨平台的OpenGL 接口实现(OS X, Linux, Windows，浏览器，iOS, Android)。   [![godoc][D]](https://godoc.org/github.com/goxjs/gl)
- [goxjs/glfw](https://github.com/goxjs/glfw) **star:78** 跨平台 glfw 库，可用于创建 OpenGL 上下文并接收事件。   [![godoc][D]](https://godoc.org/github.com/goxjs/glfw)
- [go-glmatrix](https://github.com/technohippy/go-glmatrix) **star:7** 进入[glMatrix](https://glmatrix.net/)库的端口。   [![godoc][D]](https://godoc.org/github.com/technohippy/go-glmatrix)

**[⬆ back to top](#contents)**

## ORM

_Libraries that implement Object-Relational Mapping or datamapping techniques. (翻译出错了? 试试 [英文版](README_EN.md#orm) 吧~)_

- [GORM](https://github.com/go-gorm/gorm) **star:33585** 一个出色的 ORM 库。主要目标是对开发人员友好。   [![近一周有更新][G]](https://github.com/go-gorm/gorm)   [![godoc][D]](https://godoc.org/github.com/go-gorm/gorm)
- [ent](https://github.com/facebook/ent) **star:14062** 一个用于Go的实体框架。用于建模和查询数据的简单而强大的ORM。   [![近一周有更新][G]](https://github.com/facebook/ent)   [![godoc][D]](https://godoc.org/github.com/facebook/ent)
- [SQLBoiler](https://github.com/volatiletech/sqlboiler) **star:6012** ORM 生成器。根据数据库 schema 生成一个功能强大且运行速度快的ORM。   [![近一周有更新][G]](https://github.com/volatiletech/sqlboiler)   [![godoc][D]](https://godoc.org/github.com/volatiletech/sqlboiler)
- [gorp](https://github.com/go-gorp/gorp) **star:3679** 基于 Go 的关系持久性 ORM-ish 库。   [![godoc][D]](https://godoc.org/github.com/go-gorp/gorp)
- [upper.io/db](https://github.com/upper/db) **star:3373** 对外提供统一的接口用于访问不同的存储介质，例如PostgreSQL, MySQL, SQLite, MSSQL, QL、MongoDB.。   [![近一周有更新][G]](https://github.com/upper/db)   [![godoc][D]](https://godoc.org/github.com/upper/db)
- [XORM](https://gitea.com/xorm/xorm)  简单而强大的ORM for Go。(支持:MySQL, MyMysql, PostgreSQL, Tidb, SQLite3, MsSql和Oracle)。
- [bun](https://github.com/uptrace/bun) **star:2433** SQL-first Golang ORM. Successor of go-pg.   [![近一周有更新][G]](https://github.com/uptrace/bun)   [![godoc][D]](https://godoc.org/github.com/uptrace/bun)
- [gormt](https://github.com/xxjwxc/gormt) **star:2244** Mysql数据库到golang gorm结构。   [![godoc][D]](https://godoc.org/github.com/xxjwxc/gormt)
- [Prisma](https://github.com/prisma/prisma-client-go) **star:1629** Prisma客户端Go，类型安全的数据库访问。   [![近一周有更新][G]](https://github.com/prisma/prisma-client-go)   [![godoc][D]](https://godoc.org/github.com/prisma/prisma-client-go)
- [reform](https://github.com/go-reform/reform) **star:1422** 基于非空接口和代码生成的 ORM。   [![godoc][D]](https://godoc.org/github.com/go-reform/reform)
- [pop/soda](https://github.com/gobuffalo/pop) **star:1372** 数据库迁移、创建、ORM等。用于MySQL、PostgreSQL和SQLite。   [![近一周有更新][G]](https://github.com/gobuffalo/pop)   [![godoc][D]](https://godoc.org/github.com/gobuffalo/pop)
- [go-sqlbuilder](https://github.com/huandu/go-sqlbuilder) **star:1091** 一个灵活而强大的SQL字符串构建器库。   [![近一周有更新][G]](https://github.com/huandu/go-sqlbuilder)   [![godoc][D]](https://godoc.org/github.com/huandu/go-sqlbuilder)
- [rel](https://github.com/go-rel/rel) **star:672** Golang的现代数据库访问层——可测试、可扩展，并精心设计成一个干净优雅的API。   [![godoc][D]](https://godoc.org/github.com/go-rel/rel)
- [Zoom](https://github.com/albrow/zoom) **star:301** 基于 Redis 的快速数据存储和查询引擎。   [![godoc][D]](https://godoc.org/github.com/albrow/zoom)
- [go-sql](https://github.com/rushteam/gosql) **star:175** 一个简单的ORM为mysql。   [![godoc][D]](https://godoc.org/github.com/rushteam/gosql)
- [grimoire](https://github.com/Fs02/grimoire) **star:159** 基于 golang 的数据库访问层和验证库。(支持: MySQL, PostgreSQL和SQLite3)。   [![godoc][D]](https://godoc.org/github.com/Fs02/grimoire)
- [golobby/orm](https://github.com/golobby/orm) **star:142** Simple, fast, type-safe, generic orm for developer happiness.   [![godoc][D]](https://godoc.org/github.com/golobby/orm)
- [go-store](https://github.com/gosuri/go-store) **star:111** 简单且快速的 Redis 键值存储库。   [![近三年未更新][Y]](https://github.com/gosuri/go-store)   [![godoc][D]](https://godoc.org/github.com/gosuri/go-store)
- [go-firestorm](https://github.com/jschoedt/go-firestorm) **star:47** 一个轻量级的ORM。用于Google/Firebase Cloud Firestore。   [![godoc][D]](https://godoc.org/github.com/jschoedt/go-firestorm)
- [cacheme](https://github.com/Yiling-J/cacheme-go) **star:22** 基于模式的，类型化的Redis缓存/记忆框架。   [![godoc][D]](https://godoc.org/github.com/Yiling-J/cacheme-go)   [![包含中文文档][CN]](https://github.com/Yiling-J/cacheme-go)
- [marlow](https://github.com/marlow/marlow) **star:14** 从项目结构生成ORM。   [![近三年未更新][Y]](https://github.com/marlow/marlow)   [![godoc][D]](https://godoc.org/github.com/marlow/marlow)
- [lore](https://github.com/abrahambotros/lore) **star:12** Simple and lightweight pseudo-ORM/pseudo-struct-mapping environment for Go.   [![近三年未更新][Y]](https://github.com/abrahambotros/lore)   [![godoc][D]](https://godoc.org/github.com/abrahambotros/lore)
- [go-dbw](https://github.com/hashicorp/go-dbw) **star:8** A simple package that encapsulates database operations.   [![近一周有更新][G]](https://github.com/hashicorp/go-dbw)   [![godoc][D]](https://godoc.org/github.com/hashicorp/go-dbw)

**[⬆ back to top](#contents)**

## 包管理

_用于管理依赖和包的官方工具 (翻译出错了? 试试 [英文版](README_EN.md#package-management) 吧~)_

- [go modules](https://golang.org/cmd/go/#hdr-Modules__module_versions__and_more)  Modules 是源码的版本控制和交换的单位。go命令直接支持处理模块，包括记录和解决对其他模块的依赖关系。

_包管理的官方实验工具 (翻译出错了? 试试 [英文版](README_EN.md#package-management) 吧~)_

- [dep](https://github.com/golang/dep) **star:12943**  Go 的依赖管理工具，需要 Go 1.9+   [![近三年未更新][Y]](https://github.com/golang/dep)   [![godoc][D]](https://godoc.org/github.com/golang/dep)   [![归档项目][Archived]](https://github.com/golang/dep)
- [vgo](https://go.googlesource.com/vgo/)  Go 命令版本管理

_用于包和依赖项管理的非官方库。 (翻译出错了? 试试 [英文版](README_EN.md#package-management) 吧~)_

- [glide](https://github.com/Masterminds/glide) **star:8174** 轻松管理您的 golang 第三方包。受Maven、Bundler和Pip等工具的启发。   [![godoc][D]](https://godoc.org/github.com/Masterminds/glide)
- [godep](https://github.com/tools/godep) **star:5574** godep是go的依赖工具，它通过修复包的依赖关系来帮助构建可重复的包。   [![近三年未更新][Y]](https://github.com/tools/godep)   [![godoc][D]](https://godoc.org/github.com/tools/godep)   [![归档项目][Archived]](https://github.com/tools/godep)
- [govendor](https://github.com/kardianos/govendor) **star:4943** 包管理器。使用 vendor 文件的 Go vendor 工具。   [![近三年未更新][Y]](https://github.com/kardianos/govendor)   [![godoc][D]](https://godoc.org/github.com/kardianos/govendor)   [![归档项目][Archived]](https://github.com/kardianos/govendor)
- [gopm](https://github.com/gpmgo/gopm) **star:2474** 包管理器。   [![近三年未更新][Y]](https://github.com/gpmgo/gopm)   [![godoc][D]](https://godoc.org/github.com/gpmgo/gopm)   [![归档项目][Archived]](https://github.com/gpmgo/gopm)
- [gom](https://github.com/mattn/gom) **star:1390** Go Manager - bundle for Go。   [![近三年未更新][Y]](https://github.com/mattn/gom)   [![godoc][D]](https://godoc.org/github.com/mattn/gom)   [![归档项目][Archived]](https://github.com/mattn/gom)
- [gpm](https://github.com/pote/gpm) **star:1197** 基本的 Go 依赖管理器。   [![近三年未更新][Y]](https://github.com/pote/gpm)
- [goop](https://github.com/nitrous-io/goop) **star:780** Go 的简单依赖管理器，灵感来自Bundler。   [![近三年未更新][Y]](https://github.com/nitrous-io/goop)   [![godoc][D]](https://godoc.org/github.com/nitrous-io/goop)
- [modgv](https://github.com/lucasepe/modgv) **star:465** 将'go mod graph'输出转换为Graphviz的点语言。   [![godoc][D]](https://godoc.org/github.com/lucasepe/modgv)
- [nut](https://github.com/jingweno/nut) **star:234** vendor 依赖。   [![近三年未更新][Y]](https://github.com/jingweno/nut)   [![godoc][D]](https://godoc.org/github.com/jingweno/nut)
- [johnny-deps](https://github.com/VividCortex/johnny-deps) **star:214** 使用Git的最小依赖版本。   [![归档项目][Archived]](https://github.com/VividCortex/johnny-deps)
- [gup](https://github.com/nao1215/gup) **star:212** Update binaries installed by "go install".   [![近一周有更新][G]](https://github.com/nao1215/gup)   [![godoc][D]](https://godoc.org/github.com/nao1215/gup)
- [mvn-golang](https://github.com/raydac/mvn-golang) **star:157** 插件，为自动加载Golang SDK，依赖关系管理和启动Maven项目基础设施中的构建环境提供了方法。   [![近一周有更新][G]](https://github.com/raydac/mvn-golang)
- [VenGO](https://github.com/DamnWidget/VenGO) **star:122** 创建和管理可导出的隔离go虚拟环境。   [![近三年未更新][Y]](https://github.com/DamnWidget/VenGO)   [![godoc][D]](https://godoc.org/github.com/DamnWidget/VenGO)
- [gop](https://github.com/lunny/gop) **star:50** 在GOPATH之外构建和管理Go应用程序。   [![近三年未更新][Y]](https://github.com/lunny/gop)   [![godoc][D]](https://godoc.org/github.com/lunny/gop)   [![包含中文文档][CN]](https://github.com/lunny/gop)   [![归档项目][Archived]](https://github.com/lunny/gop)

**[⬆ back to top](#contents)**

## 性能

- [jaeger](https://github.com/jaegertracing/jaeger) **star:18253** 分布式跟踪系统。   [![近一周有更新][G]](https://github.com/jaegertracing/jaeger)   [![godoc][D]](https://godoc.org/github.com/jaegertracing/jaeger)
- [pixie](https://github.com/pixie-labs/pixie) **star:4837** 通过eBPF对Golang应用程序没有检测跟踪。   [![近一周有更新][G]](https://github.com/pixie-labs/pixie)
- [statsviz](https://github.com/arl/statsviz) **star:2934** 实时可视化您的Go应用程序运行时统计数据。   [![godoc][D]](https://godoc.org/github.com/arl/statsviz)
- [profile](https://github.com/pkg/profile) **star:1898** Go的简单分析支持包。   [![godoc][D]](https://godoc.org/github.com/pkg/profile)
- [go-instrument](https://github.com/nikolaydubina/go-instrument) **star:97** Automatically add spans to all methods and functions.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/go-instrument)
- [tracer](https://github.com/kamilsk/tracer) **star:79** 简单、轻量级的跟踪。   [![godoc][D]](https://godoc.org/github.com/kamilsk/tracer)

**[⬆ back to top](#contents)**

## 查询语言

- [graphql-go](https://github.com/graphql-go/graphql) **star:9405** 为Go实现GraphQL。   [![godoc][D]](https://godoc.org/github.com/graphql-go/graphql)
- [gqlgen](https://github.com/99designs/gqlgen) **star:9170** 去生成基于graphql服务器库。   [![近一周有更新][G]](https://github.com/99designs/gqlgen)   [![godoc][D]](https://godoc.org/github.com/99designs/gqlgen)
- [dasel](https://github.com/tomwright/dasel) **star:4530** 使用命令行中的选择器查询和更新数据结构。与jq/yq类似，但支持JSON、YAML、TOML和XML，运行时依赖关系为零。   [![godoc][D]](https://godoc.org/github.com/tomwright/dasel)
- [graphql](https://github.com/neelance/graphql-go) **star:4530** 关注易用性的GraphQL服务器。   [![近一周有更新][G]](https://github.com/neelance/graphql-go)   [![godoc][D]](https://godoc.org/github.com/neelance/graphql-go)
- [gojsonq](https://github.com/thedevsaddam/gojsonq) **star:2099** 一个用来查询JSON数据的Go包。   [![godoc][D]](https://godoc.org/github.com/thedevsaddam/gojsonq)
- [rql](https://github.com/a8m/rql) **star:310** 用于REST API的资源查询语言。   [![godoc][D]](https://godoc.org/github.com/a8m/rql)
- [jsonql](https://github.com/elgs/jsonql) **star:269** Golang中的JSON查询表达式库。   [![godoc][D]](https://godoc.org/github.com/elgs/jsonql)
- [jsonslice](https://github.com/bhmj/jsonslice) **star:79** 使用高级过滤器查询Jsonpath。   [![godoc][D]](https://godoc.org/github.com/bhmj/jsonslice)
- [graphql](https://github.com/tmc/graphql) **star:57** graphql解析器+工具集   [![近三年未更新][Y]](https://github.com/tmc/graphql)   [![godoc][D]](https://godoc.org/github.com/tmc/graphql)   [![归档项目][Archived]](https://github.com/tmc/graphql)
- [rqp](https://github.com/timsolov/rest-query-parser) **star:57** REST API的查询解析器。查询中直接支持筛选、验证、'和'或'操作。   [![godoc][D]](https://godoc.org/github.com/timsolov/rest-query-parser)
- [goven](https://github.com/SeldonIO/goven) **star:55** A drop-in query language for any database schema.   [![godoc][D]](https://godoc.org/github.com/SeldonIO/goven)
- [api-fu](https://github.com/ccbrown/api-fu) **star:51** 综合GraphQL实现。   [![godoc][D]](https://godoc.org/github.com/ccbrown/api-fu)
- [straf](https://github.com/SonicRoshan/straf) **star:34** 轻松地将Golang结构转换为GraphQL对象。   [![近三年未更新][Y]](https://github.com/SonicRoshan/straf)   [![godoc][D]](https://godoc.org/github.com/SonicRoshan/straf)
- [mql](https://github.com/hashicorp/mql) **star:21** Model Query Language (mql) is a query language for your database models.   [![近一周有更新][G]](https://github.com/hashicorp/mql)   [![godoc][D]](https://godoc.org/github.com/hashicorp/mql)
- [jsonpath](https://github.com/AsaiYusuke/jsonpath) **star:18** 一个基于JSONPath语法检索部分JSON的查询库。   [![godoc][D]](https://godoc.org/github.com/AsaiYusuke/jsonpath)
- [gws](https://github.com/Zaba505/gws) **star:7** Apollos的“GraphQL over Websocket”客户端和服务器实现。   [![近三年未更新][Y]](https://github.com/Zaba505/gws)   [![godoc][D]](https://godoc.org/github.com/Zaba505/gws)
- [grapher](https://github.com/reaganiwadha/grapher) **star:1** A GraphQL field builder utilizing Go generics with extra utilities and features.   [![godoc][D]](https://godoc.org/github.com/reaganiwadha/grapher)

**[⬆ back to top](#contents)**

## 嵌入的资源

- [statik](https://github.com/rakyll/statik) **star:3649** 将静态文件嵌入到Go可执行文件中。   [![godoc][D]](https://godoc.org/github.com/rakyll/statik)
- [packr](https://github.com/gobuffalo/packr) **star:3408** 将静态文件嵌入到Go二进制文件中的简单方法。   [![godoc][D]](https://godoc.org/github.com/gobuffalo/packr)   [![归档项目][Archived]](https://github.com/gobuffalo/packr)
- [go.rice](https://github.com/GeertJohan/go.rice) **star:2373** 走了。rice是一个Go包，它使得处理HTML、JS、CSS、图像和模板等资源非常容易。   [![godoc][D]](https://godoc.org/github.com/GeertJohan/go.rice)
- [vfsgen](https://github.com/shurcooL/vfsgen) **star:976** 生成一个vfsdata。静态实现给定虚拟文件系统的go文件。   [![godoc][D]](https://godoc.org/github.com/shurcooL/vfsgen)
- [esc](https://github.com/mjibson/esc) **star:637** 将文件嵌入到Go程序中并提供http文件系统接口。   [![近三年未更新][Y]](https://github.com/mjibson/esc)   [![godoc][D]](https://godoc.org/github.com/mjibson/esc)
- [fileb0x](https://github.com/UnnoTed/fileb0x) **star:629** 一个可定制的工具用来在Go中嵌入文件   [![godoc][D]](https://godoc.org/github.com/UnnoTed/fileb0x)
- [go-resources](https://github.com/omeid/go-resources) **star:176** 嵌入到Go中的普通资源。   [![godoc][D]](https://godoc.org/github.com/omeid/go-resources)
- [statics](https://github.com/go-playground/statics) **star:66** 将静态资源嵌入到go文件中，用于单个二进制编译+使用http。文件系统+符号链接。   [![近三年未更新][Y]](https://github.com/go-playground/statics)   [![godoc][D]](https://godoc.org/github.com/go-playground/statics)
- [templify](https://github.com/wlbr/templify) **star:30** 将外部模板文件嵌入到Go代码中，以创建单个文件二进制文件。   [![godoc][D]](https://godoc.org/github.com/wlbr/templify)
- [rebed](https://github.com/soypat/rebed) **star:27** 重新创建Go 1.16' embed中的文件夹结构和文件。FS的类型   [![godoc][D]](https://godoc.org/github.com/soypat/rebed)
- [debme](https://github.com/leaanthony/debme) **star:25** 创建一个“嵌入。FS '从一个现有的'嵌入。FS的子目录。   [![godoc][D]](https://godoc.org/github.com/leaanthony/debme)
- [mule](https://github.com/wlbr/mule) **star:12** Embed external resources like images, movies ... into Go source code to create single file binaries using `go generate`. Focused on simplicity.   [![godoc][D]](https://godoc.org/github.com/wlbr/mule)

**[⬆ back to top](#contents)**

## 科学与数据分析

_用于科学计算和数据分析的库。 (翻译出错了? 试试 [英文版](README_EN.md#science-and-data-analysis) 吧~)_

- [gonum](https://github.com/gonum/gonum) **star:6820** Gonum是一组用于Go编程语言的数字库。它包含用于矩阵、统计、优化等的库。   [![近一周有更新][G]](https://github.com/gonum/gonum)   [![godoc][D]](https://godoc.org/github.com/gonum/gonum)
- [stats](https://github.com/montanaflynn/stats) **star:2806** 包含Golang标准库中缺少的公共函数的统计软件包。   [![godoc][D]](https://godoc.org/github.com/montanaflynn/stats)
- [gonum/plot](https://github.com/gonum/plot) **star:2512** gonum/plot提供了一个API，用于在Go中构建和绘制绘图。   [![godoc][D]](https://godoc.org/github.com/gonum/plot)
- [gosl](https://github.com/cpmech/gosl) **star:1768** 提供线性代数，FFT，几何，NURBS，数值方法，概率，优化，微分方程，等等。   [![godoc][D]](https://godoc.org/github.com/cpmech/gosl)
- [streamtools](https://github.com/nytlabs/streamtools) **star:1313** 通用图形工具，用于处理数据流。   [![近三年未更新][Y]](https://github.com/nytlabs/streamtools)   [![godoc][D]](https://godoc.org/github.com/nytlabs/streamtools)
- [dataframe-go](https://github.com/rocketlaunchr/dataframe-go) **star:1038** 用于机器学习和统计的数据框架(类似于panda)。   [![godoc][D]](https://godoc.org/github.com/rocketlaunchr/dataframe-go)
- [go-dsp](https://github.com/mjibson/go-dsp) **star:827** Go数字信号处理。   [![godoc][D]](https://godoc.org/github.com/mjibson/go-dsp)
- [chart](https://github.com/vdobler/chart) **star:753** 简单的图表绘制库。支持多种图形类型。   [![godoc][D]](https://godoc.org/github.com/vdobler/chart)
- [orb](https://github.com/paulmach/orb) **star:728** 2D几何类型，支持剪切、GeoJSON和Mapbox矢量平铺。   [![godoc][D]](https://godoc.org/github.com/paulmach/orb)
- [goraph](https://github.com/gyuho/goraph) **star:722** 纯golang图论库(数据结构，算法可视化)。   [![godoc][D]](https://godoc.org/github.com/gyuho/goraph)
- [graph](https://github.com/yourbasic/graph) **star:658** 基本图形算法库。   [![godoc][D]](https://godoc.org/github.com/yourbasic/graph)
- [ewma](https://github.com/VividCortex/ewma) **star:413** 提供指数加权移动平均算法。   [![godoc][D]](https://godoc.org/github.com/VividCortex/ewma)
- [calendarheatmap](https://github.com/nikolaydubina/calendarheatmap) **star:377** 基于Github贡献活动的日历热图。   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/calendarheatmap)
- [TextRank](https://github.com/DavidBelicza/TextRank) **star:184** TextRank在Golang中的实现，支持扩展特性(摘要、加权、短语提取)和多线程(goroutine)。   [![godoc][D]](https://godoc.org/github.com/DavidBelicza/TextRank)
- [gohistogram](https://github.com/VividCortex/gohistogram) **star:172** 数据流的近似直方图。   [![godoc][D]](https://godoc.org/github.com/VividCortex/gohistogram)   [![归档项目][Archived]](https://github.com/VividCortex/gohistogram)
- [sparse](https://github.com/james-bowman/sparse) **star:145**  Go 稀疏矩阵格式的线性代数支持科学和机器学习应用程序，兼容gonum矩阵库。   [![godoc][D]](https://godoc.org/github.com/james-bowman/sparse)
- [go-estimate](https://github.com/milosgajdos/go-estimate) **star:104** Go中的状态估计和滤波算法。   [![godoc][D]](https://godoc.org/github.com/milosgajdos/go-estimate)
- [pagerank](https://github.com/alixaxel/pagerank) **star:78** 加权 PageRank 算法在Go中的实现。   [![godoc][D]](https://godoc.org/github.com/alixaxel/pagerank)
- [jsonl-graph](https://github.com/nikolaydubina/jsonl-graph) **star:69** 使用graphviz支持操作JSONL图形的工具。   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/jsonl-graph)
- [geom](https://github.com/skelterjohn/geom) **star:55**  Go 的二维几何。   [![近三年未更新][Y]](https://github.com/skelterjohn/geom)   [![godoc][D]](https://godoc.org/github.com/skelterjohn/geom)
- [evaler](https://github.com/soniah/evaler) **star:52** 简单的浮点算术表达式求值器。   [![近三年未更新][Y]](https://github.com/soniah/evaler)   [![godoc][D]](https://godoc.org/github.com/soniah/evaler)
- [decimal](https://github.com/db47h/decimal) **star:38** Package decimal实现任意精度的十进制浮点运算。   [![godoc][D]](https://godoc.org/github.com/db47h/decimal)
- [triangolatte](https://github.com/tchayen/triangolatte) **star:35** 二维三角库。允许将线和多边形(都基于点)转换为gpu语言。   [![godoc][D]](https://godoc.org/github.com/tchayen/triangolatte)
- [gograph](https://github.com/hmdsefi/gograph) **star:34** A golang generic graph library that provides mathematical graph-theory and algorithms.   [![godoc][D]](https://godoc.org/github.com/hmdsefi/gograph)
- [goent](https://github.com/kzahedi/goent) **star:33**  Go 实现熵度量。   [![近三年未更新][Y]](https://github.com/kzahedi/goent)   [![godoc][D]](https://godoc.org/github.com/kzahedi/goent)
- [piecewiselinear](https://github.com/sgreben/piecewiselinear) **star:26** 微型线性插值库。   [![godoc][D]](https://godoc.org/github.com/sgreben/piecewiselinear)
- [godesim](https://github.com/soypat/godesim) **star:21** 扩展/多变量ODE求解器框架，用于基于事件的模拟与简单的API。   [![godoc][D]](https://godoc.org/github.com/soypat/godesim)
- [ode](https://github.com/ChristopherRabotin/ode) **star:21** 常微分方程(ODE)求解器，支持扩展状态和基于信道的迭代停止条件。   [![近三年未更新][Y]](https://github.com/ChristopherRabotin/ode)   [![godoc][D]](https://godoc.org/github.com/ChristopherRabotin/ode)
- [GoStats](https://github.com/OGFris/GoStats) **star:20** GoStats是一个开放源码的GoLang库，主要用于机器学习领域的数学统计，它涵盖了大多数统计度量函数。   [![近三年未更新][Y]](https://github.com/OGFris/GoStats)   [![godoc][D]](https://godoc.org/github.com/OGFris/GoStats)
- [PiHex](https://github.com/claygod/PiHex) **star:20** 实现了针对16进制数 Pi 的“bailee - borwein - plouffe”算法。   [![godoc][D]](https://godoc.org/github.com/claygod/PiHex)
- [assocentity](https://github.com/ndabAP/assocentity) **star:12** assocentity 返回单词到给定实体的平均距离。   [![godoc][D]](https://godoc.org/github.com/ndabAP/assocentity)
- [go-gt](https://github.com/ThePaw/go-gt) **star:10** 用“Go”语言编写的图论算法。   [![近三年未更新][Y]](https://github.com/ThePaw/go-gt)   [![godoc][D]](https://godoc.org/github.com/ThePaw/go-gt)
- [rootfinding](https://github.com/khezen/rootfinding) **star:10** 二次函数求根算法库。   [![近三年未更新][Y]](https://github.com/khezen/rootfinding)   [![godoc][D]](https://godoc.org/github.com/khezen/rootfinding)
- [bradleyterry](https://github.com/seanhagen/bradleyterry) **star:8** 为成对比较提供了一个 Bradley-Terry 模型。   [![近三年未更新][Y]](https://github.com/seanhagen/bradleyterry)   [![godoc][D]](https://godoc.org/github.com/seanhagen/bradleyterry)

**[⬆ back to top](#contents)**

## 安全

_用于帮助您的应用程序更安全的库。 (翻译出错了? 试试 [英文版](README_EN.md#security) 吧~)_

- [age](https://github.com/FiloSottile/age) **star:14039** 一个简单、现代和安全的加密工具(和Go库)，具有小的显式密钥，没有配置选项，并且具有unix风格的可组合性。   [![godoc][D]](https://godoc.org/github.com/FiloSottile/age)
- [lego](https://github.com/go-acme/lego) **star:6429** 纯 Go ACME 客户端库及命令行工具   [![近一周有更新][G]](https://github.com/go-acme/lego)   [![godoc][D]](https://godoc.org/github.com/go-acme/lego)
- [CertMagic](https://github.com/caddyserver/certmagic) **star:4615** 成熟、健壮和强大的ACME客户端集成，用于完全托管的TLS证书颁发和续签。   [![godoc][D]](https://godoc.org/github.com/caddyserver/certmagic)
- [Cameradar](https://github.com/Ullaakut/cameradar) **star:3487** 工具和库，以远程入侵RTSP流从监控摄像头。   [![godoc][D]](https://godoc.org/github.com/Ullaakut/cameradar)
- [memguard](https://github.com/awnumar/memguard) **star:2391** 一个用于处理内存中敏感值的纯Go库。   [![近一周有更新][G]](https://github.com/awnumar/memguard)   [![godoc][D]](https://godoc.org/github.com/awnumar/memguard)
- [secure](https://github.com/unrolled/secure) **star:2145** Go 语言 HTTP 中间件，为 Go 提供了一些安全功能   [![godoc][D]](https://godoc.org/github.com/unrolled/secure)
- [acmetool](https://github.com/hlandau/acme) **star:1995** ACME(让我们用自动更新加密)客户端工具。   [![godoc][D]](https://godoc.org/github.com/hlandau/acme)
- [themis](https://github.com/cossacklabs/themis) **star:1744** 用于解决典型数据安全任务(安全数据存储、安全消息传递、零知识证明认证)的高级加密库，可用于14种语言，最适合多平台应用程序。   [![近一周有更新][G]](https://github.com/cossacklabs/themis)
- [Coraza](https://github.com/corazawaf/coraza) **star:1348** 企业级、modsecurity和OWASP CRS兼容WAF库。   [![godoc][D]](https://godoc.org/github.com/corazawaf/coraza)
- [acra](https://github.com/cossacklabs/acra) **star:1213** 网络加密代理保护基于数据库的应用程序免受数据泄漏:强选择性加密，SQL注入预防，入侵检测系统。   [![godoc][D]](https://godoc.org/github.com/cossacklabs/acra)
- [dongle](https://github.com/golang-module/dongle) **star:757** 一个简单的，语义和开发人员友好的golang包的编码和解码和加密和解密。   [![godoc][D]](https://godoc.org/github.com/golang-module/dongle)   [![包含中文文档][CN]](https://github.com/golang-module/dongle)
- [nacl](https://github.com/kevinburke/nacl) **star:535**  Go 实现NaCL API的集合。   [![godoc][D]](https://godoc.org/github.com/kevinburke/nacl)
- [go-password-validator](https://github.com/lane-c-wagner/go-password-validator) **star:429** 基于原始密码熵值的密码验证器。   [![godoc][D]](https://godoc.org/github.com/lane-c-wagner/go-password-validator)
- [ssh-vault](https://github.com/ssh-vault/ssh-vault) **star:394** 使用ssh密钥加密/解密。   [![godoc][D]](https://godoc.org/github.com/ssh-vault/ssh-vault)
- [booster](https://github.com/anatol/booster) **star:381** Fast initramfs generator with full-disk encryption support.   [![godoc][D]](https://godoc.org/github.com/anatol/booster)
- [optimus-go](https://github.com/pjebs/optimus-go) **star:350** 使用Knuth的算法进行ID哈希和混淆。   [![近三年未更新][Y]](https://github.com/pjebs/optimus-go)   [![godoc][D]](https://godoc.org/github.com/pjebs/optimus-go)
- [firewalld-rest](https://github.com/prashantgupta24/firewalld-rest) **star:330** 用于动态更新linux服务器上的firewalld规则的rest应用程序。   [![近三年未更新][Y]](https://github.com/prashantgupta24/firewalld-rest)   [![godoc][D]](https://godoc.org/github.com/prashantgupta24/firewalld-rest)
- [BadActor](https://github.com/jaredfolkins/badactor) **star:316** 一个驻留在内存中的，应用驱动的监控程序，受 fail2ban 的启发   [![近三年未更新][Y]](https://github.com/jaredfolkins/badactor)   [![godoc][D]](https://godoc.org/github.com/jaredfolkins/badactor)
- [go-yara](https://github.com/hillu/go-yara) **star:315** YARA的 Go 语言接口，号称是 “对于恶意软件研究者（以及其他人）来说是模式匹配的瑞士军刀”   [![godoc][D]](https://godoc.org/github.com/hillu/go-yara)
- [passlib](https://github.com/hlandau/passlib) **star:284** 不过时的密码哈希库。   [![godoc][D]](https://godoc.org/github.com/hlandau/passlib)
- [simple-scrypt](https://github.com/elithrar/simple-scrypt) **star:189** Scrypt 库，具有简单、易懂的 API，同时具有内置的自动校准功能   [![godoc][D]](https://godoc.org/github.com/elithrar/simple-scrypt)
- [teler-waf](https://github.com/kitabisa/teler-waf) **star:186** teler-waf is a Go HTTP middleware that provide teler IDS functionality to protect against web-based attacks and improve the security of Go-based web applications. It is highly configurable and easy to integrate into existing Go applications.   [![近一周有更新][G]](https://github.com/kitabisa/teler-waf)   [![godoc][D]](https://godoc.org/github.com/kitabisa/teler-waf)
- [argon2pw](https://github.com/raja/argon2pw) **star:90** 使用常量时间密码比较生成Argon2密码散列。   [![godoc][D]](https://godoc.org/github.com/raja/argon2pw)
- [autocert](https://godoc.org/golang.org/x/crypto/acme/autocert)  让我们加密证书并启动TLS服务器。
- [goSecretBoxPassword](https://github.com/dwin/goSecretBoxPassword) **star:55** 一个安全哈希和加密密码的偏执包。   [![godoc][D]](https://godoc.org/github.com/dwin/goSecretBoxPassword)
- [go-generate-password](https://github.com/m1/go-generate-password) **star:50** 可以在cli上或作为库使用的密码生成器。   [![godoc][D]](https://godoc.org/github.com/m1/go-generate-password)
- [certificates](https://github.com/mvmaasakkers/certificates) **star:36** 用于生成tls证书的自定义工具。   [![godoc][D]](https://godoc.org/github.com/mvmaasakkers/certificates)
- [go-htpasswd](https://github.com/tg123/go-htpasswd) **star:31** Apache htpasswd解析器。   [![godoc][D]](https://godoc.org/github.com/tg123/go-htpasswd)
- [secureio](https://github.com/xaionaro-go/secureio) **star:30** 一个密钥交换+认证+加密的包装和多路复用的' io。读写ecloser '基于XChaCha20-poly1305, ECDH和ED25519。   [![近三年未更新][Y]](https://github.com/xaionaro-go/secureio)   [![godoc][D]](https://godoc.org/github.com/xaionaro-go/secureio)
- [secret](https://github.com/rsjethani/secret) **star:23** Prevent your secrets from leaking into logs, std\* etc.   [![godoc][D]](https://godoc.org/github.com/rsjethani/secret)
- [sslmgr](https://github.com/adrianosela/sslmgr) **star:20** 使用围绕acme/autocert的高级包装器，SSL证书变得很容易。   [![godoc][D]](https://godoc.org/github.com/adrianosela/sslmgr)
- [argon2-hashing](https://github.com/andskur/argon2-hashing) **star:19** 轻包装周围的Go的argon2包，它与Go的标准库Bcrypt和simple-scrypt包密切镜像。   [![godoc][D]](https://godoc.org/github.com/andskur/argon2-hashing)
- [goArgonPass](https://github.com/dwin/goArgonPass) **star:16** Argon2密码散列和验证设计为与现有Python和PHP实现兼容。   [![godoc][D]](https://godoc.org/github.com/dwin/goArgonPass)
- [Interpol](https://github.com/avahidi/interpol) **star:2** 基于规则的数据生成器，用于模糊和渗透测试。   [![godoc][D]](https://godoc.org/github.com/avahidi/interpol)

**[⬆ back to top](#contents)**

## 序列化

_用于二进制序列化的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#serialization) 吧~)_

- [jsoniter](https://github.com/json-iterator/go) **star:12586** 高性能，100% 兼容的“encoding/json” 替代品   [![近一周有更新][G]](https://github.com/json-iterator/go)   [![godoc][D]](https://godoc.org/github.com/json-iterator/go)
- [goprotobuf](https://github.com/golang/protobuf) **star:9243** 通过库和协议编译器插件使 Go 语言支持 Google的 protocol buffers.   [![godoc][D]](https://godoc.org/github.com/golang/protobuf)
- [mapstructure](https://github.com/mitchellh/mapstructure) **star:7128** 用于对原生键值对进行解码生成 Go 语言结构体   [![godoc][D]](https://godoc.org/github.com/mitchellh/mapstructure)
- [gogoprotobuf](https://github.com/gogo/protobuf) **star:5589** Go 语言的 Protocol Buffer 库。   [![godoc][D]](https://godoc.org/github.com/gogo/protobuf)
- [go-codec](https://github.com/ugorji/go) **star:1768** 高性能、多功能、规范化编码解码以及 rpc 库， 用于 msgpack, cbor 和 json，支持基于运行时的 OR 码生成   [![godoc][D]](https://godoc.org/github.com/ugorji/go)
- [csvutil](https://github.com/jszwec/csvutil) **star:827** 高性能、惯用的CSV记录编码和解码到本机Go结构。   [![近一周有更新][G]](https://github.com/jszwec/csvutil)   [![godoc][D]](https://godoc.org/github.com/jszwec/csvutil)
- [colfer](https://github.com/pascaldekloe/colfer) **star:717** 为Colfer二进制格式生成代码。
- [cbor](https://github.com/fxamacker/cbor) **star:601** 小，安全，容易的CBOR编码和解码库。   [![近一周有更新][G]](https://github.com/fxamacker/cbor)   [![godoc][D]](https://godoc.org/github.com/fxamacker/cbor)
- [go-capnproto](https://github.com/glycerine/go-capnproto) **star:288** Go 语言用的 Cap'n Proto 库及解析器   [![近三年未更新][Y]](https://github.com/glycerine/go-capnproto)   [![godoc][D]](https://godoc.org/github.com/glycerine/go-capnproto)
- [php_session_decoder](https://github.com/yvasiyarov/php_session_decoder) **star:159** 用于协同 PHP session 格式数据和 PHP 序列化／反序列化函数工作的go语言库   [![近三年未更新][Y]](https://github.com/yvasiyarov/php_session_decoder)   [![godoc][D]](https://godoc.org/github.com/yvasiyarov/php_session_decoder)
- [structomap](https://github.com/tuvistavie/structomap) **star:140** 用于从静态结构体简单、动态的生成键值对的库   [![近三年未更新][Y]](https://github.com/tuvistavie/structomap)   [![godoc][D]](https://godoc.org/github.com/tuvistavie/structomap)
- [binstruct](https://github.com/ghostiam/binstruct) **star:75** 用于将数据映射到结构中的Golang二进制解码器。   [![godoc][D]](https://godoc.org/github.com/ghostiam/binstruct)
- [bambam](https://github.com/glycerine/bambam) **star:67** 用于 Go 语言生成 Cap'n Proto schemas 的生成器   [![近三年未更新][Y]](https://github.com/glycerine/bambam)   [![godoc][D]](https://godoc.org/github.com/glycerine/bambam)
- [asn1](https://github.com/PromonLogicalis/asn1) **star:53** 面向golang的BER和DER编码库。   [![近三年未更新][Y]](https://github.com/PromonLogicalis/asn1)   [![godoc][D]](https://godoc.org/github.com/PromonLogicalis/asn1)   [![归档项目][Archived]](https://github.com/PromonLogicalis/asn1)
- [bel](https://github.com/32leaves/bel) **star:35** 从Go structs/interface生成TypeScript接口。对JSON RPC很有用。   [![godoc][D]](https://godoc.org/github.com/32leaves/bel)
- [fwencoder](https://github.com/o1egl/fwencoder) **star:26** 用于Go的固定宽度文件解析器(编码和解码库)。   [![godoc][D]](https://godoc.org/github.com/o1egl/fwencoder)
- [elastic](https://github.com/epiclabs-io/elastic) **star:24** 在运行时跨不同类型转换片、映射或任何其他未知值   [![godoc][D]](https://godoc.org/github.com/epiclabs-io/elastic)
- [pletter](https://github.com/vimeda/pletter) **star:19** A standard way to wrap a proto message for message brokers.   [![近一周有更新][G]](https://github.com/vimeda/pletter)   [![godoc][D]](https://godoc.org/github.com/vimeda/pletter)
- [fixedwidth](https://github.com/huydang284/fixedwidth) **star:8** 固定宽度的文本格式(支持UTF-8)。   [![近三年未更新][Y]](https://github.com/huydang284/fixedwidth)   [![godoc][D]](https://godoc.org/github.com/huydang284/fixedwidth)
- [unitpacking](https://github.com/recolude/unitpacking) **star:6** 标准库将单元向量打包到尽可能少的字节中。   [![godoc][D]](https://godoc.org/github.com/recolude/unitpacking)
- [go-lctree](https://github.com/sbourlon/go-lctree) **star:4** 提供一个CLI和原语来序列化和反序列化[LeetCode二进制树](https://support.leetcode.com/hc/en-us/articles/360011883654-what-does -1-null-2-3-mean-in-二进制树表示)。   [![近三年未更新][Y]](https://github.com/sbourlon/go-lctree)   [![godoc][D]](https://godoc.org/github.com/sbourlon/go-lctree)

**[⬆ back to top](#contents)**

## 服务器应用程序

- [Caddy](https://github.com/caddyserver/caddy) **star:49702** Caddy是另一种HTTP/2 web服务器，易于配置和使用。   [![近一周有更新][G]](https://github.com/caddyserver/caddy)   [![godoc][D]](https://godoc.org/github.com/caddyserver/caddy)
- [consul](https://www.consul.io/)  Consul 是一个用于服务发现、监控和配置的工具
- [etcd](https://github.com/coreos/etcd) **star:44475** 为共享配置和服务发现提供高可用的键值存储。   [![近一周有更新][G]](https://github.com/coreos/etcd)   [![godoc][D]](https://godoc.org/github.com/coreos/etcd)
- [minio](https://github.com/minio/minio) **star:40795** Minio是一个分布式对象存储服务器。   [![近一周有更新][G]](https://github.com/minio/minio)   [![godoc][D]](https://godoc.org/github.com/minio/minio)
- [RoadRunner](https://github.com/spiral/roadrunner) **star:7362** 高性能PHP应用服务器，负载平衡器和进程管理器。   [![近一周有更新][G]](https://github.com/spiral/roadrunner)   [![godoc][D]](https://godoc.org/github.com/spiral/roadrunner)
- [SFTPGo](https://github.com/drakkan/sftpgo) **star:6748** 完全功能和高度可配置的SFTP服务器与可选的FTP/S和WebDAV支持。它可以为本地文件系统和云存储后端(如S3和谷歌云存储)提供服务。   [![近一周有更新][G]](https://github.com/drakkan/sftpgo)   [![godoc][D]](https://godoc.org/github.com/drakkan/sftpgo)
- [Easegress](https://github.com/megaease/easegress) **star:5549** 具有可观察性和可扩展性的云本地高可用性/性能流量编排系统。   [![近一周有更新][G]](https://github.com/megaease/easegress)   [![godoc][D]](https://godoc.org/github.com/megaease/easegress)
- [devd](https://github.com/cortesi/devd) **star:3350** 为开发人员提供本地web服务器。   [![godoc][D]](https://godoc.org/github.com/cortesi/devd)
- [flipt](https://github.com/markphelps/flipt) **star:2801** 一个用Go和Vue.js编写的自包含特性标志解决方案   [![近一周有更新][G]](https://github.com/markphelps/flipt)   [![godoc][D]](https://godoc.org/github.com/markphelps/flipt)
- [Fider](https://github.com/getfider/fider) **star:2396** Fider是一个收集和组织客户反馈的开放平台。   [![godoc][D]](https://godoc.org/github.com/getfider/fider)
- [algernon](https://github.com/xyproto/algernon) **star:2292** 内置支持Lua、Markdown、GCSS和Amber的HTTP/2 web服务器。   [![近一周有更新][G]](https://github.com/xyproto/algernon)   [![godoc][D]](https://godoc.org/github.com/xyproto/algernon)
- [Wish](https://github.com/charmbracelet/wish) **star:2276** 制作SSH应用程序，就像这样!   [![近一周有更新][G]](https://github.com/charmbracelet/wish)   [![godoc][D]](https://godoc.org/github.com/charmbracelet/wish)
- [Flagr](https://github.com/checkr/flagr) **star:2229** Flagr是一个开源特性标记和A/B测试服务。   [![godoc][D]](https://godoc.org/github.com/checkr/flagr)
- [Trickster](https://github.com/tricksterproxy/trickster) **star:1906** HTTP反向代理缓存和时间序列加速器。   [![godoc][D]](https://godoc.org/github.com/tricksterproxy/trickster)
- [discovery](https://github.com/Bilibili/discovery) **star:1758** 用于弹性中间层负载平衡和故障转移的注册表。   [![godoc][D]](https://godoc.org/github.com/Bilibili/discovery)
- [jackal](https://github.com/ortuman/jackal) **star:1425** 用Go编写的XMPP服务器。   [![godoc][D]](https://godoc.org/github.com/ortuman/jackal)
- [go-feature-flag](https://github.com/thomaspoignant/go-feature-flag) **star:813** 一个特性标志解决方案，在后端只有一个YAML文件(S3、GitHub、HTTP、本地文件……)，不需要安装服务器，只需要在中央系统中添加一个文件并引用它。   [![近一周有更新][G]](https://github.com/thomaspoignant/go-feature-flag)   [![godoc][D]](https://godoc.org/github.com/thomaspoignant/go-feature-flag)
- [Euterpe](https://github.com/ironsmile/euterpe) **star:496** 自带web UI和REST API的自托管音乐流媒体服务器。   [![godoc][D]](https://godoc.org/github.com/ironsmile/euterpe)
- [dummy](https://github.com/neotoolkit/dummy) **star:176** 用一个命令运行基于API契约的模拟服务器。   [![godoc][D]](https://godoc.org/github.com/neotoolkit/dummy)   [![归档项目][Archived]](https://github.com/neotoolkit/dummy)
- [dudeldu](https://github.com/krotik/dudeldu) **star:141** 一个简单的SHOUTcast服务器。   [![近三年未更新][Y]](https://github.com/krotik/dudeldu)   [![godoc][D]](https://godoc.org/github.com/krotik/dudeldu)
- [go-proxy-cache](https://github.com/fabiocicerchia/go-proxy-cache) **star:98** 简单的反向代理与缓存，写在Go，使用Redis。   [![godoc][D]](https://godoc.org/github.com/fabiocicerchia/go-proxy-cache)
- [lets-proxy2](https://github.com/rekby/lets-proxy2) **star:81** Reverse proxy for handle https with issue certificates in fly from lets-encrypt.   [![近一周有更新][G]](https://github.com/rekby/lets-proxy2)   [![godoc][D]](https://godoc.org/github.com/rekby/lets-proxy2)
- [cortex-tenant](https://github.com/blind-oracle/cortex-tenant) **star:74** Prometheus远程写代理，添加了基于度量标签的add Cortex租户ID头。   [![godoc][D]](https://godoc.org/github.com/blind-oracle/cortex-tenant)
- [psql-streamer](https://github.com/blind-oracle/psql-streamer) **star:52** 从PostgreSQL到Kafka的流数据库事件。   [![近三年未更新][Y]](https://github.com/blind-oracle/psql-streamer)   [![godoc][D]](https://godoc.org/github.com/blind-oracle/psql-streamer)
- [nginx-prometheus](https://github.com/blind-oracle/nginx-prometheus) **star:37** Nginx日志解析器和Prometheus 导出。   [![近三年未更新][Y]](https://github.com/blind-oracle/nginx-prometheus)   [![godoc][D]](https://godoc.org/github.com/blind-oracle/nginx-prometheus)
- [nsq](https://nsq.io/)  一个实时分布式消息平台。
- [simple-jwt-provider](https://github.com/leberKleber/simple-jwt-provider) **star:34** 展示JWTs的简单轻量级提供者，支持登录、密码重置(通过邮件)和用户管理。   [![godoc][D]](https://godoc.org/github.com/leberKleber/simple-jwt-provider)
- [protoxy](https://github.com/camgraff/protoxy) **star:31** 将JSON请求体转换为协议缓冲区的代理服务器。   [![godoc][D]](https://godoc.org/github.com/camgraff/protoxy)
- [Moxy](https://github.com/sinhashubham95/moxy) **star:10** Moxy是一个简单的模拟和代理应用程序服务器，您可以创建模拟端点以及代理请求，以防端点不存在模拟。   [![godoc][D]](https://godoc.org/github.com/sinhashubham95/moxy)
- [riemann-relay](https://github.com/blind-oracle/riemann-relay) **star:2** 传递到负载平衡Riemann事件并/或将其转换为 Carbon。   [![近三年未更新][Y]](https://github.com/blind-oracle/riemann-relay)   [![godoc][D]](https://godoc.org/github.com/blind-oracle/riemann-relay)

**[⬆ back to top](#contents)**

## 流处理

_用于流处理和响应式编程的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#stream-processing) 吧~)_

- [go-streams](https://github.com/reugn/go-streams) **star:1542** 流处理库。   [![godoc][D]](https://godoc.org/github.com/reugn/go-streams)
- [machine](https://github.com/whitaker-io/machine) **star:134** 使用内置的度量和可跟踪性来编写和生成流工作人员。   [![godoc][D]](https://godoc.org/github.com/whitaker-io/machine)
- [stream](https://github.com/youthlin/stream) **star:83** 去流，像Java 8流:过滤器/地图/平面地图/Peek/排序/ForEach/减少…   [![godoc][D]](https://godoc.org/github.com/youthlin/stream)
- [goio](https://github.com/primetalk/goio) **star:71** An implementation of IO, Stream, Fiber for Golang, inspired by awesome Scala libraries cats and fs2.   [![godoc][D]](https://godoc.org/github.com/primetalk/goio)

**[⬆ back to top](#contents)**

## 模板引擎

_用于模板和词法分析的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#template-engines) 吧~)_

- [sprig](https://github.com/Masterminds/sprig) **star:3736** Go模板的有用模板函数。   [![godoc][D]](https://godoc.org/github.com/Masterminds/sprig)
- [quicktemplate](https://github.com/valyala/quicktemplate) **star:2859** 快速、强大且易用的模板引擎。将模板转化为 Go 语言并进行编译   [![godoc][D]](https://godoc.org/github.com/valyala/quicktemplate)
- [pongo2](https://github.com/flosch/pongo2) **star:2643** 类似 DjanGo 的模板引擎   [![godoc][D]](https://godoc.org/github.com/flosch/pongo2)
- [maroto](https://github.com/johnfercher/maroto) **star:1081** 创建pdf文件的maroto方法。Maroto的灵感来自于Bootstrap并使用gofpdf。快速和简单。   [![近一周有更新][G]](https://github.com/johnfercher/maroto)   [![godoc][D]](https://godoc.org/github.com/johnfercher/maroto)
- [jet](https://github.com/CloudyKit/jet) **star:1079** Jet模板引擎。   [![godoc][D]](https://godoc.org/github.com/CloudyKit/jet)
- [Razor](https://github.com/sipin/gorazor) **star:828** Go 语言的 Razor 视图引擎   [![近一周有更新][G]](https://github.com/sipin/gorazor)   [![godoc][D]](https://godoc.org/github.com/sipin/gorazor)
- [fasttemplate](https://github.com/valyala/fasttemplate) **star:768** 简单和快速的模板引擎。替换模板占位符的速度比[text/template](https://golang.org/pkg/text/template/)快10倍。   [![godoc][D]](https://godoc.org/github.com/valyala/fasttemplate)
- [ego](https://github.com/benbjohnson/ego) **star:563** 轻量级模板语言，允许您在Go中编写模板。模板被翻译成Go并编译。   [![godoc][D]](https://godoc.org/github.com/benbjohnson/ego)
- [raymond](https://github.com/aymerick/raymond) **star:550** 使用 Go 语言实现的完整的 handlebars   [![godoc][D]](https://godoc.org/github.com/aymerick/raymond)
- [goview](https://github.com/foolin/goview) **star:370** Goview是一个轻量级、极简的模板库，基于golang html/template构建Go web应用程序。   [![godoc][D]](https://godoc.org/github.com/foolin/goview)
- [liquid](https://github.com/osteele/liquid) **star:232** Go 语言实现的 Shopify Liquid 模板.   [![godoc][D]](https://godoc.org/github.com/osteele/liquid)
- [Soy](https://github.com/robfig/soy) **star:170** Go 语言实现的谷歌闭包模板(也就是 Soy templates) ,遵循[官方规范](https://developer.google.com/closure/templates/)。   [![godoc][D]](https://godoc.org/github.com/robfig/soy)
- [extemplate](https://github.com/dannyvankooten/extemplate) **star:53**  对 html/template 进行了简单的封装，支持基于文件的模板可以利用其他模板文件进行扩展   [![godoc][D]](https://godoc.org/github.com/dannyvankooten/extemplate)   [![归档项目][Archived]](https://github.com/dannyvankooten/extemplate)
- [gospin](https://github.com/m1/gospin) **star:46** 文章纺纱和spintax/纺纱语法引擎，适用于A/B，测试文本/文章片段和创建更多的自然对话。   [![godoc][D]](https://godoc.org/github.com/m1/gospin)
- [tbd](https://github.com/lucasepe/tbd) **star:25** 用占位符创建文本模板的一种非常简单的方法——暴露额外的Git repo元数据。   [![godoc][D]](https://godoc.org/github.com/lucasepe/tbd)
- [got](https://github.com/goradd/got) **star:15** 一个受Hero和Fasttemplate启发的Go代码生成器。包括文件，自定义标签定义，注入的Go代码，语言翻译，等等。   [![godoc][D]](https://godoc.org/github.com/goradd/got)

**[⬆ back to top](#contents)**

## 测试

_用于测试代码库和生成测试数据的库。 (翻译出错了? 试试 [英文版](README_EN.md#testing) 吧~)_

- Testing Frameworks

  - [Testify](https://github.com/stretchr/testify) **star:20574** 对标准测试包的扩展。   [![近一周有更新][G]](https://github.com/stretchr/testify)   [![godoc][D]](https://godoc.org/github.com/stretchr/testify)
  - [testmd](https://godoc.org/github.com/tvastar/test/cmd/testmd)  将markdown代码段转换为可测试的go代码。
  - [go-cmp](https://github.com/google/go-cmp) **star:3687** 用于比较测试中的Go值的包。   [![godoc][D]](https://godoc.org/github.com/google/go-cmp)
  - [testcontainers-go](https://github.com/testcontainers/testcontainers-go) **star:2419** A Go package that makes it simple to create and clean up container-based dependencies for automated integration/smoke tests. The clean, easy-to-use API enables developers to programmatically define containers that should be run as part of a test and clean up those resources when the test is done.   [![近一周有更新][G]](https://github.com/testcontainers/testcontainers-go)   [![godoc][D]](https://godoc.org/github.com/testcontainers/testcontainers-go)
  - [httpexpect](https://github.com/gavv/httpexpect) **star:2305** 简洁的、声明式的、易用的端到端HTTP 及 REST API 测试   [![godoc][D]](https://godoc.org/github.com/gavv/httpexpect)
  - [godog](https://github.com/cucumber/godog) **star:2035** Cucumber BDD framework for Go.   [![近一周有更新][G]](https://github.com/cucumber/godog)   [![godoc][D]](https://godoc.org/github.com/cucumber/godog)
  - [is](https://github.com/matryer/is) **star:1634** 专业的Go轻量级测试迷你框架。   [![godoc][D]](https://godoc.org/github.com/matryer/is)
  - [gnomock](https://github.com/orlangure/gnomock) **star:1230** 在Docker中运行与真实依赖项(数据库、缓存，甚至是Kubernetes或AWS)的集成测试，而不使用模拟。   [![godoc][D]](https://godoc.org/github.com/orlangure/gnomock)
  - [go-vcr](https://github.com/dnaeon/go-vcr) **star:1038** 记录并回放HTTP交互，以便进行快速、确定和准确的测试。   [![godoc][D]](https://godoc.org/github.com/dnaeon/go-vcr)
  - [testfixtures](https://github.com/go-testfixtures/testfixtures) **star:981** 类似 Rails 的测试工具，用于测试数据库应用   [![godoc][D]](https://godoc.org/github.com/go-testfixtures/testfixtures)
  - [goblin](https://github.com/franela/goblin) **star:890** 类似Mocha的测试框架。   [![godoc][D]](https://godoc.org/github.com/franela/goblin)
  - [baloo](https://github.com/h2non/baloo) **star:763** 表达性强、多功能的、端到端的HTTP API 测试工具   [![godoc][D]](https://godoc.org/github.com/h2non/baloo)
  - [goc](https://github.com/qiniu/goc) **star:715** Goc是一个针对Go编程语言的全面覆盖测试系统。   [![godoc][D]](https://godoc.org/github.com/qiniu/goc)
  - [gocheck](https://labix.org/gocheck)  更加高级的测试框架，用于替换 Gotest
  - [GoConvey](https://github.com/smartystreets/goconvey/)  BDD 风格的测试框架，具有 web 界面和计时刷新功能
  - [embedded-postgres](https://github.com/fergusstrange/embedded-postgres) **star:638** 作为另一个Go应用程序或测试的一部分，在Linux、OSX或Windows上本地运行一个真正的Postgres数据库。   [![近一周有更新][G]](https://github.com/fergusstrange/embedded-postgres)   [![godoc][D]](https://godoc.org/github.com/fergusstrange/embedded-postgres)
  - [go-mutesting](https://github.com/zimmski/go-mutesting) **star:604** 变异测试的Go源代码。   [![godoc][D]](https://godoc.org/github.com/zimmski/go-mutesting)
  - [gotest.tools](https://github.com/gotestyourself/gotest.tools) **star:458** 一组包，用于增强go测试包并支持公共模式。   [![godoc][D]](https://godoc.org/github.com/gotestyourself/gotest.tools)
  - [gofight](https://github.com/appleboy/gofight) **star:436** 对 Go 语言的路由框架进行 API 测试   [![godoc][D]](https://godoc.org/github.com/appleboy/gofight)
  - [testza](https://github.com/MarvinJWendt/testza) **star:415** 功能齐全的测试框架，带有漂亮的彩色输出。   [![godoc][D]](https://godoc.org/github.com/MarvinJWendt/testza)
  - [go-testdeep](https://github.com/maxatome/go-testdeep) **star:397** 极具灵活性的golang深度比较，扩展了go测试包。   [![godoc][D]](https://godoc.org/github.com/maxatome/go-testdeep)
  - [cupaloy](https://github.com/bradleyjkemp/cupaloy) **star:277** 测试框架的简单快照测试插件。   [![godoc][D]](https://godoc.org/github.com/bradleyjkemp/cupaloy)
  - [frisby](https://github.com/verdverm/frisby) **star:275** REST API测试框架。   [![近三年未更新][Y]](https://github.com/verdverm/frisby)   [![godoc][D]](https://godoc.org/github.com/verdverm/frisby)
  - [got](https://github.com/ysmood/got) **star:261** 一个有趣的golang测试框架。   [![近一周有更新][G]](https://github.com/ysmood/got)   [![godoc][D]](https://godoc.org/github.com/ysmood/got)
  - [endly](https://github.com/viant/endly) **star:244** 声明性端到端功能测试。   [![godoc][D]](https://godoc.org/github.com/viant/endly)
  - [go-carpet](https://github.com/msoap/go-carpet) **star:239** 在终端中查看测试覆盖率的工具。   [![godoc][D]](https://godoc.org/github.com/msoap/go-carpet)
  - [go-hit](https://github.com/Eun/go-hit) **star:236** Hit是一个用golang编写的http集成测试框架。   [![godoc][D]](https://godoc.org/github.com/Eun/go-hit)
  - [commander](https://github.com/SimonBaeumer/commander) **star:213** 用于在windows、linux和osx上测试cli应用程序的工具。   [![godoc][D]](https://godoc.org/github.com/SimonBaeumer/commander)
  - [charlatan](https://github.com/percolate/charlatan) **star:198** 为测试生成假接口实现的工具。   [![godoc][D]](https://godoc.org/github.com/percolate/charlatan)
  - [dbcleaner](https://github.com/khaiql/dbcleaner) **star:157** 清空数据库用于测试，受到database_cleaner 的启发   [![godoc][D]](https://godoc.org/github.com/khaiql/dbcleaner)
  - [jsonassert](https://github.com/kinbiko/jsonassert) **star:114** 用于验证JSON有效负载已正确序列化的包。   [![godoc][D]](https://godoc.org/github.com/kinbiko/jsonassert)
  - [GoSpec](https://github.com/orfjackal/gospec) **star:113** 用于 Go 编程语言的bdd风格的测试框架。   [![近三年未更新][Y]](https://github.com/orfjackal/gospec)   [![godoc][D]](https://godoc.org/github.com/orfjackal/gospec)
  - [testcase](https://github.com/adamluzsi/testcase) **star:113** 行为驱动开发的惯用测试框架。   [![godoc][D]](https://godoc.org/github.com/adamluzsi/testcase)
  - [wstest](https://github.com/posener/wstest) **star:100** 用于单元测试Websocket http.Handler的Websocket客户机。   [![godoc][D]](https://godoc.org/github.com/posener/wstest)
  - [gocrest](https://github.com/corbym/gocrest) **star:95** 用于 Go 断言的可组合的类似 hamcrest 的 matchers。   [![godoc][D]](https://godoc.org/github.com/corbym/gocrest)
  - [be](https://github.com/carlmjohnson/be) **star:76** The minimalist generic test assertion library.   [![近一周有更新][G]](https://github.com/carlmjohnson/be)   [![godoc][D]](https://godoc.org/github.com/carlmjohnson/be)
  - [gherkingen](https://github.com/hedhyw/gherkingen) **star:60** BDD样板生成器和框架。   [![godoc][D]](https://godoc.org/github.com/hedhyw/gherkingen)
  - [ginkgo](https://onsi.github.io/ginkgo/)  Go的BDD测试框架。
  - [Gont](https://github.com/stv0g/gont) **star:60** Go network testing toolkit for testing building complex network topologies using Linux namespaces.   [![近一周有更新][G]](https://github.com/stv0g/gont)   [![godoc][D]](https://godoc.org/github.com/stv0g/gont)
  - [assert](https://github.com/go-playground/assert) **star:59** 基础断言库，用于对 Go 语言程序进行测试，提供了一些用于自定义断言的代码块   [![godoc][D]](https://godoc.org/github.com/go-playground/assert)
  - [covergates](https://github.com/covergates/covergates) **star:58** 自托管的代码覆盖报告审查和管理服务。   [![godoc][D]](https://godoc.org/github.com/covergates/covergates)
  - [restit](https://github.com/yookoala/restit) **star:56** 帮助编写 RESTful API 集成测试的 Go 语言微型框架.。   [![近三年未更新][Y]](https://github.com/yookoala/restit)   [![godoc][D]](https://godoc.org/github.com/yookoala/restit)
  - [gospecify](https://github.com/stesla/gospecify) **star:53** 支持 BDD 语法 。对于任何使用过 rspec 等库的人来说应该非常熟悉。   [![近三年未更新][Y]](https://github.com/stesla/gospecify)   [![godoc][D]](https://godoc.org/github.com/stesla/gospecify)
  - [gomatch](https://github.com/jfilipczyk/gomatch) **star:45** 为针对模式测试JSON而创建的库。   [![godoc][D]](https://godoc.org/github.com/jfilipczyk/gomatch)
  - [gomega](https://onsi.github.io/gomega/)  类似 Rspec 的 matcher/assertion 库
  - [dsunit](https://github.com/viant/dsunit) **star:43** 用于SQL、NoSQL、结构化文件的数据存储测试。   [![godoc][D]](https://godoc.org/github.com/viant/dsunit)
  - [fluentassert](https://github.com/fluentassert/verify) **star:35** Extensible, type-safe, fluent assertion Go library.   [![godoc][D]](https://godoc.org/github.com/fluentassert/verify)
  - [Hamcrest](https://github.com/rdrdr/hamcrest) **star:28** 用于声明性 Matcher 对象的连贯框架，当将其应用于输入值时，将产生自描述结果。   [![godoc][D]](https://godoc.org/github.com/rdrdr/hamcrest)
  - [apitest](https://apitest.dev)  基于REST的服务/HTTP处理程序的简单且可扩展的行为测试库,支持模拟外部HTTP调用和呈现序列图
  - [schema](https://github.com/jgroeneveld/schema) **star:20** 快速、简单地匹配请求和响应中使用的JSON模式的表达式。   [![近三年未更新][Y]](https://github.com/jgroeneveld/schema)   [![godoc][D]](https://godoc.org/github.com/jgroeneveld/schema)
  - [fixenv](https://github.com/rekby/fixenv) **star:19** 夹具管理引擎，灵感来自pytest夹具。   [![godoc][D]](https://godoc.org/github.com/rekby/fixenv)
  - [flute](https://github.com/suzuki-shunsuke/flute) **star:17** HTTP客户端测试框架。   [![godoc][D]](https://godoc.org/github.com/suzuki-shunsuke/flute)
  - [testsql](https://github.com/zhulongcheng/testsql) **star:16** 在测试前从SQL文件生成测试数据，并在测试完成后清除数据。   [![近三年未更新][Y]](https://github.com/zhulongcheng/testsql)   [![godoc][D]](https://godoc.org/github.com/zhulongcheng/testsql)
  - [gogiven](https://github.com/corbym/gogiven) **star:14** 类似于 YATSPEC 的Go BDD测试框架。   [![godoc][D]](https://godoc.org/github.com/corbym/gogiven)
  - [biff](https://github.com/fulldump/biff) **star:12** 分支测试框架，BDD兼容。   [![godoc][D]](https://godoc.org/github.com/fulldump/biff)
  - [gosuite](https://github.com/pavlo/gosuite) **star:12** 轻量级测试套，为 Go1.7's Subtests 带来了setup/teardown 功能   [![近三年未更新][Y]](https://github.com/pavlo/gosuite)   [![godoc][D]](https://godoc.org/github.com/pavlo/gosuite)
  - [badio](https://github.com/cavaliercoder/badio) **star:10** Go 语言 testing/iotest 包的扩展。   [![近三年未更新][Y]](https://github.com/cavaliercoder/badio)   [![godoc][D]](https://godoc.org/github.com/cavaliercoder/badio)
  - [stop-and-go](https://github.com/elgohr/stop-and-go) **star:9** 并发性测试助手。   [![近一周有更新][G]](https://github.com/elgohr/stop-and-go)   [![godoc][D]](https://godoc.org/github.com/elgohr/stop-and-go)
  - [trial](https://github.com/jgroeneveld/trial) **star:6** 无需引入太多样板，即可快速轻松地扩展断言。   [![godoc][D]](https://godoc.org/github.com/jgroeneveld/trial)
  - [Tt](https://github.com/vcaesar/tt) **star:6** 简单而丰富多彩的测试工具。   [![godoc][D]](https://godoc.org/github.com/vcaesar/tt)
  - [go-testpredicate](https://github.com/maargenton/go-testpredicate) **star:5** 测试带有大量诊断输出的断言样式断言库。   [![godoc][D]](https://godoc.org/github.com/maargenton/go-testpredicate)
  - [go-mysql-test-container](https://github.com/arikama/go-mysql-test-container) **star:2** Golang MySQL testcontainer to help with MySQL integration testing.   [![godoc][D]](https://godoc.org/github.com/arikama/go-mysql-test-container)
  - [go-snaps](http://github.com/gkampitakis/go-snaps)  Jest-like snapshot testing in Golang.
  - [omg.testingtools](https://github.com/dedalqq/omg.testingtools) **star:1** 用于更改用于测试的私有字段值的简单库。   [![godoc][D]](https://godoc.org/github.com/dedalqq/omg.testingtools)

- Mock

  - [gomock](https://github.com/golang/mock) **star:9089** 用于Go编程语言的mock框架。   [![godoc][D]](https://godoc.org/github.com/golang/mock)   [![归档项目][Archived]](https://github.com/golang/mock)
  - [go-sqlmock](https://github.com/DATA-DOG/go-sqlmock) **star:5473** Mock SQL ，用于测试数据库交互   [![godoc][D]](https://godoc.org/github.com/DATA-DOG/go-sqlmock)
  - [mockery](https://github.com/vektra/mockery) **star:4988** 生成Go界面的工具。   [![godoc][D]](https://godoc.org/github.com/vektra/mockery)
  - [hoverfly](https://github.com/SpectoLabs/hoverfly) **star:2237** 使用可扩展中间件和易于使用的CLI记录和模拟REST/SOAP api的HTTP(S)代理。   [![近一周有更新][G]](https://github.com/SpectoLabs/hoverfly)   [![godoc][D]](https://godoc.org/github.com/SpectoLabs/hoverfly)
  - [gock](https://github.com/h2non/gock) **star:1921** 多功能、易用 HTTP mock   [![godoc][D]](https://godoc.org/github.com/h2non/gock)
  - [httpmock](https://github.com/jarcoal/httpmock) **star:1742** 轻松模拟来自外部资源的HTTP响应。   [![godoc][D]](https://godoc.org/github.com/jarcoal/httpmock)
  - [counterfeiter](https://github.com/maxbrunsfeld/counterfeiter) **star:862** 用于生成自包含 mock 对象的工具   [![godoc][D]](https://godoc.org/github.com/maxbrunsfeld/counterfeiter)
  - [genmock](https://gitlab.com/so_literate/genmock)  使用代码生成器构建接口方法的调用来模拟系统。
  - [go-txdb](https://github.com/DATA-DOG/go-txdb) **star:571** 基于单事务的数据库驱动，主要用于测试目的   [![godoc][D]](https://godoc.org/github.com/DATA-DOG/go-txdb)
  - [minimock](https://github.com/gojuno/minimock) **star:509** Go接口的模拟生成器。   [![godoc][D]](https://godoc.org/github.com/gojuno/minimock)
  - [govcr](https://github.com/seborama/govcr) **star:157** HTTP mock : 离线测试时记录和重放浏览器的动作   [![godoc][D]](https://godoc.org/github.com/seborama/govcr)
  - [go-localstack](https://github.com/elgohr/go-localstack) **star:72** 用于在AWS测试中使用localstack的工具。   [![近一周有更新][G]](https://github.com/elgohr/go-localstack)   [![godoc][D]](https://godoc.org/github.com/elgohr/go-localstack)
  - [timex](https://github.com/cabify/timex) **star:70** 一个测试友好的本地“时间”包的替代品。   [![近三年未更新][Y]](https://github.com/cabify/timex)   [![godoc][D]](https://godoc.org/github.com/cabify/timex)
  - [mockhttp](https://github.com/tv42/mockhttp) **star:22** Go http.ResponseWriter的模拟对象。   [![近三年未更新][Y]](https://github.com/tv42/mockhttp)   [![godoc][D]](https://godoc.org/github.com/tv42/mockhttp)
  - [mooncake](https://github.com/GuilhermeCaruso/mooncake) **star:17** A simple way to generate mocks for multiple purposes   [![godoc][D]](https://godoc.org/github.com/GuilhermeCaruso/mooncake)
  - [mockit](https://github.com/pasdam/mockit) **star:16** 允许函数和方法容易被模拟，而不需要定义新的类型;它类似于Java的Mockito。   [![godoc][D]](https://godoc.org/github.com/pasdam/mockit)   [![归档项目][Archived]](https://github.com/pasdam/mockit)
  - [monkey](https://github.com/awterman/monkey) **star:1** One line to mock functions/methods/variables in place without dependency injection or code generation.   [![godoc][D]](https://godoc.org/github.com/awterman/monkey)

- Fuzzing and delta-debugging/reducing/shrinking.

  - [go-fuzz](https://github.com/dvyukov/go-fuzz) **star:4650** 随机测试系统。   [![godoc][D]](https://godoc.org/github.com/dvyukov/go-fuzz)
  - [gofuzz](https://github.com/google/gofuzz) **star:1454** 用于生成随机值来初始化 Go 语言对象的库   [![godoc][D]](https://godoc.org/github.com/google/gofuzz)
  - [Tavor](https://github.com/zimmski/tavor) **star:242** 通用模糊测试框架   [![近三年未更新][Y]](https://github.com/zimmski/tavor)   [![godoc][D]](https://godoc.org/github.com/zimmski/tavor)

- Selenium and browser control tools.

  - [chromedp](https://github.com/knq/chromedp) **star:9537** 用于驱动和测试 Chrome, Safari, Edge, Android Webviews, 以及其他支持 Chrome 调试协议的产品   [![godoc][D]](https://godoc.org/github.com/knq/chromedp)
  - [rod](https://github.com/go-rod/rod) **star:4138** 一个Devtools驱动程序，使web自动化和抓取更加容易。   [![godoc][D]](https://godoc.org/github.com/go-rod/rod)
  - [selenoid](https://github.com/aerokube/selenoid) **star:2408** Selenium hub 服务器的替代品，在容器中启动浏览器   [![godoc][D]](https://godoc.org/github.com/aerokube/selenoid)
  - [playwright-go](https://github.com/mxschmitt/playwright-go) **star:1443** 浏览器自动化库控制铬，Firefox和WebKit与一个单一的API。
  - [cdp](https://github.com/mafredri/cdp) **star:686** 用于Chrome调试协议的类型安全绑定，可与实现该协议的浏览器或其他调试目标一起使用。   [![godoc][D]](https://godoc.org/github.com/mafredri/cdp)
  - [ggr](https://github.com/aerokube/ggr) **star:302** 一个轻量级服务器，可以将 Selenium Wedriver 的请求路由或代理到多个 Selenium hubs   [![godoc][D]](https://godoc.org/github.com/aerokube/ggr)

- Fail injection
  - [failpoint](https://github.com/pingcap/failpoint) **star:782** Golang的[故障点](https://www.freebsd.org/cgi/man.cgi?query=fail)实现。   [![godoc][D]](https://godoc.org/github.com/pingcap/failpoint)

**[⬆ back to top](#contents)**

## 文本处理

_用于解析和操作文本的库。 (翻译出错了? 试试 [英文版](README_EN.md#text-processing) 吧~)_

See also [Natural Language Processing](#natural-language-processing) and [Text Analysis](#text-analysis).

### 格式器

- [go-humanize](https://github.com/dustin/go-humanize) **star:3750** 格式化程序，用于将时间、数字和内存大小转换为可读格式。   [![godoc][D]](https://godoc.org/github.com/dustin/go-humanize)
- [gotabulate](https://github.com/bndr/gotabulate) **star:302** 使用 Go 语言简单、美观的打印表格数据   [![godoc][D]](https://godoc.org/github.com/bndr/gotabulate)
- [align](https://github.com/Guitarbum722/align) **star:81** 对文本进行对齐的通用应用程序。   [![godoc][D]](https://godoc.org/github.com/Guitarbum722/align)
- [bytes](https://github.com/labstack/gommon/tree/master/bytes)  格式和解析数字字节值(10K、2M、3G等)。
- [go-fixedwidth](https://github.com/ianlopshire/go-fixedwidth) **star:77** 固定宽度的文本格式(带反射的编码器/解码器)。   [![godoc][D]](https://godoc.org/github.com/ianlopshire/go-fixedwidth)
- [address](https://github.com/bojanz/address) **star:68** 处理地址表示、验证和格式。   [![godoc][D]](https://godoc.org/github.com/bojanz/address)
- [textwrap](https://github.com/isbm/textwrap) **star:5** 在行尾换行。从Python实现' textwrap '模块。   [![近三年未更新][Y]](https://github.com/isbm/textwrap)   [![godoc][D]](https://godoc.org/github.com/isbm/textwrap)

### 标记语言

- [blackfriday](https://github.com/russross/blackfriday) **star:5223** Markdown 解析器   [![近一周有更新][G]](https://github.com/russross/blackfriday)   [![godoc][D]](https://godoc.org/github.com/russross/blackfriday)
- [github_flavored_markdown](https://godoc.org/github.com/shurcooL/github_flavored_markdown)  GitHub 风格的 Markdown 渲染器 (使用 blackfriday) ，支持代码块高亮以及可点击的锚点
- [toml](https://github.com/BurntSushi/toml) **star:4275** TOML配置格式(带反射的编码器/解码器)。   [![godoc][D]](https://godoc.org/github.com/BurntSushi/toml)
- [goldmark](https://github.com/yuin/goldmark) **star:2883** A Markdown parser written in Go. Easy to extend, standard (CommonMark) compliant, well structured.   [![近一周有更新][G]](https://github.com/yuin/goldmark)   [![godoc][D]](https://godoc.org/github.com/yuin/goldmark)
- [go-toml](https://github.com/pelletier/go-toml) **star:1488** 使用带有查询支持和方便的cli工具的TOML格式库。   [![近一周有更新][G]](https://github.com/pelletier/go-toml)   [![godoc][D]](https://godoc.org/github.com/pelletier/go-toml)
- [htmlquery](https://github.com/antchfx/htmlquery) **star:630** 用于HTML的XPath查询包，允许您通过XPath表达式从HTML文档中提取数据或求值。   [![godoc][D]](https://godoc.org/github.com/antchfx/htmlquery)
- [html-to-markdown](https://github.com/JohannesKaufmann/html-to-markdown) **star:602** 将HTML转换成Markdown   [![近一周有更新][G]](https://github.com/JohannesKaufmann/html-to-markdown)   [![godoc][D]](https://godoc.org/github.com/JohannesKaufmann/html-to-markdown)
- [mxj](https://github.com/clbanning/mxj) **star:573** 将XML编码/解码为JSON或map[string]接口{};使用点符号路径和通配符提取值。替换x2j和j2x包。   [![godoc][D]](https://godoc.org/github.com/clbanning/mxj)
- [goq](https://github.com/andrewstuart/goq) **star:244**  声明式 HTML 编组，使用结构标签和 jQuery 语法 (使用 GoQuery).   [![godoc][D]](https://godoc.org/github.com/andrewstuart/goq)
- [bafi](https://github.com/mmalcek/bafi) **star:80** 通用JSON, BSON, YAML, XML翻译到任何格式使用模板。   [![godoc][D]](https://godoc.org/github.com/mmalcek/bafi)
- [go-output-format](https://github.com/drewstinnett/go-output-format) **star:12** 在你的命令行应用程序中将go结构输出为多种格式(YAML/JSON/etc)。   [![godoc][D]](https://godoc.org/github.com/drewstinnett/go-output-format)
- [bbConvert](https://github.com/CalebQ42/bbConvert) **star:7** 将bbCode转换为HTML，使您可以添加对自定义bbCode标记的支持。   [![近三年未更新][Y]](https://github.com/CalebQ42/bbConvert)   [![godoc][D]](https://godoc.org/github.com/CalebQ42/bbConvert)
- [htmlyaml](https://github.com/nikolaydubina/htmlyaml) **star:2**  Rich rendering of YAML as HTML in Go   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/htmlyaml)

### 解析 器/Encoders/Decoders

- [sh](https://github.com/mvdan/sh) **star:6167** Shell解析器和格式化工具。   [![godoc][D]](https://godoc.org/github.com/mvdan/sh)
- [gofeed](https://github.com/mmcdole/gofeed) **star:2254** 在Go中解析RSS和Atom feeds。   [![godoc][D]](https://godoc.org/github.com/mmcdole/gofeed)
- [when](https://github.com/olebedev/when) **star:1289** 带有可插入规则的自然EN和RU语言日期/时间解析器。   [![godoc][D]](https://godoc.org/github.com/olebedev/when)
- [commonregex](https://github.com/mingrammer/commonregex) **star:866** 一组用于Go的公共正则表达式。   [![近三年未更新][Y]](https://github.com/mingrammer/commonregex)   [![godoc][D]](https://godoc.org/github.com/mingrammer/commonregex)
- [omniparser](https://github.com/jf-tech/omniparser) **star:594** 一个通用的ETL库，以流方式解析文本输入(CSV/txt/JSON/XML/EDI/X12/EDIFACT/etc)，并使用数据驱动模式将数据转换为JSON输出。   [![近一周有更新][G]](https://github.com/jf-tech/omniparser)   [![godoc][D]](https://godoc.org/github.com/jf-tech/omniparser)
- [gographviz](https://github.com/awalterschulze/gographviz) **star:530** 解析Graphviz DOT语言。   [![godoc][D]](https://godoc.org/github.com/awalterschulze/gographviz)
- [go-nmea](https://github.com/adrianmo/go-nmea) **star:200** 用于Go语言的NMEA解析器库。   [![godoc][D]](https://godoc.org/github.com/adrianmo/go-nmea)
- [editorconfig-core-go](https://github.com/editorconfig/editorconfig-core-go) **star:123** Editorconfig文件解析器和Go操作器。   [![近一周有更新][G]](https://github.com/editorconfig/editorconfig-core-go)   [![godoc][D]](https://godoc.org/github.com/editorconfig/editorconfig-core-go)
- [sdp](https://github.com/gortc/sdp) **star:111** SDP:会话描述协议[[RFC 4566](https://tools.ietf.org/html/rfc4566)]。   [![近三年未更新][Y]](https://github.com/gortc/sdp)   [![godoc][D]](https://godoc.org/github.com/gortc/sdp)   [![归档项目][Archived]](https://github.com/gortc/sdp)
- [go-vcard](https://github.com/emersion/go-vcard) **star:89** 解析和格式化vCard。   [![godoc][D]](https://godoc.org/github.com/emersion/go-vcard)
- [did](https://github.com/ockam-network/did) **star:77** DID(分散标识符)解析器和Stringer。   [![godoc][D]](https://godoc.org/github.com/ockam-network/did)
- [allot](https://github.com/sbstjn/allot) **star:58** 用于CLI工具和机器人的占位符和通配符文本解析。   [![godoc][D]](https://godoc.org/github.com/sbstjn/allot)
- [tokenizer](https://github.com/bzick/tokenizer) **star:51** Parse any string, slice or infinite buffer to any tokens.   [![godoc][D]](https://godoc.org/github.com/bzick/tokenizer)
- [parth](https://github.com/codemodus/parth) **star:43** URL路径分割解析。   [![近三年未更新][Y]](https://github.com/codemodus/parth)   [![godoc][D]](https://godoc.org/github.com/codemodus/parth)
- [gonameparts](https://github.com/polera/gonameparts) **star:38** 将人名解析为单独的名称部分。   [![近三年未更新][Y]](https://github.com/polera/gonameparts)   [![godoc][D]](https://godoc.org/github.com/polera/gonameparts)
- [normalize](https://github.com/avito-tech/normalize) **star:36** 消毒，规范化和比较模糊的文本。   [![godoc][D]](https://godoc.org/github.com/avito-tech/normalize)
- [xj2go](https://github.com/stackerzzq/xj2go) **star:32** 将xml或json转换为struct。   [![godoc][D]](https://godoc.org/github.com/stackerzzq/xj2go)
- [codetree](https://github.com/aerogo/codetree) **star:23** 解析缩进代码(python、pixy、scarlet等)并返回树结构。   [![近三年未更新][Y]](https://github.com/aerogo/codetree)   [![godoc][D]](https://godoc.org/github.com/aerogo/codetree)
- [go-fasttld](https://github.com/elliotwutingfeng/go-fasttld) **star:19** High performance effective top level domains (eTLD) extraction module.   [![近一周有更新][G]](https://github.com/elliotwutingfeng/go-fasttld)   [![godoc][D]](https://godoc.org/github.com/elliotwutingfeng/go-fasttld)
- [parseargs-go](https://github.com/nproc/parseargs-go) **star:9** 字符串参数解析器，能够理解引用及反斜杠。   [![近三年未更新][Y]](https://github.com/nproc/parseargs-go)   [![godoc][D]](https://godoc.org/github.com/nproc/parseargs-go)
- [doi](https://github.com/hscells/doi) **star:8** 文档对象标识符(doi)解析器。   [![近三年未更新][Y]](https://github.com/hscells/doi)   [![godoc][D]](https://godoc.org/github.com/hscells/doi)
- [encdec](https://github.com/mickep76/encdec) **star:8** Package provides a generic interface to encoders and decoders.   [![近三年未更新][Y]](https://github.com/mickep76/encdec)   [![godoc][D]](https://godoc.org/github.com/mickep76/encdec)
- [ltsv](https://github.com/Wing924/ltsv) **star:8** 高性能[LTSV(Labeled Tab Separated Value)](http://ltsv.org/)。   [![近三年未更新][Y]](https://github.com/Wing924/ltsv)   [![godoc][D]](https://godoc.org/github.com/Wing924/ltsv)

### 正则表达式

- [rex](https://github.com/hedhyw/rex) **star:160** Regular expressions builder.   [![godoc][D]](https://godoc.org/github.com/hedhyw/rex)
- [regroup](https://github.com/oriser/regroup) **star:134** 使用结构标记和自动解析将正则表达式命名组匹配到go结构中。   [![godoc][D]](https://godoc.org/github.com/oriser/regroup)
- [goregen](https://github.com/zach-klippenstein/goregen) **star:84** 根据正则表达式生成随机字符串   [![godoc][D]](https://godoc.org/github.com/zach-klippenstein/goregen)
- [genex](https://github.com/alixaxel/genex) **star:75** 将正则表达式计数并展开为所有匹配的字符串。   [![近三年未更新][Y]](https://github.com/alixaxel/genex)   [![godoc][D]](https://godoc.org/github.com/alixaxel/genex)
- [go-wildcard](https://github.com/IGLOU-EU/go-wildcard) **star:49** 简单而轻量级的通配符模式匹配。   [![godoc][D]](https://godoc.org/github.com/IGLOU-EU/go-wildcard)

### 环境卫生

- [bluemonday](https://github.com/microcosm-cc/bluemonday) **star:2798** HTML 清理工具   [![godoc][D]](https://godoc.org/github.com/microcosm-cc/bluemonday)
- [gofuckyourself](https://github.com/JoshuaDoes/gofuckyourself) **star:58** 一个基于 sanitization 的 Go 敏感词过滤器。   [![godoc][D]](https://godoc.org/github.com/JoshuaDoes/gofuckyourself)

### 刮刀

- [colly](https://github.com/asciimoo/colly) **star:20734** 快速和优雅的 Scraping 框架。   [![近一周有更新][G]](https://github.com/asciimoo/colly)   [![godoc][D]](https://godoc.org/github.com/asciimoo/colly)
- [GoQuery](https://github.com/PuerkitoBio/goquery) **star:12951** GoQuery 为 Go 语言带来了一组类似 jQuery 的语法和功能   [![godoc][D]](https://godoc.org/github.com/PuerkitoBio/goquery)
- [xurls](https://github.com/mvdan/xurls) **star:1071** 从文本中提取url。   [![godoc][D]](https://godoc.org/github.com/mvdan/xurls)
- [dataflowkit](https://github.com/slotix/dataflowkit) **star:616** Web抓取框架将网站转换为结构化数据。   [![godoc][D]](https://godoc.org/github.com/slotix/dataflowkit)
- [gospider](https://github.com/zhshch2002/gospider) **star:197** 一个简单的golang蜘蛛/抓取框架，用3行代码构建一个蜘蛛。从[goribot] (https://github.com/zhshch2002/goribot)   [![godoc][D]](https://godoc.org/github.com/zhshch2002/gospider)
- [pagser](https://github.com/foolin/pagser) **star:89** Pagser是一个简单的，可扩展的，可配置的解析和反序列化的html页面结构，基于goquery和结构标签的golang爬虫。   [![godoc][D]](https://godoc.org/github.com/foolin/pagser)
- [Tagify](https://github.com/zoomio/tagify) **star:33** 从给定源生成一组标记。
- [go-recipe](https://github.com/kkyr/go-recipe) **star:25** A package for scraping recipes from websites.   [![godoc][D]](https://godoc.org/github.com/kkyr/go-recipe)
- [walker](https://github.com/cyucelen/walker) **star:5** Seamlessly fetch paginated data from any source. Simple and high performance API scraping included.   [![godoc][D]](https://godoc.org/github.com/cyucelen/walker)

### RSS

- [podcast](https://github.com/eduncan911/podcast) **star:125** 在Golang兼容iTunes和RSS 2.0播客生成器   [![godoc][D]](https://godoc.org/github.com/eduncan911/podcast)
- [syndfeed](https://github.com/zhengchun/syndfeed) **star:11** Atom 1.0和RSS 2.0的联合提要。   [![近三年未更新][Y]](https://github.com/zhengchun/syndfeed)   [![godoc][D]](https://godoc.org/github.com/zhengchun/syndfeed)

### 实用程序/Miscellaneous

- [go-runewidth](https://github.com/mattn/go-runewidth) **star:544** 函数获取字符或字符串的固定宽度。   [![godoc][D]](https://godoc.org/github.com/mattn/go-runewidth)
- [radix](https://github.com/yourbasic/radix) **star:186** 快速字符串排序算法。   [![近三年未更新][Y]](https://github.com/yourbasic/radix)   [![godoc][D]](https://godoc.org/github.com/yourbasic/radix)
- [go-zero-width](https://github.com/trubitsyn/go-zero-width) **star:110** 用于Go的零宽度字符检测和删除。   [![近三年未更新][Y]](https://github.com/trubitsyn/go-zero-width)   [![godoc][D]](https://godoc.org/github.com/trubitsyn/go-zero-width)   [![归档项目][Archived]](https://github.com/trubitsyn/go-zero-width)
- [petrovich](https://github.com/striker2000/petrovich) **star:44** 彼得罗维奇是一个图书馆，它把俄语名字的词形变化成特定的语法格。   [![godoc][D]](https://godoc.org/github.com/striker2000/petrovich)
- [kace](https://github.com/codemodus/kace) **star:20** 通用大小写转换工具   [![近三年未更新][Y]](https://github.com/codemodus/kace)   [![godoc][D]](https://godoc.org/github.com/codemodus/kace)
- [TySug](https://github.com/Dynom/TySug) **star:17** 关于键盘布局的其他建议。   [![godoc][D]](https://godoc.org/github.com/Dynom/TySug)

**[⬆ back to top](#contents)**

## 第三方api

_用于访问第三方api的库。 (翻译出错了? 试试 [英文版](README_EN.md#third-party-apis) 吧~)_

- [github](https://github.com/google/go-github) **star:9663** 访问GitHub REST API v3的库。   [![近一周有更新][G]](https://github.com/google/go-github)   [![godoc][D]](https://godoc.org/github.com/google/go-github)
- [aws-sdk-go](https://github.com/aws/aws-sdk-go) **star:8407** AWS 提供的官方go语言 SDK   [![近一周有更新][G]](https://github.com/aws/aws-sdk-go)   [![godoc][D]](https://godoc.org/github.com/aws/aws-sdk-go)
- [go-openai](https://github.com/sashabaranov/go-openai) **star:6362** OpenAI ChatGPT, DALL·E, Whisper API library for Go.   [![近一周有更新][G]](https://github.com/sashabaranov/go-openai)   [![godoc][D]](https://godoc.org/github.com/sashabaranov/go-openai)
- [slack](https://github.com/slack-go/slack) **star:4401** Slack API。   [![近一周有更新][G]](https://github.com/slack-go/slack)   [![godoc][D]](https://godoc.org/github.com/slack-go/slack)
- [discordgo](https://github.com/bwmarrin/discordgo) **star:4227**  Discord Chat API的客户端。   [![godoc][D]](https://godoc.org/github.com/bwmarrin/discordgo)
- [google](https://github.com/google/google-api-go-client) **star:3564** 为Go自动生成谷歌api。   [![近一周有更新][G]](https://github.com/google/google-api-go-client)   [![godoc][D]](https://godoc.org/github.com/google/google-api-go-client)
- [google-cloud](https://github.com/GoogleCloudPlatform/gcloud-golang) **star:3363** 谷歌云api Go 客户端库。   [![近一周有更新][G]](https://github.com/GoogleCloudPlatform/gcloud-golang)   [![godoc][D]](https://godoc.org/github.com/GoogleCloudPlatform/gcloud-golang)
- [minio-go](https://github.com/minio/minio-go) **star:2056** 用于Amazon S3兼容云存储的Minio Go库。   [![godoc][D]](https://godoc.org/github.com/minio/minio-go)
- [stripe](https://github.com/stripe/stripe-go) **star:1850**  Stripe API 的 Go 语言客户端   [![近一周有更新][G]](https://github.com/stripe/stripe-go)   [![godoc][D]](https://godoc.org/github.com/stripe/stripe-go)
- [go-twitter](https://github.com/dghubble/go-twitter) **star:1589**  Twitter v1.1 api 的客户端.   [![godoc][D]](https://godoc.org/github.com/dghubble/go-twitter)   [![归档项目][Archived]](https://github.com/dghubble/go-twitter)
- [go-jira](https://github.com/andygrunwald/go-jira) **star:1360**  Go [Atlassian JIRA](https://www.atlassian.com/software/jira)的客户端库   [![godoc][D]](https://godoc.org/github.com/andygrunwald/go-jira)
- [facebook](https://github.com/huandu/facebook) **star:1190** 支持 Facebook Graph API 的库   [![godoc][D]](https://godoc.org/github.com/huandu/facebook)
- [anaconda](https://github.com/ChimeraCoder/anaconda) **star:1137**  Twitter 1.1 API 的 go 语言客户端   [![godoc][D]](https://godoc.org/github.com/ChimeraCoder/anaconda)
- [githubql](https://github.com/shurcooL/githubql) **star:1033** 访问GitHub GraphQL API v4的库。   [![godoc][D]](https://godoc.org/github.com/shurcooL/githubql)
- [webhooks](https://github.com/go-playground/webhooks) **star:865** GitHub 和 Bitbucket 的Webhook接收器。   [![godoc][D]](https://godoc.org/github.com/go-playground/webhooks)
- [twitter-scraper](https://github.com/n0madic/twitter-scraper) **star:684** 刮Twitter前端API没有认证和限制。   [![近一周有更新][G]](https://github.com/n0madic/twitter-scraper)   [![godoc][D]](https://godoc.org/github.com/n0madic/twitter-scraper)
- [paypal](https://github.com/logpacker/PayPal-Go-SDK) **star:599** PayPal支付API的包装器。   [![godoc][D]](https://godoc.org/github.com/logpacker/PayPal-Go-SDK)
- [geo-golang](https://github.com/codingsince1985/geo-golang) **star:474** Go Library to access [Google Maps](https://developers.google.com/maps/documentation/geocoding/intro), [MapQuest](https://developer.mapquest.com/documentation/geocoding-api/), [Nominatim](https://developer.mapquest.com/documentation/open/nominatim-search), [OpenCage](https://opencagedata.com/api), [Bing](https://msdn.microsoft.com/en-us/library/ff701715.aspx), [Mapbox](https://www.mapbox.com/developers/api/geocoding/), and [OpenStreetMap](https://wiki.openstreetmap.org/wiki/Nominatim) geocoding / reverse geocoding APIs.   [![godoc][D]](https://godoc.org/github.com/codingsince1985/geo-golang)
- [lark](https://github.com/chyroc/lark) **star:347** [飞舒](https://open.feishu.cn/)/[Lark](https://open.larksuite.com/) Go SDK开放API，支持所有开放API和事件回调。   [![近一周有更新][G]](https://github.com/chyroc/lark)   [![godoc][D]](https://godoc.org/github.com/chyroc/lark)   [![包含中文文档][CN]](https://github.com/chyroc/lark)
- [openaigo](https://github.com/otiai10/openaigo) **star:272** OpenAI GPT3/GPT3.5 ChatGPT API client library for Go.   [![近一周有更新][G]](https://github.com/otiai10/openaigo)   [![godoc][D]](https://godoc.org/github.com/otiai10/openaigo)
- [ethrpc](https://github.com/onrik/ethrpc) **star:257**  Ethereum JSON RPC API的客户端。   [![godoc][D]](https://godoc.org/github.com/onrik/ethrpc)
- [Trello](https://github.com/adlio/trello) **star:212**  Trello API的 Go 语言封装。   [![godoc][D]](https://godoc.org/github.com/adlio/trello)
- [go-marathon](https://github.com/gambol99/go-marathon) **star:200**  用于和 Mesosphere's Marathon PAAS 交互的 Go 语言库   [![godoc][D]](https://godoc.org/github.com/gambol99/go-marathon)
- [go-lark](https://github.com/go-lark/lark) **star:165** 一个易于使用的非官方SDK为[飞书](https://open.feishu.cn/)和[Lark](https://open.larksuite.com/)开放平台。   [![godoc][D]](https://godoc.org/github.com/go-lark/lark)   [![包含中文文档][CN]](https://github.com/go-lark/lark)
- [wit-go](https://github.com/wit-ai/wit-go) **star:146** wit.ai HTTP API 客户端。   [![godoc][D]](https://godoc.org/github.com/wit-ai/wit-go)
- [Medium](https://github.com/Medium/medium-sdk-go) **star:138** Medium的OAuth2 API 客户端。   [![近三年未更新][Y]](https://github.com/Medium/medium-sdk-go)   [![godoc][D]](https://godoc.org/github.com/Medium/medium-sdk-go)
- [go-trending](https://github.com/andygrunwald/go-trending) **star:137** 在Github上访问[trends repository](https://github.com/trends)和[developers](https://github.com/trending/developers)的库。   [![godoc][D]](https://godoc.org/github.com/andygrunwald/go-trending)
- [pushover](https://github.com/gregdel/pushover) **star:137**  Go 包装的 Pushover API。   [![godoc][D]](https://godoc.org/github.com/gregdel/pushover)
- [gostorm](https://github.com/jsgilmore/gostorm) **star:130** GoStorm是一个Go库，它实现了编写Storm spout和bolt所需的通信协议，这些协议用于与Storm shell通信。   [![近三年未更新][Y]](https://github.com/jsgilmore/gostorm)   [![godoc][D]](https://godoc.org/github.com/jsgilmore/gostorm)
- [gosip](https://github.com/koltyakov/gosip) **star:117** Client library for SharePoint.   [![godoc][D]](https://godoc.org/github.com/koltyakov/gosip)
- [simples3](https://github.com/rhnvrm/simples3) **star:115** 使用REST和用Go编写的V4签名的AWS S3库非常简单。   [![godoc][D]](https://godoc.org/github.com/rhnvrm/simples3)
- [hipchat (xmpp)](https://github.com/daneharrigan/hipchat) **star:110** 一个用于通过XMPP与HipChat通信的golang包。   [![近三年未更新][Y]](https://github.com/daneharrigan/hipchat)   [![godoc][D]](https://godoc.org/github.com/daneharrigan/hipchat)
- [hipchat](https://github.com/andybons/hipchat) **star:104** 这个项目为Hipchat API实现了一个golang客户端库。   [![近三年未更新][Y]](https://github.com/andybons/hipchat)   [![godoc][D]](https://godoc.org/github.com/andybons/hipchat)
- [cachet](https://github.com/andygrunwald/cachet) **star:91** 使用客户端库[Cachet(开源状态页系统)](https://cachethq.io/)。   [![godoc][D]](https://godoc.org/github.com/andygrunwald/cachet)
- [go-atlassian](https://github.com/ctreminiom/go-atlassian) **star:86** 访问[Atlassian Cloud](https://www.atlassian.com/enterprise/cloud)服务(Jira, Jira Service Management, Jira Agile, Confluence, Admin Cloud)   [![godoc][D]](https://godoc.org/github.com/ctreminiom/go-atlassian)
- [golang-tmdb](https://github.com/cyruzin/golang-tmdb) **star:85** 电影数据库API v3的Golang包装器。   [![godoc][D]](https://godoc.org/github.com/cyruzin/golang-tmdb)
- [igdb](https://github.com/Henry-Sarabia/igdb) **star:78** [Internet Game Database API](https://api.igdb.com/) 客户端。   [![godoc][D]](https://godoc.org/github.com/Henry-Sarabia/igdb)
- [go-unsplash](https://github.com/hbagdi/go-unsplash) **star:72** 使用[Unsplash.com](https://unsplash.com) API的客户端库。   [![godoc][D]](https://godoc.org/github.com/hbagdi/go-unsplash)
- [gogtrends](https://github.com/groovili/gogtrends) **star:72** 非官方的Google Trends API。   [![godoc][D]](https://godoc.org/github.com/groovili/gogtrends)
- [google-play-scraper](https://github.com/n0madic/google-play-scraper) **star:72** 从谷歌播放存储获取数据。   [![godoc][D]](https://godoc.org/github.com/n0madic/google-play-scraper)
- [go-postman-collection](https://github.com/rbretecher/go-postman-collection) **star:70** 去模块工作与[邮递员收集](https://learning.getpostman.com/docs/postman/collections/creating-collections/)(兼容失眠)。   [![godoc][D]](https://godoc.org/github.com/rbretecher/go-postman-collection)
- [airtable](https://github.com/mehanizm/airtable) **star:64** 去客户端库[Airtable API](https://airtable.com/api)。   [![godoc][D]](https://godoc.org/github.com/mehanizm/airtable)
- [circleci](https://github.com/jszwedko/go-circleci) **star:64** CircleCI的API的客户端   [![近三年未更新][Y]](https://github.com/jszwedko/go-circleci)   [![godoc][D]](https://godoc.org/github.com/jszwedko/go-circleci)
- [mixpanel](https://github.com/dukex/mixpanel) **star:60** Mixpanel是一个库，用于跟踪事件并将Mixpanel概要文件更新从go应用程序发送到Mixpanel。   [![godoc][D]](https://godoc.org/github.com/dukex/mixpanel)
- [ynab](https://github.com/brunomvsouza/ynab.go) **star:59**  YNAB API 的 Go 语言封装。   [![godoc][D]](https://godoc.org/github.com/brunomvsouza/ynab.go)
- [amazon-product-advertising-api](https://github.com/ngs/go-amazon-product-advertising-api) **star:57** [Amazon Product Advertising API](https://program.amazon.com/gp/advertising/api/detail/main.html)的客户端库。   [![近三年未更新][Y]](https://github.com/ngs/go-amazon-product-advertising-api)   [![godoc][D]](https://godoc.org/github.com/ngs/go-amazon-product-advertising-api)
- [uptimerobot](https://github.com/bitfield/uptimerobot) **star:56** 运行时Robot v2 API 的 Go 语言封装和命令行客户端。   [![godoc][D]](https://godoc.org/github.com/bitfield/uptimerobot)
- [clarifai](https://github.com/samuelcouch/clarifai) **star:55** Clarifai API的客户端。   [![近三年未更新][Y]](https://github.com/samuelcouch/clarifai)   [![godoc][D]](https://godoc.org/github.com/samuelcouch/clarifai)
- [megos](https://github.com/andygrunwald/megos) **star:54** 用于访问[Apache Mesos](https://mesos.apache.org/)集群的客户端库。   [![godoc][D]](https://godoc.org/github.com/andygrunwald/megos)
- [fcm](https://github.com/maddevsio/fcm) **star:51**  Firebase Cloud Messaging 的 Go 语言库   [![近三年未更新][Y]](https://github.com/maddevsio/fcm)   [![godoc][D]](https://godoc.org/github.com/maddevsio/fcm)
- [go-xkcd](https://github.com/nishanths/go-xkcd) **star:51**  xkcd API 的客户端。   [![godoc][D]](https://godoc.org/github.com/nishanths/go-xkcd)
- [go-yapla](https://git.iglou.eu/Production/go-yapla)  Go ypla v2.0 API的客户端库。
- [GoMusicBrainz](https://github.com/michiwend/gomusicbrainz) **star:51**  Go MusicBrainz WS2客户端库。   [![godoc][D]](https://godoc.org/github.com/michiwend/gomusicbrainz)
- [gads](https://github.com/emiddleton/gads) **star:50**  Google Adwords 非官方 API   [![godoc][D]](https://godoc.org/github.com/emiddleton/gads)
- [spotify](https://github.com/rapito/go-spotify) **star:47**  用于接入 Spotify WEB API 的 Go 语言库   [![godoc][D]](https://godoc.org/github.com/rapito/go-spotify)
- [golyrics](https://github.com/mamal72/golyrics) **star:40** Golyrics是一个从Wikia网站获取音乐歌词数据的Go库。   [![近三年未更新][Y]](https://github.com/mamal72/golyrics)   [![godoc][D]](https://godoc.org/github.com/mamal72/golyrics)
- [swag](https://github.com/zc2638/swag) **star:39** No comments, simple go wrapper to create swagger 2.0 compatible APIs. Support most routing frameworks, such as built-in, gin, chi, mux, echo, httprouter, fasthttp and more.   [![godoc][D]](https://godoc.org/github.com/zc2638/swag)   [![包含中文文档][CN]](https://github.com/zc2638/swag)
- [go-myanimelist](https://github.com/nstratos/go-myanimelist) **star:36** 去访问[MyAnimeList API]的客户端库(https://myanimelist.net/apiconfig/references/api/v2)。   [![godoc][D]](https://godoc.org/github.com/nstratos/go-myanimelist)
- [patreon-go](https://github.com/mxpv/patreon-go) **star:36**  Go Patreon API库。   [![godoc][D]](https://godoc.org/github.com/mxpv/patreon-go)
- [translate](https://github.com/poorny/translate) **star:33**  Go 在线翻译包。   [![近三年未更新][Y]](https://github.com/poorny/translate)   [![godoc][D]](https://godoc.org/github.com/poorny/translate)   [![归档项目][Archived]](https://github.com/poorny/translate)
- [gami](https://github.com/bit4bit/gami) **star:32**  Asterisk Manager Interface 的 Go 语言库   [![近三年未更新][Y]](https://github.com/bit4bit/gami)   [![godoc][D]](https://godoc.org/github.com/bit4bit/gami)   [![归档项目][Archived]](https://github.com/bit4bit/gami)
- [lastpass-go](https://github.com/ansd/lastpass-go) **star:32** 使用[LastPass](https://www.lastpass.com/) API的客户端库。   [![godoc][D]](https://godoc.org/github.com/ansd/lastpass-go)
- [gcm](https://github.com/Aorioli/gcm) **star:31**  Google Cloud Messaging 库   [![近三年未更新][Y]](https://github.com/Aorioli/gcm)   [![godoc][D]](https://godoc.org/github.com/Aorioli/gcm)
- [steam](https://github.com/sostronk/go-steam) **star:30**  用于与Steam服务器进行交互的库。   [![godoc][D]](https://godoc.org/github.com/sostronk/go-steam)
- [GoFreeDB](https://github.com/FreeLeh/GoFreeDB) **star:27** Golang library providing common and simple database abstractions on top of Google Sheets.   [![godoc][D]](https://godoc.org/github.com/FreeLeh/GoFreeDB)
- [go-imgur](https://github.com/koffeinsource/go-imgur) **star:25** Go [imgur](https://imgur.com)的客户端库   [![godoc][D]](https://godoc.org/github.com/koffeinsource/go-imgur)
- [shopify](https://github.com/rapito/go-shopify) **star:25** 一个用于通过 Shopify API 进行增删改查的 Go 语言库。   [![godoc][D]](https://godoc.org/github.com/rapito/go-shopify)
- [device-check-go](https://github.com/rinchsan/device-check-go) **star:21** Go客户端库与[iOS DeviceCheck API](https://developer.apple.com/documentation/devicecheck) v1交互。   [![近一周有更新][G]](https://github.com/rinchsan/device-check-go)   [![godoc][D]](https://godoc.org/github.com/rinchsan/device-check-go)
- [jokeapi-go](https://github.com/icelain/jokeapi) **star:21** 去客户端[JokeAPI](https://sv443.net/jokeapi/v2/)。   [![godoc][D]](https://godoc.org/github.com/icelain/jokeapi)
- [coinpaprika-go](https://github.com/coinpaprika/coinpaprika-api-go-client) **star:20** Coinpaprika API的客户端。   [![godoc][D]](https://godoc.org/github.com/coinpaprika/coinpaprika-api-go-client)
- [brewerydb](https://github.com/naegelejd/brewerydb) **star:19** 用于访问 BreweryDB API的 Go 语言库   [![近三年未更新][Y]](https://github.com/naegelejd/brewerydb)   [![godoc][D]](https://godoc.org/github.com/naegelejd/brewerydb)
- [textbelt](https://github.com/dietsche/textbelt) **star:19** textbelt.com txt messaging API 的go语言客户端。   [![近三年未更新][Y]](https://github.com/dietsche/textbelt)   [![godoc][D]](https://godoc.org/github.com/dietsche/textbelt)
- [codeship-go](https://github.com/codeship/codeship-go) **star:18**  Codeship API v2的客户端。   [![godoc][D]](https://godoc.org/github.com/codeship/codeship-go)
- [go-aws-news](https://github.com/circa10a/go-aws-news) **star:18** 去应用程序和库获取AWS的新内容。   [![godoc][D]](https://godoc.org/github.com/circa10a/go-aws-news)
- [go-hacknews](https://github.com/PaulRosset/go-hacknews) **star:16** HackerNews API的小型Go客户端。   [![近三年未更新][Y]](https://github.com/PaulRosset/go-hacknews)   [![godoc][D]](https://godoc.org/github.com/PaulRosset/go-hacknews)
- [gopaapi5](https://github.com/utekaravinash/gopaapi5) **star:15** Go客户端库[亚马逊产品广告API 5.0](https://webservices.amazon.com/paapi5/documentation/)。   [![近三年未更新][Y]](https://github.com/utekaravinash/gopaapi5)   [![godoc][D]](https://godoc.org/github.com/utekaravinash/gopaapi5)
- [google-analytics](https://github.com/chonthu/go-google-analytics) **star:14** 简单的包装，方便的谷歌分析报告。   [![近三年未更新][Y]](https://github.com/chonthu/go-google-analytics)   [![godoc][D]](https://godoc.org/github.com/chonthu/go-google-analytics)
- [go-openproject](https://github.com/manuelbcd/go-openproject) **star:13** 去与[OpenProject](https://docs.openproject.org/api/) API交互的客户端库。   [![godoc][D]](https://godoc.org/github.com/manuelbcd/go-openproject)
- [goami2](https://github.com/staskobzar/goami2) **star:13** AMI v2 library for Asterisk PBX.   [![godoc][D]](https://godoc.org/github.com/staskobzar/goami2)
- [bqwriter](https://github.com/OTA-Insight/bqwriter) **star:12** High Level Go Library将数据写入[谷歌BigQuery](https://cloud.google.com/bigquery)在高位贯穿。   [![近一周有更新][G]](https://github.com/OTA-Insight/bqwriter)   [![godoc][D]](https://godoc.org/github.com/OTA-Insight/bqwriter)
- [go-here](https://github.com/abdullahselek/go-here) **star:12** 转到基于这里位置的api的客户端库。   [![近三年未更新][Y]](https://github.com/abdullahselek/go-here)   [![godoc][D]](https://godoc.org/github.com/abdullahselek/go-here)
- [go-sophos](https://github.com/esurdam/go-sophos) **star:12** 无任何依赖的[Sophos UTM REST API](https://www.sophos.com/en-us/medialibrary/pdfs/documentation/utmonaws/sophos-ut-restful-api.pdf?la=en)客户端   [![godoc][D]](https://godoc.org/github.com/esurdam/go-sophos)
- [go-swagger-ui](https://github.com/esurdam/go-swagger-ui) **star:11** Go库包含预编译[Swagger UI](https://swagger.io/tools/swagger-ui/)，用于服务Swagger json。
- [go-telegraph](https://gitlab.com/toby3d/telegraph)  Telegraph 发布平台 API 客户端。
- [gomalshare](https://github.com/MonaxGT/gomalshare) **star:11** 去图书馆MalShare API [malshare.com](https://www.malshare.com/)   [![近三年未更新][Y]](https://github.com/MonaxGT/gomalshare)   [![godoc][D]](https://godoc.org/github.com/MonaxGT/gomalshare)
- [smite](https://github.com/sergiotapia/smitego) **star:11** 对 Smite game API 的封装。   [![近三年未更新][Y]](https://github.com/sergiotapia/smitego)   [![godoc][D]](https://godoc.org/github.com/sergiotapia/smitego)
- [libgoffi](https://github.com/clevabit/libgoffi) **star:9** 用于本地[libffi](https://sourceware.org/libffi/)集成的库适配器工具箱   [![近三年未更新][Y]](https://github.com/clevabit/libgoffi)   [![godoc][D]](https://godoc.org/github.com/clevabit/libgoffi)
- [rrdaclient](https://github.com/Omie/rrdaclient) **star:9** 用于接入 statdns.com API 的库——RRDA API。通过HTTP协议进行 DNS查询。   [![近三年未更新][Y]](https://github.com/Omie/rrdaclient)   [![godoc][D]](https://godoc.org/github.com/Omie/rrdaclient)   [![归档项目][Archived]](https://github.com/Omie/rrdaclient)
- [tumblr](https://github.com/mattcunningham/gumblr) **star:9**  Tumblr v2 API 的 Go 语言封装。   [![近三年未更新][Y]](https://github.com/mattcunningham/gumblr)   [![godoc][D]](https://godoc.org/github.com/mattcunningham/gumblr)
- [go-chronos](https://github.com/axelspringer/go-chronos) **star:8** 用于与[Chronos](https://mesos.github.io/chronos/)作业调度程序进行交互的Go库   [![近三年未更新][Y]](https://github.com/axelspringer/go-chronos)   [![godoc][D]](https://godoc.org/github.com/axelspringer/go-chronos)
- [go-sptrans](https://github.com/sergioaugrod/go-sptrans) **star:8**  SPTrans Olho Vivo API 的客户端。   [![近三年未更新][Y]](https://github.com/sergioaugrod/go-sptrans)   [![godoc][D]](https://godoc.org/github.com/sergioaugrod/go-sptrans)
- [goagi](https://github.com/staskobzar/goagi) **star:8** Go library to build Asterisk PBX agi/fastagi applications.   [![godoc][D]](https://godoc.org/github.com/staskobzar/goagi)
- [google-email-audit-api](https://github.com/ngs/go-google-email-audit-api) **star:8** [谷歌G Suite Email Audit API](https://developer.google.com/admin-sdk/email-audit/) 的客户端。   [![近三年未更新][Y]](https://github.com/ngs/go-google-email-audit-api)   [![godoc][D]](https://godoc.org/github.com/ngs/go-google-email-audit-api)   [![归档项目][Archived]](https://github.com/ngs/go-google-email-audit-api)
- [rawg-sdk-go](https://github.com/dimuska139/rawg-sdk-go) **star:8** 去[RAWG视频游戏数据库](https://rawg.io/) API库   [![godoc][D]](https://godoc.org/github.com/dimuska139/rawg-sdk-go)
- [go-hibp](https://github.com/wneessen/go-hibp) **star:7** Simple Go binding to the "Have I Been Pwned" APIs.   [![godoc][D]](https://godoc.org/github.com/wneessen/go-hibp)
- [zooz](https://github.com/gojuno/go-zooz) **star:7**  Zooz API 的 Go 语言客户端。   [![godoc][D]](https://godoc.org/github.com/gojuno/go-zooz)
- [newsapi-go](https://github.com/jellydator/newsapi-go) **star:6** 去客户端[NewsAPI](https://newsapi.org/)。   [![godoc][D]](https://godoc.org/github.com/jellydator/newsapi-go)
- [appstore-sdk-go](https://github.com/Kachit/appstore-sdk-go) **star:3** 非官方的用于AppStore Connect API的Golang SDK。   [![godoc][D]](https://godoc.org/github.com/Kachit/appstore-sdk-go)
- [dusupay-sdk-go](https://github.com/Kachit/dusupay-sdk-go) **star:3** 非官方的Dusupay支付网关API客户端   [![godoc][D]](https://godoc.org/github.com/Kachit/dusupay-sdk-go)
- [go-restcountries](https://github.com/chriscross0/go-restcountries) **star:3** Go library for the [REST Countries API](https://countrylayer.com/).   [![godoc][D]](https://godoc.org/github.com/chriscross0/go-restcountries)
- [fasapay-sdk-go](https://github.com/Kachit/fasapay-sdk-go) **star:2** Unofficial Fasapay payment gateway XML API Client for Golang.   [![godoc][D]](https://godoc.org/github.com/Kachit/fasapay-sdk-go)
- [playlyfe](https://github.com/playlyfe/playlyfe-go-sdk) **star:2** Playlyfe Rest API Go SDK。   [![近三年未更新][Y]](https://github.com/playlyfe/playlyfe-go-sdk)   [![godoc][D]](https://godoc.org/github.com/playlyfe/playlyfe-go-sdk)
- [TripAdvisor](https://github.com/mrbenosborne/tripadvisor-golang) **star:2**  TripAdvisor API 的 Go 语言封装。   [![近三年未更新][Y]](https://github.com/mrbenosborne/tripadvisor-golang)   [![godoc][D]](https://godoc.org/github.com/mrbenosborne/tripadvisor-golang)
- [vl-go](https://github.com/verifid/vl-go) **star:2** 使用客户端库中的VerifID身份验证层API。   [![godoc][D]](https://godoc.org/github.com/verifid/vl-go)

**[⬆ back to top](#contents)**

## 公用事业公司

_可以让你的生活变得更简单的实用工具.。 (翻译出错了? 试试 [英文版](README_EN.md#utilities) 吧~)_

- [fzf](https://github.com/junegunn/fzf) **star:54299** 用Go编写的命令行模糊查找器。   [![近一周有更新][G]](https://github.com/junegunn/fzf)   [![godoc][D]](https://godoc.org/github.com/junegunn/fzf)
- [dive](https://github.com/wagoodman/dive) **star:38322** A tool for exploring each layer in a Docker image.   [![近一周有更新][G]](https://github.com/wagoodman/dive)   [![godoc][D]](https://godoc.org/github.com/wagoodman/dive)
- [hub](https://github.com/github/hub) **star:22527** 封装了 git 命令，提供了额外的功能用于在终端中和 Github 进行交互。   [![godoc][D]](https://godoc.org/github.com/github/hub)
- [ctop](https://github.com/bcicen/ctop) **star:14618** [Top-like](https://ctop.sh)接口(例如htop)用于容器度量。   [![godoc][D]](https://godoc.org/github.com/bcicen/ctop)
- [sqlx](https://github.com/jmoiron/sqlx) **star:14242** 为内建的数据库/sql 软件包提供一组扩展。   [![godoc][D]](https://godoc.org/github.com/jmoiron/sqlx)
- [lo](https://github.com/samber/lo) **star:13240** 一个基于Go 1.18的Lodash类库+泛型(map, filter, contains, find…)   [![godoc][D]](https://godoc.org/github.com/samber/lo)
- [goreleaser](https://github.com/goreleaser/goreleaser) **star:12080** 尽可能快速的发布 Go 语言二进制文件。   [![近一周有更新][G]](https://github.com/goreleaser/goreleaser)   [![godoc][D]](https://godoc.org/github.com/goreleaser/goreleaser)
- [air](https://github.com/cosmtrek/air) **star:11569** Air - Live reload for Go apps.   [![近一周有更新][G]](https://github.com/cosmtrek/air)   [![godoc][D]](https://godoc.org/github.com/cosmtrek/air)   [![包含中文文档][CN]](https://github.com/cosmtrek/air)
- [wuzz](https://github.com/asciimoo/wuzz) **star:10370** 用于HTTP检查的交互式cli工具。   [![godoc][D]](https://godoc.org/github.com/asciimoo/wuzz)
- [usql](https://github.com/knq/usql) **star:8221** usql 是一个通用的命令行接口，用于操作 sql 数据库。   [![近一周有更新][G]](https://github.com/knq/usql)   [![godoc][D]](https://godoc.org/github.com/knq/usql)
- [peco](https://github.com/peco/peco) **star:7425** 简单的交互过滤工具。   [![godoc][D]](https://godoc.org/github.com/peco/peco)
- [go-funk](https://github.com/thoas/go-funk) **star:4382** 现代 Go 语言工具库，提供了很多有用的工具 (map, find, contains, filter, chunk, reverse, ...)   [![godoc][D]](https://godoc.org/github.com/thoas/go-funk)
- [godropbox](https://github.com/dropbox/godropbox) **star:4145** 用于编写 Go 语言服务／应用的库，来自 Dropbox.。   [![godoc][D]](https://godoc.org/github.com/dropbox/godropbox)
- [hystrix-go](https://github.com/afex/hystrix-go) **star:4033** 实现 Hystrix 风格的、程序员预定义的 fallback 机制（熔断。   [![godoc][D]](https://godoc.org/github.com/afex/hystrix-go)
- [panicparse](https://github.com/maruel/panicparse) **star:3441** 将类似的协程分组并对调用栈进行着色   [![godoc][D]](https://godoc.org/github.com/maruel/panicparse)
- [minify](https://github.com/tdewolff/minify) **star:3415** 用于HTML、CSS、JS、XML、JSON和SVG文件格式的快速缩小器。   [![近一周有更新][G]](https://github.com/tdewolff/minify)   [![godoc][D]](https://godoc.org/github.com/tdewolff/minify)
- [goreporter](https://github.com/wgliang/goreporter) **star:3084** 进行代码静态分析，单元测试，代码检视并生成代码质量报告的工具   [![近三年未更新][Y]](https://github.com/wgliang/goreporter)   [![godoc][D]](https://godoc.org/github.com/wgliang/goreporter)
- [lancet](https://github.com/duke-git/lancet) **star:2996** A comprehensive, efficient, and reusable util function library of go.   [![近一周有更新][G]](https://github.com/duke-git/lancet)   [![godoc][D]](https://godoc.org/github.com/duke-git/lancet)   [![包含中文文档][CN]](https://github.com/duke-git/lancet)
- [mergo](https://github.com/imdario/mergo) **star:2555** 用于将结构体和map合并进 Go 语言的工具。对于配置默认值，避免杂乱的if语句很有帮助。   [![近一周有更新][G]](https://github.com/imdario/mergo)   [![godoc][D]](https://godoc.org/github.com/imdario/mergo)
- [mc](https://github.com/minio/mc) **star:2537** Minio Client 提供了一组工具，用于操作 Amazon S3 兼容云存储和文件系统。   [![近一周有更新][G]](https://github.com/minio/mc)   [![godoc][D]](https://godoc.org/github.com/minio/mc)
- [create-go-app](https://github.com/create-go-app/cli) **star:2184** 一个强大的CLI，用于通过运行一个命令创建一个后端服务(Golang)，前端(JavaScript, TypeScript)和部署自动化(Ansible, Docker)的可生产项目。   [![近一周有更新][G]](https://github.com/create-go-app/cli)   [![godoc][D]](https://godoc.org/github.com/create-go-app/cli)
- [Storm](https://github.com/asdine/storm) **star:2001** 一个简单又强大的用于 BoltDB 的工具   [![godoc][D]](https://godoc.org/github.com/asdine/storm)
- [retry-go](https://github.com/avast/retry-go) **star:1941** Simple library for retry mechanism.   [![godoc][D]](https://godoc.org/github.com/avast/retry-go)
- [EaseProbe](https://github.com/megaease/easeprobe) **star:1902** A simple, standalone, and lightWeight tool that can do health/status checking daemon, support HTTP/TCP/SSH/Shell/Client/... probes, and Slack/Discord/Telegram/SMS... notification.   [![近一周有更新][G]](https://github.com/megaease/easeprobe)   [![godoc][D]](https://godoc.org/github.com/megaease/easeprobe)
- [filetype](https://github.com/h2non/filetype) **star:1897** 通过数字签名来推测文件类型。   [![godoc][D]](https://godoc.org/github.com/h2non/filetype)
- [jump](https://github.com/gsamokovarov/jump) **star:1675** 通过学习你的习惯，可以帮助你更快地导航。   [![godoc][D]](https://godoc.org/github.com/gsamokovarov/jump)
- [mole](https://github.com/davrodpin/mole) **star:1660** cli应用程序可以轻松创建ssh隧道。   [![godoc][D]](https://godoc.org/github.com/davrodpin/mole)
- [boilr](https://github.com/tmrts/boilr) **star:1646** 非常快的CLI工具，用于从样板模板创建项目。   [![godoc][D]](https://godoc.org/github.com/tmrts/boilr)
- [gitbatch](https://github.com/isacikgoz/gitbatch) **star:1511** manage your git repositories in one place.   [![godoc][D]](https://godoc.org/github.com/isacikgoz/gitbatch)
- [mimetype](https://github.com/gabriel-vasile/mimetype) **star:1216** 用于基于神奇数字的MIME类型检测的包。   [![近一周有更新][G]](https://github.com/gabriel-vasile/mimetype)   [![godoc][D]](https://godoc.org/github.com/gabriel-vasile/mimetype)
- [circuitbreaker](https://github.com/rubyist/circuitbreaker) **star:1079** 接通断路器。   [![godoc][D]](https://godoc.org/github.com/rubyist/circuitbreaker)
- [scany](https://github.com/georgysavva/scany) **star:1005** 库扫描数据从数据库到Go structs和更多。   [![godoc][D]](https://godoc.org/github.com/georgysavva/scany)
- [git-time-metric](https://github.com/git-time-metric/gtm) **star:947** git-time-metric - 。   [![godoc][D]](https://godoc.org/github.com/git-time-metric/gtm)
- [hostctl](https://github.com/guumaster/hostctl) **star:934** 一个使用简单命令管理/etc/主机的CLI工具。   [![godoc][D]](https://godoc.org/github.com/guumaster/hostctl)
- [immortal](https://github.com/immortal/immortal) **star:773** \*nix 跨平台 (与操作系统无关的)监控程序。   [![godoc][D]](https://godoc.org/github.com/immortal/immortal)
- [circuit](https://github.com/cep21/circuit) **star:712** 一个高效和功能齐全的 类似 Hystrix Go 实现断路器模式。   [![godoc][D]](https://godoc.org/github.com/cep21/circuit)
- [delve](https://github.com/derekparker/delve) **star:599** Go 语言调试器   [![godoc][D]](https://godoc.org/github.com/derekparker/delve)
- [ergo](https://github.com/cristianoliveira/ergo) **star:583** 管理运行在不同端口上的多个本地服务变得很容易。   [![godoc][D]](https://godoc.org/github.com/cristianoliveira/ergo)
- [htcat](https://github.com/htcat/htcat) **star:550** 并行及流水线的 HTTP GET 工具。   [![近三年未更新][Y]](https://github.com/htcat/htcat)   [![godoc][D]](https://godoc.org/github.com/htcat/htcat)
- [koazee](https://github.com/wesovilabs/koazee) **star:520** 库的灵感来自于延迟计算和函数式编程，从而减少了使用数组的麻烦。   [![godoc][D]](https://godoc.org/github.com/wesovilabs/koazee)
- [clockwork](https://github.com/jonboulle/clockwork) **star:514** 一个简单的假 clock 。   [![godoc][D]](https://godoc.org/github.com/jonboulle/clockwork)
- [changie](https://github.com/miniscruff/changie) **star:507** 自动化的变更日志工具，用于准备带有大量定制选项的版本。   [![近一周有更新][G]](https://github.com/miniscruff/changie)   [![godoc][D]](https://godoc.org/github.com/miniscruff/changie)
- [godaemon](https://github.com/VividCortex/godaemon) **star:492** 用于编写守护进程的工具   [![godoc][D]](https://godoc.org/github.com/VividCortex/godaemon)
- [go-dry](https://github.com/ungerik/go-dry) **star:486** DRY(don't repeat yourself)库。   [![godoc][D]](https://godoc.org/github.com/ungerik/go-dry)
- [gubrak](https://github.com/novalagung/gubrak) **star:450** 带有语法糖的Golang实用工具，就像lodash。   [![godoc][D]](https://godoc.org/github.com/novalagung/gubrak)
- [gopencils](https://github.com/bndr/gopencils) **star:446** 小而简单的包，可以轻松地使用REST api。   [![近三年未更新][Y]](https://github.com/bndr/gopencils)   [![godoc][D]](https://godoc.org/github.com/bndr/gopencils)
- [scan](https://github.com/blockloop/scan) **star:445** 扫描golang的sql。行直接指向结构、片或基本类型。   [![godoc][D]](https://godoc.org/github.com/blockloop/scan)
- [clipboard](https://github.com/golang-design/clipboard) **star:442** 📋跨平台剪贴板包中去。   [![godoc][D]](https://godoc.org/github.com/golang-design/clipboard)
- [request](https://github.com/mozillazg/request) **star:427** Go 语言版的 HTTP Requests for Humans™.。   [![近三年未更新][Y]](https://github.com/mozillazg/request)   [![godoc][D]](https://godoc.org/github.com/mozillazg/request)
- [Deepcopier](https://github.com/ulule/deepcopier) **star:421** 结构体拷贝   [![近三年未更新][Y]](https://github.com/ulule/deepcopier)   [![godoc][D]](https://godoc.org/github.com/ulule/deepcopier)
- [remote-touchpad](https://github.com/Unrud/remote-touchpad) **star:415** Control mouse and keyboard from a smartphone.   [![godoc][D]](https://godoc.org/github.com/Unrud/remote-touchpad)
- [go-rate](https://github.com/beefsack/go-rate) **star:389**  Go 限速器。   [![godoc][D]](https://godoc.org/github.com/beefsack/go-rate)
- [mani](https://github.com/alajmo/mani) **star:385** CLI工具，帮助您管理多个存储库。   [![godoc][D]](https://godoc.org/github.com/alajmo/mani)
- [retry](https://github.com/kamilsk/retry) **star:335** 基于上下文的功能机制，反复执行命令直到成功。   [![godoc][D]](https://godoc.org/github.com/kamilsk/retry)
- [serve](https://github.com/syntaqx/serve) **star:307** 任何您需要的静态http服务器。   [![近一周有更新][G]](https://github.com/syntaqx/serve)   [![godoc][D]](https://godoc.org/github.com/syntaqx/serve)
- [grofer](https://github.com/pesos/grofer) **star:285** 一个用Golang编写的系统和资源监控工具!   [![godoc][D]](https://godoc.org/github.com/pesos/grofer)
- [countries](https://github.com/biter777/countries) **star:278** Full implementation of ISO-3166-1, ISO-4217, ITU-T E.164, Unicode CLDR and IANA ccTLD standards.   [![godoc][D]](https://godoc.org/github.com/biter777/countries)
- [util](https://github.com/shomali11/util) **star:277** 有用实用函数的集合。(字符串，并发，操作，…)   [![godoc][D]](https://godoc.org/github.com/shomali11/util)
- [gotenv](https://github.com/subosito/gotenv) **star:268** 从 `.env` 或者任何 `io.Reader`。   [![godoc][D]](https://godoc.org/github.com/subosito/gotenv)
- [gohper](https://github.com/cosiner/gohper) **star:255** 多种能够帮助你进行软件开发的工具和模块。   [![近三年未更新][Y]](https://github.com/cosiner/gohper)   [![godoc][D]](https://godoc.org/github.com/cosiner/gohper)   [![归档项目][Archived]](https://github.com/cosiner/gohper)
- [wifiqr](https://github.com/reugn/wifiqr) **star:238** Wi-Fi QR Code Generator.   [![godoc][D]](https://godoc.org/github.com/reugn/wifiqr)
- [go-trigger](https://github.com/sadlil/go-trigger) **star:236** Go 语言全局事件触发器，通过 id 和触发器，在程序的任何地方注册事件。   [![近三年未更新][Y]](https://github.com/sadlil/go-trigger)   [![godoc][D]](https://godoc.org/github.com/sadlil/go-trigger)
- [rospo](https://github.com/ferama/rospo) **star:235** 简单可靠的ssh隧道，嵌入式ssh服务器在Golang。   [![近一周有更新][G]](https://github.com/ferama/rospo)   [![godoc][D]](https://godoc.org/github.com/ferama/rospo)
- [pattern-match](https://github.com/alexpantyukhin/go-pattern-match) **star:231** Pattern matching library.   [![godoc][D]](https://godoc.org/github.com/alexpantyukhin/go-pattern-match)
- [go-sitemap-generator](https://github.com/ikeikeikeike/go-sitemap-generator) **star:204** 用Go编写的XML站点地图生成器。   [![godoc][D]](https://godoc.org/github.com/ikeikeikeike/go-sitemap-generator)
- [limiters](https://github.com/mennanov/limiters) **star:197** Golang中的分布式应用程序速率限制器，具有可配置的后端和分布式锁。   [![godoc][D]](https://godoc.org/github.com/mennanov/limiters)
- [toolbox](https://github.com/viant/toolbox) **star:193** 切片, map, multimap, 结构体, 函数,数据转换工具。服务路由，宏求值和标记器。   [![godoc][D]](https://godoc.org/github.com/viant/toolbox)
- [Death](https://github.com/vrecan/death) **star:190** 利用信号管理应用程序的关闭。   [![godoc][D]](https://godoc.org/github.com/vrecan/death)
- [go-bind-plugin](https://github.com/wendigo/go-bind-plugin) **star:183** Go:generate 工具，用于构建 Go 语言插件(1.8 only)，并对导出的符号进行包装。   [![近三年未更新][Y]](https://github.com/wendigo/go-bind-plugin)   [![godoc][D]](https://godoc.org/github.com/wendigo/go-bind-plugin)
- [moldova](https://github.com/StabbyCutyou/moldova) **star:166** 基于输入目标生成随机数据的工具   [![近三年未更新][Y]](https://github.com/StabbyCutyou/moldova)   [![godoc][D]](https://godoc.org/github.com/StabbyCutyou/moldova)
- [rerun](https://github.com/ivpusic/rerun) **star:166** 当源代码发生更改时，重新编译和重新运行go应用程序。   [![近三年未更新][Y]](https://github.com/ivpusic/rerun)   [![godoc][D]](https://godoc.org/github.com/ivpusic/rerun)
- [apm](https://github.com/topfreegames/apm) **star:164** Go 语言进程管理工具具有HTTP API.。   [![近三年未更新][Y]](https://github.com/topfreegames/apm)   [![godoc][D]](https://godoc.org/github.com/topfreegames/apm)
- [robustly](https://github.com/VividCortex/robustly) **star:156** 有弹性的执行函数，遇到错误时捕获并重新运行。   [![godoc][D]](https://godoc.org/github.com/VividCortex/robustly)
- [chyle](https://github.com/antham/chyle) **star:152** 使用具有多种配置可能性的git存储库生成变更日志。   [![godoc][D]](https://godoc.org/github.com/antham/chyle)
- [go-bsdiff](https://github.com/gabstv/go-bsdiff) **star:145** 纯Go bsdiff和bspatch库和CLI工具。   [![近三年未更新][Y]](https://github.com/gabstv/go-bsdiff)   [![godoc][D]](https://godoc.org/github.com/gabstv/go-bsdiff)
- [cmd](https://github.com/SimonBaeumer/cmd) **star:135** 用于在osx、windows和linux上执行shell命令的库。   [![godoc][D]](https://godoc.org/github.com/SimonBaeumer/cmd)
- [nostromo](https://github.com/pokanop/nostromo) **star:135** CLI用于构建强大的别名。   [![godoc][D]](https://godoc.org/github.com/pokanop/nostromo)
- [cryptgo](https://github.com/Gituser143/cryptgo) **star:134** Crytpgo是一个基于TUI的应用程序，纯粹在Go中编写，实时监控和观察加密货币价格!   [![godoc][D]](https://godoc.org/github.com/Gituser143/cryptgo)
- [filter](https://github.com/gookit/filter) **star:133** 提供Go数据的过滤、清理和转换。   [![近一周有更新][G]](https://github.com/gookit/filter)   [![godoc][D]](https://godoc.org/github.com/gookit/filter)
- [onecache](https://github.com/adelowo/onecache) **star:133** 支持多个后端存储(Redis、Memcached、文件系统等)的缓存库。   [![近三年未更新][Y]](https://github.com/adelowo/onecache)   [![godoc][D]](https://godoc.org/github.com/adelowo/onecache)
- [goval](https://github.com/maja42/goval) **star:129** 在Go中计算任意表达式。   [![godoc][D]](https://godoc.org/github.com/maja42/goval)
- [lrserver](https://github.com/jaschaephraim/lrserver) **star:124** LiveReload 服务器。   [![godoc][D]](https://godoc.org/github.com/jaschaephraim/lrserver)
- [mongo-go-pagination](https://github.com/gobeam/mongo-go-pagination) **star:123** Mongodb Pagination for official mongodb/mongo-go-driver package which supports both normal queries and Aggregation pipelines.   [![godoc][D]](https://godoc.org/github.com/gobeam/mongo-go-pagination)
- [sorty](https://github.com/jfcg/sorty) **star:122** 快速并发/并行排序。   [![godoc][D]](https://godoc.org/github.com/jfcg/sorty)
- [goseaweedfs](https://github.com/linxGnu/goseaweedfs) **star:107** conseilSeaweedFS 客户端，几乎具有全部的特性。   [![godoc][D]](https://godoc.org/github.com/linxGnu/goseaweedfs)
- [mssqlx](https://github.com/linxGnu/mssqlx) **star:101** 数据库客户端，用于主-从 (或主-主) 数据库，集成了简单的、轻量级的轮询调度负载均衡。   [![godoc][D]](https://godoc.org/github.com/linxGnu/mssqlx)
- [go-lock](https://github.com/viney-shih/go-lock) **star:99** go-lock是一个锁库，它实现了读写互斥锁和读写尝试锁，而不需要等待。   [![godoc][D]](https://godoc.org/github.com/viney-shih/go-lock)
- [xferspdy](https://github.com/monmohan/xferspdy) **star:98** Xferspdy在golang中提供二进制diff和补丁库。   [![godoc][D]](https://godoc.org/github.com/monmohan/xferspdy)
- [go-health](https://github.com/Talento90/go-health) **star:93** 健康包简化了向服务中添加健康检查的方式。   [![godoc][D]](https://godoc.org/github.com/Talento90/go-health)
- [mimemagic](https://github.com/zRedShift/mimemagic) **star:89** 纯粹 Go 超性能MIME嗅探库/实用程序。   [![godoc][D]](https://godoc.org/github.com/zRedShift/mimemagic)
- [pgo](https://github.com/arthurkushman/pgo) **star:82** 用于PHP社区的 Convenient 函数。   [![godoc][D]](https://godoc.org/github.com/arthurkushman/pgo)
- [repeat](https://github.com/ssgreg/repeat) **star:81** 执行不同的后 backoff 策略，这对重新尝试操作和心跳非常有用。   [![近三年未更新][Y]](https://github.com/ssgreg/repeat)   [![godoc][D]](https://godoc.org/github.com/ssgreg/repeat)
- [countries](https://github.com/pioz/countries) **star:80** All you need when you are working with countries in Go.   [![godoc][D]](https://godoc.org/github.com/pioz/countries)
- [pm](https://github.com/VividCortex/pm) **star:78** 进程(即goroutine)管理器与HTTP API。   [![godoc][D]](https://godoc.org/github.com/VividCortex/pm)
- [go-pattern-match](https://github.com/PhakornKiong/go-pattern-match) **star:77** A Pattern matching library inspired by ts-pattern.   [![godoc][D]](https://godoc.org/github.com/PhakornKiong/go-pattern-match)
- [handy](https://github.com/miguelpragier/handy) **star:74** 许多实用程序和帮助程序，如字符串处理程序/格式化程序和验证器。   [![godoc][D]](https://godoc.org/github.com/miguelpragier/handy)
- [netbug](https://github.com/e-dard/netbug) **star:72** 远程对你的服务进行性能分析   [![近三年未更新][Y]](https://github.com/e-dard/netbug)   [![godoc][D]](https://godoc.org/github.com/e-dard/netbug)
- [UNIS](https://github.com/esemplastic/unis) **star:70** Go 语言字符串处理函数的通用架构 。   [![近三年未更新][Y]](https://github.com/esemplastic/unis)   [![godoc][D]](https://godoc.org/github.com/esemplastic/unis)
- [goreadability](https://github.com/philipjkim/goreadability) **star:67** 网页摘要提取器使用Facebook开放图形和arc90的可读性。   [![近三年未更新][Y]](https://github.com/philipjkim/goreadability)   [![godoc][D]](https://godoc.org/github.com/philipjkim/goreadability)
- [multitick](https://github.com/VividCortex/multitick) **star:67** 用于 aligned tickers 的多路复用   [![godoc][D]](https://godoc.org/github.com/VividCortex/multitick)
- [retry](https://github.com/thedevsaddam/retry) **star:63** 简单易用的重试机制包，为 Go 。   [![godoc][D]](https://godoc.org/github.com/thedevsaddam/retry)
- [minquery](https://github.com/icza/minquery) **star:61** MongoDB / mgo.v2, 支持高效分页查询(用于继续列出我们停止的文档的游标)。   [![godoc][D]](https://godoc.org/github.com/icza/minquery)
- [go-astitodo](https://github.com/asticode/go-astitodo) **star:60** 解析你 Go 语言代码中的 TODOs（待办事项）。   [![godoc][D]](https://godoc.org/github.com/asticode/go-astitodo)
- [golog](https://github.com/mlimaloureiro/golog) **star:60** 简单、轻量级的命令后工具，用于对你的计划任务进行跟踪。   [![近三年未更新][Y]](https://github.com/mlimaloureiro/golog)   [![godoc][D]](https://godoc.org/github.com/mlimaloureiro/golog)
- [dbt](https://github.com/nikogura/dbt) **star:57** 用于从中心可信存储库运行自更新签名二进制文件的框架。   [![godoc][D]](https://godoc.org/github.com/nikogura/dbt)
- [beyond](https://github.com/wesovilabs/beyond) **star:54** Go工具将带你进入AOP的世界!   [![godoc][D]](https://godoc.org/github.com/wesovilabs/beyond)
- [scan](https://github.com/wroge/scan) **star:52** Scan sql rows into any type powered by generics.   [![godoc][D]](https://godoc.org/github.com/wroge/scan)
- [shutdown](https://github.com/ztrue/shutdown) **star:52** ' os的应用程序关闭挂钩。信号的处理。   [![godoc][D]](https://godoc.org/github.com/ztrue/shutdown)
- [slice](https://github.com/psampaz/slice) **star:51** 用于普通Go切片操作的类型安全函数。   [![近三年未更新][Y]](https://github.com/psampaz/slice)   [![godoc][D]](https://godoc.org/github.com/psampaz/slice)
- [copy-pasta](https://github.com/jutkko/copy-pasta) **star:50** 通用多工作站剪切板，使用类似 S3 的后端作为存储。   [![近三年未更新][Y]](https://github.com/jutkko/copy-pasta)   [![godoc][D]](https://godoc.org/github.com/jutkko/copy-pasta)
- [golarm](https://github.com/msempere/golarm) **star:50** 告警（支持系统事件）。   [![近三年未更新][Y]](https://github.com/msempere/golarm)   [![godoc][D]](https://godoc.org/github.com/msempere/golarm)
- [backscanner](https://github.com/icza/backscanner) **star:49** 类似 bufio 的扫描器，但它以相反的顺序读取和返回行，从给定的位置开始，然后返回。   [![godoc][D]](https://godoc.org/github.com/icza/backscanner)
- [goback](https://github.com/carlescere/goback) **star:48**  一个 Go 语言的简单的指数补偿包。   [![godoc][D]](https://godoc.org/github.com/carlescere/goback)
- [retry-go](https://github.com/rafaeljesus/retry-go) **star:48** 对 Go 来说，重试变得简单而容易。   [![近三年未更新][Y]](https://github.com/rafaeljesus/retry-go)   [![godoc][D]](https://godoc.org/github.com/rafaeljesus/retry-go)
- [intrinsic](https://github.com/mengzhuo/intrinsic) **star:46** 不需要编写任何汇编代码就能使用 x86 SIMD。   [![近三年未更新][Y]](https://github.com/mengzhuo/intrinsic)   [![godoc][D]](https://godoc.org/github.com/mengzhuo/intrinsic)   [![归档项目][Archived]](https://github.com/mengzhuo/intrinsic)
- [set](https://github.com/nofeaturesonlybugs/set) **star:45** 性能和灵活的结构映射和松散的类型转换。   [![godoc][D]](https://godoc.org/github.com/nofeaturesonlybugs/set)
- [sshman](https://github.com/shoobyban/sshman) **star:44** 用于多个远程服务器上的authorized_keys文件的SSH管理器。   [![godoc][D]](https://godoc.org/github.com/shoobyban/sshman)
- [equalizer](https://github.com/reugn/equalizer) **star:43** 用Go实现的限流工具   [![godoc][D]](https://godoc.org/github.com/reugn/equalizer)
- [go-httpheader](https://github.com/mozillazg/go-httpheader) **star:43**  用于将结构体编码进 http 头的 Go 语言库   [![godoc][D]](https://godoc.org/github.com/mozillazg/go-httpheader)
- [slicer](https://github.com/leaanthony/slicer) **star:43** 使处理切片更容易。   [![godoc][D]](https://godoc.org/github.com/leaanthony/slicer)
- [gostrutils](https://github.com/ik5/gostrutils) **star:41** 字符串操作和转换函数的集合。   [![godoc][D]](https://godoc.org/github.com/ik5/gostrutils)
- [gpath](https://github.com/tenntenn/gpath) **star:40**  用于简化结构体域访问的库。   [![近三年未更新][Y]](https://github.com/tenntenn/gpath)   [![godoc][D]](https://godoc.org/github.com/tenntenn/gpath)
- [cvt](https://github.com/shockerli/cvt) **star:39** 简单而安全的将任何值转换为另一种类型。   [![godoc][D]](https://godoc.org/github.com/shockerli/cvt)   [![包含中文文档][CN]](https://github.com/shockerli/cvt)
- [pointer](https://github.com/xorcare/pointer) **star:38** 包指针包含帮助程序，用于简化基本类型可选字段的创建。   [![godoc][D]](https://godoc.org/github.com/xorcare/pointer)
- [evaluator](https://github.com/nullne/evaluator) **star:37** Evaluate an expression dynamically based on s-expression. It's simple and easy to extend.   [![godoc][D]](https://godoc.org/github.com/nullne/evaluator)
- [copy](https://github.com/gotidy/copy) **star:35** 包快速复制不同类型的struct。   [![godoc][D]](https://godoc.org/github.com/gotidy/copy)
- [ghokin](https://github.com/antham/ghokin) **star:35** 没有外部依赖的gherkin (cucumber, behat…)并行格式化程序。   [![godoc][D]](https://godoc.org/github.com/antham/ghokin)
- [myhttp](https://github.com/inancgumus/myhttp) **star:35** 简单的API，使HTTP GET请求与超时支持。   [![近三年未更新][Y]](https://github.com/inancgumus/myhttp)   [![godoc][D]](https://godoc.org/github.com/inancgumus/myhttp)   [![归档项目][Archived]](https://github.com/inancgumus/myhttp)
- [rclient](https://github.com/zpatrick/rclient) **star:35** 可读、灵活、易于使用的REST api客户端。   [![近三年未更新][Y]](https://github.com/zpatrick/rclient)   [![godoc][D]](https://godoc.org/github.com/zpatrick/rclient)
- [tome](https://github.com/cyruzin/tome) **star:34** Tome设计用于对简单的RESTful api进行分页。   [![godoc][D]](https://godoc.org/github.com/cyruzin/tome)
- [throttle](https://github.com/yudppp/throttle) **star:33** Throttle是一个在每个持续时间内只执行一个动作的对象。   [![godoc][D]](https://godoc.org/github.com/yudppp/throttle)
- [yogo](https://github.com/antham/yogo) **star:33** Check yopmail mails from command line.
- [generate](https://github.com/go-playground/generate) **star:29** 针对一个路径或环境变量，递归的执行 Go generate，可以通过正则表达式来进行过滤。   [![近三年未更新][Y]](https://github.com/go-playground/generate)   [![godoc][D]](https://godoc.org/github.com/go-playground/generate)
- [mimesniffer](https://github.com/aofei/mimesniffer) **star:28** 一个用于Go的MIME类型嗅探器。   [![godoc][D]](https://godoc.org/github.com/aofei/mimesniffer)
- [ugo](https://github.com/alxrm/ugo) **star:27** uGo 是一个切片工具箱，有着和 Go 语言一致的语法法。   [![近三年未更新][Y]](https://github.com/alxrm/ugo)   [![godoc][D]](https://godoc.org/github.com/alxrm/ugo)   [![归档项目][Archived]](https://github.com/alxrm/ugo)
- [goplaceholder](https://github.com/michiwend/goplaceholder) **star:26** 一个小巧的 Go 语言库用于生成占位图片。   [![近三年未更新][Y]](https://github.com/michiwend/goplaceholder)   [![godoc][D]](https://godoc.org/github.com/michiwend/goplaceholder)
- [gofn](https://github.com/tiendc/gofn) **star:25** High performance utitlity functions written using Generics for Go 1.18+.   [![近一周有更新][G]](https://github.com/tiendc/gofn)   [![godoc][D]](https://godoc.org/github.com/tiendc/gofn)
- [graterm](https://github.com/skovtunenko/graterm) **star:25** Provides primitives to perform ordered (sequential/concurrent) GRAceful TERMination (aka shutdown) in Go application.   [![godoc][D]](https://godoc.org/github.com/skovtunenko/graterm)
- [watchhttp](https://github.com/nikolaydubina/watchhttp) **star:25** Run command periodically and expose latest STDOUT or its rich delta as HTTP endpoint.   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/watchhttp)
- [ctxutil](https://github.com/posener/ctxutil) **star:23** 上下文工具。   [![近三年未更新][Y]](https://github.com/posener/ctxutil)   [![godoc][D]](https://godoc.org/github.com/posener/ctxutil)
- [ptr](https://github.com/gotidy/ptr) **star:22** 提供函数的包，用于从基本类型的常量简化指针的创建。   [![godoc][D]](https://godoc.org/github.com/gotidy/ptr)
- [structs](https://github.com/PumpkinSeed/structs) **star:22** 简单来讲就是 "Make" 的替代品。   [![近三年未更新][Y]](https://github.com/PumpkinSeed/structs)   [![godoc][D]](https://godoc.org/github.com/PumpkinSeed/structs)
- [go-convert](https://github.com/Eun/go-convert) **star:20** 包go-convert使您能够将一个值转换为另一种类型。   [![godoc][D]](https://godoc.org/github.com/Eun/go-convert)
- [jsend](https://github.com/clevergo/jsend) **star:19** JSend's implementation written in Go.   [![godoc][D]](https://godoc.org/github.com/clevergo/jsend)
- [just](https://github.com/kazhuravlev/just) **star:19** Just a collection of useful functions for working with generic data structures.   [![godoc][D]](https://godoc.org/github.com/kazhuravlev/just)
- [contextplus](https://github.com/contextplus/contextplus) **star:17** Package contextplus provide more easy to use functions for contexts.   [![godoc][D]](https://godoc.org/github.com/contextplus/contextplus)
- [dlog](https://github.com/kirillDanshin/dlog) **star:17** 编译时控制的日志，让你的 release 包变得更小而不需移除 debug 调用。   [![近三年未更新][Y]](https://github.com/kirillDanshin/dlog)   [![godoc][D]](https://godoc.org/github.com/kirillDanshin/dlog)
- [filler](https://github.com/yaronsumel/filler) **star:17** 使用“fill”标签填充结构的小工具。   [![近三年未更新][Y]](https://github.com/yaronsumel/filler)   [![godoc][D]](https://godoc.org/github.com/yaronsumel/filler)
- [go-problemdetails](https://github.com/mvmaasakkers/go-problemdetails) **star:16** 打包处理问题细节。   [![近三年未更新][Y]](https://github.com/mvmaasakkers/go-problemdetails)   [![godoc][D]](https://godoc.org/github.com/mvmaasakkers/go-problemdetails)
- [go-type](https://github.com/mikekonan/go-types) **star:16** 为ISO-4217、ISO-3166和其他类型的存储/验证和传输提供Go类型的库。   [![godoc][D]](https://godoc.org/github.com/mikekonan/go-types)
- [okrun](https://github.com/xta/okrun) **star:16**  Go 运行错误 steamroller。   [![近三年未更新][Y]](https://github.com/xta/okrun)   [![godoc][D]](https://godoc.org/github.com/xta/okrun)
- [rest-go](https://github.com/edermanoel94/rest-go) **star:16** 一个包，它为使用rest api提供了许多有用的方法。   [![近三年未更新][Y]](https://github.com/edermanoel94/rest-go)   [![godoc][D]](https://godoc.org/github.com/edermanoel94/rest-go)
- [command](https://github.com/txgruppi/command) **star:14** 命令模式，支持线程安全的串行、并行调度。   [![近三年未更新][Y]](https://github.com/txgruppi/command)   [![godoc][D]](https://godoc.org/github.com/txgruppi/command)
- [go-actuator](https://github.com/sinhashubham95/go-actuator) **star:14** 基于Go的web框架的生产就绪特性。   [![godoc][D]](https://godoc.org/github.com/sinhashubham95/go-actuator)
- [silk](https://github.com/chrispassas/silk) **star:13** 阅读silk netflow文件。   [![godoc][D]](https://godoc.org/github.com/chrispassas/silk)
- [go-clip](https://github.com/prashantgupta24/go-clip) **star:12** Mac的一个极简的剪贴板管理器。   [![godoc][D]](https://godoc.org/github.com/prashantgupta24/go-clip)
- [retry](https://github.com/shafreeck/retry) **star:11** 一个相当简单的库，以确保您的工作可以完成。   [![近三年未更新][Y]](https://github.com/shafreeck/retry)   [![godoc][D]](https://godoc.org/github.com/shafreeck/retry)
- [blank](https://github.com/Henry-Sarabia/blank) **star:10** 验证或删除字符串中的空白。   [![近三年未更新][Y]](https://github.com/Henry-Sarabia/blank)   [![godoc][D]](https://godoc.org/github.com/Henry-Sarabia/blank)
- [go-countries](https://github.com/mikekonan/go-countries) **star:10** 对ISO-3166代码的轻量级查找。   [![godoc][D]](https://godoc.org/github.com/mikekonan/go-countries)
- [statiks](https://github.com/janiltonmaciel/statiks) **star:10** 快速，零配置，静态HTTP文件服务器。   [![godoc][D]](https://godoc.org/github.com/janiltonmaciel/statiks)
- [bleep](https://github.com/sinhashubham95/bleep) **star:9** 在Go中对任意一组OS信号执行任意数量的操作。   [![godoc][D]](https://godoc.org/github.com/sinhashubham95/bleep)
- [retry](https://github.com/percolate/retry) **star:9** 一个简单但高度可配置的Go重试包。
- [nfdump](https://github.com/chrispassas/nfdump) **star:8** 读取nfdump netflow文件。   [![godoc][D]](https://godoc.org/github.com/chrispassas/nfdump)
- [sliceconv](https://github.com/Henry-Sarabia/sliceconv) **star:8** 基本类型之间的片转换。   [![近三年未更新][Y]](https://github.com/Henry-Sarabia/sliceconv)   [![godoc][D]](https://godoc.org/github.com/Henry-Sarabia/sliceconv)
- [loncha](https://github.com/kazu/loncha) **star:7** A high-performance slice Utilities.   [![godoc][D]](https://godoc.org/github.com/kazu/loncha)
- [go-pkg](https://github.com/chenquan/go-pkg) **star:6** 一个工具包。   [![godoc][D]](https://godoc.org/github.com/chenquan/go-pkg)   [![包含中文文档][CN]](https://github.com/chenquan/go-pkg)
- [lets-go](https://github.com/aplescia-chwy/lets-go) **star:6** Go模块，为云本地REST API开发提供公共工具。还包含AWS特定的实用程序。   [![godoc][D]](https://godoc.org/github.com/aplescia-chwy/lets-go)
- [reflectutils](https://github.com/muir/reflectutils) **star:6** 处理反射的助手:结构标记解析;递归行走;从字符串填充值。   [![godoc][D]](https://godoc.org/github.com/muir/reflectutils)
- [olaf](https://github.com/btnguyen2k/olaf) **star:5** Twitter Snowflake 在Go中实现。   [![近三年未更新][Y]](https://github.com/btnguyen2k/olaf)   [![godoc][D]](https://godoc.org/github.com/btnguyen2k/olaf)
- [tik](https://github.com/andy2046/tik) **star:5** 简单和容易的时间轮包去。   [![godoc][D]](https://godoc.org/github.com/andy2046/tik)
- [goctx](https://github.com/zerosnake0/goctx) **star:4** 获得高性能的上下文值。   [![godoc][D]](https://godoc.org/github.com/zerosnake0/goctx)
- [go-qr](https://github.com/piglig/go-qr) **star:3** A native, high-quality and minimalistic QR code generator.   [![近一周有更新][G]](https://github.com/piglig/go-qr)   [![godoc][D]](https://godoc.org/github.com/piglig/go-qr)
- [objwalker](https://github.com/rekby/objwalker) **star:2** 走过带有反射的物体。   [![godoc][D]](https://godoc.org/github.com/rekby/objwalker)

**[⬆ back to top](#contents)**

## UUID

_用于处理uuid的库。 (翻译出错了? 试试 [英文版](README_EN.md#uuid) 吧~)_

- [uuid](https://github.com/google/uuid) **star:4590** 基于RFC 4122和DCE 1.1的uuid包:身份验证和安全服务。   [![godoc][D]](https://godoc.org/github.com/google/uuid)
- [ulid](https://github.com/oklog/ulid) **star:3702** 实现了ULID(普遍唯一的词典分类标识符)。   [![近一周有更新][G]](https://github.com/oklog/ulid)   [![godoc][D]](https://godoc.org/github.com/oklog/ulid)
- [uniq](https://gitlab.com/skilstak/code/go/uniq)  没有麻烦，安全，快速的唯一标识符与命令。
- [xid](https://github.com/rs/xid) **star:3498** Xid是一个全局唯一id生成器库，可以直接在服务器代码中安全地使用。   [![godoc][D]](https://godoc.org/github.com/rs/xid)
- [uuid](https://github.com/gofrs/uuid) **star:1414** 通用唯一标识符(UUID)的实现。支持uuid的创建和解析。积极维护satori uuid的fork。   [![近一周有更新][G]](https://github.com/gofrs/uuid)   [![godoc][D]](https://godoc.org/github.com/gofrs/uuid)
- [wuid](https://github.com/edwingeng/wuid) **star:501** An extremely fast globally unique number generator.   [![godoc][D]](https://godoc.org/github.com/edwingeng/wuid)
- [sno](https://github.com/muyo/sno) **star:87** 使用嵌入元数据的紧凑、可排序和快速的惟一id。   [![godoc][D]](https://godoc.org/github.com/muyo/sno)
- [nanoid](https://github.com/aidarkhanov/nanoid) **star:58** 一个小而有效的Go唯一字符串ID生成器。   [![godoc][D]](https://godoc.org/github.com/aidarkhanov/nanoid)   [![归档项目][Archived]](https://github.com/aidarkhanov/nanoid)
- [goid](https://github.com/jakehl/goid) **star:38** 生成和解析RFC4122兼容的V4 uuid。   [![近三年未更新][Y]](https://github.com/jakehl/goid)   [![godoc][D]](https://godoc.org/github.com/jakehl/goid)
- [gouid](https://github.com/twharmon/gouid) **star:21** 生成加密安全的随机字符串id，只有一个分配。   [![godoc][D]](https://godoc.org/github.com/twharmon/gouid)
- [uuid](https://github.com/agext/uuid) **star:16** 使用快速或加密质量的随机节点标识符生成、编码和解码UUIDs v1。   [![近三年未更新][Y]](https://github.com/agext/uuid)   [![godoc][D]](https://godoc.org/github.com/agext/uuid)

**[⬆ back to top](#contents)**

## 验证

_库进行验证。 (翻译出错了? 试试 [英文版](README_EN.md#validation) 吧~)_

- [validator](https://github.com/go-playground/validator) **star:13976**  Go 结构体及域验证，包括：跨域、跨结构体, Map, 切片和数组。   [![近一周有更新][G]](https://github.com/go-playground/validator)   [![godoc][D]](https://godoc.org/github.com/go-playground/validator)
- [govalidator](https://github.com/asaskevich/govalidator) **star:5781** 用于字符串，数字，切片和结构的验证器和sanitizers。   [![godoc][D]](https://godoc.org/github.com/asaskevich/govalidator)
- [ozzo-validation](https://github.com/go-ozzo/ozzo-validation) **star:3331** 支持各种数据类型(结构、字符串、映射、片等)的验证，使用可配置和可扩展的验证规则，这些规则在通常的代码构造中指定，而不是在结构标签中指定。   [![godoc][D]](https://godoc.org/github.com/go-ozzo/ozzo-validation)
- [govalidator](https://github.com/thedevsaddam/govalidator) **star:1239** 用简单的规则验证Golang请求数据。深受Laravel请求验证的启发。   [![godoc][D]](https://godoc.org/github.com/thedevsaddam/govalidator)
- [validate](https://github.com/gookit/validate) **star:943**  Go 封装数据验证和过滤。支持验证映射、结构、请求(表单、JSON、url)。值，上载文件)数据和更多特性。   [![近一周有更新][G]](https://github.com/gookit/validate)   [![godoc][D]](https://godoc.org/github.com/gookit/validate)   [![包含中文文档][CN]](https://github.com/gookit/validate)
- [checkdigit](https://github.com/osamingo/checkdigit) **star:101** 提供校验数字算法(Luhn, Verhoeff, Damm)和计算器(ISBN, EAN, JAN, UPC等)。   [![godoc][D]](https://godoc.org/github.com/osamingo/checkdigit)
- [validate](https://github.com/gobuffalo/validate) **star:89** 这个包提供了一个框架，用于为Go应用程序编写验证。   [![godoc][D]](https://godoc.org/github.com/gobuffalo/validate)
- [jio](https://github.com/faceair/jio) **star:87** jio是一个json模式验证器，类似于[joi](https://github.com/hapijs/joi)。   [![近三年未更新][Y]](https://github.com/faceair/jio)   [![godoc][D]](https://godoc.org/github.com/faceair/jio)   [![包含中文文档][CN]](https://github.com/faceair/jio)
- [gody](https://github.com/guiferpa/gody) **star:63** :一个轻量级的结构验证器。   [![godoc][D]](https://godoc.org/github.com/guiferpa/gody)
- [govalid](https://github.com/twharmon/govalid) **star:34** 快速、基于标签的结构验证。   [![godoc][D]](https://godoc.org/github.com/twharmon/govalid)
- [Validator](https://github.com/go-the-way/validator) **star:6** 一个用Go编写的轻量级模型验证器。包含VFs:Min、Max、MinLength、MaxLength、Length、Enum、Regex。   [![godoc][D]](https://godoc.org/github.com/go-the-way/validator)
- [valix](https://github.com/marrow16/valix) Go package for validating requests

**[⬆ back to top](#contents)**

## 版本控制

_用于版本控制的库。 (翻译出错了? 试试 [英文版](README_EN.md#version-control) 吧~)_

- [go-git](https://github.com/go-git/go-git) **star:4918** 纯Go中高度可扩展的Git实现。   [![近一周有更新][G]](https://github.com/go-git/go-git)   [![godoc][D]](https://godoc.org/github.com/go-git/go-git)
- [hercules](https://github.com/src-d/hercules) **star:1916** 从Git存储库历史中获得高级见解。   [![godoc][D]](https://godoc.org/github.com/src-d/hercules)
- [git2go](https://github.com/libgit2/git2go) **star:1868**  libgit2 的 Go 语言接口。   [![godoc][D]](https://godoc.org/github.com/libgit2/git2go)
- [gh](https://github.com/rjeczalik/gh) **star:80** 用于GitHub webhook的可编写脚本的服务器和net/http中间件。   [![近三年未更新][Y]](https://github.com/rjeczalik/gh)   [![godoc][D]](https://godoc.org/github.com/rjeczalik/gh)
- [githooks](https://github.com/gabyx/githooks) **star:77** 每回购和共享Git挂钩版本控制和自动更新。   [![godoc][D]](https://godoc.org/github.com/gabyx/githooks)
- [go-vcs](https://github.com/sourcegraph/go-vcs) **star:75** 在Go中操作和检查VCS存储库。   [![godoc][D]](https://godoc.org/github.com/sourcegraph/go-vcs)
- [froggit-go](https://github.com/jfrog/froggit-go) **star:39** Froggit-Go是一个Go库，允许在VCS提供商上执行操作。   [![近一周有更新][G]](https://github.com/jfrog/froggit-go)   [![godoc][D]](https://godoc.org/github.com/jfrog/froggit-go)
- [hgo](https://github.com/beyang/hgo) **star:15** Hgo是一组Go包的集合，提供对本地Mercurial存储库的读取访问。   [![近三年未更新][Y]](https://github.com/beyang/hgo)   [![godoc][D]](https://godoc.org/github.com/beyang/hgo)
- [cli](https://gitlab.com/gitlab-org/cli)  一个开源的GitLab命令行工具，将GitLab的酷特性带到您的命令行。

**[⬆ back to top](#contents)**

## 视频

_用于操作视频的库。 (翻译出错了? 试试 [英文版](README_EN.md#video) 吧~)_

- [goav](https://github.com/giorgisio/goav) **star:2017** FFmpeg的全面Go绑定。   [![godoc][D]](https://godoc.org/github.com/giorgisio/goav)
- [m3u8](https://github.com/grafov/m3u8) **star:1070** 苹果HLS的M3U8播放列表解析器和生成器库。   [![godoc][D]](https://godoc.org/github.com/grafov/m3u8)
- [gmf](https://github.com/3d0c/gmf) **star:856**  FFmpeg av\* 库的 Go 语言接口。   [![godoc][D]](https://godoc.org/github.com/3d0c/gmf)
- [go-astisub](https://github.com/asticode/go-astisub) **star:499** 使用 Go 语言操作字幕(.srt, .stl, .ttml, .webvtt, .ssa/.ass, teletext, .smi, etc.)。   [![godoc][D]](https://godoc.org/github.com/asticode/go-astisub)
- [go-astits](https://github.com/asticode/go-astits) **star:498** 在GO中解析和演示MPEG传输流(.ts)。   [![godoc][D]](https://godoc.org/github.com/asticode/go-astits)
- [gortsplib](https://github.com/aler9/gortsplib) **star:485** 纯Go RTSP服务器和客户端库。   [![近一周有更新][G]](https://github.com/aler9/gortsplib)   [![godoc][D]](https://godoc.org/github.com/aler9/gortsplib)
- [libvlc-go](https://github.com/adrg/libvlc-go) **star:366** Go绑定libvlc 2.X/3.X/4。X(由VLC媒体播放器使用)。   [![近一周有更新][G]](https://github.com/adrg/libvlc-go)   [![godoc][D]](https://godoc.org/github.com/adrg/libvlc-go)
- [gst](https://github.com/ziutek/gst) **star:168**  GStreamer的Go工具。   [![godoc][D]](https://godoc.org/github.com/ziutek/gst)
- [v4l](https://github.com/korandiz/v4l) **star:76** 用于Linux的视频捕捉库，用Go编写。   [![godoc][D]](https://godoc.org/github.com/korandiz/v4l)
- [libgosubs](https://github.com/wargarblgarbl/libgosubs) **star:24** 字幕格式支持 .srt、.ttml和.ass。   [![近三年未更新][Y]](https://github.com/wargarblgarbl/libgosubs)   [![godoc][D]](https://godoc.org/github.com/wargarblgarbl/libgosubs)
- [go-m3u8](https://github.com/etherlabsio/go-m3u8) **star:19** Parser and generator library for Apple m3u8 playlists. Actively maintained version of quangngotan95/go-m3u8 with improvements and latest HLS playlist parsing compatibility.   [![godoc][D]](https://godoc.org/github.com/etherlabsio/go-m3u8)
- [go-mpd](https://github.com/unki2aut/go-mpd) **star:17** MPEG-DASH清单文件的解析器和生成器库。   [![近三年未更新][Y]](https://github.com/unki2aut/go-mpd)   [![godoc][D]](https://godoc.org/github.com/unki2aut/go-mpd)

**[⬆ back to top](#contents)**

## Web框架

_全栈 web 框架。 (翻译出错了? 试试 [英文版](README_EN.md#web-frameworks) 吧~)_

- [Gin](https://github.com/gin-gonic/gin) **star:71448** Gin是一个用Go编写的web框架!它具有一个类似于martini的API，性能更好，速度快40倍。   [![近一周有更新][G]](https://github.com/gin-gonic/gin)   [![godoc][D]](https://godoc.org/github.com/gin-gonic/gin)
- [Beego](https://github.com/beego/beego) **star:30189** beego是一种用于 Go 编程语言的开源高性能web框架。   [![近一周有更新][G]](https://github.com/beego/beego)   [![godoc][D]](https://godoc.org/github.com/beego/beego)
- [Buffalo](https://gobuffalo.io)  为 Go 语言带来堪比 Rails 的高生产效率!
- [Confetti Framework](https://confetti-framework.github.io/docs/)  Confetti is a Go web application framework with an expressive, elegant syntax. Confetti combines the elegance of Laravel and the simplicity of Go.
- [Fiber](https://github.com/gofiber/fiber) **star:28306** 一个灵感来自Express.js的web框架构建在Fasthttp上。   [![近一周有更新][G]](https://github.com/gofiber/fiber)   [![godoc][D]](https://godoc.org/github.com/gofiber/fiber)
- [Echo](https://github.com/labstack/echo) **star:26584** 高性能、极简的Go web框架。   [![近一周有更新][G]](https://github.com/labstack/echo)   [![godoc][D]](https://godoc.org/github.com/labstack/echo)
- [Revel](https://github.com/revel/revel) **star:12970** 用于Go语言的高效web框架。   [![godoc][D]](https://godoc.org/github.com/revel/revel)
- [GoFrame](https://github.com/gogf/gf) **star:10008** GoFrame is a modular, full-featured and production-ready application development framework of golang.   [![近一周有更新][G]](https://github.com/gogf/gf)   [![godoc][D]](https://godoc.org/github.com/gogf/gf)
- [Goa](https://github.com/goadesign/goa) **star:5278** Goa为在Go中开发远程api和微服务提供了一种全面的方法。   [![近一周有更新][G]](https://github.com/goadesign/goa)   [![godoc][D]](https://godoc.org/github.com/goadesign/goa)
- [Hertz](https://github.com/cloudwego/hertz) **star:4152** A high-performance and strong-extensibility Go HTTP framework that helps developers build microservices.   [![近一周有更新][G]](https://github.com/cloudwego/hertz)   [![godoc][D]](https://godoc.org/github.com/cloudwego/hertz)   [![包含中文文档][CN]](https://github.com/cloudwego/hertz)
- [Gizmo](https://github.com/NYTimes/gizmo) **star:3729** 《纽约时报》使用的微服务工具包。   [![godoc][D]](https://godoc.org/github.com/NYTimes/gizmo)
- [go-json-rest](https://github.com/ant0ine/go-json-rest) **star:3510** 设置RESTful JSON API的快速简便方法。   [![godoc][D]](https://godoc.org/github.com/ant0ine/go-json-rest)
- [Macaron](https://github.com/go-macaron/macaron) **star:3422** Macaron 是一个高效的模块化设计的web框架   [![近一周有更新][G]](https://github.com/go-macaron/macaron)   [![godoc][D]](https://godoc.org/github.com/go-macaron/macaron)
- [utron](https://github.com/gernest/utron) **star:2224** Go(Golang)的轻量级MVC框架。   [![近三年未更新][Y]](https://github.com/gernest/utron)   [![godoc][D]](https://godoc.org/github.com/gernest/utron)   [![归档项目][Archived]](https://github.com/gernest/utron)
- [Goyave](https://github.com/go-goyave/goyave) **star:1326** 功能完备的REST API框架，旨在干净的代码和快速的开发，具有强大的内置功能。   [![近一周有更新][G]](https://github.com/go-goyave/goyave)   [![godoc][D]](https://godoc.org/github.com/go-goyave/goyave)
- [REST Layer](https://github.com/rs/rest-layer) **star:1225** 框架，用于在数据库之上构建REST/GraphQL API，主要是通过代码进行配置。   [![godoc][D]](https://godoc.org/github.com/rs/rest-layer)
- [Atreugo](https://github.com/savsgio/atreugo) **star:1115** High performance and extensible micro web framework with zero memory allocations in hot paths.   [![godoc][D]](https://godoc.org/github.com/savsgio/atreugo)
- [tigertonic](https://github.com/rcrowley/go-tigertonic) **star:996** 用于构建 JSON web 服务的 Go 语言框架，受到 Dropwizard 的启发。   [![近三年未更新][Y]](https://github.com/rcrowley/go-tigertonic)   [![godoc][D]](https://godoc.org/github.com/rcrowley/go-tigertonic)
- [tango](https://github.com/lunny/tango) **star:833** 微型的、支持插件的 web 框架。   [![近三年未更新][Y]](https://github.com/lunny/tango)   [![godoc][D]](https://godoc.org/github.com/lunny/tango)   [![包含中文文档][CN]](https://github.com/lunny/tango)   [![归档项目][Archived]](https://github.com/lunny/tango)
- [Gearbox](https://github.com/abahmed/gearbox) **star:723** 一个用Go编写的web框架，专注于高性能和内存优化。   [![godoc][D]](https://godoc.org/github.com/abahmed/gearbox)
- [Aero](https://github.com/aerogo/aero) **star:534** 高性能的Go web框架，在Lighthouse中达到最高分。   [![godoc][D]](https://godoc.org/github.com/aerogo/aero)
- [gongular](https://github.com/mustafaakin/gongular) **star:501**  快速 Go web 框架，支持输入映射／验证以及依赖注入。   [![近三年未更新][Y]](https://github.com/mustafaakin/gongular)   [![godoc][D]](https://godoc.org/github.com/mustafaakin/gongular)
- [Flamingo Commerce](https://github.com/i-love-flamingo/flamingo-commerce) **star:449** 提供使用干净的体系结构(如DDD和端口和适配器)的电子商务功能，您可以使用这些功能来构建灵活的电子商务应用程序。   [![近一周有更新][G]](https://github.com/i-love-flamingo/flamingo-commerce)   [![godoc][D]](https://godoc.org/github.com/i-love-flamingo/flamingo-commerce)
- [rk-boot](https://github.com/rookie-ninja/rk-boot) **star:439** 一个引导程序库，用于快速方便地使用Gin和gRPC构建企业微服务。   [![godoc][D]](https://godoc.org/github.com/rookie-ninja/rk-boot)
- [Air](https://github.com/aofei/air) **star:432** 一个理想的精细化的Go web框架。   [![godoc][D]](https://godoc.org/github.com/aofei/air)
- [neo](https://github.com/ivpusic/neo) **star:418** Neo是一个非常简单且快速的Web框架API。   [![godoc][D]](https://godoc.org/github.com/ivpusic/neo)
- [Flamingo](https://github.com/i-love-flamingo/flamingo) **star:399** 可插拔web项目的框架。包括模块的概念和提供DI、Configareas、i18n、模板引擎、graphql、可观察性、安全性、事件、路由和反向路由等功能。   [![近一周有更新][G]](https://github.com/i-love-flamingo/flamingo)   [![godoc][D]](https://godoc.org/github.com/i-love-flamingo/flamingo)
- [mango](https://github.com/paulbellamy/mango) **star:372** ManGo 是一个模块化 web 应用框架，受到 Rack 和 PEP333 的启发。   [![近三年未更新][Y]](https://github.com/paulbellamy/mango)   [![godoc][D]](https://godoc.org/github.com/paulbellamy/mango)
- [Gondola](https://github.com/rainycape/gondola) **star:310** web框架写的网站越快越好。   [![近三年未更新][Y]](https://github.com/rainycape/gondola)   [![godoc][D]](https://godoc.org/github.com/rainycape/gondola)
- [uAdmin](https://github.com/uadmin/uadmin) **star:292** 受到 Sinatra 启发的 Go 语言 web 框架。   [![godoc][D]](https://godoc.org/github.com/uadmin/uadmin)
- [WebGo](https://github.com/bnkamalesh/webgo) **star:287** 构建web应用程序的微框架;处理程序链接、中间件和上下文注入。与标准库兼容的HTTP处理程序(即http.HandlerFunc)。   [![godoc][D]](https://godoc.org/github.com/bnkamalesh/webgo)
- [Ginrpc](https://github.com/xxjwxc/ginrpc) **star:281** Gin参数自动绑定工具，Gin rpc工具。   [![godoc][D]](https://godoc.org/github.com/xxjwxc/ginrpc)   [![包含中文文档][CN]](https://github.com/xxjwxc/ginrpc)
- [Golf](https://github.com/dinever/golf) **star:266** Golf 是一个快速、简单、轻量级的 Go 语言微型 web 框架。具有强大的功能且没有标准库以外的依赖。   [![godoc][D]](https://godoc.org/github.com/dinever/golf)
- [hiboot](https://github.com/hidevopsio/hiboot) **star:178** hiboot是一个高性能的web应用程序框架，支持自动配置和依赖注入。   [![godoc][D]](https://godoc.org/github.com/hidevopsio/hiboot)   [![包含中文文档][CN]](https://github.com/hidevopsio/hiboot)
- [Huma](https://github.com/danielgtaylor/huma/)  内置OpenAPI 3的现代REST/GraphQL api框架，生成文档和CLI。
- [appy](https://github.com/appist/appy) **star:129** 一个固执己见的高效web框架，有助于更容易地扩展业务。   [![godoc][D]](https://godoc.org/github.com/appist/appy)
- [go-rest](https://github.com/ungerik/go-rest) **star:127** 小型的 REST 框架。   [![近三年未更新][Y]](https://github.com/ungerik/go-rest)   [![godoc][D]](https://godoc.org/github.com/ungerik/go-rest)
- [patron](https://github.com/beatlabs/patron) **star:124** Patron是一个遵循最佳云实践的微服务框架，专注于提升开发效率。   [![近一周有更新][G]](https://github.com/beatlabs/patron)   [![godoc][D]](https://godoc.org/github.com/beatlabs/patron)
- [Pnutmux](https://gitlab.com/fruitygo/pnutmux)  Pnutmux is a powerful Go web framework that uses regex for matching and handling HTTP requests. It offers features such as CORS handling, structured logging, URL parameters extraction, middlewares, and concurrency limiting.
- [Microservice](https://github.com/claygod/microservice) **star:113** 创建微服务的框架，用Golang编写。   [![godoc][D]](https://godoc.org/github.com/claygod/microservice)
- [rux](https://github.com/gookit/rux) **star:94** 简单而快速的web框架，可用于构建golang HTTP应用程序   [![近一周有更新][G]](https://github.com/gookit/rux)   [![godoc][D]](https://godoc.org/github.com/gookit/rux)   [![包含中文文档][CN]](https://github.com/gookit/rux)
- [vox](https://github.com/aisk/vox) **star:80** 一个面向人类的golang web框架，深受Koa的启发。   [![godoc][D]](https://godoc.org/github.com/aisk/vox)
- [aah](https://aahframework.org)  可伸缩、高性能、快速开发的Go Web框架。
- [Golax](https://github.com/fulldump/golax) **star:76** 一个非Sinatra快速HTTP框架，支持谷歌自定义方法、深度拦截器、递归等。   [![godoc][D]](https://godoc.org/github.com/fulldump/golax)
- [YARF](https://github.com/yarf-framework/yarf) **star:65** 快速微框架，旨在以快速和简单的方式构建REST api和web服务。   [![近三年未更新][Y]](https://github.com/yarf-framework/yarf)   [![godoc][D]](https://godoc.org/github.com/yarf-framework/yarf)
- [Fireball](https://github.com/zpatrick/fireball) **star:59** 感觉更加自然的 web 框架。   [![近三年未更新][Y]](https://github.com/zpatrick/fireball)   [![godoc][D]](https://godoc.org/github.com/zpatrick/fireball)
- [goa](https://github.com/goa-go/goa) **star:49** goa就像golang中的koajs一样，是一个灵活、轻量级、高性能和可扩展的基于中间件的web框架。   [![近三年未更新][Y]](https://github.com/goa-go/goa)   [![godoc][D]](https://godoc.org/github.com/goa-go/goa)
- [GoTuna](https://github.com/gotuna/gotuna) **star:44** 具有mux路由器、中间件、会话、模板、嵌入式视图和静态文件的Go的极简web框架。   [![godoc][D]](https://godoc.org/github.com/gotuna/gotuna)
- [Pulse](https://github.com/gopulse/pulse) **star:36** Pulse is an HTTP web framework written in Go (Golang)   [![godoc][D]](https://godoc.org/github.com/gopulse/pulse)
- [goweb](https://github.com/twharmon/goweb) **star:35** 具有路由、websockets、日志、中间件、静态文件服务器(可选gzip)和自动TLS的Web框架。   [![godoc][D]](https://godoc.org/github.com/twharmon/goweb)
- [Resoursea](https://github.com/resoursea/api) **star:33** 用于快速编写基于资源的服务的REST框架。   [![近三年未更新][Y]](https://github.com/resoursea/api)   [![godoc][D]](https://godoc.org/github.com/resoursea/api)
- [rex](https://github.com/goanywhere/rex) **star:33**  Rex 是一个用于进行模块化开发的库，基于Gorilla/mux 完全兼容大多数的 net/HTTP.   [![近三年未更新][Y]](https://github.com/goanywhere/rex)   [![godoc][D]](https://godoc.org/github.com/goanywhere/rex)
- [Don](https://github.com/abemedia/go-don) **star:31** A highly performant and simple to use API framework.   [![近一周有更新][G]](https://github.com/abemedia/go-don)   [![godoc][D]](https://godoc.org/github.com/abemedia/go-don)
- [Banjo](https://github.com/nsheremet/banjo) **star:21** 非常简单和快速的网络框架 Go 。   [![近三年未更新][Y]](https://github.com/nsheremet/banjo)   [![godoc][D]](https://godoc.org/github.com/nsheremet/banjo)
- [anoweb](https://github.com/go-the-way/anoweb) **star:5** 轻量级和强大的web框架使用了新的Go方式。另一个走了。   [![godoc][D]](https://godoc.org/github.com/go-the-way/anoweb)
- [golamb](https://github.com/twharmon/golamb) **star:5** Golamb makes it easier to write API endpoints for use with AWS Lambda and API Gateway.   [![godoc][D]](https://godoc.org/github.com/twharmon/golamb)

**[⬆ back to top](#contents)**

### 中间件

#### 仿真中间件

- [Tollbooth](https://github.com/didip/tollbooth) **star:2472** 限制速率的 HTTP 请求处理程序。   [![godoc][D]](https://godoc.org/github.com/didip/tollbooth)
- [CORS](https://github.com/rs/cors) **star:2412** 轻松地向API添加CORS功能。   [![godoc][D]](https://godoc.org/github.com/rs/cors)
- [Limiter](https://github.com/ulule/limiter) **star:1827** 简单的速度限制中间件。   [![godoc][D]](https://godoc.org/github.com/ulule/limiter)
- [go-server-timing](https://github.com/mitchellh/go-server-timing) **star:851** 添加/解析Server-Timing头。   [![godoc][D]](https://godoc.org/github.com/mitchellh/go-server-timing)
- [go-fault](https://github.com/github/go-fault) **star:480** Go的故障注入中间件。   [![godoc][D]](https://godoc.org/github.com/github/go-fault)
- [ln-paywall](https://github.com/philippgille/ln-paywall) **star:136** 使用Lightning Network(比特币)实现基于每个请求的api货币化中间件。   [![近三年未更新][Y]](https://github.com/philippgille/ln-paywall)   [![godoc][D]](https://godoc.org/github.com/philippgille/ln-paywall)
- [XFF](https://github.com/sebest/xff) **star:97** 处理 X-Forwarded-For 头的中间件。   [![godoc][D]](https://godoc.org/github.com/sebest/xff)
- [rk-grpc](https://github.com/rookie-ninja/rk-grpc) **star:66** 中间件为gRPC与日志，指标，认证，跟踪等。   [![godoc][D]](https://godoc.org/github.com/rookie-ninja/rk-grpc)
- [rk-gin](https://github.com/rookie-ninja/rk-gin) **star:40** 用于Gin框架的中间件，具有日志记录、度量、认证、跟踪等功能。   [![godoc][D]](https://godoc.org/github.com/rookie-ninja/rk-gin)
- [formjson](https://github.com/rs/formjson) **star:38** 透明地将JSON输入作为标准表单POST处理。   [![近三年未更新][Y]](https://github.com/rs/formjson)   [![godoc][D]](https://godoc.org/github.com/rs/formjson)
- [client-timing](https://github.com/posener/client-timing) **star:24** 用于服务器定时报头的HTTP客户机。   [![近三年未更新][Y]](https://github.com/posener/client-timing)   [![godoc][D]](https://godoc.org/github.com/posener/client-timing)
- [echo-middleware](https://github.com/faabiosr/echo-middleware) **star:13** Middleware for Echo framework with logging and metrics.   [![godoc][D]](https://godoc.org/github.com/faabiosr/echo-middleware)
- [mid](https://github.com/bobg/mid) **star:7** 其他HTTP中间件特性:从处理程序返回惯用错误;接收/响应JSON数据;请求跟踪;和更多。   [![godoc][D]](https://godoc.org/github.com/bobg/mid)

#### 用于创建HTTP中间件的库

- [negroni](https://github.com/urfave/negroni) **star:7354** 符合语言习惯的 HTTP 中间件库。   [![godoc][D]](https://godoc.org/github.com/urfave/negroni)   [![包含中文文档][CN]](https://github.com/urfave/negroni)
- [alice](https://github.com/justinas/alice) **star:2851** 用于连接中间件的库，简单无痛苦。   [![godoc][D]](https://godoc.org/github.com/justinas/alice)
- [render](https://github.com/unrolled/render) **star:1838** Go package用于方便地呈现JSON、XML和HTML模板响应。   [![godoc][D]](https://godoc.org/github.com/unrolled/render)
- [stats](https://github.com/thoas/stats) **star:593** 使用中间件来存储关于web应用程序的各种信息。   [![godoc][D]](https://godoc.org/github.com/thoas/stats)
- [interpose](https://github.com/carbocation/interpose) **star:293** golang的极简网络/http中间件。   [![近三年未更新][Y]](https://github.com/carbocation/interpose)   [![godoc][D]](https://godoc.org/github.com/carbocation/interpose)
- [renderer](https://github.com/thedevsaddam/renderer) **star:255** 简单、轻量级和更快的响应(JSON、JSONP、XML、YAML、HTML、文件)。   [![godoc][D]](https://godoc.org/github.com/thedevsaddam/renderer)
- [muxchain](https://github.com/stephens2424/muxchain) **star:208** 用于net/http的轻量级中间件。   [![近三年未更新][Y]](https://github.com/stephens2424/muxchain)   [![godoc][D]](https://godoc.org/github.com/stephens2424/muxchain)
- [rye](https://github.com/InVisionApp/rye) **star:102** 支持JWT、CORS、Statsd和Go 1.7上下文的小型Go中间件库(带有罐装中间件)。   [![godoc][D]](https://godoc.org/github.com/InVisionApp/rye)
- [gores](https://github.com/alioygur/gores) **star:100** 处理HTML、JSON、XML等响应的Go包。对于RESTful api非常有用。   [![godoc][D]](https://godoc.org/github.com/alioygur/gores)
- [mediary](https://github.com/HereMobilityDevelopers/mediary) **star:87** 在http中添加拦截器。客户端允许转储/成型/跟踪/…的请求/响应。   [![近三年未更新][Y]](https://github.com/HereMobilityDevelopers/mediary)   [![godoc][D]](https://godoc.org/github.com/HereMobilityDevelopers/mediary)
- [chain](https://github.com/codemodus/chain) **star:64** 带有范围数据的处理程序包装器链接(基于网络/上下文的“中间件”)。   [![近三年未更新][Y]](https://github.com/codemodus/chain)   [![godoc][D]](https://godoc.org/github.com/codemodus/chain)
- [catena](https://github.com/codemodus/catena) **star:9** HTTP.Handler wrapper catenation (和chain具有相同的 API ).。   [![近三年未更新][Y]](https://github.com/codemodus/catena)   [![godoc][D]](https://godoc.org/github.com/codemodus/catena)

**[⬆ back to top](#contents)**

### 路由器

- [mux](https://github.com/gorilla/mux) **star:19164** 强大的URL路由器和调度器为golang。   [![godoc][D]](https://godoc.org/github.com/gorilla/mux)
- [httprouter](https://github.com/julienschmidt/httprouter) **star:15748** 高性能路由。使用这个库和标准http处理工具可以构建一个非常高性能大web框架。   [![godoc][D]](https://godoc.org/github.com/julienschmidt/httprouter)
- [chi](https://github.com/go-chi/chi) **star:15267** 小巧、快速、具有丰富表达力的 HTTP 路由，基于net/context.。   [![近一周有更新][G]](https://github.com/go-chi/chi)   [![godoc][D]](https://godoc.org/github.com/go-chi/chi)
- [gocraft/web](https://github.com/gocraft/web) **star:1499** Mux和中间件包在Go中。   [![godoc][D]](https://godoc.org/github.com/gocraft/web)
- [Bone](https://github.com/go-zoo/bone) **star:1293** 闪电快速HTTP多路复用器。   [![近三年未更新][Y]](https://github.com/go-zoo/bone)   [![godoc][D]](https://godoc.org/github.com/go-zoo/bone)
- [Goji](https://github.com/goji/goji) **star:945** 枸杞是一种简约的和灵活的与支持'net/context` HTTP请求多路复用器。   [![godoc][D]](https://godoc.org/github.com/goji/goji)
- [fasthttprouter](https://github.com/buaazp/fasthttprouter) **star:875** 高性能路由器分叉从`httprouter`。第一个路由器适合`fasthttp`。   [![近三年未更新][Y]](https://github.com/buaazp/fasthttprouter)   [![godoc][D]](https://godoc.org/github.com/buaazp/fasthttprouter)
- [httptreemux](https://github.com/dimfeld/httptreemux) **star:605** 高速，灵活，基于树的 HTTP 路由。受到了 httprouter 的启发。   [![godoc][D]](https://godoc.org/github.com/dimfeld/httptreemux)
- [xujiajun/gorouter](https://github.com/xujiajun/gorouter) **star:532** 一个简单和快速的HTTP路由器 Go 。   [![近三年未更新][Y]](https://github.com/xujiajun/gorouter)   [![godoc][D]](https://godoc.org/github.com/xujiajun/gorouter)
- [ozzo-routing](https://github.com/go-ozzo/ozzo-routing) **star:445** 一个非常快的Go (golang) HTTP路由器，支持正则表达式路由匹配。完全支持构建RESTful api。   [![godoc][D]](https://godoc.org/github.com/go-ozzo/ozzo-routing)
- [lars](https://github.com/go-playground/lars) **star:390** 是一个轻量级、快速、可扩展、零分配的HTTP路由，用于创建定制化的框架。   [![近三年未更新][Y]](https://github.com/go-playground/lars)   [![godoc][D]](https://godoc.org/github.com/go-playground/lars)
- [Siesta](https://github.com/VividCortex/siesta) **star:351** 编写中间件和处理程序的可组合框架。   [![godoc][D]](https://godoc.org/github.com/VividCortex/siesta)
- [vestigo](https://github.com/husobee/vestigo) **star:269** 高性能，独立，HTTP兼容的URL路由器的go web应用程序。   [![godoc][D]](https://godoc.org/github.com/husobee/vestigo)
- [gowww/router](https://github.com/gowww/router) **star:166** 超快的HTTP 路由，完全兼容 net/HTTP.Handler 接口.。   [![近一周有更新][G]](https://github.com/gowww/router)   [![godoc][D]](https://godoc.org/github.com/gowww/router)
- [GoRouter](https://github.com/vardius/gorouter) **star:149** GoRouter是一个服务器/API微框架，HTTP请求路由器，多路复用器，mux，它为请求路由器提供了支持“net/context”的中间件。   [![godoc][D]](https://godoc.org/github.com/vardius/gorouter)
- [pure](https://github.com/go-playground/pure) **star:142** 是一个轻量级HTTP路由器，它坚持net/ HTTP“实现”的std。   [![godoc][D]](https://godoc.org/github.com/go-playground/pure)
- [alien](https://github.com/gernest/alien) **star:127** 轻量级和快速http路由器从外层空间。   [![godoc][D]](https://godoc.org/github.com/gernest/alien)
- [violetear](https://github.com/nbari/violetear) **star:106** HTTP路由器。   [![godoc][D]](https://godoc.org/github.com/nbari/violetear)
- [Bxog](https://github.com/claygod/Bxog) **star:104** 简单和快速的HTTP路由器 Go 。它可以处理不同难度、长度和嵌套的路径。他还知道如何根据接收到的参数创建URL。   [![godoc][D]](https://godoc.org/github.com/claygod/Bxog)
- [xmux](https://github.com/rs/xmux) **star:97** 高性能mux基于httprouter 'net/context`支持。   [![近三年未更新][Y]](https://github.com/rs/xmux)   [![godoc][D]](https://godoc.org/github.com/rs/xmux)
- [goblin](https://github.com/bmf-san/goblin) **star:70** 一种基于树的golang http路由器。   [![godoc][D]](https://godoc.org/github.com/bmf-san/goblin)
- [ngamux](https://github.com/ngamux/ngamux) **star:61** 简单的HTTP路由器为Go。   [![godoc][D]](https://godoc.org/github.com/ngamux/ngamux)
- [bellt](https://github.com/GuilhermeCaruso/bellt) **star:54** 一个简单的Go HTTP路由器。   [![godoc][D]](https://godoc.org/github.com/GuilhermeCaruso/bellt)
- [FastRouter](https://github.com/razonyang/fastrouter) **star:22** 一个快速，灵活的HTTP路由器写在Go。   [![近三年未更新][Y]](https://github.com/razonyang/fastrouter)   [![godoc][D]](https://godoc.org/github.com/razonyang/fastrouter)
- [GoLobby/Router](https://github.com/golobby/router) **star:21** GoLobby路由器是一款轻量级但功能强大的Go编程语言HTTP路由器。   [![godoc][D]](https://godoc.org/github.com/golobby/router)
- [nchi](https://github.com/muir/nchi) **star:13** Chi-like路由器构建在httprouter上，带有基于依赖注入的中间件包装器   [![近一周有更新][G]](https://github.com/muir/nchi)   [![godoc][D]](https://godoc.org/github.com/muir/nchi)
- [goroute](https://github.com/goroute/route) **star:8** 简单但功能强大的HTTP请求多路复用器。   [![近三年未更新][Y]](https://github.com/goroute/route)   [![godoc][D]](https://godoc.org/github.com/goroute/route)

**[⬆ back to top](#contents)**

## WebAssembly

- [tinygo](https://github.com/tinygo-org/tinygo) **star:13447** 去编译小地方。微控制器、网络组装和命令行工具。基于LLVM。   [![近一周有更新][G]](https://github.com/tinygo-org/tinygo)   [![godoc][D]](https://godoc.org/github.com/tinygo-org/tinygo)
- [dom](https://github.com/dennwc/dom) **star:480** DOM库。   [![近三年未更新][Y]](https://github.com/dennwc/dom)   [![godoc][D]](https://godoc.org/github.com/dennwc/dom)
- [go-canvas](https://github.com/markfarnan/go-canvas) **star:214** 库使用HTML5画布，与所有绘画内的go代码。   [![godoc][D]](https://godoc.org/github.com/markfarnan/go-canvas)
- [wasmbrowsertest](https://github.com/agnivade/wasmbrowsertest) **star:150** 在浏览器中运行Go WASM测试。   [![godoc][D]](https://godoc.org/github.com/agnivade/wasmbrowsertest)
- [webapi](https://github.com/gowebapi/webapi) **star:143** 从WebIDL生成的DOM和HTML的绑定。   [![godoc][D]](https://godoc.org/github.com/gowebapi/webapi)
- [vert](https://github.com/norunners/vert) **star:89** Go和JS值之间的互操作。   [![godoc][D]](https://godoc.org/github.com/norunners/vert)

**[⬆ back to top](#contents)**

## Windows

- [go-ole](https://github.com/go-ole/go-ole) **star:1018** 为 Go 语言实现的 Win32 OLE。   [![godoc][D]](https://godoc.org/github.com/go-ole/go-ole)
- [d3d9](https://github.com/gonutz/d3d9) **star:147**  Direct3D9 的 Go 语言接口。   [![godoc][D]](https://godoc.org/github.com/gonutz/d3d9)
- [gosddl](https://github.com/MonaxGT/gosddl) **star:10** 从SDDL-string到用户友好的JSON的转换器。SDDL由四个部分组成:所有者、主群、DACL、SACL。   [![近三年未更新][Y]](https://github.com/MonaxGT/gosddl)   [![godoc][D]](https://godoc.org/github.com/MonaxGT/gosddl)

**[⬆ back to top](#contents)**

## XML

_用于操作XML的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#xml) 吧~)_

- [zek](https://github.com/miku/zek) **star:685** 从XML生成Go结构。   [![godoc][D]](https://godoc.org/github.com/miku/zek)
- [xpath](https://github.com/antchfx/xpath) **star:595** Go的XPath包。   [![godoc][D]](https://godoc.org/github.com/antchfx/xpath)
- [xquery](https://github.com/antchfx/xquery) **star:156** XQuery允许您使用XPath表达式从HTML/XML文档中提取数据。   [![近三年未更新][Y]](https://github.com/antchfx/xquery)   [![godoc][D]](https://godoc.org/github.com/antchfx/xquery)   [![归档项目][Archived]](https://github.com/antchfx/xquery)
- [xml2map](https://github.com/sbabiv/xml2map) **star:53** XML来映射转换器编写的Golang。   [![godoc][D]](https://godoc.org/github.com/sbabiv/xml2map)
- [xmlwriter](https://github.com/shabbyrobe/xmlwriter) **star:23** 基于libxml2的xmlwriter模块的过程性XML生成API。   [![godoc][D]](https://godoc.org/github.com/shabbyrobe/xmlwriter)
- [XML-Comp](https://github.com/xml-comp/xml-comp) **star:20** 简单的命令行XML比较器，生成文件夹、文件和标记的差异。   [![近三年未更新][Y]](https://github.com/xml-comp/xml-comp)   [![godoc][D]](https://godoc.org/github.com/xml-comp/xml-comp)

## 零信任

_实现零信任架构的库和工具。 (翻译出错了? 试试 [英文版](README_EN.md#zero-trust) 吧~)_

- [Cosign](https://github.com/sigstore/cosign) **star:3610** 在OCI注册中心中的容器签名、验证和存储。   [![近一周有更新][G]](https://github.com/sigstore/cosign)   [![godoc][D]](https://godoc.org/github.com/sigstore/cosign)
- [Spire](https://github.com/spiffe/spire) **star:1492** SPIRE (SPIFFE Runtime Environment)是一个api工具链，用于跨各种托管平台在软件系统之间建立信任。   [![近一周有更新][G]](https://github.com/spiffe/spire)   [![godoc][D]](https://godoc.org/github.com/spiffe/spire)
- [in-toto](https://github.com/in-toto/in-toto-golang) **star:97** 实现in-toto(提供一个框架来保护软件供应链的完整性)python参考实现。   [![godoc][D]](https://godoc.org/github.com/in-toto/in-toto-golang)
- [Spiffe-Vault](https://github.com/philips-labs/spiffe-vault) **star:62** 利用Spiffe JWT认证和Hashicorp Vault实现无秘密认证。   [![近一周有更新][G]](https://github.com/philips-labs/spiffe-vault)   [![godoc][D]](https://godoc.org/github.com/philips-labs/spiffe-vault)

## 代码分析

_源代码分析工具，也称为静态应用程序安全测试(SAST)工具。 (翻译出错了? 试试 [英文版](README_EN.md#code-analysis) 吧~)_

- [GoLint](https://github.com/golang/lint) **star:3974** Go 源码的 linter。   [![godoc][D]](https://godoc.org/github.com/golang/lint)   [![归档项目][Archived]](https://github.com/golang/lint)
- [errcheck](https://github.com/kisielk/errcheck) **star:2120** Errcheck是一个用于检查Go程序中未检查错误的程序。   [![godoc][D]](https://godoc.org/github.com/kisielk/errcheck)
- [go-critic](https://github.com/go-critic/go-critic) **star:1668** 源代码检查工具。   [![godoc][D]](https://godoc.org/github.com/go-critic/go-critic)
- [GoPlantUML](https://github.com/jfeliu007/goplantuml) **star:1522** 生成文本plantump类图的库和CLI，其中包含关于结构和接口的信息，以及它们之间的关系。   [![godoc][D]](https://godoc.org/github.com/jfeliu007/goplantuml)
- [goreturns](https://sourcegraph.com/github.com/sqs/goreturns)  添加 zero 返回声明，以匹配 func 返回类型。
- [gcvis](https://github.com/davecheney/gcvis) **star:1087** 实时可视化跟踪 GC 数据。   [![近三年未更新][Y]](https://github.com/davecheney/gcvis)   [![godoc][D]](https://godoc.org/github.com/davecheney/gcvis)   [![归档项目][Archived]](https://github.com/davecheney/gcvis)
- [php-parser](https://github.com/z7zmey/php-parser) **star:928** 用 Go 编写的 PHP 解析器。   [![godoc][D]](https://godoc.org/github.com/z7zmey/php-parser)
- [staticcheck](https://github.com/dominikh/go-tools/tree/master/cmd/staticcheck)  用于大量静态分析检查，您可能已经从 c# 的 ReSharper 等工具中习惯了这些检查。
- [go-cleanarch](https://github.com/roblaszczak/go-cleanarch) **star:762** go-cleanarch 的创建是为了验证 Clean 体系结构规则，比如 Go 项目中的依赖关系。   [![godoc][D]](https://godoc.org/github.com/roblaszczak/go-cleanarch)
- [goast-viewer](https://github.com/yuroyoro/goast-viewer) **star:727** 基于 Web 的 Golang AST 可视化工具。
- [goimports](https://godoc.org/golang.org/x/tools/cmd/goimports)  来修复(添加，删除) Go 中自动导入的工具。
- [golines](https://github.com/segmentio/golines) **star:690** 格式化程序，它自动缩短Go代码中的长行。   [![godoc][D]](https://godoc.org/github.com/segmentio/golines)
- [go-mod-outdated](https://github.com/psampaz/go-mod-outdated) **star:640** 找出项目中过期的依赖项。   [![godoc][D]](https://godoc.org/github.com/psampaz/go-mod-outdated)
- [Chronos](https://github.com/amit-davidson/Chronos) **star:405** Detects race conditions statically   [![godoc][D]](https://godoc.org/github.com/amit-davidson/Chronos)
- [todocheck](https://github.com/preslavmihaylov/todocheck) **star:398** 静态代码分析器连接TODO注释代码有问题在你的问题跟踪器。   [![godoc][D]](https://godoc.org/github.com/preslavmihaylov/todocheck)
- [unconvert](https://github.com/mdempsky/unconvert) **star:357** 在源码中删除不必要的类型转换。   [![godoc][D]](https://godoc.org/github.com/mdempsky/unconvert)
- [dupl](https://github.com/mibk/dupl) **star:319** 用于代码克隆检测的工具。   [![godoc][D]](https://godoc.org/github.com/mibk/dupl)
- [tickgit](https://github.com/augmentable-dev/tickgit) **star:312** CLI和go包用于显示代码注释TODOs(以任何语言)并应用“git blame”来识别作者。   [![godoc][D]](https://godoc.org/github.com/augmentable-dev/tickgit)
- [vaccum](https://github.com/daveshanley/vacuum) **star:276** An ultra-super-fast, lightweight OpenAPI linter and quality checking tool.   [![godoc][D]](https://godoc.org/github.com/daveshanley/vacuum)
- [gostatus](https://github.com/shurcooL/gostatus) **star:243** 用于显示包含 Go 包的存储库的状态的命令行工具，。   [![godoc][D]](https://godoc.org/github.com/shurcooL/gostatus)
- [apicompat](https://github.com/bradleyfalzon/apicompat) **star:176** 检查 Go 项目最近的向下不兼容修改。   [![近三年未更新][Y]](https://github.com/bradleyfalzon/apicompat)   [![godoc][D]](https://godoc.org/github.com/bradleyfalzon/apicompat)
- [go-checkstyle](https://github.com/qiniu/checkstyle) **star:127** checkstyle是一个类似于java checkstyle的检查工具。   [![godoc][D]](https://godoc.org/github.com/qiniu/checkstyle)
- [lint](https://github.com/surullabs/lint) **star:66** 将 linters 作为测试的一部分。   [![近三年未更新][Y]](https://github.com/surullabs/lint)   [![godoc][D]](https://godoc.org/github.com/surullabs/lint)
- [validate](https://github.com/mccoyst/validate) **star:61** 使用 tags 自动验证结构体字段。   [![godoc][D]](https://godoc.org/github.com/mccoyst/validate)
- [asty](https://github.com/asty-org/asty) **star:60** Converts golang AST to JSON and JSON to AST.   [![godoc][D]](https://godoc.org/github.com/asty-org/asty)
- [blanket](https://gitlab.com/verygoodsoftwarenotvirus/blanket)  blanket is a tool that helps you catch functions which don't have direct unit tests in your Go packages.
- [ChainJacking](https://github.com/Checkmarx/chainjacking) **star:48** 找到你的Go lang直接的GitHub依赖中哪个容易受到链劫持攻击。
- [go-outdated](https://github.com/firstrow/go-outdated) **star:45** 显示过期包的终端应用。   [![近三年未更新][Y]](https://github.com/firstrow/go-outdated)   [![godoc][D]](https://godoc.org/github.com/firstrow/go-outdated)   [![归档项目][Archived]](https://github.com/firstrow/go-outdated)
- [usestdlibvars](https://github.com/sashamelentyev/usestdlibvars) **star:41** A linter that detect the possibility to use variables/constants from the Go standard library.   [![godoc][D]](https://godoc.org/github.com/sashamelentyev/usestdlibvars)
- [golang-ifood-sdk](https://github.com/arxdsilva/golang-ifood-sdk) **star:10** 好   [![godoc][D]](https://godoc.org/github.com/arxdsilva/golang-ifood-sdk)

**[⬆ back to top](#contents)**

## 编辑器插件

_文本编辑器和ide插件。 (翻译出错了? 试试 [英文版](README_EN.md#editor-plugins) 吧~)_

- [vim-go](https://github.com/fatih/vim-go) **star:15573** Go 开发会用到的 Vim 插件。
- [gocode](https://github.com/nsf/gocode) **star:5008** Autocompletion daemon for the Go programming language.   [![godoc][D]](https://godoc.org/github.com/nsf/gocode)
- [vscode-go](https://github.com/golang/vscode-go) **star:3525** Visual Studio代码的扩展(VS代码)，它提供了对Go语言的支持。
- [GoSublime](https://github.com/DisposaBoy/GoSublime) **star:3419** 包含了可为文本编辑器 SublimeText 3 提供代码自动填充和其他类似IDE的功能的 Golang IDE 插件集合。   [![近三年未更新][Y]](https://github.com/DisposaBoy/GoSublime)   [![godoc][D]](https://godoc.org/github.com/DisposaBoy/GoSublime)
- [go-plus](https://github.com/joefitzgerald/go-plus) **star:1506** 在 Atom 中添加自动完成，格式化，语法检查，高亮和审查。   [![归档项目][Archived]](https://github.com/joefitzgerald/go-plus)
- [go-mode](https://github.com/dominikh/go-mode.el) **star:1334** 在 GNU/Emacs 支持 GO。
- [coc-go language server extension for Vim/Neovim](https://github.com/josa42/coc-go) **star:546** 这个插件添加[gopls](https://github.com/golang/tools/blob/master/gopls/README.md)功能到Vim/Neovim。   [![近一周有更新][G]](https://github.com/josa42/coc-go)
- [goimports-reviser](https://github.com/incu6us/goimports-reviser) **star:416** 用于导入的格式化工具。   [![近一周有更新][G]](https://github.com/incu6us/goimports-reviser)   [![godoc][D]](https://godoc.org/github.com/incu6us/goimports-reviser)
- [goprofiling](https://marketplace.visualstudio.com/items?itemName=MaxMedia.go-prof)  在 VS Code 中支持 Go 的基准分析。
- [Watch](https://github.com/eaburns/Watch) **star:200** Runs a command in an acme win on file changes.   [![godoc][D]](https://godoc.org/github.com/eaburns/Watch)
- [vim-compiler-go](https://github.com/rjohnsondev/vim-compiler-go) **star:86** 在保存时突出显示语法错误的 Vim 插件。   [![近三年未更新][Y]](https://github.com/rjohnsondev/vim-compiler-go)
- [go-language-server](https://github.com/theia-ide/go-language-server) **star:31** A wrapper to turn the VSCode go extension into a language server supporting the language-server-protocol.   [![近三年未更新][Y]](https://github.com/theia-ide/go-language-server)   [![归档项目][Archived]](https://github.com/theia-ide/go-language-server)
- [gounit-vim](https://github.com/hexdigest/gounit-vim) **star:23** 基于函数或方法的签名生成Go测试的Vim插件。   [![近三年未更新][Y]](https://github.com/hexdigest/gounit-vim)
- [theia-go-extension](https://github.com/theia-ide/theia-go-extension) **star:15** 在 Theia IDE中支持 Go。   [![近三年未更新][Y]](https://github.com/theia-ide/theia-go-extension)   [![归档项目][Archived]](https://github.com/theia-ide/theia-go-extension)
- [Go Doc](https://github.com/msyrus/vscode-go-doc) **star:7** 一个Visual Studio Code扩展，用于在输出中显示定义和生成go doc。
- [Go plugin for JetBrains IDEs](https://plugins.jetbrains.com/plugin/9568-go)  JetBrains IDEs 的 Go 插件。

**[⬆ back to top](#contents)**

## Go 生成工具

- [gotests](https://github.com/cweill/gotests) **star:4694** 从源代码生成测试用例。   [![近一周有更新][G]](https://github.com/cweill/gotests)   [![godoc][D]](https://godoc.org/github.com/cweill/gotests)
- [genny](https://github.com/cheekybits/genny) **star:1681** 优雅的 Go 泛型。   [![godoc][D]](https://godoc.org/github.com/cheekybits/genny)
- [xgen](https://github.com/xuri/xgen) **star:266** XSD (XML模式定义)解析器和Go/C/Java/Rust/TypeScript代码生成器。   [![godoc][D]](https://godoc.org/github.com/xuri/xgen)
- [hasgo](https://github.com/DylanMeeus/hasgo) **star:130** 可生成用于切片的 Haskell。   [![godoc][D]](https://godoc.org/github.com/DylanMeeus/hasgo)
- [gonerics](https://github.com/bouk/gonerics) **star:114** Go中的易用的泛型。   [![近三年未更新][Y]](https://github.com/bouk/gonerics)   [![godoc][D]](https://godoc.org/github.com/bouk/gonerics)
- [gocontracts](https://github.com/Parquery/gocontracts) **star:100** 通过同步代码和文档来实现 design-by-contract 设计。   [![近三年未更新][Y]](https://github.com/Parquery/gocontracts)   [![godoc][D]](https://godoc.org/github.com/Parquery/gocontracts)
- [gounit](https://github.com/hexdigest/gounit) **star:72** 使用您自己的模板生成Go测试用例。   [![近三年未更新][Y]](https://github.com/hexdigest/gounit)   [![godoc][D]](https://godoc.org/github.com/hexdigest/gounit)
- [sqlgen](https://github.com/anqiansong/sqlgen) **star:66** Generate gorm, xorm, sqlx, bun, sql code from SQL file or DSN.   [![godoc][D]](https://godoc.org/github.com/anqiansong/sqlgen)   [![包含中文文档][CN]](https://github.com/anqiansong/sqlgen)
- [TOML-to-Go](https://xuri.me/toml-to-go)  在浏览器中将 TOML 转换为 Go 类型。
- [generic](https://github.com/usk81/generic) **star:48** 灵活的 Go 数据类型。   [![godoc][D]](https://godoc.org/github.com/usk81/generic)
- [options-gen](https://github.com/kazhuravlev/options-gen) **star:43** Functional options described by Dave Cheney's post "Functional options for friendly APIs".   [![godoc][D]](https://godoc.org/github.com/kazhuravlev/options-gen)
- [re2dfa](https://github.com/opennota/re2dfa)  将正则表达式转换为有限状态机，并输出 Go 源代码。
- [godal](https://github.com/mafulong/godal) **star:16** 通过指定可被gorm使用的sql ddl文件，生成golang对应的orm模型。   [![godoc][D]](https://godoc.org/github.com/mafulong/godal)

**[⬆ back to top](#contents)**

## Go 工具

- [go-swagger](https://github.com/go-swagger/go-swagger) **star:8876** 基于 Go 的Swagger 2.0实现。   [![godoc][D]](https://godoc.org/github.com/go-swagger/go-swagger)
- [go-callvis](https://github.com/TrueFurby/go-callvis) **star:5406** 使用 dot format 可视化 Go 程序的调用图。   [![godoc][D]](https://godoc.org/github.com/TrueFurby/go-callvis)
- [OctoLinker](https://github.com/OctoLinker/browser-extension) **star:5176** 借助的 OctoLinker 浏览器扩展，可以高效的地浏览  GitHub go文件。   [![近一周有更新][G]](https://github.com/OctoLinker/browser-extension)
- [depth](https://github.com/KyleBanks/depth) **star:848** 通过分析导入，将包依赖关系树可视化输出。   [![godoc][D]](https://godoc.org/github.com/KyleBanks/depth)
- [richgo](https://github.com/kyoh86/richgo) **star:802** 用文本装饰丰富 go test 的输出。   [![godoc][D]](https://godoc.org/github.com/kyoh86/richgo)
- [rts](https://github.com/galeone/rts) **star:246** 从服务器响应生成Go结构。   [![godoc][D]](https://godoc.org/github.com/galeone/rts)
- [godbg](https://github.com/tylerwince/godbg) **star:197** 实现了 Rusts 的 dbg! 宏，可以方便的在开发过程中快速、容易地调试。   [![近三年未更新][Y]](https://github.com/tylerwince/godbg)   [![godoc][D]](https://godoc.org/github.com/tylerwince/godbg)
- [gomodrun](https://github.com/dustinblackman/gomodrun/)  执行并缓存Go中包含的二进制文件的Go工具。国防部文件。
- [gotemplate.io](https://gotemplate.io/)  Online tool to preview `text/template` templates live.
- [typex](https://github.com/dtgorski/typex) **star:180** 检查Go类型及其传递依赖关系，或者将结果导出为TypeScript值对象(或类型)声明。   [![godoc][D]](https://godoc.org/github.com/dtgorski/typex)
- [roumon](https://github.com/becheran/roumon) **star:151** 通过命令行接口监控所有激活goroutines的当前状态。   [![godoc][D]](https://godoc.org/github.com/becheran/roumon)
- [gothanks](https://github.com/psampaz/gothanks) **star:118** GoThanks自动帮你开始。mod github依赖，以这种方式发送一些爱给他们的维护者。   [![godoc][D]](https://godoc.org/github.com/psampaz/gothanks)
- [colorgo](https://github.com/songgao/colorgo) **star:112** 将 go 命令包装成彩色的 go build 输出。   [![近三年未更新][Y]](https://github.com/songgao/colorgo)   [![godoc][D]](https://godoc.org/github.com/songgao/colorgo)
- [gotestdox](https://github.com/bitfield/gotestdox) **star:61** Go测试结果显示为可读的句子。   [![godoc][D]](https://godoc.org/github.com/bitfield/gotestdox)
- [go-james](https://github.com/pieterclaerhout/go-james) **star:59** 去项目骨架创造者，建立和测试您的项目没有手动设置。   [![godoc][D]](https://godoc.org/github.com/pieterclaerhout/go-james)   [![归档项目][Archived]](https://github.com/pieterclaerhout/go-james)
- [igo](https://github.com/rocketlaunchr/igo) **star:59** 一个igo to go transpiler (go语言的新语言功能!)   [![近三年未更新][Y]](https://github.com/rocketlaunchr/igo)   [![godoc][D]](https://godoc.org/github.com/rocketlaunchr/igo)
- [go-pkg-complete](https://github.com/skelterjohn/go-pkg-complete) **star:43** Bash completion for go and wgo。   [![近三年未更新][Y]](https://github.com/skelterjohn/go-pkg-complete)
- [docs](https://github.com/go-oas/docs) **star:24** 自动为GO项目生成RESTful API文档-与开放API规范标准一致。   [![godoc][D]](https://godoc.org/github.com/go-oas/docs)
- [modver](https://github.com/bobg/modver) **star:8** 根据[semver](https://semver.org/)规则，比较Go模块的两个版本，以检查所需的版本号更改(主要、次要或patchlevel)。   [![godoc][D]](https://godoc.org/github.com/bobg/modver)
- [textra](https://github.com/ravsii/textra) **star:3** Extract Go struct field names, types and tags for filtering and exporting.   [![godoc][D]](https://godoc.org/github.com/ravsii/textra)

**[⬆ back to top](#contents)**

## 软件包

_用Go编写的软件。 (翻译出错了? 试试 [英文版](README_EN.md#software-packages) 吧~)_

**[⬆ back to top](#contents)**

### DevOps 工具

- [kubernetes](https://github.com/kubernetes/kubernetes) **star:101636** 来自谷歌的容器集群管理器。   [![近一周有更新][G]](https://github.com/kubernetes/kubernetes)   [![godoc][D]](https://godoc.org/github.com/kubernetes/kubernetes)
- [Moby](https://github.com/moby/moby) **star:66661** Collaborative project for the container ecosystem to assemble container-based systems.   [![近一周有更新][G]](https://github.com/moby/moby)   [![godoc][D]](https://godoc.org/github.com/moby/moby)
- [traefik](https://github.com/containous/traefik) **star:44594** 反向代理和负载均衡器，支持多个后端。   [![近一周有更新][G]](https://github.com/containous/traefik)   [![godoc][D]](https://godoc.org/github.com/containous/traefik)
- [Gitea](https://github.com/go-gitea/gitea) **star:38297** 从 Gogs fork，完全由社区驱动。   [![近一周有更新][G]](https://github.com/go-gitea/gitea)   [![godoc][D]](https://godoc.org/github.com/go-gitea/gitea)   [![包含中文文档][CN]](https://github.com/go-gitea/gitea)
- [gitea-github-migrator](https://git.jonasfranz.software/JonasFranzDEV/gitea-github-migrator)  将所有GitHub repositories、issues、milestones 和 labels 都迁移到 Gitea。
- [Vegeta](https://github.com/tsenart/vegeta) **star:21860** HTTP负载测试工具和库。超过9000 !   [![近一周有更新][G]](https://github.com/tsenart/vegeta)   [![godoc][D]](https://godoc.org/github.com/tsenart/vegeta)
- [Hey](https://github.com/rakyll/hey) **star:16229** 压力测试工具，可用来代替 ApacheBench (ab)。   [![godoc][D]](https://godoc.org/github.com/rakyll/hey)
- [Packer](https://github.com/mitchellh/packer) **star:14602** 用于从一个源配置为多个平台创建相同的机器图像。   [![近一周有更新][G]](https://github.com/mitchellh/packer)   [![godoc][D]](https://godoc.org/github.com/mitchellh/packer)
- [kubeshark](https://github.com/kubeshark/kubeshark) **star:9526** API traffic analyzer for Kubernetes, inspired by Wireshark, purposely built for Kubernetes.   [![近一周有更新][G]](https://github.com/kubeshark/kubeshark)   [![godoc][D]](https://godoc.org/github.com/kubeshark/kubeshark)
- [webhook](https://github.com/adnanh/webhook) **star:9266** 允许用户创建在服务器上执行命令的 HTTP hooks。   [![godoc][D]](https://godoc.org/github.com/adnanh/webhook)
- [Wide](https://wide.b3log.org/login)  为使用 Golang 的团队提供基于 web 的 IDE。
- [GVM](https://github.com/moovweb/gvm) **star:8819** GVM 提供了一个接口来管理 Go 版本。   [![近一周有更新][G]](https://github.com/moovweb/gvm)
- [Ddosify](https://github.com/ddosify/ddosify) **star:7759** 高性能负载测试工具，用Golang编写。   [![近一周有更新][G]](https://github.com/ddosify/ddosify)   [![godoc][D]](https://godoc.org/github.com/ddosify/ddosify)
- [ko](https://github.com/google/ko) **star:6315** 命令行工具，用于在Kubernetes上构建和部署Go应用程序   [![近一周有更新][G]](https://github.com/google/ko)   [![godoc][D]](https://godoc.org/github.com/google/ko)
- [KubeVela](https://github.com/kubevela/kubevela) **star:5578** Cloud native application delivery.   [![近一周有更新][G]](https://github.com/kubevela/kubevela)   [![godoc][D]](https://godoc.org/github.com/kubevela/kubevela)
- [gaia](https://github.com/gaia-pipeline/gaia) **star:5104** 可用于任何编程语言来构建强大的管道。   [![godoc][D]](https://godoc.org/github.com/gaia-pipeline/gaia)
- [bombardier](https://github.com/codesenberg/bombardier) **star:4586** 快速跨平台 HTTP 基准测试工具。   [![godoc][D]](https://godoc.org/github.com/codesenberg/bombardier)
- [gox](https://github.com/mitchellh/gox) **star:4572** 非常简单，没有多余的跨平台编译工具。   [![godoc][D]](https://godoc.org/github.com/mitchellh/gox)
- [script](https://github.com/bitfield/script) **star:4565** 让DevOps编写类shell和系统管理任务变得更加容易。   [![godoc][D]](https://godoc.org/github.com/bitfield/script)
- [Pomerium](https://github.com/pomerium/pomerium) **star:3648** Pomerium是一个可识别身份的访问代理。   [![近一周有更新][G]](https://github.com/pomerium/pomerium)   [![godoc][D]](https://godoc.org/github.com/pomerium/pomerium)
- [bosun](https://github.com/bosun-monitor/bosun) **star:3359** 按照时间轴发出告警的框架。   [![godoc][D]](https://godoc.org/github.com/bosun-monitor/bosun)
- [kala](https://github.com/ajvb/kala) **star:2035** 简单、现代和高性能的作业调度程序。   [![godoc][D]](https://godoc.org/github.com/ajvb/kala)
- [s5cmd](https://github.com/peak/s5cmd) **star:1958** 非常快的S3和本地文件系统执行工具。   [![近一周有更新][G]](https://github.com/peak/s5cmd)   [![godoc][D]](https://godoc.org/github.com/peak/s5cmd)
- [fac](https://github.com/mkchoi212/fac) **star:1815** 修复 git 合并冲突。   [![godoc][D]](https://godoc.org/github.com/mkchoi212/fac)
- [goxc](https://github.com/laher/goxc) **star:1682** 专注于跨平台编译和打包的 Go 构建工具。   [![近三年未更新][Y]](https://github.com/laher/goxc)   [![godoc][D]](https://godoc.org/github.com/laher/goxc)   [![归档项目][Archived]](https://github.com/laher/goxc)
- [StatusOK](https://github.com/sanathp/statusok) **star:1588** 监视您的网站和REST api。当服务器宕机或响应时间超过预期时，通过Slack、电子邮件获得通知。   [![godoc][D]](https://godoc.org/github.com/sanathp/statusok)
- [Fleet device management](https://github.com/fleetdm/fleet) **star:1543** Lightweight, programmable telemetry for servers and workstations.   [![近一周有更新][G]](https://github.com/fleetdm/fleet)   [![godoc][D]](https://godoc.org/github.com/fleetdm/fleet)
- [ghorg](https://github.com/gabrie30/ghorg) **star:1336** 支持GitHub, GitLab, Gitea和Bitbucket。   [![godoc][D]](https://godoc.org/github.com/gabrie30/ghorg)
- [go-selfupdate](https://github.com/sanbornm/go-selfupdate) **star:1287** 允许你的 Go应用程序 进行自我更新。   [![godoc][D]](https://godoc.org/github.com/sanbornm/go-selfupdate)
- [s3gof3r](https://github.com/rlmcpherson/s3gof3r) **star:1140** 小型实用程序/库，针对大型对象在Amazon S3中的高速传输进行了优化。   [![godoc][D]](https://godoc.org/github.com/rlmcpherson/s3gof3r)
- [uTask](https://github.com/ovh/utask) **star:977** 对yaml中声明的业务流程进行建模和执行的自动化引擎。   [![近一周有更新][G]](https://github.com/ovh/utask)   [![godoc][D]](https://godoc.org/github.com/ovh/utask)
- [skm](https://github.com/TimothyYe/skm) **star:895** SKM是一个简单而强大的SSH密钥管理器，它可以帮助您轻松地管理多个SSH密钥!   [![godoc][D]](https://godoc.org/github.com/TimothyYe/skm)
- [Scaleway-cli](https://github.com/scaleway/scaleway-cli) **star:843** 从命令行管理 BareMetal 服务器(与使用Docker一样容易)。   [![近一周有更新][G]](https://github.com/scaleway/scaleway-cli)   [![godoc][D]](https://godoc.org/github.com/scaleway/scaleway-cli)
- [kwatch](https://github.com/abahmed/kwatch) **star:779** 立即监视和检测Kubernetes(k8)集群中的崩溃。   [![近一周有更新][G]](https://github.com/abahmed/kwatch)   [![godoc][D]](https://godoc.org/github.com/abahmed/kwatch)
- [cassowary](https://github.com/rogerwelin/cassowary) **star:679** 用Go编写的跨平台HTTP负载测试工具。   [![godoc][D]](https://godoc.org/github.com/rogerwelin/cassowary)   [![包含中文文档][CN]](https://github.com/rogerwelin/cassowary)
- [kool](https://github.com/kool-dev/kool) **star:643** 命令行工具管理Docker环境作为一种简单的方式。   [![近一周有更新][G]](https://github.com/kool-dev/kool)   [![godoc][D]](https://godoc.org/github.com/kool-dev/kool)
- [aurora](https://github.com/xuri/aurora) **star:583** 基于web的跨平台 Beanstalkd 队列服务器控制台。
- [govvv](https://github.com/ahmetalpbalkan/govvv) **star:535** 可轻松地添加版本信息到 Go 二进制文件。   [![godoc][D]](https://godoc.org/github.com/ahmetalpbalkan/govvv)
- [Pewpew](https://github.com/bengadbois/pewpew) **star:391** 灵活的 HTTP 命令行压测工具。   [![godoc][D]](https://godoc.org/github.com/bengadbois/pewpew)
- [jcli](https://github.com/jenkins-zh/jenkins-cli) **star:367** 詹金斯CLI允许你管理你的詹金斯作为一个简单的方法。   [![godoc][D]](https://godoc.org/github.com/jenkins-zh/jenkins-cli)   [![包含中文文档][CN]](https://github.com/jenkins-zh/jenkins-cli)
- [gonative](https://github.com/inconshreveable/gonative) **star:334** 用原生 Go 创建一个跨平台的 Go 工具链。   [![近三年未更新][Y]](https://github.com/inconshreveable/gonative)   [![godoc][D]](https://godoc.org/github.com/inconshreveable/gonative)
- [trubka](https://github.com/xitonix/trubka) **star:330** 一个CLI工具，用于管理和故障排除Apache Kafka集群，具有通用发布/使用协议缓冲区和与Kafka之间的纯文本事件的能力。   [![godoc][D]](https://godoc.org/github.com/xitonix/trubka)
- [Mora](https://github.com/emicklei/mora) **star:312** 用于访问 MongoDB 文档和元数据的 REST 服务器。   [![godoc][D]](https://godoc.org/github.com/emicklei/mora)
- [lstags](https://github.com/ivanilves/lstags) **star:307** 提供了工具和API，可用来同步不同注册中心的Docker图像。   [![godoc][D]](https://godoc.org/github.com/ivanilves/lstags)
- [Balerter](https://github.com/balerter/balerter) **star:293** 一个自托管的基于脚本的警报管理器。   [![godoc][D]](https://godoc.org/github.com/balerter/balerter)
- [easyssh-proxy](https://github.com/appleboy/easyssh-proxy) **star:289** Golang package for easy remote execution through SSH and SCP downloading via `ProxyCommand`.   [![godoc][D]](https://godoc.org/github.com/appleboy/easyssh-proxy)
- [manssh](https://github.com/xwjdsh/manssh) **star:288** manssh是一个命令行工具，可以方便地管理ssh别名配置。   [![godoc][D]](https://godoc.org/github.com/xwjdsh/manssh)
- [gobrew](https://github.com/kevincobain2000/gobrew) **star:276** Go version manager. Super simple tool to install and manage Go versions. Install go without root. Gobrew doesn't require shell rehash.   [![近一周有更新][G]](https://github.com/kevincobain2000/gobrew)   [![godoc][D]](https://godoc.org/github.com/kevincobain2000/gobrew)
- [terraform-provider-openapi](https://github.com/dikhan/terraform-provider-openapi) **star:258** Terraform provider plugin，它根据OpenAPI文档(以前称为swagger文件)在运行时动态配置自身，该文档包含了公开的api的定义。   [![godoc][D]](https://godoc.org/github.com/dikhan/terraform-provider-openapi)
- [dogo](https://github.com/liudng/dogo) **star:256** 监视源文件中的更改并自动编译和运行(restart)。   [![近三年未更新][Y]](https://github.com/liudng/dogo)   [![godoc][D]](https://godoc.org/github.com/liudng/dogo)   [![包含中文文档][CN]](https://github.com/liudng/dogo)
- [godbg](https://github.com/sirnewton01/godbg) **star:225** 基于 web 的 gdb 前端应用程序。   [![近三年未更新][Y]](https://github.com/sirnewton01/godbg)
- [Gogs](https://gogs.io/)  自托管的Git服务。
- [Blast](https://github.com/dave/blast) **star:212** 一个用于API负载测试和批处理作业的简单工具。   [![近三年未更新][Y]](https://github.com/dave/blast)   [![godoc][D]](https://godoc.org/github.com/dave/blast)
- [s3-proxy](https://github.com/oxyno-zeta/s3-proxy) **star:212** 具有GET、PUT和DELETE方法和身份验证(OpenID连接和基本身份验证)的S3代理。   [![近一周有更新][G]](https://github.com/oxyno-zeta/s3-proxy)   [![godoc][D]](https://godoc.org/github.com/oxyno-zeta/s3-proxy)
- [abbreviate](https://github.com/dnnrly/abbreviate) **star:206** abbreviate is a tool turning long strings in to shorter ones with configurable separators, for example to embed branch names in to deployment stack IDs.   [![godoc][D]](https://godoc.org/github.com/dnnrly/abbreviate)
- [kcli](https://github.com/cswank/kcli) **star:198** 用于检查kafka主题/分区/消息的命令行工具。   [![近三年未更新][Y]](https://github.com/cswank/kcli)   [![godoc][D]](https://godoc.org/github.com/cswank/kcli)
- [gobrew](https://github.com/cryptojuice/gobrew) **star:194** gobrew 允许您轻松地在 go 的多个版本之间切换。   [![近三年未更新][Y]](https://github.com/cryptojuice/gobrew)
- [ostent](https://github.com/ostrost/ostent) **star:178** 收集和显示系统指标，并可选 Graphite and/or fluxdb作为依赖。   [![godoc][D]](https://godoc.org/github.com/ostrost/ostent)
- [grapes](https://github.com/yaronsumel/grapes) **star:165** 旨在轻松地通过ssh分发命令的轻量级工具。   [![godoc][D]](https://godoc.org/github.com/yaronsumel/grapes)
- [Dockerfile-Generator](https://github.com/ozankasikci/dockerfile-generator) **star:156** 一个go库和一个可执行文件，它使用各种输入通道生成有效的Dockerfiles。   [![godoc][D]](https://godoc.org/github.com/ozankasikci/dockerfile-generator)
- [winrm-cli](https://github.com/masterzen/winrm-cli) **star:156** 在Windows机器上远程执行命令的Cli工具。   [![godoc][D]](https://godoc.org/github.com/masterzen/winrm-cli)
- [drone-scp](https://github.com/appleboy/drone-scp) **star:126** 通过 SSH 进行文件拷贝。其中 SSH 通过二进制文件、docker 或 Drone CI触发。   [![godoc][D]](https://godoc.org/github.com/appleboy/drone-scp)
- [tf-profile](https://github.com/datarootsio/tf-profile) **star:126** Profiler for Terraform runs. Generate global stats, resource-level stats or visualizations.   [![godoc][D]](https://godoc.org/github.com/datarootsio/tf-profile)
- [Mantil](https://github.com/mantil-io/mantil) **star:104** 使用特定的框架在AWS上构建无服务器应用程序，使您能够专注于纯Go代码，而Mantil负责基础设施。   [![godoc][D]](https://godoc.org/github.com/mantil-io/mantil)
- [go-furnace](https://github.com/go-furnace/go-furnace) **star:97** 用Go编写的托管解决方案，可轻松地在AWS、GCP或DigitalOcean上部署应用程序。   [![godoc][D]](https://godoc.org/github.com/go-furnace/go-furnace)
- [go-rocket-update](https://github.com/mouuff/go-rocket-update) **star:85** A simple way to make self updating Go applications - Supports Github and Gitlab.   [![godoc][D]](https://godoc.org/github.com/mouuff/go-rocket-update)
- [Dropship](https://github.com/chrismckenzie/dropship) **star:64** 通过 cdn 部署代码的工具。   [![近三年未更新][Y]](https://github.com/chrismckenzie/dropship)   [![godoc][D]](https://godoc.org/github.com/chrismckenzie/dropship)
- [docker-go-mingw](https://github.com/x1unix/docker-go-mingw) **star:38** 使用MinGW工具链在Windows上构建Go二进制文件的Docker图像。
- [drone-jenkins](https://github.com/appleboy/drone-jenkins) **star:37** 使用二进制文件、docker或 Drone CI 来触发下游Jenkins作业。   [![godoc][D]](https://godoc.org/github.com/appleboy/drone-jenkins)
- [Rodent](https://github.com/alouche/rodent) **star:34** 管理Go版本、项目和跟踪依赖项。   [![近三年未更新][Y]](https://github.com/alouche/rodent)
- [awsenv](https://github.com/soniah/awsenv) **star:33** 可以为 profile 加载Amazon (AWS)环境变量的轻量二进制文件。   [![近三年未更新][Y]](https://github.com/soniah/awsenv)   [![godoc][D]](https://godoc.org/github.com/soniah/awsenv)
- [httpref](https://github.com/dnnrly/httpref) **star:32** httpref是一个方便的CLI参考，用于HTTP方法、状态码、头以及TCP和UDP端口。   [![godoc][D]](https://godoc.org/github.com/dnnrly/httpref)
- [lwc](https://github.com/timdp/lwc) **star:31** UNIX wc命令的实时更新版本。   [![godoc][D]](https://godoc.org/github.com/timdp/lwc)
- [DepCharge](https://github.com/centerorbit/depcharge) **star:23** Helps orchestrating the execution of commands across the many dependencies in larger projects.   [![godoc][D]](https://godoc.org/github.com/centerorbit/depcharge)
- [wait-for](https://github.com/dnnrly/wait-for) **star:15** Wait for something to happen (from the command line) before continuing. Easy orchestration of Docker services and other things.   [![godoc][D]](https://godoc.org/github.com/dnnrly/wait-for)
- [aptly](https://github.com/smira/aptly) **star:9** Debian存储库管理工具。   [![近三年未更新][Y]](https://github.com/smira/aptly)   [![godoc][D]](https://godoc.org/github.com/smira/aptly)
- [sg](https://github.com/ChristopherRabotin/sg) **star:8** 可测试一组HTTP极限(如ab)，可以在每个调用之间使用响应代码和数据，根据之前的响应来确定特定的服务器压力。   [![近三年未更新][Y]](https://github.com/ChristopherRabotin/sg)   [![godoc][D]](https://godoc.org/github.com/ChristopherRabotin/sg)

**[⬆ back to top](#contents)**

### 其他软件

- [croc](https://github.com/schollz/croc) **star:23551** 轻松、安全地将文件或文件夹从一台计算机发送到另一台计算机。   [![godoc][D]](https://godoc.org/github.com/schollz/croc)
- [Docker](https://www.docker.com/)  面向开发人员和系统管理员的分布式应用程序的开放平台。
- [restic](https://github.com/restic/restic) **star:21158** 消除重复项备份程序。   [![godoc][D]](https://godoc.org/github.com/restic/restic)
- [Seaweed File System](https://github.com/chrislusf/seaweedfs) **star:18254** 快速、简单、可伸缩的分布式文件系统，采用了O(1)磁盘查找。   [![近一周有更新][G]](https://github.com/chrislusf/seaweedfs)   [![godoc][D]](https://godoc.org/github.com/chrislusf/seaweedfs)
- [Gor](https://github.com/buger/gor) **star:17804** Http 流量复制工具，用于实时回放从生产环境到阶段/开发环境的流量。   [![godoc][D]](https://godoc.org/github.com/buger/gor)
- [Comcast](https://github.com/tylertreat/Comcast) **star:10031** 模拟坏的网络连接。   [![godoc][D]](https://godoc.org/github.com/tylertreat/Comcast)
- [toxiproxy](https://github.com/shopify/toxiproxy) **star:9402** 为自动化测试模拟网络和系统条件的代理。   [![近一周有更新][G]](https://github.com/shopify/toxiproxy)   [![godoc][D]](https://godoc.org/github.com/shopify/toxiproxy)
- [tsuru](https://tsuru.io/)  Extensible and open source Platform as a Service software.
- [confd](https://github.com/kelseyhightower/confd) **star:8167** 使用 etcd 或 consul 的模板和数据管理本地应用程序配置文件。   [![godoc][D]](https://godoc.org/github.com/kelseyhightower/confd)
- [LiteIDE](https://github.com/visualfc/liteide) **star:7292** 简单的、开源的、跨平台的Go IDE。   [![包含中文文档][CN]](https://github.com/visualfc/liteide)
- [drive](https://github.com/odeke-em/drive) **star:6567** 基于命令行的谷歌驱动器客户端。   [![godoc][D]](https://godoc.org/github.com/odeke-em/drive)
- [nes](https://github.com/fogleman/nes) **star:5281** 任天堂娱乐系统(NES)模拟器。   [![godoc][D]](https://godoc.org/github.com/fogleman/nes)
- [scc](https://github.com/boyter/scc) **star:5034** 一个非常快速准确的代码计数器，采用了复杂的计算和 COCOMO 预估。   [![近一周有更新][G]](https://github.com/boyter/scc)   [![godoc][D]](https://godoc.org/github.com/boyter/scc)
- [Duplicacy](https://github.com/gilbertchen/duplicacy) **star:4758** 跨平台网络和云备份工具。   [![近一周有更新][G]](https://github.com/gilbertchen/duplicacy)   [![godoc][D]](https://godoc.org/github.com/gilbertchen/duplicacy)
- [blocky](https://github.com/0xERR0R/blocky) **star:2859** 快速和轻量级的DNS代理作为广告拦截器，为本地网络具有许多功能。   [![近一周有更新][G]](https://github.com/0xERR0R/blocky)   [![godoc][D]](https://godoc.org/github.com/0xERR0R/blocky)
- [myLG](https://github.com/mehrdadrad/mylg) **star:2663** 命令行网络诊断工具。   [![近三年未更新][Y]](https://github.com/mehrdadrad/mylg)   [![godoc][D]](https://godoc.org/github.com/mehrdadrad/mylg)
- [GoBoy](https://github.com/Humpheh/goboy) **star:2551** 用 Go 编写的任天堂Game Boy彩色模拟器。   [![godoc][D]](https://godoc.org/github.com/Humpheh/goboy)
- [Stack Up](https://github.com/pressly/sup) **star:2434** Stack Up 是一个超级简单的部署工具 — 只面向Unix。   [![godoc][D]](https://godoc.org/github.com/pressly/sup)
- [lgo](https://github.com/yunabe/lgo) **star:2327** 与 Jupyter 可进行交互 Go 程序。它支持代码完成、代码检查以及与Go 100% 兼容性。   [![godoc][D]](https://godoc.org/github.com/yunabe/lgo)
- [limetext](https://limetext.github.io)  一个强大而优雅的文本编辑器。
- [Circuit](https://github.com/gocircuit/circuit) **star:1972** Circuit 是一个可编程平台即服务(PaaS)和/或基础设施即服务(IaaS)，用于管理、发现、同步和编排包含云应用程序的服务和主机。   [![近三年未更新][Y]](https://github.com/gocircuit/circuit)   [![godoc][D]](https://godoc.org/github.com/gocircuit/circuit)
- [Documize](https://github.com/documize/community) **star:1945** 集成了SaaS工具数据的现代wiki软件。   [![近一周有更新][G]](https://github.com/documize/community)
- [snap](https://github.com/intelsdi-x/snap) **star:1798** 强大的遥测框架。   [![godoc][D]](https://godoc.org/github.com/intelsdi-x/snap)   [![归档项目][Archived]](https://github.com/intelsdi-x/snap)
- [borg](https://github.com/crufter/borg) **star:1583** 基于终端的bash代码段搜索引擎。   [![近三年未更新][Y]](https://github.com/crufter/borg)   [![godoc][D]](https://godoc.org/github.com/crufter/borg)
- [Plik](https://github.com/root-gg/plik) **star:1300** Plik是Go中的临时文件上传系统(类似于Wetransfer)。   [![近一周有更新][G]](https://github.com/root-gg/plik)   [![godoc][D]](https://godoc.org/github.com/root-gg/plik)
- [shell2http](https://github.com/msoap/shell2http) **star:1153** 通过http服务器执行shell命令(用于原型或远程控制)。   [![godoc][D]](https://godoc.org/github.com/msoap/shell2http)
- [vFlow](https://github.com/VerizonDigital/vflow) **star:1012** 高性能、可伸缩和可靠的 IPFIX、sFlow和 Netflow 收集器。   [![godoc][D]](https://godoc.org/github.com/VerizonDigital/vflow)
- [portal](https://github.com/SpatiumPortae/portal) **star:958** Portal is a quick and easy command-line file transfer utility from any computer to another.   [![近一周有更新][G]](https://github.com/SpatiumPortae/portal)   [![godoc][D]](https://godoc.org/github.com/SpatiumPortae/portal)
- [peg](https://github.com/pointlander/peg) **star:923** 解析表达式语法，是Packrat解析器生成器的实现。   [![godoc][D]](https://godoc.org/github.com/pointlander/peg)
- [Go Package Store](https://github.com/shurcooL/Go-Package-Store) **star:894** App that displays updates for the Go packages in your GOPATH.   [![godoc][D]](https://godoc.org/github.com/shurcooL/Go-Package-Store)
- [Gokapi](https://github.com/Forceu/gokapi) **star:789** Lightweight server to share files, which expire after a set amount of downloads or days. Similar to Firefox Send, but without public upload.   [![godoc][D]](https://godoc.org/github.com/Forceu/gokapi)
- [GoLand](https://jetbrains.com/go)  功能齐全的跨平台 Go IDE。
- [Leaps](https://github.com/jeffail/leaps) **star:735** 使用操作转换的成对编程服务。   [![godoc][D]](https://godoc.org/github.com/jeffail/leaps)
- [gfile](https://github.com/Antonito/gfile) **star:708** 通过WebRTC在两台计算机之间安全地传输文件，不需要任何第三方依赖。   [![godoc][D]](https://godoc.org/github.com/Antonito/gfile)
- [Guora](https://github.com/meloalright/guora) **star:658** 一个用Go编写的类似Quora的自托管web应用程序。   [![godoc][D]](https://godoc.org/github.com/meloalright/guora)   [![包含中文文档][CN]](https://github.com/meloalright/guora)
- [Gebug](https://github.com/moshebe/gebug) **star:622** 一个工具，通过启用调试器和热重新加载特性，使docker化的Go应用程序的调试非常容易，无缝。   [![近一周有更新][G]](https://github.com/moshebe/gebug)   [![godoc][D]](https://godoc.org/github.com/moshebe/gebug)
- [sake](https://github.com/alajmo/sake) **star:612** sake is a command runner for local and remote hosts.   [![godoc][D]](https://godoc.org/github.com/alajmo/sake)
- [gocc](https://github.com/goccmack/gocc) **star:578** Gocc是一个用Go编写的编译器工具包。   [![godoc][D]](https://godoc.org/github.com/goccmack/gocc)
- [mockingjay](https://github.com/quii/mockingjay-server) **star:542** 一份配置文件中便可伪造HTTP服务器与用户之间的行为。您还可以使服务器随机宕机，以帮助进行更实际的性能测试。   [![godoc][D]](https://godoc.org/github.com/quii/mockingjay-server)
- [go-peerflix](https://github.com/Sioro-Neoku/go-peerflix) **star:457** 视频流 torrent 客户端。   [![godoc][D]](https://godoc.org/github.com/Sioro-Neoku/go-peerflix)
- [goblin](https://goblin.reaper.im)  戈朗双星在一个卷曲，由地精建造。
- [woke](https://github.com/get-woke/woke) **star:391** 检测源代码中不包含的语言。   [![godoc][D]](https://godoc.org/github.com/get-woke/woke)
- [zs](https://git.mills.io/prologic/zs)  an extremely minimal static site generator.
- [ipe](https://github.com/dimiro1/ipe) **star:366** Open source Pusher server implementation compatible with Pusher client libraries written in GO.   [![godoc][D]](https://godoc.org/github.com/dimiro1/ipe)   [![归档项目][Archived]](https://github.com/dimiro1/ipe)
- [ide](https://github.com/thestrukture/ide) **star:354** 基于浏览器的IDE   [![godoc][D]](https://godoc.org/github.com/thestrukture/ide)
- [tcpprobe](https://github.com/mehrdadrad/tcpprobe) **star:339** 用于网络性能和路径监控的TCP工具，包括套接字统计信息。   [![godoc][D]](https://godoc.org/github.com/mehrdadrad/tcpprobe)
- [wellington](https://github.com/wellington/wellington) **star:302** Sass 项目管理工具，使用sprite函数(如Compass)扩展语言。   [![godoc][D]](https://godoc.org/github.com/wellington/wellington)
- [GoNB](https://github.com/janpfeifer/gonb) **star:292** Interactive Go programming with Jupyter Notebooks (also works in VSCode, Binder and Google's Colab).   [![近一周有更新][G]](https://github.com/janpfeifer/gonb)   [![godoc][D]](https://godoc.org/github.com/janpfeifer/gonb)
- [Cherry](https://github.com/rafael-santiago/cherry) **star:290** 微型网络聊天服务器。   [![近三年未更新][Y]](https://github.com/rafael-santiago/cherry)   [![godoc][D]](https://godoc.org/github.com/rafael-santiago/cherry)
- [Neo-cowsay](https://github.com/Code-Hex/Neo-cowsay) **star:262** 🐮cowsay重生。一个新时代。   [![近一周有更新][G]](https://github.com/Code-Hex/Neo-cowsay)   [![godoc][D]](https://godoc.org/github.com/Code-Hex/Neo-cowsay)
- [hotswap](https://github.com/edwingeng/hotswap) **star:251** A complete solution to reload your go code without restarting your server, interrupting or blocking any ongoing procedure.   [![godoc][D]](https://godoc.org/github.com/edwingeng/hotswap)   [![包含中文文档][CN]](https://github.com/edwingeng/hotswap)
- [hugo](https://gohugo.io/)  快速、现代的静态网站引擎。
- [tcpdog](https://github.com/mehrdadrad/tcpdog) **star:237** 基于eBPF的TCP可观测性。   [![godoc][D]](https://godoc.org/github.com/mehrdadrad/tcpdog)
- [joincap](https://github.com/assafmo/joincap) **star:191** 用于合并多个pcap文件的命令行实用程序。   [![godoc][D]](https://godoc.org/github.com/assafmo/joincap)
- [Juju](https://jujucharms.com/)  Cloud-agnostic的服务部署和编制 —— 支持EC2、Azure、Openstack、MAAS等。
- [Orbit](https://github.com/gulien/orbit) **star:176** 一个根据模板来运行命令和生成文件的简单小工具。   [![godoc][D]](https://godoc.org/github.com/gulien/orbit)
- [crawley](https://github.com/s0rg/crawley) **star:165** 网刮板/爬虫为cli。   [![godoc][D]](https://godoc.org/github.com/s0rg/crawley)
- [Better Go Playground](https://goplay.tools)  使用语法高亮显示、代码完成和其他功能。
- [vaku](https://github.com/lingrino/vaku) **star:150** 用于库中基于文件夹的函数(如复制、移动和搜索)的CLI和API。   [![近一周有更新][G]](https://github.com/lingrino/vaku)   [![godoc][D]](https://godoc.org/github.com/lingrino/vaku)
- [stew](https://github.com/marwanhawari/stew) **star:118** 一个独立的编译二进制文件的包管理器。   [![godoc][D]](https://godoc.org/github.com/marwanhawari/stew)
- [syncthing](https://syncthing.net/)  开放，分散的文件同步工具和协议。
- [dp](https://github.com/scryinfo/dp) **star:84** 通过SDK与区块链进行数据交换，开发人员可以轻松访问DAPP开发。   [![godoc][D]](https://godoc.org/github.com/scryinfo/dp)
- [boxed](https://github.com/tejo/boxed) **star:78** 基于Dropbox的博客引擎。   [![近三年未更新][Y]](https://github.com/tejo/boxed)   [![godoc][D]](https://godoc.org/github.com/tejo/boxed)
- [term-quiz](https://github.com/crazcalm/term-quiz) **star:24** 测试你的终端。   [![近三年未更新][Y]](https://github.com/crazcalm/term-quiz)   [![godoc][D]](https://godoc.org/github.com/crazcalm/term-quiz)
- [naclpipe](https://github.com/unix4fun/naclpipe) **star:23** 基于加密管的简单的NaCL EC25519工具。   [![近三年未更新][Y]](https://github.com/unix4fun/naclpipe)   [![godoc][D]](https://godoc.org/github.com/unix4fun/naclpipe)
- [Snitch](https://github.com/lucasgomide/snitch) **star:16** 当有人通过 Tsuru 部署任何应用程序时，会通知您的团队以及其他工具。   [![近三年未更新][Y]](https://github.com/lucasgomide/snitch)   [![godoc][D]](https://godoc.org/github.com/lucasgomide/snitch)
- [GoDocTooltip](https://github.com/diankong/GoDocTooltip) **star:13** 包含了 Go 使用手册文档的 Chrome 扩展。
- [hoofli](https://github.com/dnnrly/hoofli) **star:7** 从Chrome或Firefox网络检查生成PlantUML图表。   [![godoc][D]](https://godoc.org/github.com/dnnrly/hoofli)
- [protoncheck](https://github.com/servusdei2018/protoncheck) **star:4** ProtonMail模块的waybar/polybar/yabar/i3blocks。   [![godoc][D]](https://godoc.org/github.com/servusdei2018/protoncheck)   [![归档项目][Archived]](https://github.com/servusdei2018/protoncheck)

**[⬆ back to top](#contents)**

# 资源

_在哪里可以找到新的Go库。 (翻译出错了? 试试 [英文版](README_EN.md#resources) 吧~)_

**[⬆ back to top](#contents)**

## 基准

- [go-web-framework-benchmark](https://github.com/smallnest/go-web-framework-benchmark) **star:1920** web框架基准测试。   [![godoc][D]](https://godoc.org/github.com/smallnest/go-web-framework-benchmark)
- [go-http-routing-benchmark](https://github.com/julienschmidt/go-http-routing-benchmark) **star:1617** HTTP请求路由器基准测试和比较。   [![近一周有更新][G]](https://github.com/julienschmidt/go-http-routing-benchmark)   [![godoc][D]](https://godoc.org/github.com/julienschmidt/go-http-routing-benchmark)
- [go_serialization_benchmarks](https://github.com/alecthomas/go_serialization_benchmarks) **star:1479** Go序列化方法的基准测试。   [![godoc][D]](https://godoc.org/github.com/alecthomas/go_serialization_benchmarks)
- [skynet](https://github.com/atemerev/skynet) **star:1027** 天网 1M 线程微基准测试。
- [speedtest-resize](https://github.com/fawick/speedtest-resize) **star:237** 对比各种图像大小调整算法性能。   [![godoc][D]](https://godoc.org/github.com/fawick/speedtest-resize)
- [go-benchmarks](https://github.com/tylertreat/go-benchmarks) **star:145** Few miscellaneous Go microbenchmarks. Compare some language features to alternative approaches   [![近三年未更新][Y]](https://github.com/tylertreat/go-benchmarks)   [![godoc][D]](https://godoc.org/github.com/tylertreat/go-benchmarks)
- [gospeed](https://github.com/feyeleanor/GoSpeed) **star:112** 计算语言结构的速度的微观基准测试。   [![godoc][D]](https://godoc.org/github.com/feyeleanor/GoSpeed)
- [autobench](https://github.com/davecheney/autobench) **star:96** 用来来比较不同Go版本之间的性能的框架。   [![近三年未更新][Y]](https://github.com/davecheney/autobench)   [![godoc][D]](https://godoc.org/github.com/davecheney/autobench)
- [golang-sql-benchmark](https://github.com/tyler-smith/golang-sql-benchmark) **star:65** 为流行的 Go 数据库/SQL实用程序收集基准测试。   [![godoc][D]](https://godoc.org/github.com/tyler-smith/golang-sql-benchmark)
- [gocostmodel](https://github.com/PuerkitoBio/gocostmodel) **star:60** Go语言常用基本操作的基准测试。   [![godoc][D]](https://godoc.org/github.com/PuerkitoBio/gocostmodel)
- [go-ml-benchmarks](https://github.com/nikolaydubina/go-ml-benchmarks) **star:28** 机器学习推理基准。   [![godoc][D]](https://godoc.org/github.com/nikolaydubina/go-ml-benchmarks)
- [go-benchmark-app](https://github.com/mrLSD/go-benchmark-app) **star:26** 强大的HTTP基准测试工具，包含了Аb，Wrk，Siege工具。收集统计和各种参数指标，并比较相关结果。   [![近三年未更新][Y]](https://github.com/mrLSD/go-benchmark-app)   [![godoc][D]](https://godoc.org/github.com/mrLSD/go-benchmark-app)
- [kvbench](https://github.com/jimrobinson/kvbench) **star:25** K / V 类型数据库基准测试。   [![近三年未更新][Y]](https://github.com/jimrobinson/kvbench)   [![godoc][D]](https://godoc.org/github.com/jimrobinson/kvbench)
- [go-json-benchmark](https://github.com/zerosnake0/go-json-benchmark) **star:8** JSON的基准。   [![godoc][D]](https://godoc.org/github.com/zerosnake0/go-json-benchmark)

**[⬆ back to top](#contents)**

## 会议

- [GoCon](https://gocon.connpass.com/)  东京,日本。
- [GoDays](https://www.godays.io/)  德国柏林。
- [GoLab](https://golab.io/)  佛罗伦萨,意大利。
- [GopherChina](https://gopherchina.org)  上海,中国。
- [GopherCon](https://www.gophercon.com/)  美国丹佛。
- [GopherCon Australia](https://gophercon.com.au/)  澳大利亚悉尼。
- [GopherCon Brazil](https://gopherconbr.org)  弗洛,巴西。
- [GopherCon Europe](https://gophercon.eu/)  德国柏林。
- [GopherCon India](https://www.gophercon.in/)  印度浦那。
- [GopherCon Israel](https://www.gophercon.org.il/)  特拉维夫,以色列。
- [GopherCon Russia](https://www.gophercon-russia.ru)  莫斯科,俄罗斯。
- [GopherCon Singapore](https://gophercon.sg)  新加坡枫树商贸城。
- [GopherCon UK](https://www.gophercon.co.uk/)  伦敦,英国。
- [GopherCon Vietnam](https://gophercon.vn/)  越南胡志明市。
- [GoWest Conference](https://www.gowestconf.com/)  利希、美国。

**[⬆ back to top](#contents)**

## E-Books

### 电子书购买

- [100 Go Mistakes: How to Avoid Them](https://www.manning.com/books/100-go-mistakes-how-to-avoid-them)
- [Black Hat Go](https://nostarch.com/blackhatgo)  Go programming for hackers and pentesters.
- [Build an Orchestrator in Go](https://www.manning.com/books/build-an-orchestrator-in-go)
- [Continuous Delivery in Go](https://www.manning.com/books/continuous-delivery-in-go)  这篇关于持续交付的实用指南向您展示了如何快速建立一个自动化管道，以改进您的测试、代码质量和最终产品。
- [Creative DIY Microcontroller Project With TinyGo and WebAssembly](https://www.packtpub.com/product/creative-diy-microcontroller-projects-with-tinygo-and-webassembly/9781800560208)  An introduction into the TinyGo compiler with projects involving Arduino and WebAssembly.
- [Effective Go: Elegant, efficient, and testable code](https://www.manning.com/books/effective-go)  Unlock Go’s unique perspective on program design, and start writing simple, maintainable, and testable Go code.
- [For the Love of Go](https://bitfieldconsulting.com/books/love)  为golang初学者准备的入门书。
- [Go Faster](https://leanpub.com/gofaster)  This book seeks to shorten your learning curve and help you become a proficient Go programmer, faster.
- [Know Go: Generics](https://bitfieldconsulting.com/books/generics)  在Go中理解和使用泛型的指南。
- [Lets-Go](https://lets-go.alexedwards.net)  A step-by-step guide to creating fast, secure and maintanable web applications with Go.
- [Lets-Go-Further](https://lets-go-further.alexedwards.net)  Advanced patterns for building APIs and web applications in Go.
- [The Power of Go: Tests](https://bitfieldconsulting.com/books/tests)  A guide to testing in Go.
- [The Power of Go: Tools](https://bitfieldconsulting.com/books/tools)  在Go中编写命令行工具的指南。
- [Writing A Compiler In Go](https://compilerbook.com)
- [Writing An Interpreter In Go](https://interpreterbook.com)  这本书介绍了编写习惯的，表达的，高效的Go代码的技巧，避免了常见的陷阱。

### 免费电子书

- [A Go Developer's Notebook](https://leanpub.com/GoNotebook/read)
- [An Introduction to Programming in Go](http://www.golang-book.com/)
- [Build Web Application with Golang](https://astaxie.gitbooks.io/build-web-application-with-golang/content/en/)
- [Building Web Apps With Go](https://codegangsta.gitbooks.io/building-web-apps-with-go/content/)
- [GoBooks](https://github.com/dariubs/GoBooks) **star:14753** 一份精选的 Go 书籍清单。
- [How To Code in Go eBook](https://www.digitalocean.com/community/books/how-to-code-in-go-ebook)  600页的Go介绍针对的是第一次开发人员。
- [Go AST Book (Chinese)](https://github.com/chai2010/go-ast-book) **star:5104** A book focusing on Go `go/*` packages.   [![godoc][D]](https://godoc.org/github.com/chai2010/go-ast-book)
- [Go 101](https://go101.org)  一本关注 Go 语法/语义和各种细节的书。
- [Go Succinctly](https://github.com/thedevsir/gosuccinctly) **star:23** in Persian.   [![近三年未更新][Y]](https://github.com/thedevsir/gosuccinctly)   [![godoc][D]](https://godoc.org/github.com/thedevsir/gosuccinctly)
- [Learning Go](https://www.miek.nl/downloads/Go/Learning-Go-latest.pdf)
- [Network Programming With Go](https://jan.newmarch.name/golang/)
- [Practical Go Lessons](https://www.practical-go-lessons.com/)
- [Spaceship Go A Journey to the Standard Library](https://blasrodri.github.io/spaceship-go-gh-pages/)
- [The Go Programming Language](https://www.gopl.io/)
- [The Golang Standard Library by Example (Chinese)](https://github.com/polaris1119/The-Golang-Standard-Library-by-Example)
- [Web Application with Go the Anti-Textbook](https://github.com/thewhitetulip/web-dev-golang-anti-textbook/)

**[⬆ back to top](#contents)**

## Gophers

- [Free Gophers Pack](https://github.com/MariaLetta/free-gophers-pack) **star:3121** 由 Maria Letta 提供的与 Gopher 有关的图片包，其中包含了插图,表情文字。   [![godoc][D]](https://godoc.org/github.com/MariaLetta/free-gophers-pack)
- [gopher-logos](https://github.com/GolangUA/gopher-logos) **star:114** 可爱的 gopher 标识。
- [Go-gopher-Vector](https://github.com/keygx/Go-gopher-Vector) **star:65** 与 Go gopher 相关的媒介数据[。ai . svg)。   [![近三年未更新][Y]](https://github.com/keygx/Go-gopher-Vector)
- [gopher-stickers](https://github.com/tenntenn/gopher-stickers)
- [gophericons](https://github.com/shalakhin/gophericons)
- [gophers](https://github.com/egonelbre/gophers) **star:3224** Free gophers.   [![godoc][D]](https://godoc.org/github.com/egonelbre/gophers)
- [gophers](https://github.com/ashleymcnamara/gophers) **star:2846** 阿什莉·麦克纳马拉的歌斐艺术品。   [![近三年未更新][Y]](https://github.com/ashleymcnamara/gophers)   [![godoc][D]](https://godoc.org/github.com/ashleymcnamara/gophers)
- [gopherize.me](https://github.com/matryer/gopherize.me) **star:653** Gopherize自己。
- [gophers](https://github.com/sillecelik/go-gopher) **star:123** Gopher amigurumi玩具图案。
- [gophers](https://github.com/rogeralsing/gophers) **star:57** 随机gopher图形。   [![近三年未更新][Y]](https://github.com/rogeralsing/gophers)
- [gophers](https://github.com/scraly/gophers) **star:23** Gophers by Aurélie Vache.

**[⬆ back to top](#contents)**

## 聚会

- [Basel Go Meetup](https://www.meetup.com/Basel-Go-Meetup/)
- [Belfast Gophers](https://www.meetup.com/Belfast-Gophers/)
- [Belgrade Golang Meetup](https://www.meetup.com/golang-serbia/)
- [Berlin Golang](https://www.meetup.com/golang-users-berlin/)
- [Brisbane Gophers](https://www.meetup.com/Brisbane-Golang-Meetup/)
- [Canberra Gophers](https://www.meetup.com/Canberra-Gophers/)
- [Go Language NYC](https://www.meetup.com/golanguagenewyork/)
- [Go London User Group](https://www.meetup.com/Go-London-User-Group/)
- [Go Remote Meetup](https://www.meetup.com/Go-Remote-Meetup/)
- [Go Toronto](https://www.meetup.com/go-toronto/)
- [Go User Group Atlanta](https://www.meetup.com/Go-Users-Group-Atlanta/)
- [GoBandung](https://www.meetup.com/GoBandung/)
- [GoBridge, San Francisco, CA](https://www.meetup.com/gobridge/)
- [GoCracow - Krakow, Poland](https://www.meetup.com/GoCracow/)
- [GoJakarta](https://www.meetup.com/GoJakarta/)
- [Golang Amsterdam](https://www.meetup.com/golang-amsterdam/)
- [Golang Argentina](https://www.meetup.com/Golang-Argentina/)
- [Golang Athens](https://www.meetup.com/Athens-Gophers/)
- [Golang Baltimore, MD](https://www.meetup.com/BaltimoreGolang/)
- [Golang Bangalore](https://www.meetup.com/Golang-Bangalore/)
- [Golang Belo Horizonte - Brazil](https://www.meetup.com/go-belo-horizonte/)
- [Golang Boston](https://www.meetup.com/bostongo/)
- [Golang Bulgaria](https://www.meetup.com/Golang-Bulgaria/)
- [Golang Cardiff, UK](https://www.meetup.com/Cardiff-Go-Meetup/)
- [Golang Copenhagen](https://www.meetup.com/Go-Cph/)
- [Golang Curitiba - Brazil](https://www.meetup.com/GolangCWB/)
- [Golang DC, Arlington, VA](https://www.meetup.com/Golang-DC/)
- [Golang Dorset, UK](https://www.meetup.com/golang-dorset/)
- [Golang Estonia](https://www.meetup.com/Golang-Estonia/)
- [Golang Gurgaon, India](https://www.meetup.com/Gurgaon-Go-Meetup/)
- [Golang Hamburg - Germany](https://www.meetup.com/Go-User-Group-Hamburg/)
- [Golang Israel](https://www.meetup.com/Go-Israel/)
- [Golang Kathmandu](https://www.meetup.com/Golang-Kathmandu/)
- [Golang Korea](https://www.meetup.com/GDG-Golang-Korea/)
- [Golang Lima - Peru](https://www.meetup.com/Golang-Peru/)
- [Golang Lyon](https://www.meetup.com/Golang-Lyon/)
- [Golang Marseille](https://www.meetup.com/fr-FR/Golang-Marseille/)
- [Golang Melbourne](https://www.meetup.com/golang-mel/)
- [Golang Mountain View](https://www.meetup.com/Golang-Mountain-View/)
- [Golang North East](https://www.meetup.com/en-AU/Golang-North-East/)
- [Golang Paris](https://www.meetup.com/Golang-Paris/)
- [Golang Poland](https://www.meetup.com/Golang-Poland/)
- [Golang Pune](https://www.meetup.com/Golang-Pune/)
- [Golang Rotterdam](https://www.meetup.com/golang-rotterdam/)
- [Golang Singapore](https://www.meetup.com/golangsg/)
- [Golang Stockholm](https://www.meetup.com/Go-Stockholm/)
- [Golang Sydney, AU](https://www.meetup.com/golang-syd/)
- [Golang São Paulo - Brazil](https://www.meetup.com/golangbr/)
- [Golang Taipei](https://www.meetup.com/golang-taipei-meetup/)
- [Golang Thessaloniki](https://www.meetup.com/thessaloniki-golang-meetup/)
- [Golang Turkey](https://kommunity.com/goturkiye)
- [Golang Vancouver, BC](https://www.meetup.com/golangvan/)
- [Golang Vienna, Austria](https://www.meetup.com/viennago/)
- [Golang Москва](https://www.meetup.com/Golang-Moscow/)
- [GoSF - San Francisco, CA](https://www.meetup.com/golangsf)
- [Istanbul Golang](https://www.meetup.com/Istanbul-Golang/)
- [Seattle Go Programmers](https://www.meetup.com/golang/)
- [Ukrainian Golang User Groups](https://www.meetup.com/uagolang/)
- [Utah Go User Group](https://www.meetup.com/utahgophers/)
- [Women Who Go - San Francisco, CA](https://www.meetup.com/Women-Who-Go/)

_在这里添加您所在城市/国家的群组(发送**PR**) (翻译出错了? 试试 [英文版](README_EN.md#meetups) 吧~)_

**[⬆ back to top](#contents)**

## 风格指南

- [bahlo/go-styleguide](https://github.com/bahlo/go-styleguide)
- [CockroachDB](https://github.com/cockroachdb/cockroach/blob/master/docs/style.md)
- [GitLab](https://docs.gitlab.com/ee/development/go_guide/)
- [Google](https://google.github.io/styleguide/go/)
- [Hyperledger](https://github.com/hyperledger/fabric/blob/release-1.4/docs/source/style-guides/go-style.rst)
- [Magnetico](https://github.com/boramalper/magnetico/wiki/magnetico-Design-Specification)
- [Sourcegraph](https://docs.sourcegraph.com/dev/background-information/languages/go)
- [Thanos](https://thanos.io/tip/contributing/coding-style-guide.md/)
- [Trybe](https://github.com/betrybe/playbook-go/blob/main/README_EN.md)
- [Uber](https://github.com/uber-go/guide/blob/master/style.md)

**[⬆ back to top](#contents)**

## 社交媒体

### Twitter

- [@GoDiscussions](https://twitter.com/GoDiscussions)
- [@golang](https://twitter.com/golang)
- [@golang_news](https://twitter.com/golang_news)
- [@golangch](https://twitter.com/golangch)
- [@golangflow](https://twitter.com/golangflow)
- [@golangweekly](https://twitter.com/golangweekly)

**[⬆ back to top](#contents)**

### Reddit

- [r/golang](https://www.reddit.com/r/golang/)

**[⬆ back to top](#contents)**

## 网站

- [awesome-awesomeness](https://github.com/bayandin/awesome-awesomeness) **star:30565** 其他 awesome 系列的列表。
- [Awesome Remote Job](https://github.com/lukasz-madon/awesome-remote-job) **star:26552** Curated list of awesome remote jobs. A lot of them are looking for Go hackers.
- [Awesome Golang Workshops](https://github.com/amit-davidson/awesome-golang-workshops) **star:485** 一个令人敬畏的戈朗工作室的策划列表。
- [golang-graphics](https://github.com/mholt/golang-graphics) **star:138** 收藏的 Go 图像，图形和艺术作品。   [![近三年未更新][Y]](https://github.com/mholt/golang-graphics)   [![归档项目][Archived]](https://github.com/mholt/golang-graphics)
- [golang-nuts](https://groups.google.com/forum/#!forum/golang-nuts)  Go 邮件列表。
- [Google Plus Community](https://plus.google.com/communities/114112804251407510571)  Google+社区 golang爱好者聚集地。
- [Gopher Community Chat](https://invite.slack.golangbridge.org)  加入我们为Gophers设立的全新Slack社区([了解它是如何产生的](https://blog.gopheracademy.com/gophers-slack-community/))。
- [Gophercises](https://gophercises.com/)  为 Go 初学者提供免费的代码训练。
- [gowalker.org](https://gowalker.org)   Go API 文档。
- [json2go](https://m-zajac.github.io/json2go)  高级JSON去结构转换-在线工具。
- [justforfunc](https://www.youtube.com/c/justforfunc)  Youtube channel dedicated to Go programming language tips and tricks, hosted by Francesc Campoy [@francesc](https://twitter.com/francesc).
- [Learn Go Programming](https://blog.learngoprogramming.com)  学习Go概念与插图。
- [gocryforhelp](https://github.com/ninedraft/gocryforhelp) **star:41** 专门收集需要帮助的Go项目，这是你开启开源之路的好去处。   [![近三年未更新][Y]](https://github.com/ninedraft/gocryforhelp)
- [godoc.org](https://godoc.org/)  开源 Go 包的文档。
- [Golang Developer Jobs](https://golangjob.xyz)  Developer Jobs exclusively for Golang related Roles.
- [Golang Flow](https://golangflow.io)  发布更新、新闻、包等等。
- [Golang News](https://golangnews.com)  关于 Go 编程的链接和新闻。
- [Golang Resources](https://golangresources.com)  一个最佳示范，包含文章，练习，讨论和视频学习。
- [Golang Weekly](https://discu.eu/weekly/golang/)  Each monday projects, tutorials and articles about Go.
- [Awesome Go @LibHunt](https://go.libhunt.com)  属于你的 Go 工具箱。
- [awesome-go-extra](https://github.com/xwjdsh/awesome-go-extra) **star:22** 解析awesome-go README文件并生成一个新的README文件与repo信息。   [![godoc][D]](https://godoc.org/github.com/xwjdsh/awesome-go-extra)   [![包含中文文档][CN]](https://github.com/xwjdsh/awesome-go-extra)
- [Code with Mukesh](https://codewithmukesh.com/blog/category/golang)  Software Engineer and Blogs @ codewithmukesh.com.
- [Coding Mystery](https://codingmystery.com)  使用golang解决令人兴奋的逃脱室启发的编程挑战。
- [CodinGame](https://www.codingame.com/)  以小游戏互动完成任务的形式来学习 Go。
- [Explore Go Libraries & Projects](https://kandi.openweaver.com/explore/go)  Discover & find a curated list of popular & new Go libraries, top authors, trending project kits, discussions, tutorials & learning resources on kandi.
- [Go Blog](https://blog.golang.org)  官方 Go 博客。
- [Go Code Club](https://www.youtube.com/watch?v=nvoIPQYdx9g&list=PLEcwzBXTPUE_YQR7R0BRtHBYJ0LN3Y0i3)  一群地鼠每周阅读和讨论一个不同的Go项目。
- [Go Community on Hashnode](https://hashnode.com/n/go)  Hashnode上的Go社区。
- [Go Forum](https://forum.golangbridge.org)  讨论 Go 的论坛。
- [Go Projects](https://github.com/golang/go/wiki/Projects)  wiki上的 Go 社区项目列表。
- [Go Proverbs](https://go-proverbs.github.io/)  罗伯·派克的箴言。
- [Go Report Card](https://goreportcard.com)  为你的 Go 包生成一份报告单。
- [go.dev](https://go.dev/)  一个 go 开发者的中心。
- [Made with Golang](https://madewithgolang.com/?ref=awesome-go)
- [r/Golang](https://www.reddit.com/r/golang)  与 Go 有关的新闻。
- [studygolang](https://studygolang.com)  Go语言中文网
- [Trending Go repositories on GitHub today](https://github.com/trending?l=go)  寻找最新的 Go库 的好地方。
- [TutorialEdge - Golang](https://tutorialedge.net/course/golang/)

**[⬆ back to top](#contents)**

### 教程

- [Build web application with Golang](https://github.com/astaxie/build-web-application-with-golang) **star:42310** Golang电子书，主要讲述如何用 Golang 建立一个web应用程序。   [![godoc][D]](https://godoc.org/github.com/astaxie/build-web-application-with-golang)   [![包含中文文档][CN]](https://github.com/astaxie/build-web-application-with-golang)
- [Building and Testing a REST API in Go with Gorilla Mux and PostgreSQL](https://semaphoreci.com/community/tutorials/building-and-testing-a-rest-api-in-go-with-gorilla-mux-and-postgresql)  我们会写一个API的帮助下强大的大猩猩Mux。
- [Building Go Web Applications and Microservices Using Gin](https://semaphoreci.com/community/tutorials/building-go-web-applications-and-microservices-using-gin)  Get familiar with Gin and find out how it can help you reduce boilerplate code and build a request handling pipeline.
- [Caching Slow Database Queries](https://medium.com/@rocketlaunchr.cloud/caching-slow-database-queries-1085d308a0c9)  如何缓存数据库的慢查询。
- [Canceling MySQL](https://medium.com/@rocketlaunchr.cloud/canceling-mysql-in-go-827ed8f83b30)  如何取消MySQL查询。
- [CodeCrafters Golang Track](https://app.codecrafters.io/tracks/go)  Achieve mastery in advanced Go by building your own Redis, Docker, Git, and SQLite. Featuring goroutines, systems programming, file I/O, and more.
- [Go Cheat Sheet](https://github.com/a8m/go-lang-cheat-sheet) **star:7829**  Go's reference card。
- [Go database/sql tutorial](http://go-database-sql.org/)  数据库概论/ sql。
- [Ethereum Development with Go](https://github.com/miguelmota/ethereum-development-with-go-book) **star:1628** 一本讲述如何用 Go 进行以太开发的小册。   [![godoc][D]](https://godoc.org/github.com/miguelmota/ethereum-development-with-go-book)   [![包含中文文档][CN]](https://github.com/miguelmota/ethereum-development-with-go-book)   [![归档项目][Archived]](https://github.com/miguelmota/ethereum-development-with-go-book)
- [Games With Go](https://www.youtube.com/watch?v=9D4yH7e_ea8&list=PLDZujg-VgQlZUy1iCqBbe5faZLMkA3g2x)  关于编程和游戏开发系列教学视频。
- [Go By Example](https://gobyexample.com/)  手把手教你 如何在 Go 应用程序中使用注释。
- [50 Shades of Go](https://devs.cloudimmunity.com/gotchas-and-common-mistakes-in-go-golang/)  Go 初学者经常遇到的陷阱、误区、错误
- [A Comprehensive Guide to Structured Logging in Go](https://betterstack.com/community/guides/logging/logging-in-go/)  Delve deep into the world of structured logging in Go with a specific focus on recently accepted slog proposal which aims to bring high performance structured logging with levels to the standard library.
- [A Guide to Golang E-Commerce](https://snipcart.com/blog/golang-ecommerce-ponzu-cms-demo?utm_term=golang-ecommerce-ponzu-cms-demo)  教你如何用 Go 搭建一个电商平台 (包括demo)。
- [A Tour of Go](https://tour.golang.org/)  互动的 Go 之旅。
- [Build a Database in 1000 lines of code]( https://link.medium.com/O9YQlx89Htb)  Build a NoSQL Database From Zero in 1000 Lines of Code.
- [Go in 7 days](https://github.com/harrytran103/7_days_of_go) **star:126** Learn everything about Go in 7 days (from a Nodejs developer).   [![近三年未更新][Y]](https://github.com/harrytran103/7_days_of_go)   [![godoc][D]](https://godoc.org/github.com/harrytran103/7_days_of_go)
- [Go Language Tutorial](https://www.javatpoint.com/go-tutorial)  学习Go语言教程。
- [Go Tutorial](https://www.tutorialspoint.com/go/index.htm)  学习编程。
- [Design Patterns in Go](https://github.com/shubhamzanwar/design-patterns) **star:104** 在Go中实现的编程设计模式的集合。   [![godoc][D]](https://godoc.org/github.com/shubhamzanwar/design-patterns)
- [Debugged.it Go patterns](https://github.com/haveyoudebuggedit/go-patterns) **star:11** 高级的Go模式和准备运行的示例。   [![godoc][D]](https://godoc.org/github.com/haveyoudebuggedit/go-patterns)   [![归档项目][Archived]](https://github.com/haveyoudebuggedit/go-patterns)
- [Go WebAssembly Tutorial - Building a Simple Calculator](https://tutorialedge.net/golang/go-webassembly-tutorial/)
- [go-patterns](https://github.com/tmrts/go-patterns) **star:22794** 策划的清单去设计模式，食谱和习惯用法。   [![godoc][D]](https://godoc.org/github.com/tmrts/go-patterns)
- [Learn Go with TDD](https://github.com/quii/learn-go-with-tests) **star:20130** 学习使用测试驱动开发。   [![近一周有更新][G]](https://github.com/quii/learn-go-with-tests)   [![godoc][D]](https://godoc.org/github.com/quii/learn-go-with-tests)   [![包含中文文档][CN]](https://github.com/quii/learn-go-with-tests)
- [Learning Go by examples](https://dev.to/aurelievache/learning-go-by-examples-introduction-448n)  Series of articles in order to learn Golang language by concrete applications as example.
- [Microservices with Go](https://www.youtube.com/playlist?list=PLmD8u-IFdreyh6EUfevBcbiuCKzFk0EW_)  Dive deep into building microservices using Go, including gRPC.
- [package main](https://www.youtube.com/packagemain)  关于 Go 编程的YouTube频道。
- [Programming with Google Go](https://www.coursera.org/specializations/google-golang)  Coursera的专业学习可以从零开始。
- [Saving a Third of Our Memory by Re-ordering Go Struct Fields](https://qvault.io/golang/struct-field-ordering-memory/)  Go结构中的字段排序是多么低效。
- [Scaling Go Applications](https://betterstack.com/community/guides/scaling-go/)  Everything about building, deploying and scaling Go applications in production.
- [Learn Go with 1000+ Exercises](https://github.com/inancgumus/learngo) **star:17648** 通过成千上万的例子、练习和测验来学习Go。   [![godoc][D]](https://godoc.org/github.com/inancgumus/learngo)
- [go-clean-template](https://github.com/evrone/go-clean-template) **star:5427** Golang服务的Clean Architecture模板。   [![godoc][D]](https://godoc.org/github.com/evrone/go-clean-template)
- [Golang for Node.js Developers](https://github.com/miguelmota/golang-for-nodejs-developers) **star:3995** 引入示例讲述 Golang 与Node.js在学习上的差异。   [![godoc][D]](https://godoc.org/github.com/miguelmota/golang-for-nodejs-developers)
- [Golang Tutorial Guide](https://www.freecodecamp.org/news/golang-tutorial-list-free-courses-learn-go-programming-language/)  学习Go编程语言的免费课程列表。
- [Golangbot](https://golangbot.com/learn-golang-series/)  Go 编程教程。
- [GopherCoding](https://gophercoding.com/)  收集代码片段和教程，以帮助处理日常问题。
- [GopherSnippets](https://gophersnippets.com/)  带有测试和可测试示例的代码片段，用于Go编程语言。
- [Gosamples](https://gosamples.dev/)  让您解决日常代码问题的代码片段集合。
- [Hackr.io](https://hackr.io/tutorials/learn-golang)  Go社区投票选举出来的最好的在线 Go 教程。
- [goapp](https://github.com/bnkamalesh/goapp) **star:650** 关于构建和开发Go web应用/服务的指南。   [![godoc][D]](https://godoc.org/github.com/bnkamalesh/goapp)
- [Hex Monscape](https://github.com/Haraj-backend/hex-monscape) **star:42** Getting started guidelines in writing maintainable code using Hexagonal Architecture.   [![godoc][D]](https://godoc.org/github.com/Haraj-backend/hex-monscape)
- [How to Benchmark: dbq vs sqlx vs GORM](https://medium.com/@rocketlaunchr.cloud/how-to-benchmark-dbq-vs-sqlx-vs-gorm-e814caacecb5)  学习如何在Golang中进行基准测试。作为案例研究，我们将对dbq、sqlx和GORM进行基准测试。
- [How To Deploy a Go Web Application with Docker](https://semaphoreci.com/community/tutorials/how-to-deploy-a-go-web-application-with-docker)  学习如何使用Docker进行Go开发，以及如何构建Docker生产镜像。
- [How to Use Godog for Behavior-driven Development in Go](https://semaphoreci.com/community/tutorials/how-to-use-godog-for-behavior-driven-development-in-go)  快速使用Godog —— 一个行为驱动开发的构建和测试应用程序框架。
- [The world’s easiest introduction to WebAssembly with Golang](https://medium.com/@martinolsansky/webassembly-with-golang-is-fun-b243c0e34f02)
- [W3basic Go Tutorials](https://www.w3basic.com/golang/)  W3Basic provides an in-depth tutorial and well-organized content to learn Golang programming.
- [Working with Go](https://github.com/mkaz/working-with-go) **star:1158** 由一个经验丰富的Go程序员群体编写的一系列Go学习范例。   [![近三年未更新][Y]](https://github.com/mkaz/working-with-go)   [![归档项目][Archived]](https://github.com/mkaz/working-with-go)
- [Your basic Go](https://yourbasic.org/golang)  如何收集大量的教程。

**[⬆ back to top](#contents)**

### Guided Learning

- [The Go Developer Roadmap](https://roadmap.sh/golang)  A visual roadmap that new Go developers can follow through to help them learn Go.
- [The Go Learning Path](https://tutorialedge.net/paths/golang/)  A guided learning path containing a mix of free and premium resources.

**[⬆ back to top](#contents)**

